(function() {
	angular.module('connect.accountdetails').directive('connectAccountDetails', accountDetailsDirective).controller('accountDetailsController', accountDetailsController);

	accountDetailsDirective.$inject = [];
	accountDetailsController.$inject = ['$scope', '$timeout', 'Loading', 'ClientSet'];

	function accountDetailsDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'accountdetails/connect.accountdetails.html',
			controller: 'accountDetailsController'
		};

		return directive;
	}

	function accountDetailsController($scope, $timeout, Loading, ClientSet) {

		$('#accountDetails').on('pageshow', function(){
			$('#accountDetailsControlGroup').controlgroup('refresh'); //The control group is dynamically updated (from js/app.js) so we update it on every pageshow
		});


		Loading.then(function() {
			$timeout(function() {
				$scope.UserEmail = getEmail();

				if(globals.debugApp){
					console.log('USER EMAIL IN SCOPE' + $scope.UserEmail );
				}

				$scope.ShowGas = ClientSet.getShowGasPrice();
				$scope.InterestTitle = ClientSet.getInterestTitle();

				if (getPushEnabled()){
					$scope.PushSetting = 'Disable Push';
				}
				else{
					$scope.PushSetting = 'Enable Push';
				}
			},1);
		});


		$scope.Android = window.device.platform == 'Android';
		var inProgress = false;
		
		$scope.editPush = function() {
			if (!inProgress) {
				inProgress = true;
				if (getPushEnabled()) {
					//PushNotification.disablePush();
					SetItemInLocalData('PushEnabled', 'false');
					SetItemInLocalData('PushToken', "");

					$timeout(function() {
						$scope.PushSetting = 'Enable Push';
					}, 1);
				} else {
					//PushNotification.enablePush();
					SetItemInLocalData('PushEnabled', 'true');

					$timeout(function() {
						$scope.PushSetting = 'Disable Push';
					}, 1);
				}
				setTimeout(function() {
					inProgress = false;
				}, 500);
			}
		};

		$scope.logOut = function() {
			if (!inProgress) {
				inProgress = true;

				$timeout(function() {
				
					if(globals.debugApp){
						console.log("DEBUG: Logging out");
					}

					navigator.notification.confirm(
						'Your points are stored on the server. They are tied to this email only. Remember your password.',
						callBackConfirm, // Specify a function to be called
						'Are you sure you want to logout?', ["Yes", "No"]
					);

					function callBackConfirm(b) {
						if (b == 1) {
							// for YES

							navigator.splashscreen.show();

							if (window.device.platform == 'Android'){
								var options = {
									label : "Logging Out"
								};
							}
							else{
								var options = {
									label : "Logging Out",
									color : '#000',
									spinnerColor : '#000'
								}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
							} 

							//Cancel Sync if it's still running
							if( isSyncFinished() == false ){
								stopSync();
							}

							window.wizSpinner.show(options);
							//call function to clear data for log out
							ClearDataAndLogOut();

							setTimeout(function() {
								navigator.splashscreen.hide();
							}, 11000);

							setTimeout(function() {
								//Now sync app to retart it (add timer)
								window.localStorage.setItem('appRestart', 1);
								setSyncNow('true');
				       			window.location.href = window.location.href.substring(0, window.location.href.indexOf('#')); //reload main.html, basically restart the web app
				       		}, 5000);
						}
						else{
							// for NO - Do Nothing
						}
						inProgress = false;
					}
				}, 10);
			}
		};
	}
}());