(function() {
	angular.module('connect.changeaccountdetails')
		.directive('changeAccountDetails', changeAccountDetailsDirective)
		//TODO: reformat controller
		.controller('ChangeAccountDetailsController', changeAccountDetailsController);

	changeAccountDetailsDirective.$inject = [];

	changeAccountDetailsController.$inject = ['$scope', '$rootScope', '$http'];


	function changeAccountDetailsDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'changeAccountDetails/connect.changeaccountdetails.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) { }
	}

	function changeAccountDetailsController($scope, $rootScope, $http) {

		$('#changeAccountDetails').on('pageshow', function() {

			$('#birthdaychangeaccountdetails').mobiscroll({ preset: 'date'});
			//when the page is shown, update the form fields with the user's current info if available
			$scope.fullname = getFullName();
			$scope.phone = getPhone();
			if (getBirthday() != 0 && getBirthday() != null && moment(getBirthday()).isValid() && moment(getBirthday()).year() != 1900) {
				$scope.birthday = moment(getBirthday()).format("MM/DD/YYYY");
			}
			$scope.geopromo = getGeoPromo();
			$scope.password = '';
			$scope.Submit = false;

			$('input').trigger('input');
		});
		$('#changeAccountDetails').on('pagehide', function() {

			$scope.password = '';
			$scope.Submit = false;
		});

		$scope.Submit = false;

		$scope.ChangeAccountDetails = function() {
			$scope.Submit = true;

			if (!$('#changeAccountDetailsForm').hasClass('ng-invalid')) {

				var birthday = $('#birthdaychangeaccountdetails').val();
				if (birthday != undefined && birthday != "") {
					var newbirthday = moment(birthday).toDate().getTime();
				} 
				else {
					var newbirthday = -2208739198680;
				}

				if ($scope.geoPromo){
					var newgeopromo = 1;
				}
				else{
					var newgeopromo = 0;
				}
				

				if (window.device.platform == 'Android') {
					var options = {
						label : "Processing..",
						timeout: 120
					};
				} else {
					var options = {
						label : "Processing..",
						color: '#000',
						spinnerColor: '#000',
						timeout: 120
					};
				}
				window.wizSpinner.show(options); 

				$http.post(GetItemFromLocalData('ClientURL'), soapMessageChangeAccountDetail($scope.password, $scope.fullname, $scope.phone, newbirthday, newgeopromo), {timeout: 25000} ).then(function(response) {
					window.wizSpinner.hide();		
					var processed = $(response.data).find('ChangeAccountDetailResult').children("Processed").text();
					var error = $(response.data).find('Standard').children('MethodErrorMsg').text();

					if (processed == "true") {
						saveAccountDetailJson(response.data);
						$rootScope.RegisteredUser = true; //probably don't need this line
						navigator.notification.alert(
							'Your account has been updated.', // message
							function() {
								//$.mobile.changePage('#accountDetails', { transition: "slide", reverse: true});
								//	$scope.Submit = false;
							}, // callback
							'Success!', // title
							'Ok' // buttonName
						);
						setTimeout(function() {
							$scope.Submit = false;
						}, 500); //clear the change password form
						$.mobile.changePage('#accountDetails');

					} else {
						alert(error, function() {
							$.mobile.changePage('#accountDetails');
						});
					}

				}, function(error) {
					window.wizSpinner.hide();
					$rootScope.Error(globals.ajaxTimeoutMessage, function() {
						if(globals.debugApp){
							console.log(" .. ");
						}
					}, false, function() {
						if(globals.debugApp){
							console.log(" .. ");
						}
					});
					
				});
			}
		};

	}
})();