(function() {
	angular.module('connect.changeEmail')
		.directive('connectChangeEmail', connectChangeEmailDirective)
		.controller('connectChangeEmailController', connectChangeEmailController);

	connectChangeEmailDirective.$inject = [];
	connectChangeEmailController.$inject = ['$scope', '$rootScope', '$http'];

	function connectChangeEmailDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'changeEmail/connect.changeemail.html',
			controller: 'connectChangeEmailController'
		};
		return directive;
	}

	function connectChangeEmailController($scope, $rootScope, $http) {

		$('#changeEmail').on('pageshow', function(){
			var scope = angular.element($("#changeEmail")).scope();
			scope.$apply(function(){

	        	scope.password = '';
		    	scope.newEmail = '';
		    	scope.Submit = false;
	    	});
		}); //when the page is shown, update the form fields with the user's current info if available


		$('#changeEmail').on('pagehide', function(){ //refresh the interests on the page on pagehide in case the user has updated them

			var scope = angular.element($("#changeEmail")).scope();
			scope.$apply(function(){

	        	scope.password = '';
		   		scope.newEmail = '';
		    	scope.Submit = false;
	    	});
		});

		$scope.Submit = false;

		$scope.ChangeEmail = function() {
			$scope.Submit = true;

			if (!$('#changeEmailForm').hasClass('ng-invalid')) {
				
				if (window.device.platform == 'Android') {
					var options = {
						label : "Changing Email...",
						timeout: 120
					};
				} else {
					var options = {
						label : "Changing Email...",
						color: '#000',
						spinnerColor: '#000',
						timeout: 120
					};
				}
				window.wizSpinner.show(options); 

				$http.post(GetItemFromLocalData('ClientURL'), soapMessageChangeAccountEmail($scope.password, $scope.newEmail), {timeout: 25000}).then(function(response) {
					
					window.wizSpinner.hide();
					var processed = $(response.data).find('ChangeAccountEmailResult').children("Processed").text();
					var error = $(response.data).find('Standard').children('MethodErrorMsg').text();

					if (processed == "true") {
						SetItemInLocalData("Email", $scope.newEmail);

						navigator.notification.alert(
							'Email change complete.', // message

							function() {
							}, // callback
							'Success!', // title
							'Ok' // buttonName
						);
						setTimeout(function() {
							$scope.Submit = false;
						}, 500); //clear the change password form
						$.mobile.changePage('#accountDetails');

					} else{
						alert(error, function() {
							$.mobile.changePage('#accountDetails');
						});
					}
				}, function(error) {
					
					window.wizSpinner.hide();

					$rootScope.Error(globals.ajaxTimeoutMessage, function() {
						if(globals.debugApp){
							console.log(" .. ");
						}
					}, false, function() {
						if(globals.debugApp){
							console.log(" .. ");
						}
					});
				});
			}
		};
	}
}());