(function(){
	angular.module('connect.client.set')
	.factory('ClientSet', clientSetService);

	clientSetService.$inject = [];

	function clientSetService(){
		return {

		getRegistrationPrompt : function(){
			var registrationPrompt;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				registrationPrompt = tempObj.ClientSets ? tempObj.ClientSets['registration.prompt'] : null;
	      	}
	      	else{
				registrationPrompt = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['registration.prompt'] : null;
			}

			//return data requested
			if (!registrationPrompt || registrationPrompt == 0){
				return 0;
			}
			else{
				return parseInt(registrationPrompt);
			}
		},

		getRegistrationPromptHour : function(){
			var registrationPromptHour;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				registrationPromptHour = tempObj.ClientSets ? tempObj.ClientSets['registration.prompt.hour'] : null;

	      	}
	      	else{
				registrationPromptHour = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['registration.prompt.hour'] : null;
			}

			//return data requested
			if (!registrationPromptHour || registrationPromptHour == 0){
				return 0;
			}
			else{
				return parseInt(registrationPromptHour);
			}
		},

		getCompanyName : function(){
			var companyName;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				companyName = tempObj.ClientSets ? tempObj.ClientSets['companyname'] : null;
	      	}
	      	else{
				companyName = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['companyname'] : null;
			}			

			//return data requested
			if (!companyName || companyName == 0){
				return globals.Change.chain;
			}
			else{
				return companyName;
			}
		},

		getProductName : function(){
			var productName;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				productName = tempObj.ClientSets ? tempObj.ClientSets['productname'] : null;
	      	}
	      	else{
				productName = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['productname'] : null;
			}

			//return data requested
			if (!productName || productName == 0){
				return globals.Change.chain;
			}
			else{
				return productName;
			}
		},

		getShowGasPrice : function(){
			var showGasPrice

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showGasPrice = tempObj.ClientSets  ? tempObj.ClientSets['show.gasprice'] : null;
	      	}
	      	else{
				showGasPrice = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['show.gasprice'] : null;
			}

			if(globals.debugApp){
				console.log('DEBUG-CLIENTSETS: ShowGasPrice (should be 1 or 0) = ' + showGasPrice);
			}

			//return data requested
			if (!showGasPrice || showGasPrice == 0){
				return false;
			}
			else{
				return true;
			}
		},

		getLotteryState01 : function(){
			var showLotteryState;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showLotteryState = tempObj.ClientSets ? tempObj.ClientSets['lottery.state1.name'] : null;
	      	}
	      	else{
				showLotteryState = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['lottery.state1.name'] : null;
			}

			//return data requested
			if (!showLotteryState || showLotteryState == 0){
				return null;
			}
			else{
				return showLotteryState;
			}
		},

		getLotteryUrl01 : function(){
			var showLotteryUrl;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showLotteryUrl = tempObj.ClientSets ? tempObj.ClientSets['lottery.state1.url'] : null;
	      	}
	      	else{
				showLotteryUrl = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['lottery.state1.url'] : null;
			}

			//return data requested
			if (!showLotteryUrl || showLotteryUrl == 0){
				return null;
			}
			else{
				return showLotteryUrl;
			}
		},

		getLotteryState02 : function(){
			var showLotteryState;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showLotteryState = tempObj.ClientSets ? tempObj.ClientSets['lottery.state2.name'] : null;
	      	}
	      	else{
				showLotteryState = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['lottery.state2.name'] : null;
			}

			//return data requested
			if (!showLotteryState || showLotteryState == 0){
				return null;
			}
			else{
				return showLotteryState;
			}
		},

		getLotteryUrl02 : function(){
			var showLotteryUrl;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showLotteryUrl = tempObj.ClientSets ? tempObj.ClientSets['lottery.state2.url'] : null;}
	      	else{
				showLotteryUrl = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['lottery.state2.url'] : null;
			}

			if (!showLotteryUrl || showLotteryUrl == 0){
				return null;
			}
			else{
				return showLotteryUrl;
			}
		},

		getLotteryState03 : function(){
			var showLotteryState;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showLotteryState = tempObj.ClientSets ? tempObj.ClientSets['lottery.state3.name'] : null;
	      	}
	      	else{
				showLotteryState = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['lottery.state3.name'] : null;
			}
			
			//return data requested
			if (!showLotteryState || showLotteryState == 0){
				return null;
			}
			else{
				return showLotteryState;
			}
		},

		getLotteryUrl03 : function(){
			var lotteryUrl;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				lotteryUrl = tempObj.ClientSets ? tempObj.ClientSets['lottery.state3.url'] : null;
	      	}
	      	else{
				lotteryUrl = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['lottery.state3.url'] : null;
			}
			
			//return data requested
			if (!lotteryUrl || lotteryUrl == 0){
				return null;
			}
			else{
				return lotteryUrl;
			}
		},	

		getInterestTitle : function(){
			var interestTile ;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				interestTile = tempObj.ClientSets ? tempObj.ClientSets['interest.title'] : null;
	      	}
	      	else{
				interestTile = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['interest.title'] : null;
			}
			
			//return data requested
			if (!interestTile || interestTile == 0){
				return "Interests";
			}
			else{
				return interestTile;
			}
		},

		getInterestHeader : function(){
			var interestHeader;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				interestHeader = tempObj.ClientSets ? tempObj.ClientSets['interest.header'] : null;
	      	}
	      	else{
				interestHeader = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['interest.header'] : null;
			}
			
			//return data requested
			if (!interestHeader || interestHeader == 0){
				return 'Please select your Interests.  This helps customize your experience.';
			}
			else{
				return interestHeader;
			}
		},

		getInterestMax : function(){
			var interestMax;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				interestMax = tempObj.ClientSets ? tempObj.ClientSets['interest.max'] : null;
	      	}
	      	else{
				interestMax = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['interest.max'] : null;
			}

			//return data requested
			if (!interestMax || interestMax == 0){
				return 1000;
			}
			else{
				return parseInt(interestMax);
			}
		},

		getInterestOverMax : function(){
			var interestOverMax;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				var cs = tempObj.ClientSets ? tempObj.ClientSets: null;
				interestOverMax = cs ? cs['interest.overmax'] : null;
	      	}
	      	else{
				var cs = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets')) : null;
				interestOverMax = cs ? cs['interest.overmax'] : null;
			}

			//return data requested
			if (!interestOverMax || interestOverMax == 0){
				return 'Please select no more than ' + cs['interest.max'] + ' interests.';
			}
			else{
				return interestOverMax;
			}
		},


		getGameTitle : function(){
			var gameTitle;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				gameTitle = tempObj.ClientSets ? tempObj.ClientSets['game.title'] : null;
	      	}
	      	else{
				gameTitle = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['game.title'] : null;
			}

			//return data requested
			if (!gameTitle || gameTitle == 0){
				return '';
			}
			else{
				return gameTitle;
			}
		},

		getGameValueOne : function(){
			var gameValueOne;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				gameValueOne = tempObj.ClientSets ? tempObj.ClientSets['game.value01'] : null;
	      	}
	      	else{
				gameValueOne = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['game.value01'] : null;
			}

			//return data requested
			if (!gameValueOne || gameValueOne == 0){
				return '1,2,3,4,5,6,7,10';
			}
			else{
				return gameValueOne;
			}
		},

		getShowStoreCall : function(){
			var showStoreCall;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showStoreCall = tempObj.ClientSets ? tempObj.ClientSets['show.store.call'] : null;
	      	}
	      	else{
				showStoreCall = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['show.store.call'] : null;
			}

			//return data requested
			if (!showStoreCall || showStoreCall == 0){
				return false;
			}
			else{
				return true;
			}
		},

		getRegisterFieldBirthday : function(){
			var registerFieldBirthday;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				registerFieldBirthday = tempObj.ClientSets ? tempObj.ClientSets['register.field.birthday'] : null;
	      	}
	      	else{
				registerFieldBirthday = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['register.field.birthday'] : null;
			}

			//return data requested
			if (!registerFieldBirthday || registerFieldBirthday == 0){
				return 'Birthday Club';
			}
			else{
				return registerFieldBirthday;
			}
		},

		getSocialShareTitle : function(){
			var socialShareTitle;


			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				socialShareTitle = tempObj.ClientSets ? tempObj.ClientSets['social.share.title'] : null;
			}
	      	else{
				socialShareTitle = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['social.share.title'] : null;
			}

			//return data requested
			if (!socialShareTitle || socialShareTitle == 0){
				return null;
			}
			else{
				return socialShareTitle;
			}
		},

		getSocialShareMessage : function(){
			var socialShareMessage;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				socialShareMessage = tempObj.ClientSets ? tempObj.ClientSets['social.share.message'] : null;
			}
	      	else{
				socialShareMessage = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['social.share.message'] : null;
			}

			//return data requested
			if (!socialShareMessage || socialShareMessage == 0){
				return null;
			}
			else{
				return socialShareMessage;
			}
		},

		getSocialShareURL : function(){
			var socialShareURL;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				socialShareURL = tempObj.ClientSets ? tempObj.ClientSets['social.share.url'] : null;
			}
	      	else{
				socialShareURL = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['social.share.url'] : null;
			}

			//return data requested
			if (!socialShareURL || socialShareURL == 0){
				return '';
			}
			else{
				return socialShareURL;
			}
		},

		getCheckinGPSEnable : function(){
			var checkinGPSEnable;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				checkinGPSEnable = tempObj.ClientSets  ? tempObj.ClientSets['checkin.gps.enable'] : null;
			}
	      	else{
				checkinGPSEnable = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['checkin.gps.enable'] : null;
			}

			//return data requested
			if (!checkinGPSEnable || checkinGPSEnable == 0){
				return false;
			}
			else{
				return true;
			}
		},

		getCheckinGPSMaxAccuracy : function(){
			var checkinGPSMaxAccuracy;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				checkinGPSMaxAccuracy = tempObj.ClientSets ? tempObj.ClientSets['checkin.gps.maxaccuracy'] : null;			
			}
	      	else{
				checkinGPSMaxAccuracy = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['checkin.gps.maxaccuracy'] : null;
			}

			//return data requested
			if (!checkinGPSMaxAccuracy || checkinGPSMaxAccuracy == 0){
				return 1500;
			}
			else{
				return parseInt(checkinGPSMaxAccuracy);
			}
		},

		getCheckinGPSMaxDistance : function(){
			var checkinGPSMaxDistance;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				checkinGPSMaxDistance = tempObj.ClientSets ? tempObj.ClientSets['checkin.gps.maxdistance'] : null;			
			}
	      	else{
				checkinGPSMaxDistance = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['checkin.gps.maxdistance'] : null;
			}

			//return data requested
			if (!checkinGPSMaxDistance || checkinGPSMaxDistance == 0){
				return 500;
			}
			else{
				return parseInt(checkinGPSMaxDistance);
			}
		},

		getSurvey : function(){
			var cs;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				cs = tempObj.ClientSets ? tempObj.ClientSets : null;		
			}
	      	else{
				cs = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets')) : null;
			}


			var question = cs ? cs['survey.question'] : null;
			if (!question){
				question = '';
			}
			var answerone = cs ? cs['survey.answer.one'] : null;
			if (!answerone){
				answerone = '';
			}
			var answeronecolor = cs ? cs['survey.answer.one.color'] : null;
			if (!answeronecolor){
				answeronecolor = '';
			}
			var answertwo = cs ? cs['survey.answer.two'] : null;
			if (!answertwo){
				answertwo = '';
			}
			var answertwocolor = cs ? cs['survey.answer.two.color'] : null;
			if (!answertwocolor){
				answertwocolor = '';
			}
			var answerthree = cs ? cs['survey.answer.three'] : null;
			if (!answerthree){
				answerthree = '';
			}
			var answerthreecolor = cs ? cs['survey.answer.three.color'] : null;
			if (!answerthreecolor){
				answerthreecolor = '';
			}
			var answerfour = cs ? cs['survey.answer.four'] : null;
			if (!answerfour){
				answerfour = '';
			}
			var answerfourcolor = cs ? cs['survey.answer.four.color'] : null;
			if (!answerfourcolor){
				answerfourcolor = '';
			}

			return {
				Question : question,
				AnswerOne: answerone,
				AnswerOneColor: answeronecolor,
				AnswerTwo: answertwo,
				AnswerTwoColor: answertwocolor,
				AnswerThree: answerthree,
				AnswerThreeColor: answerthreecolor,
				AnswerFour: answerfour,
				AnswerFourColor: answerfourcolor
			};
		},

		getStates : function(){
			var states;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				states = tempObj.ClientSets ? tempObj.ClientSets['states'] : null;		
			}
	      	else{
				states = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['states'] : null;
			}

			//return data requested
			if (!states || states == 0){
				return null;
			}
			else{
				return states.split(',');
			}
		},

		getFasCash : function(){
			var fascash;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				fascash = tempObj.ClientSets ? tempObj.ClientSets['fascash'] : null;		
			}
	      	else{
				fascash = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['fascash'] : null;
			}

			//return data requested
			if (!fascash || fascash == 0){
				return 0;
			}
			else{
				return parseInt(fascash);
			}
		},

		getACHSubmitURL : function(){
			var achsubmiturl;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				achsubmiturl = tempObj.ClientSets ? tempObj.ClientSets['ach.submit.url'] : null;		
			}
	      	else{
				achsubmiturl = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['ach.submit.url'] : null;
			}

			//return data requested
			if (!achsubmiturl || achsubmiturl == 0){
				return null;
			}
			else{
				return achsubmiturl;
			}
		},

		getACHMerchantID : function(){
			var achmerchantid;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				achmerchantid = tempObj.ClientSets ? tempObj.ClientSets['ach.merchantid'] : null;		
			}
	      	else{
				achmerchantid = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['ach.merchantid'] : null;
			}

			//return data requested
			if (!achmerchantid || achmerchantid == 0){
				return null;
			}
			else{
				return achmerchantid;
			}
		},

		getGameHide : function(){
			var gamehide;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				gamehide = tempObj.ClientSets ? tempObj.ClientSets['game.hide'] : null;		
			}
	      	else{
				gamehide = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['game.hide'] : null;
			}

			//return data requested
			if (!gamehide || gamehide == 0){
				return 0;
			}
			else{
				return parseInt(gamehide);
			}
		},

		getShowPush : function(){
			var nowpush;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowpush = tempObj.ClientSets ? tempObj.ClientSets['now.push'] : null;		
			}
	      	else{
				nowpush = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.push'] : null;
			}

			//return data requested
			if (!nowpush || nowpush == 0){
				return 0;
			}
			else{
				return parseInt(nowpush);
			}
		},

		getShowTrivia : function(){
			var nowtrivia;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowtrivia = tempObj.ClientSets ? tempObj.ClientSets['now.trivia'] : null;		
			}
	      	else{
				nowtrivia = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.trivia'] : null;
			}

			//return data requested
			if (!nowtrivia || nowtrivia == 0){
				return 0;
			}
			else{
				return parseInt(nowtrivia);
			}
		},

		getShowMap : function(){
			var nowmap;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowmap = tempObj.ClientSets ? tempObj.ClientSets['now.map'] : null;		
			}
	      	else{
				nowmap = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.map'] : null;
			}

			//return data requested
			if (!nowmap || nowmap == 0){
				return 0;
			}
			else{
				return parseInt(nowmap);
			}
		},

		getShowCheckIn : function(){
			var nowcheckin;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowcheckin = tempObj.ClientSets ? tempObj.ClientSets['now.checkin'] : null;	
			}
	      	else{
				nowcheckin = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.checkin'] : null;
			}

			//return data requested
			if (!nowcheckin || nowcheckin == 0){
				return 0;
			}
			else{
				return parseInt(nowcheckin);
			}
		},

		getShowGame : function(){
			var nowgame;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowgame = tempObj.ClientSets ? tempObj.ClientSets['now.game'] : null;
			}
	      	else{
				nowgame = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.game'] : null;
			}

			if(!nowgame){
				console.log('getShowGame in clientsets equals ' + nowgame);
			}

			//return data requested
			if (!nowgame || nowgame == 0){
				return 0;
			}
			else{
				return parseInt(nowgame);
			}
		},

		getShowRating : function(){
			var nowrating;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowrating = tempObj.ClientSets ? tempObj.ClientSets['now.rating'] : null;
			}
	      	else{
				nowrating = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.rating'] : null;
			}

			//return data requested
			if (!nowrating || nowrating == 0){
				return 0;
			}
			else{
				return parseInt(nowrating);
			}
		},

		getShowShare : function(){
			var nowshare;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowshare = tempObj.ClientSets ? tempObj.ClientSets['now.share'] : null;
			}
	      	else{
				nowshare = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.share'] : null;
			}

			//return data requested
			if (!nowshare || nowshare == 0){
				return 0;
			}
			else{
				return parseInt(nowshare);
			}
		},

		getShowFocusPromo : function(){
			var nowfocus;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowfocus = tempObj.ClientSets ? tempObj.ClientSets['now.focus.promo'] : null;
			}
	      	else{
				nowfocus = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.focus.promo'] : null;
			}

			//return data requested
			if (!nowfocus || nowfocus == 0){
				return 0;
			}
			else{
				return parseInt(nowfocus);
			}
		},

		getGameVersion : function(){
			var gameversion;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				gameversion = tempObj.ClientSets ? tempObj.ClientSets['game.version'] : null;
			}
	      	else{
				gameversion = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['game.version'] : null;
			}

			//return data requested
			if (!gameversion || gameversion == 0){
				return 0;
			}
			else{
				return gameversion;
			}
		},

		getKickbackURL : function(){
			var kickbackUrl;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackUrl = tempObj.ClientSets ? tempObj.ClientSets['kickback.url'] : null;
			}
	      	else{
				kickbackUrl = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.url'] : null;
			}

			//return data requested
			return kickbackUrl;
		},

		getKickbackPass : function(){
			var kickbackPass;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackPass = tempObj.ClientSets ? tempObj.ClientSets['kickback.pass'] : null;
			}
	      	else{
				kickbackPass = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.pass'] : null;
			}

			//return data requested
			return kickbackPass;
		},

		getKickbackUser : function(){
			var kickbackUser;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackUser = tempObj.ClientSets ? tempObj.ClientSets['kickback.user'] : null;
			}
	      	else{
				kickbackUser = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.user'] : null;
			}

			//return data requested
			return kickbackUser;
		},

		getKickbackImage : function(){
			return globals.Change.kickbackImage;
		},

		getKBGamePoker : function(){
			var kickbackGamePoker;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackGamePoker = tempObj.ClientSets ? tempObj.ClientSets['kickback.game.poker'] : null;
			}
	      	else{
				kickbackGamePoker = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.game.poker'] : null;
			}

			//return data requested
			if (!kickbackGamePoker || kickbackGamePoker == 0){
				return 0;
			}
			else{
				return parseInt(kickbackGamePoker);
			}
		},

		getKBGameFootball : function(){
			var kickbackGameFootball;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackGameFootball = tempObj.ClientSets ? tempObj.ClientSets['kickback.game.football'] : null;
			}
	      	else{
				kickbackGameFootball = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.game.football'] : null;
			}

			//return data requested
			if (!kickbackGameFootball || kickbackGameFootball == 0){
				return 0;
			}
			else{
				return parseInt(kickbackGameFootball);
			}
		},

		getKBGameTitle : function(){
			var kickbackGameName;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackGameName = tempObj.ClientSets ? tempObj.ClientSets['kickback.game.title'] : null;			
			}
	      	else{
				kickbackGameName = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.game.title'] : null;
			}

			//return data requested
			return kickbackGameName;
		},

		getKBGameURL : function(){
			var kickbackGameURL;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackGameURL = tempObj.ClientSets ? tempObj.ClientSets['kickback.game.url'] : null;
			}
	      	else{
				kickbackGameURL = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.game.url'] : null;
			}

			//return data requested
			return kickbackGameURL;
		},

		getKBGameHide : function(){
			var KBGameHide;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				KBGameHide = tempObj.ClientSets ? tempObj.ClientSets['kickback.game.hide'] : null;			
			}
	      	else{
				KBGameHide = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.game.hide'] : null;
			}

			//return data requested
			if (!KBGameHide || KBGameHide == 0){
				return 0;
			}
			else{
				return parseInt(KBGameHide);
			}
		},

		getElectrumURL : function(){
			var electrumurl;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrumurl = tempObj.ClientSets ? tempObj.ClientSets['electrum.url'] : null;		
			}
	      	else{
				electrumurl = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.url'] : null;
			}

			//return data requested
			return electrumurl;
		},

		getElectrumAppID : function(){
			var electrumappid;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrumappid = tempObj.ClientSets ? tempObj.ClientSets['electrum.appid'] : null;		
			}
	      	else{
				electrumappid = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.appid'] : null;
			}

			//return data requested
			return electrumappid;
		},

		getElectrumPoints : function(){
			var electrumpoints;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrumpoints = tempObj.ClientSets ? tempObj.ClientSets['electrum.points'] : null;		
			}
	      	else{
				electrumpoints = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.points'] : null;
			}

			//return data requested
			if (electrumpoints){
				return parseInt(electrumpoints);
			}
			else{
				return 0;
			}
		},

		getElectrumServerErr : function(){
			var electrumservererr;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrumservererr = tempObj.ClientSets ? tempObj.ClientSets['electrum.servererr'] : null;	
			}
	      	else{
				electrumservererr = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.servererr'] : null;
			}

			//return data requested
			if (electrumservererr){
				return electrumservererr;
			}
			else{
				return "We're sorry but we are unable to contact the server at this time. Please check your Internet connection.";
			}
		},

		getElectrumNow47 : function(){
			var electrumnow;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrumnow = tempObj.ClientSets ? tempObj.ClientSets['electrum.now.47'] : null;
			}
	      	else{
				electrumnow = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.now.47'] : null;
			}

			//return data requested
			return electrumnow;
		},

		getElectrumMenu47 : function(){
			var electrummenu;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrummenu = tempObj.ClientSets ? tempObj.ClientSets['electrum.menu.47'] : null;
			}
	      	else{
				electrummenu = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.menu.47'] : null;
			}

			//return data requested
			return electrummenu;
		},

		getElectrumMenuMain : function(){
			var electrummenumain;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrummenumain = tempObj.ClientSets ? tempObj.ClientSets['electrum.menu.main'] : null;			
			}
	      	else{
				electrummenumain = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.menu.main'] : null;
			}

			//return data requested
			return electrummenumain;
		},

		getElectrumOptions: function(){
			var enrolled = false;

			if( getElectrumUniqueID() ){
				enrolled = true;
			}

			//var enrolled = 'Electrum.Unique.ID'in localStorage;
			var electrumoptions = [];
			var electrumtrans;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrumtrans = tempObj.ClientSets ? tempObj.ClientSets['electrum.trans'] : null;		
			}
	      	else{
				electrumtrans = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.trans'] : null;
			}

			//return data requested
			if (electrumtrans){
				electrumtrans = electrumtrans.split(',');
				for (var i = 0; i < electrumtrans.length; i++){
					if ((enrolled && electrumtrans[i] != 44) || (!enrolled && electrumtrans[i] == 44)){
						var electrumtranstext = tempObj.ClientSets ? tempObj.ClientSets['electrum.trans.' + electrumtrans[i]] : null;

						if (electrumtranstext){
							electrumoptions.push({
								TranCode: electrumtrans[i],
								Text: electrumtranstext
							});
						}
					}
				}
			}
			return electrumoptions;
		},
		
		getRadiusActive : function(){
			var radiusactive;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				radiusactive = tempObj.ClientSets ? tempObj.ClientSets['radius.active'] : null;			
			}
	      	else{
				radiusactive = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['radius.active'] : null;
			}

			//return data requested
			if (radiusactive || radiusactive == 0){
				return parseInt(radiusactive);
			}
			else{
				return 0;
			}
		},

		//TODO: Move this to appropiate KB module
		//This method uses no local storage
		getPunchCardImage : function(id, label){
			var image;

			if(globals.debugApp){
				console.log('KICKBACK-DEBUG: Getting ' + label + ' image with punchcard id: ' + id);
			}

			//Add these mentos.png , naturevalley.png, orbit.png, skins.png
			if(id == 3){
				image = 'images/kickback-Clubs/coffee.png';
			}
			else if(id == 35){
				image = 'images/kickback-Clubs/minutemaid.png';
			}
			else if(id == 43){
				image = 'images/kickback-Clubs/yupmilk.png';
			}
			else if(id == 47){
				image = 'images/kickback-Clubs/mentos.png';
			}
			else if(id == 45){
				image = 'images/kickback-Clubs/magnumbar.png';
			}
			else if(id == 41){
				image = 'images/kickback-Clubs/grannygreens.png';
			}
			else if(id == 29){
				image = 'images/kickback-Clubs/5hrenergy.png';
			}
			else if(id == 37){
				image = 'images/kickback-Clubs/bonappetit.png';
			}
			else if(id == 55){
				image = 'images/kickback-Clubs/doritoslaysmall.png';
			}
			else if(id == 31){
				image = 'images/kickback-Clubs/powerade32.png';
			}
			else if(id == 39){
				image = 'images/kickback-Clubs/fantabottles.png';
			}
			else if(id == 5){
				image = 'images/kickback-Clubs/fountaindrink.png';
			}
			else if(id == 9){
				image = 'images/kickback-Clubs/maolamilkgallon.png';
			}
			else if(id == 11){
				image = 'images/kickback-Clubs/frozendrinks.png';
			}
			else if(id == 19){
				image = 'images/kickback-Clubs/snickers.png';
			}
			else if(id == 21){
				image = 'images/kickback-Clubs/m&m.png';
			}
			else if(id == 23){
				image = 'images/kickback-Clubs/monsterjava.png';
			}
			else if(id == 25){
				image = 'images/kickback-Clubs/monsterultra.png';
			}
			else if(id == 33){
				image = 'images/kickback-Clubs/hersheys.png';
			}
			else if(id == 57){
				image = 'images/kickback-Clubs/doritoslaysmall.png';
			}
			else if(id == 99){
				image = 'images/kickback-Clubs/naturevalley.png';
			}
			else if(id == 115){
				image = 'images/kickback-Clubs/orbit.png';
			}
			else if(id == 141){
				image = 'images/kickback-Clubs/goodys.png';
			}
			else if(id == 167){
				image = 'images/kickback-Clubs/squatch.png';
			}
			else if(id == 169){
				image = 'images/kickback-Clubs/monster.png';
			}
			else{
				image = 'images/kickback-Clubs/placeholder.png';
			}
			//continue with else if's - if more images are needed

			return image;
		}

		};
	}
})();