(function () {
	angular.module('connect.app').factory('connectAppFooterService', connectAppFooterService);
	connectAppFooterService.$inject = ['$rootScope'];

	function connectAppFooterService($rootScope) {
		var service = {
			navIcons: []
		};

		$rootScope.$on('connect:ready', initialize);

		return service;

		function initialize() {
			service.navIcons.push({
				click: null,
				href: '#main',
				icon: 'fa-home',
				selected: true,
				navText: 'Home'
			});

			if ($rootScope.kickbackEnabled) {
				service.navIcons.push({
					click: null,
					href: '#kickbackRewards',
					icon: 'fa-trophy',
					selected: false,
					navText: 'Rewards'
				});
			} else if ($rootScope.enableElectrum) {
				service.navIcons.push({
					click: null,
					href: '#electrum',
					icon: 'fa-credit-card',
					selected: false,
					navText: 'Loyalty'
				});
			} else if ($rootScope.showGame) {
				service.navIcons.push({
					click: $rootScope.Game,
					href: '#game',
					icon: 'fa-gamepad',
					selected: false,
					navText: 'Win'
				});
			} else {
				service.navIcons.push({
					click: null,
					href: '#feedbackprompt',
					icon: 'fa-comment',
					selected: false,
					navText: 'Feedback'
				});
			}

			service.navIcons.push({
				click: null,
				href: '#promos',
				icon: 'fa-shopping-cart',
				selected: false,
				navText: 'Specials'
			});

			service.navIcons.push({
				click: null,
				href: '#stores',
				icon: 'fa-location-arrow',
				selected: false,
				navText: 'Locations'
			});

			service.navIcons.push({
				click: null,
				href: '#settings',
				icon: 'fa-bars',
				selected: false,
				navText: 'More'
			});
		}
	}
} ());