(function() {
	angular.module('connect.oldelectrum.page')
		.directive('oldelectrumPage', electrumPageDirective)
		.controller('ElectrumNavigationController', electrumNavigationController);

	electrumPageDirective.$inject = [];

	electrumNavigationController.$inject = ['$scope', '$rootScope', '$timeout', 'Loading', 'ClientSet'];

	function electrumPageDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'electrum/electrumPage/connect.electrum.page.html',
			link: link
		};
		return directive;

		function link(scope, element, attrs) {}
	}

	function electrumNavigationController($scope, $rootScope, $timeout, Loading, ClientSet) {

		if (Change.electrumImage) {
			$rootScope.ElectrumImage = Change.electrumImage;
		}

		Loading.then(function() {
			$timeout(function(){
				$rootScope.ElectrumOptions = ClientSet.getElectrumOptions();
			},1);
		});

		$('#electrum').on('pageinit', function() {
			$("#ElectrumMain #electrumContent").css('width', $(window).width() );
			$("#ElectrumMain #electrumWrapper").css('width', $(window).width() );
			$("#ElectrumMain #electrumNavigationControlGroup").css('width', $(window).width() );
			$("#ElectrumMain #electrumContent").css('height', $(window).height() - $('#ElectrumMain .ui-header').height() - $('#ElectrumMain .ui-footer').height()  );
			$("#ElectrumMain #electrumBarcodeImage").css('width', $(window).width() - 30 );
			$("#ElectrumMain #electrumBarcodeImage").css('margin-right', '4px' );
			$("#ElectrumMain #electrumNavigationControlGroup .ui-btn").css('margin-right',  $(window).width() * .125 );
			$("#ElectrumMain #electrumBarcodeImage").css('padding-bottom', '16px' );
			$("#ElectrumMain #electrumBarcodeImage").css('padding-top', '3px' );

			$('#ElectrumMain #storesLoading').hide();
		});
		

		var frame = document.getElementById('electrumIframe');

		$scope.ElectrumRequest = function(trancode, text) {
			$rootScope.electrumTranCode = trancode;
			if (!$rootScope.Latitude) {
				$rootScope.Latitude = 0;
			}
			if (!$rootScope.Longitude) {
				$rootScope.Longitude = 0;
			}
			var DeviceType;
			if (window.device.platform == 'Android') {
				DeviceType = 1;
			} else {
				DeviceType = 0;
			}

			$rootScope.ElectrumRequestPayload = '%3Cpayload%3E%3CRequest%3E%3CApplicationId%3E' + $rootScope.electrumAppID + '%3C%2FApplicationId%3E%3CTranCodeId%3E' + trancode + '%3C%2FTranCodeId%3E%3CValue%3E%3C%2FValue%3E%3CUniqueId%3E' + getElectrumUniqueID() + '%3C%2FUniqueId%3E%3CDevice%3E%3CAccountId%3E' + decryptAccountID() + '%3C%2FAccountId%3E%3CGPSCoord%3E' + $rootScope.Latitude + '%2C' + $rootScope.Longitude + '%3C%2FGPSCoord%3E%3CDeviceType%3E' + DeviceType + '%3C%2FDeviceType%3E%3C%2FDevice%3E%3C%2FRequest%3E%3C%2Fpayload%3E';
			$rootScope.electrumOption = text;
			
			if (window.device.platform == 'Android') {
				var options = {
					label : "Loading Content",
					timeout: 60
				};
			} else {
				var options = {
					label : "Loading Content",
					color: '#000',
					spinnerColor: '#000',
					timeout: 60
				};
			}
			
			window.wizSpinner.show(options); 

			console.log("electrumURL : " + $rootScope.electrumURL);

			var frame = document.getElementById('electrumIframe');
			frame.src = $rootScope.electrumURL;

			frame.onload = function() {

				setTimeout(function() { 
					var iframe = document.getElementById('electrumIframe');
					iframe.contentWindow.scrollTo(0,0);
					console.log("content height adjusted");
				}, 100);

				$('#electContent').css('top', 0);
				frame.contentWindow.Ready($rootScope.ElectrumRequestPayload);
			}

			setTimeout(function() {
				$.mobile.changePage('#electrumIframePage');
				console.log("Loading electrumIframePage");
			}, 100);
		};
	}
})();


//end