(function () {
	angular.module('connect.electrum-rewards').factory('ElectrumRegistrationUser', ElectrumRegistrationUserModel);

	ElectrumRegistrationUserModel.$inject = [];
	function ElectrumRegistrationUserModel() {
		/**
		 * @class electrumRegistrationUser
		 * @description electrumRegistrationUser is the user for electrum that contains all the data needed for registration and user info
		 * @constructor
		 */
		function ElectrumRegistrationUser(electrumRegistrationUser) {
			if(!electrumRegistrationUser || typeof electrumRegistrationUser !== 'object') {
				throw 'Cannot create new ElectrumRegistrationUser: You must pass in a electrum user, to create a new ElectrumRegistrationUser pass in an empty object {}';
			}
			this.FirstName = electrumRegistrationUser.FirstName;
			this.LastName = electrumRegistrationUser.LastName;
			this.cardnumber = electrumRegistrationUser.cardnumber;
			this.PIN = electrumRegistrationUser.PIN;
			this.BirthDate = electrumRegistrationUser.BirthDate;
			this.Prefix = electrumRegistrationUser.Prefix;
			this.MiddleName = electrumRegistrationUser.MiddleName;
			this.Address1 = electrumRegistrationUser.Address1;
			this.Address2 = electrumRegistrationUser.Address2;
			this.City = electrumRegistrationUser.City;
			this.State = electrumRegistrationUser.state;
			this.Zip = electrumRegistrationUser.Zip;
			this.Country = electrumRegistrationUser.country;
			this.phone = electrumRegistrationUser.phone;
			this.mobile = electrumRegistrationUser.mobile;
			this.Email = electrumRegistrationUser.Email;

			this.mobile = electrumRegistrationUser.mobile;
			
			/* Secure Information */
			this.MothersMaiden = electrumRegistrationUser.MothersMaiden;
			this.security1_id = electrumRegistrationUser.security1_id;
			this.security1_answer = electrumRegistrationUser.security1_answer;
			this.security2_id = electrumRegistrationUser.security2_id;
			this.security2_answer = electrumRegistrationUser.security2_answer;
			this.flag1 = electrumRegistrationUser.flag1;
			this.DriversLicense = electrumRegistrationUser.DriversLicense;
			
			this.gender = electrumRegistrationUser.gender;
			
			/* Used by electrum, not needed for the App */
			this.LocationEnrolled = electrumRegistrationUser.LocationEnrolled;

			if(this.BirthDate === null || this.BirthDate === ''){
				this.BirthDate = '00-00-0000';
			}
		}
		
		ElectrumRegistrationUser.prototype.removePersonalData = removePersonalData;
		ElectrumRegistrationUser.prototype.removeAddress = removeAddress;
		
		return ElectrumRegistrationUser;
		
		function removePersonalData() {
			this.MothersMaiden = null;
			this.BirthDate = null;
			this.security1_id = null;
			this.security1_answer = null;
			this.security2_id = null;
			this.security2_answer = null;
			this.DriversLicense = null;
		}
		
		function removeAddress() {
			this.Address1 = null;
			this.Address2 = null;
			this.City = null;
			this.State = null;
			this.Zip = null;
			this.Country = null;
		}
	}
	
}());