(function(){
	angular.module('connect.electrum-rewards').directive('electrumRewards', electrumRewards);
	
	electrumRewards.$inject = [];
	electrumRewardsCtrl.$inject = ['$scope', '$timeout', 'electrumRewardsService', 'ClientSet'];
	
	function electrumRewards() {
		return {
			restrict: 'E',
			templateUrl: 'electrum-rewards/connect.electrum-rewards.html',
			controller: electrumRewardsCtrl,
			controllerAs: 'electrumRewardsCtrl'
		}
	}
	
	function electrumRewardsCtrl($scope,  $timeout, electrumRewardsService, ClientSet) {

		var vm = this;
		vm.goToSignIn = goToSignIn;
		vm.goToRegister = goToRegister;
		vm.showTerms = showTerms;
		vm.hideTerms = hideTerms;
		vm.refresh = refresh;

		setTimeout(function() {
			vm.electrumImage = globals.Change.electrumImage;
			$scope.Chain = globals.Change.chainFriendly;
			console.log('Electrum: initializing Rewards Ctrl for ' + $scope.Chain);
		}, 800);
		
		vm.electrumState = electrumRewardsService.getElectrumState();
		vm.settingsOpen = false;
		
		$scope.$on('electrum-settings:close', function() {
			vm.settingsOpen = false;
		});
		
		function goToSignIn() {
			vm.showSignIn = true;
			vm.showRegister = false;
		}
		
		function goToRegister() {
			vm.showSignIn = false;
			vm.showRegister = true;
		}
		
		function showTerms() {
			vm.termsOpen = true;
		}
		
		function hideTerms() {
			vm.termsOpen = false;
		}
		
		function refresh() {
			$scope.$broadcast('electrum-rewards:refresh');
		}
	}
}());