(function () {
	angular.module('connect.electrum-rewards').factory('ElectrumPunchCard', ElectrumPunchCardModel);

	ElectrumPunchCardModel.$inject = ['ClientSet'];
	function ElectrumPunchCardModel(ClientSet) {
		/**
		 * @class ElectrumPunchCard
		 * @description ElectrumPunchCard is the user for electrum that contains all the data needed for registration and user info
		 * @constructor
		 */
		function ElectrumPunchCard(electrumPunchCard) {
			if (!electrumPunchCard || typeof electrumPunchCard !== 'object') {
				debugger;
				throw 'Cannot create new ElectrumPunchCard: You must pass in a electrum user, to create a new ElectrumPunchCard pass in an empty object {}';
			}
			this.currentPunches = electrumPunchCard.currentPunches ? parseInt(electrumPunchCard.currentPunches) : 0;
			this.desc = electrumPunchCard.desc;
			this.id = electrumPunchCard.id;
			this.numberToGet = electrumPunchCard.numberToGet ? parseInt(electrumPunchCard.numberToGet) : 0;
			this.progressLine = electrumPunchCard.progressLine;

			console.log("electrum punch ID = " + this.id);
			console.log(this.id + ' - ' + ClientSet.getPunchCardImage(this.id) );
			//image selection based on id
			this.punchImage = ClientSet.getPunchCardImage(this.id);
			
			
			this.__defineGetter__('_progressPercent', function() {
				if(this.currentPunches === 0 || this.numberToGet === 0)
					return 0;
				return parseInt((this.currentPunches / this.numberToGet)*100);
			});
			
			this.__defineGetter__('_complete', function() {
				return this.currentPunches >= this.numberToGet;
			});
		}

		ElectrumPunchCard.prototype.$merge = $merge;

		return ElectrumPunchCard;
		
		/**
		 * @description allows for the bound angular object to keep bindings while updating data
		 */
		function $merge(electrumPunchCard) {
			this.currentPunches = electrumPunchCard.currentPunches;
		}
	}

} ());