(function () {
	angular.module('connect.electrum-rewards').factory('ElectrumReward', ElectrumRewardModel);

	ElectrumRewardModel.$inject = [];
	function ElectrumRewardModel() {
		/**
		 * @class electrumReward
		 * @description electrumReward is the user for electrum that contains all the data needed for registration and user info
		 * @constructor
		 */
		function ElectrumReward(electrumReward) {
			if (!electrumReward || typeof electrumReward !== 'object') {
				debugger;
				throw 'Cannot create new ElectrumReward: You must pass in a electrum user, to create a new ElectrumReward pass in an empty object {}';
			}

			this.uid = electrumReward.uid;
			this.group_id = electrumReward.group_id;
			this.combo_id = electrumReward.combo_id;
			this.category = electrumReward.category;
			this.label = electrumReward.label;
			this.messageBody = electrumReward.messageBody;
			this.codeType = electrumReward.codeType;
			this.code = electrumReward.code;
			this.dollarvalue = electrumReward.dollarvalue;
			this.pointvalue = electrumReward.pointvalue;
			this.expire_days = electrumReward.expire_days;
			this.count = electrumReward.count;
			this.expiresOn = electrumReward.expiresOn;
		}

		ElectrumReward.prototype.$merge = $merge;

		return ElectrumReward;
		
		/**
		 * @description allows for the bound angular object to keep bindings while updating data
		 */
		function $merge(electrumReward) {
			this.uid = electrumReward.uid;
			this.group_id = electrumReward.group_id;
			this.combo_id = electrumReward.combo_id;
			this.category = electrumReward.category;
			this.label = electrumReward.label;
			this.messageBody = electrumReward.messageBody;
			this.codeType = electrumReward.codeType;
			this.code = electrumReward.code;
			this.dollarvalue = electrumReward.dollarvalue;
			this.pointvalue = electrumReward.pointvalue;
			this.expire_days = electrumReward.expire_days;
			this.count = electrumReward.count;
			this.expiresOn = electrumReward.expiresOn;
		}
	}

} ());