(function () {
	angular.module('connect.electrum-rewards').factory('ElectrumUser', ElectrumUserModel);

	ElectrumUserModel.$inject = [];
	function ElectrumUserModel() {
		/**
		 * @class electrumUser
		 * @description electrumUser is the user for electrum that contains all the data needed for registration and user info
		 * @constructor
		 */
		function ElectrumUser(electrumUser) {

			
			if (!electrumUser || typeof electrumUser !== 'object') {
				debugger;
				throw 'Cannot create new electrumUser: You must pass in an electrum user, to create a new electrumUser pass in an empty object {}';
			}
			this.AccessTimes = electrumUser.AccessTimes;
			this.AccessedFrom = electrumUser.AccessedFrom;
			this.AccruedDollars = electrumUser.AccruedDollars;
			this.AccruedGallons = electrumUser.AccruedGallons;
			this.AccruedPoints = electrumUser.AccruedPoints;
			this.ActivationDate = electrumUser.ActivationDate;
			this.ActiveMember = electrumUser.ActiveMember;
			this.Address1 = electrumUser.Address1;
			this.Address2 = electrumUser.Address2;
			this.AnniversaryDate = electrumUser.AnniversaryDate;
			this.BirthDate = electrumUser.BirthDate;
			this.CancellationDate = electrumUser.CancellationDate;
			this.CardNumber = electrumUser.CardNumber;
			this.CardToTrack1 = electrumUser.CardToTrack1;
			this.City = electrumUser.City;
			this.Country = electrumUser.Country;
			this.Creation_Date = electrumUser.Creation_Date;
			this.DollarsRedeemed = electrumUser.DollarsRedeemed;
			this.DriversLicense = electrumUser.DriversLicense;
			this.Email = electrumUser.Email;
			this.Expiration = electrumUser.Expiration;
			this.FirstName = electrumUser.FirstName;
			this.FirstRedemptionDate = electrumUser.FirstRedemptionDate;
			this.FirstTrxCashier = electrumUser.FirstTrxCashier;
			this.FirstTrxDate = electrumUser.FirstTrxDate;
			this.FirstTrxLocation = electrumUser.FirstTrxLocation;
			this.GLocationID = electrumUser.GLocationID;
			this.LastName = electrumUser.LastName;
			this.LastPurchaseDate = electrumUser.LastPurchaseDate;
			this.LastRedemptionDate = electrumUser.LastRedemptionDate;
			this.LastTriggerDate = electrumUser.LastTriggerDate;
			this.LifeTimePoints = electrumUser.LifeTimePoints;
			this.LifetimeDollars = electrumUser.LifetimeDollars;
			this.LocationEnrolled = electrumUser.LocationEnrolled;
			this.MaxDollars = electrumUser.MaxDollars;
			this.MaxPoints = electrumUser.MaxPoints;
			this.MemLPI = electrumUser.MemLPI;
			this.MiddleName = electrumUser.MiddleName;
			this.MothersMaiden = electrumUser.MothersMaiden;
			this.Notes = electrumUser.Notes;
			this.NumberOfRedemptions = electrumUser.NumberOfRedemptions;
			this.PIN = electrumUser.PIN;
			this.ParentCardNumber = electrumUser.ParentCardNumber;
			this.ParentType = electrumUser.ParentType;
			this.PersonalInfoModifiedDate = electrumUser.PersonalInfoModifiedDate;
			this.PhoneSelected = electrumUser.PhoneSelected;
			this.Prefix = electrumUser.Prefix;
			this.PromoID = electrumUser.PromoID;
			this.SpouseBirthdate = electrumUser.SpouseBirthdate;
			this.State = electrumUser.State;
			this.TriggerGroup = electrumUser.TriggerGroup;
			this.Zip = electrumUser.Zip;
			this.cardnumber = electrumUser.cardnumber;//?why are there 2 card numbers? this one is null JK 10/28
			this.created_at = electrumUser.created_at;
			this.email_address = electrumUser.email_address;
			this.email_confirmation_token = electrumUser.email_confirmation_token;
			this.email_confirmed = electrumUser.email_confirmed;
			this.email_confirmed_at = electrumUser.email_confirmed_at;
			this.email_confirmed_on = electrumUser.email_confirmed_on;
			this.flag1 = electrumUser.flag1;
			this.gender = electrumUser.gender;
			this.is_onhold = electrumUser.is_onhold;
			this.maxpointsperday = electrumUser.maxpointsperday;
			this.maxtrxperday = electrumUser.maxtrxperday;
			this.memberGroup = electrumUser.memberGroup;
			this.message1 = electrumUser.message1;
			this.message2 = electrumUser.message2;
			this.message3 = electrumUser.message3;
			this.mobile = electrumUser.mobile;
			this.notes2 = electrumUser.notes2;
			this.phone = electrumUser.phone;
			this.security1_answer = electrumUser.security1_answer;
			this.security1_id = electrumUser.security1_id;
			this.security2_answer = electrumUser.security2_answer;
			this.security2_id = electrumUser.security2_id;
			this.updated_at = electrumUser.updated_at;

			if(this.BirthDate === null || this.BirthDate === ''){
				this.BirthDate = '00-00-0000';
			}
		}

		ElectrumUser.prototype.removePersonalData = removePersonalData;
		ElectrumUser.prototype.removeAddress = removeAddress;
		ElectrumUser.prototype.$merge = $merge;

		return ElectrumUser;

		function removePersonalData() {
			this.MothersMaiden = null;
			this.BirthDate = null;
			this.SpouseBirthdate = null;
			this.security1_id = null;
			this.security1_answer = null;
			this.security2_id = null;
			this.security2_answer = null;
			this.DriversLicense = null;
		}

		function removeAddress() {
			this.Address1 = null;
			this.Address2 = null;
			this.City = null;
			this.State = null;
			this.Zip = null;
			this.Country = null;
		}
			
	

		/**
		 * @description allows for the bound angular object to keep bindings while updating data
		 */
		 
		function $merge(electrumUser) {
			this.AccessTimes = electrumUser.AccessTimes;
			this.AccessedFrom = electrumUser.AccessedFrom;
			this.AccruedDollars = electrumUser.AccruedDollars;
			this.AccruedGallons = electrumUser.AccruedGallons;
			this.AccruedPoints = electrumUser.AccruedPoints;
			this.ActivationDate = electrumUser.ActivationDate;
			this.ActiveMember = electrumUser.ActiveMember;
			this.Address1 = electrumUser.Address1;
			this.Address2 = electrumUser.Address2;
			this.AnniversaryDate = electrumUser.AnniversaryDate;
			this.BirthDate = electrumUser.BirthDate;
			this.CancellationDate = electrumUser.CancellationDate;
			this.CardNumber = electrumUser.CardNumber;
			this.CardToTrack1 = electrumUser.CardToTrack1;
			this.City = electrumUser.City;
			this.Country = electrumUser.Country;
			this.Creation_Date = electrumUser.Creation_Date;
			this.DollarsRedeemed = electrumUser.DollarsRedeemed;
			this.DriversLicense = electrumUser.DriversLicense;
			this.Email = electrumUser.Email;
			this.Expiration = electrumUser.Expiration;
			this.FirstName = electrumUser.FirstName;
			this.FirstRedemptionDate = electrumUser.FirstRedemptionDate;
			this.FirstTrxCashier = electrumUser.FirstTrxCashier;
			this.FirstTrxDate = electrumUser.FirstTrxDate;
			this.FirstTrxLocation = electrumUser.FirstTrxLocation;
			this.GLocationID = electrumUser.GLocationID;
			this.LastName = electrumUser.LastName;
			this.LastPurchaseDate = electrumUser.LastPurchaseDate;
			this.LastRedemptionDate = electrumUser.LastRedemptionDate;
			this.LastTriggerDate = electrumUser.LastTriggerDate;
			this.LifeTimePoints = electrumUser.LifeTimePoints;
			this.LifetimeDollars = electrumUser.LifetimeDollars;
			this.LocationEnrolled = electrumUser.LocationEnrolled;
			this.MaxDollars = electrumUser.MaxDollars;
			this.MaxPoints = electrumUser.MaxPoints;
			this.MemLPI = electrumUser.MemLPI;
			this.MiddleName = electrumUser.MiddleName;
			this.MothersMaiden = electrumUser.MothersMaiden;
			this.Notes = electrumUser.Notes;
			this.NumberOfRedemptions = electrumUser.NumberOfRedemptions;
			this.PIN = electrumUser.PIN;
			this.ParentCardNumber = electrumUser.ParentCardNumber;
			this.ParentType = electrumUser.ParentType;
			this.PersonalInfoModifiedDate = electrumUser.PersonalInfoModifiedDate;
			this.PhoneSelected = electrumUser.PhoneSelected;
			this.Prefix = electrumUser.Prefix;
			this.PromoID = electrumUser.PromoID;
			this.SpouseBirthdate = electrumUser.SpouseBirthdate;
			this.State = electrumUser.State;
			this.TriggerGroup = electrumUser.TriggerGroup;
			this.Zip = electrumUser.Zip;
			this.cardnumber = electrumUser.cardnumber;//?why are there 2 card numbers? this one is null JK 10/28
			this.created_at = electrumUser.created_at;
			this.email_address = electrumUser.email_address;
			this.email_confirmation_token = electrumUser.email_confirmation_token;
			this.email_confirmed = electrumUser.email_confirmed;
			this.email_confirmed_at = electrumUser.email_confirmed_at;
			this.email_confirmed_on = electrumUser.email_confirmed_on;
			this.flag1 = electrumUser.flag1;
			this.gender = electrumUser.gender;
			this.is_onhold = electrumUser.is_onhold;
			this.maxpointsperday = electrumUser.maxpointsperday;
			this.maxtrxperday = electrumUser.maxtrxperday;
			this.memberGroup = electrumUser.memberGroup;
			this.message1 = electrumUser.message1;
			this.message2 = electrumUser.message2;
			this.message3 = electrumUser.message3;
			this.mobile = electrumUser.mobile;
			this.notes2 = electrumUser.notes2;
			this.phone = electrumUser.phone;
			this.security1_answer = electrumUser.security1_answer;
			this.security1_id = electrumUser.security1_id;
			this.security2_answer = electrumUser.security2_answer;
			this.security2_id = electrumUser.security2_id;
			this.updated_at = electrumUser.updated_at;

			if(this.BirthDate === null || this.BirthDate === ''){
				this.BirthDate = '00-00-0000';
			}
		}
		
	}
} ());



