(function () {
	angular.module('connect.electrum-rewards').directive('electrumPunchCards', electrumPunchCards);

	electrumPunchCards.$inject = [];
	electrumPunchCardsCtrl.$inject = ['$scope', '$timeout', 'electrumRewardsService'];

	function electrumPunchCards() {
		return {
			restrict: 'E',
			templateUrl: 'electrum-rewards/electrum-home/electrum-punch-cards/connect.electrum-rewards.electrum-punch-cards.html',
			scope: {
				cardNumber: '=',
				pin: '=',
				lastName: '='
			},
			link: function (scope, element, attrs) {

			},
			controller: electrumPunchCardsCtrl,
			controllerAs: 'electrumPunchCardsCtrl'
		}
	}

	function electrumPunchCardsCtrl($scope, $timeout, electrumRewardsService) {
		var vm = this;
		vm.punchCardsReady = false;

		$scope.$on('electrum-rewards:refresh', loadPunchCardStatus);

		setTimeout(function(){
			console.log('electrum-DEBUG: Loading Punch Card status in - electrumPunchCardsCtrl');
			loadPunchCardStatus();
		},1100);

		function loadPunchCardStatus() {
			vm.punchCardsReady = false;
			electrumRewardsService.getPunchStatus($scope.cardNumber, $scope.pin, $scope.lastName).then(function (punchCards) {
				vm.punchCards = punchCards;
				vm.punchCardsReady = true;
			}, function (err) {
				//we are making the assumtion that they are not verified
				vm.error = 'You are now Registered. Please restart app.'; // This msg used to warn the user to validate registration in their email, not anymore.
				setTimeout(function(){
					$scope.$broadcast('electrum-rewards:refresh');
				},250);
			});
		}
	}
} ());