(function () {
	angular.module('connect.kickback-rewards').directive('kickbackPunchCards', kickbackPunchCards);

	kickbackPunchCards.$inject = [];
	kickbackPunchCardsCtrl.$inject = ['$scope', '$timeout', 'kickbackRewardsService'];

	function kickbackPunchCards() {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/kickback-home/kickback-punch-cards/connect.kickback-rewards.kickback-punch-cards.html',
			scope: {
				cardNumber: '=',
				pin: '=',
				lastName: '='
			},
			link: function (scope, element, attrs) {

			},
			controller: kickbackPunchCardsCtrl,
			controllerAs: 'kickbackPunchCardsCtrl'
		}
	}

	function kickbackPunchCardsCtrl($scope, $timeout, kickbackRewardsService) {
		var vm = this;
		vm.punchCardsReady = false;

		$scope.$on('kickback-rewards:refresh', loadPunchCardStatus);

		setTimeout(function(){
			console.log('KICKBACK-DEBUG: Loading Punch Card status in - kickbackPunchCardsCtrl');
			loadPunchCardStatus();
		},1100);

		function loadPunchCardStatus() {
			vm.punchCardsReady = false;
			kickbackRewardsService.getPunchStatus($scope.cardNumber, $scope.pin, $scope.lastName).then(function (punchCards) {
				vm.punchCards = punchCards;
				vm.punchCardsReady = true;
			}, function (err) {
				//we are making the assumtion that they are not verified
				vm.error = 'You are now Registered. Please restart app.'; // This msg used to warn the user to validate registration in their email, not anymore.
				setTimeout(function(){
					$scope.$broadcast('kickback-rewards:refresh');
				},250);
			});
		}
	}
} ());