(function () {
	angular.module('connect.electrum-rewards').directive('electrumPunchCard', electrumPunchCard);

	electrumPunchCard.$inject = ['$timeout', '$rootScope'];


	function electrumPunchCard($timeout, $rootScope) {
		return {
			restrict: 'EA',
			templateUrl: 'electrum-rewards/electrum-home/electrum-punch-cards/electrum-punch-card/connect.electrum-rewards.electrum-punch-card.html',
			scope: {
				punchCard: '='
			},
			link: function (scope, element, attrs) {
				scope.selectPunchCard = selectPunchCard;
				scope.closePunchCard = closePunchCard;

				$rootScope.$on('electrum:select-punch-card', function (event, data) {
					if (scope.$id !== data.scopeId) {
						$(element).css('display', 'none').css('opacity', '0').css('margin-top', '25px');
					}
				});

				$rootScope.$on('electrum:close-punch-card', function (event, data) {
					if (scope.$id !== data.scopeId) {
						$(element).css('display', 'inline-block');
						$timeout(function () {
							$(element).css('opacity', '1').css('margin-top', '0px');
						}, 215);
					}
				});

				$timeout(function () {
					$(element).find('.progress-bar').progressbar({
						value: scope.punchCard._progressPercent
					});
				});

				function selectPunchCard() {
					if(scope.isOpen)
						return;
					scope.isOpen = true;
					
					$(element).addClass('open');
					$rootScope.$emit('electrum:select-punch-card', { scopeId: scope.$id });
				}

				function closePunchCard() {
					$(element).removeClass('open');
					$rootScope.$emit('electrum:close-punch-card', { scopeId: scope.$id });
					$timeout(function(){
						scope.isOpen = false;
						
					});
				}

			}
		}
	}
} ());