(function(){
	angular.module('connect.electrum-rewards').directive('electrumSignin', electrumSignin);
	
	electrumSignin.$inject = [];
	electrumSigninCtrl.$inject = ['$scope', 'electrumRewardsService'];
	
	function electrumSignin() {
		return {
			restrict: 'E',
			templateUrl: 'electrum-rewards/electrum-signin/connect.electrum-rewards.electrum-signin.html',
			scope: {
				goToRegister: '&',
				showTerms: '&'
			},
			controller: electrumSigninCtrl,
			controllerAs: 'electrumSigninCtrl'
		}
	}
	
	function electrumSigninCtrl($scope, electrumRewardsService) {

		$scope.Chain = globals.Change.chainFriendly;

		var vm = this;
		vm.electrumState = electrumRewardsService.getElectrumState();
		vm.signin = signin;
		
		vm.pin = null;
		vm.cardNumber = null;
		vm.lastName = null;
		
		function signin() {
			vm.submitted = true;
			vm.error = null;
			if($scope.signInForm.$invalid) {
				vm.error = "Please fill in all the fields";
				return;
			}
			if(!$scope.agreedToTerms) {
				vm.error = "You must agree to the terms";
				return;
			}

			console.log("Signing in with (cardnum, pin, last name): " + vm.cardNumber + ' / ' + vm.pin + ' / ' + vm.lastName);

			electrumRewardsService.signin(vm.cardNumber, vm.pin, vm.lastName).then(function(result){
				console.log(result);
			}, function(data) {
				console.log('ERROR: ' + data.message);
				vm.error = data.message;
			});
		}
		
	}
}());