(function() {
	angular.module('connect.electrum.iframe')
		.directive('electrumIframe', electrumIframeDirective)
		//TODO: change ElectrumController to correct format
		//.controller('electrumIframeController', electrumIframeController);
		.controller('ElectrumController', electrumIframeController);

	electrumIframeDirective.$inject = [];
	electrumIframeController.$inject = ['$scope', '$rootScope', '$timeout', 'ClientSet'];

	function electrumIframeDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'electrum/electrumIFramePage/connect.electrum.iframe.html',
			link: link
		};
		return directive;

		function link(scope, element, attrs) { }
	}

	function electrumIframeController($scope, $rootScope, $timeout, ClientSet) {

		
		var frame = document.getElementById('electrumIframe');

		$('#electrumIframePage').on('pagebeforeshow', function() {

			$("#electrumIframePage .ui-content").css('height', $(window).height() - $('#electrumIframePage .ui-header').height() - 50 );
			$("#electrumIframePage #electrumIframeWrapper").css('height', $('#electrumIframePage .ui-content').height() );
			$("#electrumIframePage #electrumIframe").css('height', $('#electrumIframePage .ui-content').height() );
			$("#electrumIframePage #electrumIframe").css('width', $(window).width() );

			console.log('Now connecting to URL - ' + $rootScope.ElectrumURL );

			var electrumCounter = 0;
			var electrumIframeInterval = setInterval(function() {
				if (electrumCounter == 60) {
					clearInterval(electrumIframeInterval);
					window.wizSpinner.hide();
					navigator.notification.alert(
						$rootScope.electrumServerErr, // message
						function() {
							$.mobile.changePage('#electrum');
						}, // callback
						'Error', // title
						'Ok' // buttonName
					);
				} else if (frame.contentWindow.document.body.innerHTML.replace(/(\r\n|\n|\r)/gm, "")) {
					clearInterval(electrumIframeInterval);
					window.wizSpinner.hide();
					console.log("Iframe loaded");
					
				} else {
					electrumCounter++;
				}
			}, 1000);
		});


		window.addEventListener("message", function(event) {

			if(globals.debugApp){
				console.log("Electrum Iframe 'Message' method fired.");
			}

			// alert('The value of Mobile_Host_Response is: ' + frame.contentWindow.Mobile_Host_Response);
			$("#electrumNavigationControlGroup .ui-btn").remove();

			var response = frame.contentWindow.Mobile_Host_Response;
			response = $($.parseXML(response));
			var uniqueID = response.find('UniqueId').text();
			var barcode = response.find('ACCT_NUM_IMAGE').text();
			var errorDescription = response.find('ErrorDescription').text();
			var errorNumber = response.find('ErrorNumber').text();

			if (uniqueID || barcode) {
				setElectrumUniqueID(uniqueID);
				setElectrumBarcode('data:image/x-ms-bmp;base64,' + barcode);
				saveLocalData();
				
				$timeout(function() {
					$rootScope.ElectrumOptions = ClientSet.getElectrumOptions();
					$rootScope.electrumBarcode = getElectrumBarcode();
					$('#electrum #storesLoading').show();

					$('#electrumIframePage').on('pagehide', function() {
						$("#electrumNavigationControlGroup a").button();
						$("#electrumNavigationControlGroup a").css('color', '#2f3e46');
						$("#electrumNavigationControlGroup").controlgroup("refresh");

						setTimeout(function(){
							$('#electrum #storesLoading').hide();
							//Save All Data to File
							SaveAppDataJson(); 
							if(globals.debugApp){
								console.log('Saving ELECTRUM DATA');
							}
						}, 60);
					});

				},100);
			}
			if (errorDescription) {
				navigator.notification.alert(
					errorDescription,
					function() {}, // callback
					'Error', // title
					'Ok' // buttonName
				);
				saveClientLog(90, 0, 0, '', 0, $rootScope.electrumTranCode + ', ' + errorNumber + ', ' + errorDescription);
			}
		}, false);

	}
})();