(function() {
	angular.module('connect.error').directive('connectError', connectError);

	connectError.$inject = [];
	connectErrorCtrl.$inject = ['$scope', '$rootScope', '$timeout'];

	function connectError() {
		var directive = {
			restrict: 'E',
			templateUrl: 'error/connect.error.html',
			controller: connectErrorCtrl
		}
	}


	function connectErrorCtrl($scope, $rootScope, $timeout) {

		$rootScope.Error = function(message, callback, cantryagain, tryagain) {
			$timeout(function() {
				$rootScope.ErrorMessage = message;
				$rootScope.CanTryAgain = cantryagain;
			}); //update the error screen error message and indicate if the user can try again (show try again option or not)
			$('#error').show();
			$('.errorImage').css('margin-top', ($(window).height() - $('.errorImage').height()) / 2 - $('.errorTextWrapper').height());
			$(".errorImage").animate({
				opacity: 1
			}, 2000);
			$('#error').addClass('slideInDown');

			$rootScope.Exit = function() {
				$('#error').addClass('slideOutUp');
				$('#error').hide();
				$('#error').removeClass('slideInDown');
				$(".errorImage").css('opacity', 0);
				$timeout(function() {
					callback();
				});
			}; //function for closing the error screen and calling the callback passed into the function

			$rootScope.TryAgain = function() {
				$('#error').addClass('slideOutUp');
				$('#error').hide();
				$('#error').removeClass('slideInDown');
				$timeout(function() {
					tryagain();
				});
			}; //function for closing screen and trying again (used in gameend)
		};
	}
}());