(function() {
	angular.module('connect.game.matchingGame')
		.directive('connectGameMatchingGame', connectGameMatchingGameDirective)
		.controller('connectGameMatchingGameController', connectGameMatchingGameController);

	connectGameMatchingGameDirective.$inject = [];
	connectGameMatchingGameController.$inject = ['$scope', '$rootScope', '$http', '$timeout', 'Loading', 'ClientSet'];

	function connectGameMatchingGameDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'game/matchinggame/connect.game.matchinggame.html',
			controller: 'connectGameMatchingGameController'
		};
		return directive;
	}

	function connectGameMatchingGameController($scope, $rootScope, $http, $timeout, Loading, ClientSet) {
		var insufficientPlays = false;

		function gameAssetsReady() {

			if(globals.debugApp){
				console.log('Game Assets ready??  -  ' + getGameCard('bg1.png') != null && getGameCard('cardfront.png') != null && getGameCard('cardback.png') != null && getGameCard('cardfrontmatch.png') != null && getGameCard('promo.png') != null && getGameCard('1.png') != null && getGameCard('2.png') != null && getGameCard('3.png') != null && getGameCard('4.png') != null && getGameCard('5.png') != null && getGameCard('6.png') != null && getGameCard('7.png') != null && getGameCard('8.png') != null );
			}

			return getGameCard('bg1.png') != null && getGameCard('cardfront.png') != null && getGameCard('cardback.png') != null && getGameCard('cardfrontmatch.png') != null && getGameCard('promo.png') != null && getGameCard('1.png') != null && getGameCard('2.png') != null && getGameCard('3.png') != null && getGameCard('4.png') != null && getGameCard('5.png') != null && getGameCard('6.png') != null && getGameCard('7.png') != null && getGameCard('8.png') != null;
		}

		var gameReady = false;

		function updateGameAssets($rootScope, version) {
			storeImage('bg1.png');
			storeImage('cardfront.png');
			storeImage('cardback.png');
			storeImage('cardfrontmatch.png');
			storeImage('promo.png');
			storeImage('1.png');
			storeImage('2.png');
			storeImage('3.png');
			storeImage('4.png');
			storeImage('5.png');
			storeImage('6.png');
			storeImage('7.png');
			storeImage('8.png');
			var newAssets = {};

			function storeImage(imageID) {
				$.ajax({
					url: GetItemFromLocalData('ClientURL'),
					type: "POST",
					dataType: "xml",
					timeout: 40000,
					data: soapMessageGetFileChunk('GameImage', imageID),
					success: function(data) {
						var error = $(data).find('Standard').children('MethodErrorLevel').text();
						if (error == "None") {
							newAssets[imageID] = "data:image/png;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();

							if(globals.debugApp){
								console.log("SUCCESS: A Game Asset Image Downloaded");
							}
							saveClientLog(74, 0, 0, '', 0,  "SUCCESS: A Game Asset Image Downloaded");
						}
						else{

							if(globals.debugApp){
								console.log("ERROR: A Game Asset Image was not Downloaded - " + error);
							}

							saveClientLog(75, 0, 0, '', 0, "ERROR: A Game Asset Image was not Downloaded - " + error);
						}
					},
					contentType: "text/xml; charset=utf-8"
				}).done(function() {
					if (Object.keys(newAssets).length == 13) {

						for (var prop in newAssets) {
							setGameCard(prop, newAssets[prop]);
						}

						setGameVersion(version);
						saveLocalData();

						setTimeout(function(){
							SaveAppDataJson(); // Save all the Data that was initialized into the FILE
						}, 100);

						if (gameAssetsReady() && !gameReady) {
							gameReady = true;

							if(globals.debugApp){
								console.log('Game Ready is TRUE');
							}

							loadGame($rootScope);
						}
					}
				})
			}
		}

		$('#mainContainer').on('tap', function() {
			if ($('#cards').css('pointer-events') == 'none' && insufficientPlays) {
				navigator.notification.alert(
					"Sorry, you don't have any plays available. Try back later, or check-in at a store for more plays.", // message
					function() {}, // callback
					'Insufficient Plays', // title
					'Ok' // buttonName
				);
			} else if ($('#cards').css('pointer-events') == 'none' && !insufficientPlays) {
				navigator.notification.alert(
					"Sorry, we were unable to load your game progress. This is likey due to a poor internet connection.", // message
					function() {}, // callback
					'Game Unavailable', // title
					'Ok' // buttonName
				);
			}
		});

		Loading.then(function() {
			$timeout(function(){
				if (!ClientSet.getGameHide()) {
					
					$scope.GameTitle = ClientSet.getGameTitle();
					$rootScope.CardValues = ClientSet.getGameValueOne();
					$scope.playing = false;
					if (gameAssetsReady()) {
						gameReady = true;
						loadGame($rootScope);
					}

					if(globals.debugApp){
						console.log( ' ClientSet.getGameVersion = ' + ClientSet.getGameVersion() + ' / getGameVersion = ' + getGameVersion() );
					}

					if (!gameAssetsReady() || (ClientSet.getGameVersion() != getGameVersion())) {
						$timeout(function() {
							updateGameAssets($rootScope, ClientSet.getGameVersion());
							if(globals.debugApp){
								console.log("Updating and grabbing Game Assets from server");
							}
						}, 1);
					}
				}
			}, 1);
		});

		$('#fun').on('pageinit', function() {
			var height = $(window).height(); // android and ios
			$("#fun .ui-content").css('height', height - $('#fun .ui-header').height() - $('#fun .ui-footer').height() - 2 );
		});
		
		$('#fun').on('pageshow', function() {
			if (gameReady) {
				beginGame();
			} else {
				alert('Game assets are unavailable at this time. The game requires an internet connection for play.', function() {
					$.mobile.back({ transition: "slide", reverse: true});
				});
			}

			function beginGame() {
				$timeout(function() {
					$rootScope.playsLeft = getGamePlays();
					$rootScope.totalPoints = getPoints();
					$rootScope.pointsWon = 0;
				});
				if (getNewPlayer()) {
					if (window.device.platform == 'Android') {
						var m = 'Welcome to the Match Game. Select two cards. Each incorrect guess will cost 1 play.';
					} else {
						var m = 'Welcome to the Match Game. Select two cards. Each incorrect guess will cost 1 play. \n\nApple is not a sponsor nor is involved in any way with this game or prizes.';
					}
					navigator.notification.alert(
						m, // message
						function() {
							setNewPlayer('0');
							saveLocalData();

							setTimeout(function(){
								SaveAppDataJson(); // Save all the Data that was initialized into the FILE
							}, 100);
							$scope.playNow();
						}, // callback
						'Welcome!', // title
						'Play' // buttonName
					);
				} else{
					saveLocalData();

					setTimeout(function(){
						SaveAppDataJson(); // Save all the Data that was initialized into the FILE
					}, 100);
					$scope.playNow();
				}
			}
		});


		$('#fun').on('pagehide', function() {
			if ($scope.playing) {
				$rootScope.endGame(1);
			}
		});


		$scope.playNow = function() {
			if (window.device.platform == 'Android'){
				var options = {
					label : "Loading Game"
				};
			}
			else{
				var options = {
					label : "Loading Game",
					color : '#000',
					spinnerColor : '#000'
				}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
			} 

			window.wizSpinner.show(options);

			var GameProgress = getGameProgress();

			if (GameProgress != null) {
				GameProgress = JSON.parse(GameProgress);
				saveClientLog(71, 0, 0, '', 0, 'calling end game on unsaved game progress with ' + GameProgress.pointsWon + ' points won and ' + GameProgress.playsLeft + ' plays left and ' + GameProgress.wonPromo + ' promo');
				$http.post(GetItemFromLocalData('ClientURL'), soapMessageGameEnd(GameProgress.pointsWon, GameProgress.playsLeft, GameProgress.wonPromo), {timeout: 25000} ).then(function(response) {
					
					var processed = parseInt($(response.data).find('GameEndResult').children("Processed").text());
					setPoints( parseInt($(response.data).find('GameEndResult').children("Points").text()) );
					setGamePlays( parseInt($(response.data).find('GameEndResult').children("Plays").text()) );
					setPromoPlay( parseInt($(response.data).find('GameEndResult').children("PromoPlay").text()) );


					var error = $(response.data).find('Standard').children('MethodErrorMsg').text();
					if (processed == 1) {
						//window.localStorage.removeItem('GameProgress');
						setGameProgress(null); //remove GameProgress
					}

					saveLocalData();

					setTimeout(function(){
						SaveAppDataJson(); // Save all the Data that was initialized into the FILE
					}, 100);

					callGameStart();
				}, function(error) {
					alert(error, function() {});
					callGameStart();
				});
			} else{
				callGameStart();
			}

			function callGameStart() {

				$http.post(GetItemFromLocalData('ClientURL'), soapMessageGameStart(), {timeout: 25000} ).then(function(response) {
					var processed = parseInt($(response.data).find('GameStartResult').children("Processed").text());
					if (processed == 1) {

						//window.localStorage.setItem('PromoPlay', parseInt($(response.data).find('GameStartResult').children("PromoPlay").text()) );
						setPromoPlay( parseInt($(response.data).find('GameStartResult').children("PromoPlay").text()) );

						$rootScope.promoPlay = getPromoPlay();
						
						if ($rootScope.promoPlay) {
							$('.card').each(function() {
								if ($(this).attr('num') == '1')
									$(this).find(".frontImg").backstretch(getGameCard('promo.png'));
							});
						} else {
							$('.card').each(function() {
								if ($(this).attr('num') == '1')
									$(this).find(".frontImg").backstretch(getGameCard('1.png'));
							});
						}

						setTokenID( $(response.data).find('GameStartResult').children("TokenID").text() );
						setVersion( $(response.data).find('GameStartResult').children("Version").text() );
						setPoints( parseInt($(response.data).find('GameStartResult').children("Points").text()) );
						setGamePlays( parseInt($(response.data).find('GameStartResult').children("Plays").text()) );
						
						saveLocalData();

						setTimeout(function(){
							SaveAppDataJson(); // Save all the Data that was initialized into the FILE
						}, 100);

						$rootScope.playsLeft = getGamePlays();
						$rootScope.totalPoints = getPoints();
						$rootScope.wonPromo = false;
						$rootScope.pointsWon = 0;
						$('#cards').css('pointer-events', '');
						$scope.playing = true;
						saveClientLog(70, 0, 0, '', 0, 'user started game with ' + getPoints() + ' points and ' + $rootScope.playsLeft + ' plays');

						if(globals.debugApp){
							console.log('user started game with ' + getPoints() + ' points and ' + $rootScope.playsLeft + ' plays');
						}
					} else {
						var error = $(response.data).find('Standard').children('MethodErrorMsg').text();
						if (error.indexOf('enough plays') != -1) {
							$('#cards').css('pointer-events', 'none');
							insufficientPlays = true;
						} else {
							alert(error, function() {
								$('#cards').css('pointer-events', 'none');
							});
							insufficientPlays = false;
						}
					}

					setTimeout(function() {
						$('.card').css('opacity', 1);
						//stopLoader();
						window.wizSpinner.hide();
					}, 10);
				}, function(error) {
					$('#cards').css('pointer-events', 'none');
					setTimeout(function() {
						$('.card').css('opacity', 1);
						//stopLoader();
						window.wizSpinner.hide();

						console.log("Game Server error. 1");
						navigator.notification.confirm(
							'Server couldnt be reached..',
							callBackFunctionServerDown, // Specify a function to be called
							'Please check your internet signal, Would you like to Retry.', ["Yes", "No"]
						);

						function callBackFunctionServerDown(b) {
							if (b == 1) {
								$scope.playNow();
							}
							else{
								// DO NOTHING
							}
						}

					}, 100);
					insufficientPlays = false;
				});
			}
		};

		function retry() {
			setTimeout(function() {
				$http.post(GetItemFromLocalData('ClientURL'), soapMessageGameEnd($rootScope.pointsWon, $rootScope.playsLeft, $rootScope.wonPromo), {timeout: 25000} ).then(function(response) {
					var processed = parseInt($(response.data).find('GameEndResult').children("Processed").text());
					
					setPoints( parseInt($(response.data).find('GameEndResult').children("Points").text()) );
					setGamePlays( parseInt($(response.data).find('GameEndResult').children("Plays").text()) );
					setPromoPlay( parseInt($(response.data).find('GameEndResult').children("PromoPlay").text()) );
					
					saveLocalData();

					setTimeout(function(){
						SaveAppDataJson(); // Save all the Data that was initialized into the FILE
					}, 100);

					var error = $(response.data).find('Standard').children('MethodErrorMsg').text();
					if (processed != 1)
						alert(error, function() {});
					else {
						//window.localStorage.removeItem('GameProgress');
						setGameProgress(null); //remove GameProgress

						if($rootScope.wonPromo){
							updateInstantPrize();
						}
					}
				}, function(error) {
					window.wizSpinner.hide();

					if(globals.debugApp){
						console.log("Game Server error. 2");
					}
				});
			}, 2000);
		}


		$rootScope.endGame = function(pageHide) {
			$scope.playing = false;
			$timeout(function() {

				$('.card-flipped').removeClass('card-flipped');
				$('.card-flipped1').removeClass('card-flipped1');
				$('.card-removed').removeClass('card-removed');
				$('.noclick').removeClass('noclick');
				$("img[src$='cardfrontmatch.png']").attr('src', getGameCard('cardfront'));

				var cardPositions = [];

				for (var i = 0; i < 16; i++)
					cardPositions.push({
						left: $($('.card')[i]).css('left'),
						top: $($('.card')[i]).css('top')
					});
				cardPositions.sort(function() {
					return 0.5 - Math.random();
				});

				for (var i = 0; i < 16; i++) {
					$($('.card')[i]).css('left', cardPositions[i].left);
					$($('.card')[i]).css('top', cardPositions[i].top);
				}
			}, 10);

			saveClientLog(71, 0, 0, '', 0, 'user ended game with ' + $rootScope.pointsWon + ' points won and ' + $rootScope.playsLeft + ' plays left and ' + $rootScope.wonPromo + ' promo');

			$http.post(GetItemFromLocalData('ClientURL'), soapMessageGameEnd($rootScope.pointsWon, $rootScope.playsLeft, $rootScope.wonPromo), {timeout: 25000}).then(function(response) {
				var processed = parseInt($(response.data).find('GameEndResult').children("Processed").text());

				if(globals.debugApp){
					console.log('points received from the server: (game.end) ' + $(response.data).find('GameStartResult').children("Points").text() );
				}

				setPoints( parseInt($(response.data).find('GameEndResult').children("Points").text()) );
				setGamePlays( parseInt($(response.data).find('GameEndResult').children("Plays").text()) );
				setPromoPlay( parseInt($(response.data).find('GameEndResult').children("PromoPlay").text()) );
				saveLocalData();

				setTimeout(function(){
					SaveAppDataJson(); // Save all the Data that was initialized into the FILE
				}, 100);

				var error = $(response.data).find('Standard').children('MethodErrorMsg').text();
				if (processed != 1){
					alert(error, function() {});
				}
				else {
					setGameProgress(null); //remove GameProgress
					$rootScope.pointsWon = 0;

					if ($rootScope.wonPromo) {
						updateInstantPrize();
					}
					if (getGamePlays() > 0 && pageHide == 0){
						$scope.playNow();
					}
				}

			}, function(error) {

				if(globals.debugApp){
					console.log('ERROR: End game error: Server was not reached.');
				}
				
				retry();
			});
		};


		function updateInstantPrize() {
			var ip = null;
			$.ajax({
				url: GetItemFromLocalData('ClientURL'),
				type: "POST",
				dataType: "xml",
				timeout: 16000,
				data: soapMessagePromoList2(),
				success: function(data) {
					$(data).find('RPromoServer2').each(function(index) {
						var PromoID = $(this).children("PromoID").text();
						var Descript1 = $(this).children("Descript1").text();
						var Descript2 = $(this).children("Descript2").text();
						var PromoType = parseInt($(this).children("PromoType").text());
						var HeadID = $(this).children("HeadID").text();
						var InterestID = $(this).children("InterestID").text();
						var PromoStore = parseInt($(this).children("PromoStore").text());
						var PromoUse = parseInt($(this).children("PromoUse").text());
						var PromoAccount = parseInt($(this).children("PromoAccount").text());
						var DateStart = ticksToEpoch(parseInt($(this).children("DateStartTicks").text()));
						var DateEnd = ticksToEpoch(parseInt($(this).children("DateEndTicks").text()));
						var DisplaySec = parseInt($(this).children("DisplaySec").text());
						var Uses = parseInt($(this).children("Uses").text());
						var AccountUses = parseInt($(this).children("AccountUses").text());
						var Age = parseInt($(this).children("Age").text());
						var Points = parseInt($(this).children("Points").text());
						var DetailHTMLFile = $(this).children("DetailHTMLFile").text();
						var PhotoFile = $(this).children("PhotoFile").text();
						var ThumbFile = $(this).children("ThumbFile").text();
						var DescriptPush = $(this).children("DescriptPush").text();
						var PhotoURL = null;
						if (PromoType == 1 && PromoAccount == 1) {
							$.ajax({
								url: GetItemFromLocalData('ClientURL'),
								type: "POST",
								dataType: "xml",
								timeout: 16000,
								data: soapMessageGetFileChunk('Image', PhotoFile),
								success: function(data) {
									var error = $(data).find('Standard').children('MethodErrorLevel').text();
									if (error == "None") {
										if (PhotoFile.substring(PhotoFile.indexOf('.') + 1) == 'png')
											PhotoURL = "data:image/png;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();
										else {
											PhotoURL = "data:image/jpeg;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();
										}
										ip = {
											PromoID: PromoID,
											Descript1: Descript1,
											Descript2: Descript2,
											PromoType: PromoType,
											HeadID: HeadID,
											InterestID: InterestID,
											PromoStore: PromoStore,
											PromoUse: PromoUse,
											PromoAccount: PromoAccount,
											DateStart: DateStart,
											DateEnd: DateEnd,
											DisplaySec: DisplaySec,
											Uses: Uses,
											AccountUses: AccountUses,
											Age: Age,
											Points: Points,
											DetailHTMLFile: DetailHTMLFile,
											PhotoFile: PhotoFile,
											PhotoURL: PhotoURL,
											ThumbFile: ThumbFile,
											DescriptPush: DescriptPush,
										}
									}
								},
								contentType: "text/xml; charset=utf-8"
							}).done(function() {
								if (ip) {
									ip = updatePromoLinkVideoPhoto(ip);
									$timeout(function() {
										$rootScope.InstantPrize = ip;
										resetScrollbar();
									});
								}
							});
						}
					});
				},
				error: function(data) {
					$rootScope.Error(globals.ajaxTimeoutMessage, function() {}, false, function() {});
				},
				contentType: "text/xml; charset=utf-8"
			});
		}
	}
}());