(function() {
	angular.module('connect.geolocation')
	//TODO: rename GeoLocation to geoLocationService
	//.factory('geoLocationService', geoLocationService);
		.factory('GeoLocation', geoLocationService);

	geoLocationService.$inject = ['$q', '$rootScope'];

	function geoLocationService($q, $rootScope) {
		return {

			setCurrentPosition: function() {

				var locationService = navigator.geolocation; // cordova geolocation plugin

				if(globals.debugApp){
					console.log("CHECK IN - DEBUG - Location: Using Cordova's Geoloaction");
				}

				var defer = $q.defer();
				locationService.getCurrentPosition(function(position) {
					console.log("CHECK IN - DEBUG - Location: Success: Lat/Long/Acc - " + position.coords.latitude + " " + position.coords.longitude + " " + position.coords.accuracy);
					//alert("DEBUG - Location: Success: Lat/Long/Acc - " + position.coords.latitude + " " + position.coords.longitude + " " + position.coords.accuracy);
					
					$rootScope.Latitude = position.coords.latitude;
					$rootScope.Longitude = position.coords.longitude;
					$rootScope.Accuracy = position.coords.accuracy;
					$rootScope.haveGPS = true; //$rootScope.haveGPS is a global Angular variable that keeps track of whether or not the user has a GPS location
					defer.resolve();
				}, function(error) {
					if(globals.debugApp){
						console.log("CHECK IN - DEBUG - Location: Error: " + error.message);
					}
					locationService.getCurrentPosition(function(position) {
						$rootScope.Latitude = position.coords.latitude;
						$rootScope.Longitude = position.coords.longitude;
						$rootScope.Accuracy = position.coords.accuracy;
						$rootScope.haveGPS = true;
						defer.resolve();
					}, function(error) {
						if(globals.debugApp){
							console.log("CHECK IN - DEBUG - Location: Error: " + error.message);
						}
						$rootScope.haveGPS = false;
						$rootScope.Latitude = 0;
						$rootScope.Longitude = 0;
						$rootScope.Accuracy = 0;
						defer.resolve();
					}, {
						enableHighAccuracy: false,
						maximumAge: 10000,
						timeout: 10000
					}); //if high accuracy fails, try getting it with low accuracy
				}, {
					enableHighAccuracy: true,
					maximumAge: 10000,
					timeout: 12000
				}); //try getting gps with high accuracy enabled
				return defer.promise;
			}
		}
	}
})();