(function() {
	angular.module('connect.kickback-iframe')
		.directive('kickbackIframe', kickbackIframeDirective)
		.controller('KickbackIframeController', kickbackIframeController);

	kickbackIframeDirective.$inject = [];
	kickbackIframeController.$inject = ['$scope', 'kickbackRewardsService', 'Loading', '$rootScope', '$timeout', 'ClientSet', '$sce'];

	function kickbackIframeDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'kickback-iframe/connect.kickback-iframe.html',
			link: link
		};
		return directive;

		function link(scope, element, attrs) { }

	}

	function kickbackIframeController($scope, kickbackRewardsService, Loading, $rootScope, $timeout, ClientSet, $sce) {

		var frame = document.getElementById('kickbackGameIframe');
		var vm = this;
		var kickbackState = kickbackRewardsService.getKickbackState();
		vm.kickbackUser = kickbackState.kickbackUser;

		Loading.then(function(){
			$scope.updateKbGameURL(); //KB Game Client Sets init
		}); 

		$scope.updateKbGameURL = function(){
			console.log('updateKbGameURL was Fired');

			// *KB Game Client Sets init* //
			$scope.kbGameURL = $sce.trustAsResourceUrl( ClientSet.getKBGameURL() + vm.kickbackUser.CardNumber + '/' ); //URL + their cardnumber appended to the game's URL + '/'

			if(globals.debugApp){
				console.log( 'KB Iframe was initiated. ');
			}

			// If KB Game exists (if URL is not null or 0), initialize game 
			if($scope.kbGameURL && $scope.kbGameURL != 0){
				$scope.kbGameTitle = ClientSet.getKBGameTitle();
				//if(globals.debugApp){
					console.log( 'KB GAME URL: ' + $scope.kbGameURL + ' Title: ' + $scope.kbGameTitle );
				//}
			}
		}


		$('#kickbackIframe').on('pagebeforeshow', function() {

			if (window.device.platform == 'Android') {
				var options = {
					label : "Loading Content",
					timeout: 60
				};
			} else {
				var options = {
					label : "Loading Content",
					color: '#000',
					spinnerColor: '#000',
					timeout: 60
				};
			}	
			
			window.wizSpinner.show(options); 

			if(globals.debugApp){
				//alert('Debug: Connecting to ' + $scope.kbGameURL); 
				console.log( 'KB GAME was initiated. with url ' + $scope.kbGameURL);   //   http://www.handymartrewardsgames.com/poker/?program=handymart&mobile=true&cardnumber=
			}

			$("#kickbackIframe .ui-content").css('height', $(window).height() - $('#kickbackIframe .ui-header').height() - 50 );
			$("#kickbackIframe #kickbackIframeWrapper").css('height', $('#kickbackIframe .ui-content').height() + 50 );
			$("#kickbackIframe #kickbackGameIframe").css('height', $('#kickbackIframe .ui-content').height() + 50 );
			$("#kickbackIframe #kickbackGameIframe").css('width', $(window).width() + 50 );

			var kickbackCounter = 0;
			var kickbackIframeInterval = setInterval(function() {
				if (kickbackCounter == 50) {
					clearInterval(kickbackIframeInterval);
					window.wizSpinner.hide();
					navigator.notification.alert(
						'Could not connect to server', // message
						function() {
							$.mobile.changePage('#kickbackRewards');
						}, // callback
						'Error', // title
						'Ok' // buttonName
					);
				} else if (frame.contentWindow.document.body.innerHTML.replace(/(\r\n|\n|\r)/gm, "")) {
					clearInterval(kickbackIframeInterval);
					window.wizSpinner.hide();
					
					if(globals.debugApp){
						console.log("kickback games Iframe loaded");
					}
				} else {
					kickbackCounter++;
				}
			}, 1000);
		});

	}
})();