(function () {
	angular.module('connect.kickback-rewards').factory('KickbackRegistrationUser', KickbackRegistrationUserModel);

	KickbackRegistrationUserModel.$inject = [];
	function KickbackRegistrationUserModel() {
		/**
		 * @class KickbackRegistrationUser
		 * @description KickbackRegistrationUser is the user for kickback that contains all the data needed for registration and user info
		 * @constructor
		 */
		function KickbackRegistrationUser(kickbackRegistrationUser) {
			if(!kickbackRegistrationUser || typeof kickbackRegistrationUser !== 'object') {
				throw 'Cannot create new KickbackRegistrationUser: You must pass in a kickback user, to create a new KickbackRegistrationUser pass in an empty object {}';
			}
			this.FirstName = kickbackRegistrationUser.FirstName;
			this.LastName = kickbackRegistrationUser.LastName;
			this.cardnumber = kickbackRegistrationUser.cardnumber;
			this.PIN = kickbackRegistrationUser.PIN;
			this.BirthDate = kickbackRegistrationUser.BirthDate;
			this.Prefix = kickbackRegistrationUser.Prefix;
			this.MiddleName = kickbackRegistrationUser.MiddleName;
			this.Address1 = kickbackRegistrationUser.Address1;
			this.Address2 = kickbackRegistrationUser.Address2;
			this.City = kickbackRegistrationUser.City;
			this.State = kickbackRegistrationUser.state;
			this.Zip = kickbackRegistrationUser.Zip;
			this.Country = kickbackRegistrationUser.country;
			this.phone = kickbackRegistrationUser.phone;
			this.mobile = kickbackRegistrationUser.mobile;
			this.Email = kickbackRegistrationUser.Email;

			this.mobile = kickbackRegistrationUser.mobile;
			
			/* Secure Information */
			this.MothersMaiden = kickbackRegistrationUser.MothersMaiden;
			this.security1_id = kickbackRegistrationUser.security1_id;
			this.security1_answer = kickbackRegistrationUser.security1_answer;
			this.security2_id = kickbackRegistrationUser.security2_id;
			this.security2_answer = kickbackRegistrationUser.security2_answer;
			this.flag1 = kickbackRegistrationUser.flag1;
			this.DriversLicense = kickbackRegistrationUser.DriversLicense;
			
			this.gender = kickbackRegistrationUser.gender;
			
			/* Used by Kickback, not needed for the App */
			this.LocationEnrolled = kickbackRegistrationUser.LocationEnrolled;

			if(this.BirthDate === null || this.BirthDate === ''){
				this.BirthDate = '00-00-0000';
			}
		}
		
		KickbackRegistrationUser.prototype.removePersonalData = removePersonalData;
		KickbackRegistrationUser.prototype.removeAddress = removeAddress;
		
		return KickbackRegistrationUser;
		
		function removePersonalData() {
			this.MothersMaiden = null;
			this.BirthDate = null;
			this.security1_id = null;
			this.security1_answer = null;
			this.security2_id = null;
			this.security2_answer = null;
			this.DriversLicense = null;
		}
		
		function removeAddress() {
			this.Address1 = null;
			this.Address2 = null;
			this.City = null;
			this.State = null;
			this.Zip = null;
			this.Country = null;
		}
	}
	
}());