(function(){
	angular.module('connect.kickback-rewards').directive('kickbackRewards', kickbackRewards);
	
	kickbackRewards.$inject = [];
	kickbackRewardsCtrl.$inject = ['$scope', '$rootScope', '$timeout', 'kickbackRewardsService', 'ClientSet'];
	
	function kickbackRewards() {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/connect.kickback-rewards.html',
			controller: kickbackRewardsCtrl,
			controllerAs: 'kickbackRewardsCtrl'
		}
	}
	
	function kickbackRewardsCtrl($scope, $rootScope,  $timeout, kickbackRewardsService, ClientSet) {

		var vm = this;
		vm.goToSignIn = goToSignIn;
		vm.goToRegister = goToRegister;
		vm.showTerms = showTerms;
		vm.hideTerms = hideTerms;
		vm.refresh = refresh;

		setTimeout(function() {
			vm.kickbackImage = globals.Change.kickbackImage;
			$scope.Chain = globals.Change.chainFriendly;

			if(globals.debugApp){
				console.log('Kickback: initializing Rewards Ctrl for ' + $scope.Chain);
			}
		}, 800);
		
		vm.kickbackState = kickbackRewardsService.getKickbackState();
		vm.settingsOpen = false;
		
		$scope.$on('kickback-settings:close', function() {
			vm.settingsOpen = false;
		});
		
		function goToSignIn() {
			vm.showSignIn = true;
			vm.showRegister = false;
		}
		
		function goToRegister() {
			vm.showSignIn = false;
			vm.showRegister = true;
		}
		
		function showTerms() {
			vm.termsOpen = true;
		}
		
		function hideTerms() {
			vm.termsOpen = false;
		}
		
		function refresh() {
			$scope.$broadcast('kickback-rewards:refresh');
		}
	}
}());