(function () {
	angular.module('connect.kickback-rewards').factory('KickbackPunchCard', KickbackPunchCardModel);

	KickbackPunchCardModel.$inject = ['ClientSet'];
	function KickbackPunchCardModel(ClientSet) {
		/**
		 * @class KickbackPunchCard
		 * @description KickbackPunchCard is the user for kickback that contains all the data needed for registration and user info
		 * @constructor
		 */
		function KickbackPunchCard(kickbackPunchCard) {
			if (!kickbackPunchCard || typeof kickbackPunchCard !== 'object') {
				debugger;
				throw 'Cannot create new KickbackPunchCard: You must pass in a kickback user, to create a new KickbackPunchCard pass in an empty object {}';
			}
			this.currentPunches = kickbackPunchCard.currentPunches ? parseInt(kickbackPunchCard.currentPunches) : 0;
			this.desc = kickbackPunchCard.desc;
			this.id = kickbackPunchCard.id;
			this.numberToGet = kickbackPunchCard.numberToGet ? parseInt(kickbackPunchCard.numberToGet) : 0;
			this.progressLine = kickbackPunchCard.progressLine;

			if(globals.debugApp){
				console.log("Kickback punch ID for " + this.desc + " = " + this.id);
				console.log(this.id + ' - ' + ClientSet.getPunchCardImage(this.id) );
			}
			
			//image selection based on id
			this.punchImage = ClientSet.getPunchCardImage(this.id, this.desc);
			
			
			this.__defineGetter__('_progressPercent', function() {
				if(this.currentPunches === 0 || this.numberToGet === 0)
					return 0;
				return parseInt((this.currentPunches / this.numberToGet)*100);
			});
			
			this.__defineGetter__('_complete', function() {
				return this.currentPunches >= this.numberToGet;
			});
		}

		KickbackPunchCard.prototype.$merge = $merge;

		return KickbackPunchCard;
		
		/**
		 * @description allows for the bound angular object to keep bindings while updating data
		 */
		function $merge(kickbackPunchCard) {
			this.currentPunches = kickbackPunchCard.currentPunches;
		}
	}

} ());