(function () {
	angular.module('connect.kickback-rewards').factory('KickbackReward', KickbackRewardModel);

	KickbackRewardModel.$inject = [];
	function KickbackRewardModel() {
		/**
		 * @class KickbackReward
		 * @description KickbackReward is the user for kickback that contains all the data needed for registration and user info
		 * @constructor
		 */
		function KickbackReward(kickbackReward) {
			if (!kickbackReward || typeof kickbackReward !== 'object') {
				debugger;
				throw 'Cannot create new KickbackReward: You must pass in a kickback user, to create a new KickbackReward pass in an empty object {}';
			}

			this.uid = kickbackReward.uid;
			this.group_id = kickbackReward.group_id;
			this.combo_id = kickbackReward.combo_id;
			this.category = kickbackReward.category;
			this.label = kickbackReward.label;
			this.messageBody = kickbackReward.messageBody;
			this.codeType = kickbackReward.codeType;
			this.code = kickbackReward.code;
			this.dollarvalue = kickbackReward.dollarvalue;
			this.pointvalue = kickbackReward.pointvalue;
			this.expire_days = kickbackReward.expire_days;
			this.count = kickbackReward.count;
			this.expiresOn = kickbackReward.expiresOn;
		}

		KickbackReward.prototype.$merge = $merge;

		return KickbackReward;
		
		/**
		 * @description allows for the bound angular object to keep bindings while updating data
		 */
		function $merge(kickbackReward) {
			this.uid = kickbackReward.uid;
			this.group_id = kickbackReward.group_id;
			this.combo_id = kickbackReward.combo_id;
			this.category = kickbackReward.category;
			this.label = kickbackReward.label;
			this.messageBody = kickbackReward.messageBody;
			this.codeType = kickbackReward.codeType;
			this.code = kickbackReward.code;
			this.dollarvalue = kickbackReward.dollarvalue;
			this.pointvalue = kickbackReward.pointvalue;
			this.expire_days = kickbackReward.expire_days;
			this.count = kickbackReward.count;
			this.expiresOn = kickbackReward.expiresOn;
		}
	}

} ());