(function () {
	angular.module('connect.kickback-rewards').factory('KickbackUser', KickbackUserModel);

	KickbackUserModel.$inject = [];
	function KickbackUserModel() {
		/**
		 * @class KickbackUser
		 * @description KickbackUser is the user for kickback that contains all the data needed for registration and user info
		 * @constructor
		 */
		function KickbackUser(kickbackUser) {
			if (!kickbackUser || typeof kickbackUser !== 'object') {
				debugger;
				throw 'Cannot create new KickbackUser: You must pass in a kickback user, to create a new KickbackUser pass in an empty object {}';
			}
			this.AccessTimes = kickbackUser.AccessTimes;
			this.AccessedFrom = kickbackUser.AccessedFrom;
			this.AccruedDollars = kickbackUser.AccruedDollars;
			this.AccruedGallons = kickbackUser.AccruedGallons;
			this.AccruedPoints = kickbackUser.AccruedPoints;
			this.ActivationDate = kickbackUser.ActivationDate;
			this.ActiveMember = kickbackUser.ActiveMember;
			this.Address1 = kickbackUser.Address1;
			this.Address2 = kickbackUser.Address2;
			this.AnniversaryDate = kickbackUser.AnniversaryDate;
			this.BirthDate = kickbackUser.BirthDate;
			this.CancellationDate = kickbackUser.CancellationDate;
			this.CardNumber = kickbackUser.CardNumber;
			this.CardToTrack1 = kickbackUser.CardToTrack1;
			this.City = kickbackUser.City;
			this.Country = kickbackUser.Country;
			this.Creation_Date = kickbackUser.Creation_Date;
			this.DollarsRedeemed = kickbackUser.DollarsRedeemed;
			this.DriversLicense = kickbackUser.DriversLicense;
			this.Email = kickbackUser.Email;
			this.Expiration = kickbackUser.Expiration;
			this.FirstName = kickbackUser.FirstName;
			this.FirstRedemptionDate = kickbackUser.FirstRedemptionDate;
			this.FirstTrxCashier = kickbackUser.FirstTrxCashier;
			this.FirstTrxDate = kickbackUser.FirstTrxDate;
			this.FirstTrxLocation = kickbackUser.FirstTrxLocation;
			this.GLocationID = kickbackUser.GLocationID;
			this.LastName = kickbackUser.LastName;
			this.LastPurchaseDate = kickbackUser.LastPurchaseDate;
			this.LastRedemptionDate = kickbackUser.LastRedemptionDate;
			this.LastTriggerDate = kickbackUser.LastTriggerDate;
			this.LifeTimePoints = kickbackUser.LifeTimePoints;
			this.LifetimeDollars = kickbackUser.LifetimeDollars;
			this.LocationEnrolled = kickbackUser.LocationEnrolled;
			this.MaxDollars = kickbackUser.MaxDollars;
			this.MaxPoints = kickbackUser.MaxPoints;
			this.MemLPI = kickbackUser.MemLPI;
			this.MiddleName = kickbackUser.MiddleName;
			this.MothersMaiden = kickbackUser.MothersMaiden;
			this.Notes = kickbackUser.Notes;
			this.NumberOfRedemptions = kickbackUser.NumberOfRedemptions;
			this.PIN = kickbackUser.PIN;
			this.ParentCardNumber = kickbackUser.ParentCardNumber;
			this.ParentType = kickbackUser.ParentType;
			this.PersonalInfoModifiedDate = kickbackUser.PersonalInfoModifiedDate;
			this.PhoneSelected = kickbackUser.PhoneSelected;
			this.Prefix = kickbackUser.Prefix;
			this.PromoID = kickbackUser.PromoID;
			this.SpouseBirthdate = kickbackUser.SpouseBirthdate;
			this.State = kickbackUser.State;
			this.TriggerGroup = kickbackUser.TriggerGroup;
			this.Zip = kickbackUser.Zip;
			this.cardnumber = kickbackUser.cardnumber;//?why are there 2 card numbers? this one is null JK 10/28
			this.created_at = kickbackUser.created_at;
			this.email_address = kickbackUser.email_address;
			this.email_confirmation_token = kickbackUser.email_confirmation_token;
			this.email_confirmed = kickbackUser.email_confirmed;
			this.email_confirmed_at = kickbackUser.email_confirmed_at;
			this.email_confirmed_on = kickbackUser.email_confirmed_on;
			this.flag1 = kickbackUser.flag1;
			this.gender = kickbackUser.gender;
			this.is_onhold = kickbackUser.is_onhold;
			this.maxpointsperday = kickbackUser.maxpointsperday;
			this.maxtrxperday = kickbackUser.maxtrxperday;
			this.memberGroup = kickbackUser.memberGroup;
			this.message1 = kickbackUser.message1;
			this.message2 = kickbackUser.message2;
			this.message3 = kickbackUser.message3;
			this.mobile = kickbackUser.mobile;
			this.notes2 = kickbackUser.notes2;
			this.phone = kickbackUser.phone;
			this.security1_answer = kickbackUser.security1_answer;
			this.security1_id = kickbackUser.security1_id;
			this.security2_answer = kickbackUser.security2_answer;
			this.security2_id = kickbackUser.security2_id;
			this.updated_at = kickbackUser.updated_at;

			if(this.BirthDate === null || this.BirthDate === ''){
				this.BirthDate = '00-00-0000';
			}
		}

		KickbackUser.prototype.removePersonalData = removePersonalData;
		KickbackUser.prototype.removeAddress = removeAddress;
		KickbackUser.prototype.$merge = $merge;

		return KickbackUser;

		function removePersonalData() {
			this.MothersMaiden = null;
			this.BirthDate = null;
			this.SpouseBirthdate = null;
			this.security1_id = null;
			this.security1_answer = null;
			this.security2_id = null;
			this.security2_answer = null;
			this.DriversLicense = null;
		}

		function removeAddress() {
			this.Address1 = null;
			this.Address2 = null;
			this.City = null;
			this.State = null;
			this.Zip = null;
			this.Country = null;
		}
		
		/**
		 * @description allows for the bound angular object to keep bindings while updating data
		 */
		function $merge(kickbackUser) {
			this.AccessTimes = kickbackUser.AccessTimes;
			this.AccessedFrom = kickbackUser.AccessedFrom;
			this.AccruedDollars = kickbackUser.AccruedDollars;
			this.AccruedGallons = kickbackUser.AccruedGallons;
			this.AccruedPoints = kickbackUser.AccruedPoints;
			this.ActivationDate = kickbackUser.ActivationDate;
			this.ActiveMember = kickbackUser.ActiveMember;
			this.Address1 = kickbackUser.Address1;
			this.Address2 = kickbackUser.Address2;
			this.AnniversaryDate = kickbackUser.AnniversaryDate;
			this.BirthDate = kickbackUser.BirthDate;
			this.CancellationDate = kickbackUser.CancellationDate;
			this.CardNumber = kickbackUser.CardNumber;
			this.CardToTrack1 = kickbackUser.CardToTrack1;
			this.City = kickbackUser.City;
			this.Country = kickbackUser.Country;
			this.Creation_Date = kickbackUser.Creation_Date;
			this.DollarsRedeemed = kickbackUser.DollarsRedeemed;
			this.DriversLicense = kickbackUser.DriversLicense;
			this.Email = kickbackUser.Email;
			this.Expiration = kickbackUser.Expiration;
			this.FirstName = kickbackUser.FirstName;
			this.FirstRedemptionDate = kickbackUser.FirstRedemptionDate;
			this.FirstTrxCashier = kickbackUser.FirstTrxCashier;
			this.FirstTrxDate = kickbackUser.FirstTrxDate;
			this.FirstTrxLocation = kickbackUser.FirstTrxLocation;
			this.GLocationID = kickbackUser.GLocationID;
			this.LastName = kickbackUser.LastName;
			this.LastPurchaseDate = kickbackUser.LastPurchaseDate;
			this.LastRedemptionDate = kickbackUser.LastRedemptionDate;
			this.LastTriggerDate = kickbackUser.LastTriggerDate;
			this.LifeTimePoints = kickbackUser.LifeTimePoints;
			this.LifetimeDollars = kickbackUser.LifetimeDollars;
			this.LocationEnrolled = kickbackUser.LocationEnrolled;
			this.MaxDollars = kickbackUser.MaxDollars;
			this.MaxPoints = kickbackUser.MaxPoints;
			this.MemLPI = kickbackUser.MemLPI;
			this.MiddleName = kickbackUser.MiddleName;
			this.MothersMaiden = kickbackUser.MothersMaiden;
			this.Notes = kickbackUser.Notes;
			this.NumberOfRedemptions = kickbackUser.NumberOfRedemptions;
			this.PIN = kickbackUser.PIN;
			this.ParentCardNumber = kickbackUser.ParentCardNumber;
			this.ParentType = kickbackUser.ParentType;
			this.PersonalInfoModifiedDate = kickbackUser.PersonalInfoModifiedDate;
			this.PhoneSelected = kickbackUser.PhoneSelected;
			this.Prefix = kickbackUser.Prefix;
			this.PromoID = kickbackUser.PromoID;
			this.SpouseBirthdate = kickbackUser.SpouseBirthdate;
			this.State = kickbackUser.State;
			this.TriggerGroup = kickbackUser.TriggerGroup;
			this.Zip = kickbackUser.Zip;
			this.cardnumber = kickbackUser.cardnumber;//?why are there 2 card numbers? this one is null JK 10/28
			this.created_at = kickbackUser.created_at;
			this.email_address = kickbackUser.email_address;
			this.email_confirmation_token = kickbackUser.email_confirmation_token;
			this.email_confirmed = kickbackUser.email_confirmed;
			this.email_confirmed_at = kickbackUser.email_confirmed_at;
			this.email_confirmed_on = kickbackUser.email_confirmed_on;
			this.flag1 = kickbackUser.flag1;
			this.gender = kickbackUser.gender;
			this.is_onhold = kickbackUser.is_onhold;
			this.maxpointsperday = kickbackUser.maxpointsperday;
			this.maxtrxperday = kickbackUser.maxtrxperday;
			this.memberGroup = kickbackUser.memberGroup;
			this.message1 = kickbackUser.message1;
			this.message2 = kickbackUser.message2;
			this.message3 = kickbackUser.message3;
			this.mobile = kickbackUser.mobile;
			this.notes2 = kickbackUser.notes2;
			this.phone = kickbackUser.phone;
			this.security1_answer = kickbackUser.security1_answer;
			this.security1_id = kickbackUser.security1_id;
			this.security2_answer = kickbackUser.security2_answer;
			this.security2_id = kickbackUser.security2_id;
			this.updated_at = kickbackUser.updated_at;

			if(this.BirthDate === null || this.BirthDate === ''){
				this.BirthDate = '00-00-0000';
			}
		}
	}

} ());