(function () {
	angular.module('connect.kickback-rewards').directive('kickbackBarcode', kickbackBarcode);

	kickbackBarcode.$inject = [];

	function kickbackBarcode() {
		return {
			restrict: 'E',
			template: '<img></img>',
			scope: {
				cardNumber: '='
			},
			link: function (scope, element, attrs) {
				var UPC_A = kickbackCardNumberToUPC_A(scope.cardNumber);


				JsBarcode($(element).find('img'), UPC_A, {
					width: 2,
					height: 95,
					quite: 10,
					format: "UPC",
					displayValue: true,
					font: "monospace",
					textAlign: "center",
					fontSize: 12,
					backgroundColor: "#FFFFFF",
					lineColor: "#000"
				});
				
				/**
				 * @description logic ported from C# implementation
				 */
				function kickbackCardNumberToUPC_A(cardNumber) {
					var str = '4' + cardNumber.substring(6, 16),
						even = [],
						odd = [];

					for (var i = 0, len = str.length; i < len; i++) {
						if ((i % 2) == 0)
							odd.push(parseInt(str[i]));
						else
							even.push(parseInt(str[i]));
					}

					var evenSum = even.reduce(function (previousValue, currentValue, index, array) {
						return previousValue + currentValue;
					}),
						oddSum = odd.reduce(function (previousValue, currentValue, index, array) {
							return previousValue + currentValue;
						});
					return str + ((10 - ((oddSum * 3 + evenSum) % 10)) % 10);
				}
			}
		}
	}
} ());