(function () {
	angular.module('connect.kickback-rewards').directive('kickbackPunchCards', kickbackPunchCards);

	kickbackPunchCards.$inject = [];
	kickbackPunchCardsCtrl.$inject = ['$scope', '$timeout', 'kickbackRewardsService', 'Loading', 'ClientSet', '$rootScope', '$sce'];

	function kickbackPunchCards() {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/kickback-home/kickback-punch-cards/connect.kickback-rewards.kickback-punch-cards.html',
			scope: {
				cardNumber: '=',
				pin: '=',
				lastName: '='
			},
			link: function (scope, element, attrs) {  },
			controller: kickbackPunchCardsCtrl,
			controllerAs: 'kickbackPunchCardsCtrl'
		}
	}

	function kickbackPunchCardsCtrl($scope, $timeout, kickbackRewardsService, Loading, ClientSet, $rootScope, $sce) {
		var vm = this;
		vm.punchCardsReady = false;

		$scope.$on('kickback-rewards:refresh', loadPunchCardStatus);
		$scope.$on('kickback-rewards:refresh', updateKbGame);

		var kickbackState = kickbackRewardsService.getKickbackState();
		vm.kickbackUser = kickbackState.kickbackUser;

		Loading.then(function(){
			// *KB Game Client Sets init* //
			setTimeout(function(){
				updateKbGame();
			},10);
		}); //End of Loading Function

		function updateKbGame(){
			// *KB Game Client Sets init* //
			console.log('updateKbGame was Fired');

			$scope.kbGameHide = ClientSet.getKBGameHide();

			if($scope.kbGameHide === 0){   //change it back to 0 and in html
				if(globals.debugApp){
					console.log( 'KB GAME was initiated. with url ' + $scope.kbGameURL);   //   http://www.handymartrewardsgames.com/poker/?program=handymart&mobile=true&cardnumber=
				}

				$scope.kbGameURL = $sce.trustAsResourceUrl( ClientSet.getKBGameURL() + vm.kickbackUser.CardNumber + '/' ); //URL + their cardnumber appended to the game's URL
				//$scope.kbGameURL = ClientSet.getKBGameURL() ; //URL + their cardnumber appended to the game's URL
				
				$scope.kbGamePoker = ClientSet.getKBGamePoker();
				$scope.kbGameFootball = ClientSet.getKBGameFootball();

				if(globals.debugApp){
					console.log( 'KB GAME was initiated. with New EMBEDDED Url ' + $scope.kbGameURL);   //   http://www.handymartrewardsgames.com/poker/?program=handymart&mobile=true&cardnumber=
				}

				//Load Game image Button for KB rewards page
				if($scope.kbGamePoker === 1){
					$scope.kbGameImage = 'images/kickback-poker.png';
				}
				else if($scope.kbGameFootball === 1){
					$scope.kbGameImage = 'images/kickback-football.png';
				}
				else{
					// Nothing
				}

				if(globals.debugApp){
					console.log( 'KB GAME Image: ' + $scope.kbGameImage );
				}
			}
		}


		$scope.showGameUrl = function(){
     
     		if(globals.debugApp){
           		console.log( "GAME Button was clicked for KB Rewards."); 
           	}

            setTimeout(function(){
				$.mobile.changePage('#kickbackIframe');  // Go to Iframe page
			});
		};

		setTimeout(function(){
			if(globals.debugApp){
				console.log('KICKBACK-DEBUG: Loading Punch Card status in - kickbackPunchCardsCtrl');
			}

			loadPunchCardStatus();
		},1100);

		function loadPunchCardStatus() {
			vm.punchCardsReady = false;
			kickbackRewardsService.getPunchStatus($scope.cardNumber, $scope.pin, $scope.lastName).then(function (punchCards) {
				vm.punchCards = punchCards;
				vm.punchCardsReady = true;
			}, function (err) {
				//we are making the assumtion that they are not verified
				vm.error = 'You are now Registered. Please restart app.'; // This msg used to warn the user to validate registration in their email, not anymore.
				setTimeout(function(){
					$scope.$broadcast('kickback-rewards:refresh');
				},250);
			});
		}
	}
} ());