(function () {
	angular.module('connect.kickback-rewards').directive('kickbackRegister', kickbackRegister);

	kickbackRegister.$inject = [];
	kickbackRegisterCtrl.$inject = ['$scope','kickbackRewardsService', 'KickbackRegistrationUser'];

	function kickbackRegister() {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/kickback-register/connect.kickback-rewards.kickback-register.html',
			scope: {
				goToSignIn: '&',
				showTerms: '&'
			},
			controller: kickbackRegisterCtrl,
			controllerAs: 'kickbackRegisterCtrl'
		}
	}

	function kickbackRegisterCtrl($scope, kickbackRewardsService, KickbackRegistrationUser) {

		//This checks the phone number input and auto insert the dashes (exp 999-999-9999)
		$('#ssn').keyup(function(e){
			if(globals.debugApp){
				console.log('DEBUG: KB Phone number modified');
			}
		    
		      if ((e.keyCode > 47 && e.keyCode < 58) || (e.keyCode < 106 && e.keyCode > 95) ) {

		      	
		      	if(this.value.length <= 6){
			    	this.value = this.value.replace(/(\d{3})\-?/, '$1-');
			    	if(globals.debugApp){
			    		console.log('fired ---> success');
			    	}
		      	}
			    else{
			    	this.value = this.value.replace(/(\d{3})\-?(\d{3})\-?/,'$1-$2-');
			    	if(globals.debugApp){
			    		console.log('fired ---> success 2');
			    	}
			    }

			  	//this.value = this.value.replace(/(\d{3})\-?(\d{3})\-?(\d{4})/,'$1-$2-$3');
			    return true;
			  }
			//remove all chars, except dash and digits
			this.value = this.value.replace(/[^\-0-9]/g, '');
		});




		$scope.Chain = globals.Change.chainFriendly;

		var vm = this;
		vm.getSecurityQuestions = getSecurityQuestions;
		vm.register = register;
		vm.selectSecurityQuestion = selectSecurityQuestion;
		vm.kickbackRegistrationUserModel = new KickbackRegistrationUser({});
		vm.currentStep = 'registration';
		vm.selectedSecurityQuestion1 = null;
		vm.selectedSecurityQuestion2 = null;

		function getSecurityQuestions() {
			vm.submittedRegisterForm = true;
			vm.error = null;
			if ($scope.registerForm.$invalid) {
				vm.error = "Please fill in all the fields";
				return;
			}
			if (!$scope.agreedToTerms) {
				vm.error = "You must agree to the terms";
				return;
			}
			if ($scope.registerForm.email.$error.email) {
				vm.error = "Must be a valid email";
				return;
			}
			kickbackRewardsService.securityquestions(vm.kickbackRegistrationUserModel.cardnumber).then(function (securityQuestions) {
				vm.securityQuestions = securityQuestions;
				var i,
					securityQuestionsLength = vm.securityQuestions.length;
				vm.availableSecuityQuestions1 = new Array(securityQuestionsLength);
				vm.availableSecuityQuestions2 = new Array(securityQuestionsLength);
				for (i = 0; i < securityQuestionsLength; i++) {
					//replace the html escaped text
					securityQuestions[i].question = $('<div>').html(securityQuestions[i].question).text();
					vm.availableSecuityQuestions1[i] = securityQuestions[i];
					vm.availableSecuityQuestions2[i] = securityQuestions[i];
				}
				vm.submittedRegisterForm = false;
				vm.error = null;
				vm.currentStep = 'security questions';

				if(globals.debugApp){
					console.log('getSecurityQuestions() fired' + ' .. Going to ' + vm.currentStep);
				}
			}, function (err) {
				vm.error = err;
			});
		}

		function register() {
			vm.submittedRegisterForm = true;
			if(globals.debugApp){
				console.log('register() fired');
			}

			if ($scope.secuirtyQuestionsForm.$invalid) {
				vm.error = "Please fill in all the fields";
				return;
			}

			vm.error = null;

			kickbackRewardsService.register(vm.kickbackRegistrationUserModel).then(function () {
				//nothing, the main module will use kickbackState.registered from the service and show another view	
			}, function (data) {
				vm.error = data.message;
			});
		}

		$scope.backToBeginning = function() {
			vm.submittedRegisterForm = false;
			vm.currentStep = 'registration';

			if(globals.debugApp){
				console.log('goBack() from Security questions was fired' + ' .. Going back to ' + vm.currentStep);
			}
		}

		function selectSecurityQuestion() {
			vm.availableSecuityQuestions1.splice(0, vm.availableSecuityQuestions1.length);
			vm.availableSecuityQuestions2.splice(0, vm.availableSecuityQuestions2.length);
			for (var i = 0, len = vm.securityQuestions.length; i < len; i++) {
				if (!vm.selectedSecurityQuestion1 || vm.securityQuestions[i].id !== vm.selectedSecurityQuestion1.id) {
					vm.availableSecuityQuestions2.push(vm.securityQuestions[i]);
				}
				if (!vm.selectedSecurityQuestion2 || vm.securityQuestions[i].id !== vm.selectedSecurityQuestion2.id) {
					vm.availableSecuityQuestions1.push(vm.securityQuestions[i]);
				}

			}
			if (vm.selectedSecurityQuestion1) {
				vm.securityQuestionText1 = vm.selectedSecurityQuestion1.question;
				vm.kickbackRegistrationUserModel.security1_id = vm.selectedSecurityQuestion1.id;
			} else {
				vm.securityQuestionText1 = null; 
				vm.kickbackRegistrationUserModel.security1_id = null;
			}
			if (vm.selectedSecurityQuestion2) {
				vm.securityQuestionText2 = vm.selectedSecurityQuestion2.question;
				vm.kickbackRegistrationUserModel.security2_id = vm.selectedSecurityQuestion2.id;
			} else {
				vm.securityQuestionText2 = null;
				vm.kickbackRegistrationUserModel.security2_id = null;
			}

		}
	}
} ());