(function(){
	angular.module('connect.kickback-rewards').directive('kickbackSignin', kickbackSignin);
	
	kickbackSignin.$inject = [];
	kickbackSigninCtrl.$inject = ['$scope', 'kickbackRewardsService'];
	
	function kickbackSignin() {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/kickback-signin/connect.kickback-rewards.kickback-signin.html',
			scope: {
				goToRegister: '&',
				showTerms: '&'
			},
			controller: kickbackSigninCtrl,
			controllerAs: 'kickbackSigninCtrl'
		}
	}
	
	function kickbackSigninCtrl($scope, kickbackRewardsService) {

		$scope.Chain = globals.Change.chainFriendly;

		var vm = this;
		vm.kickbackState = kickbackRewardsService.getKickbackState();
		vm.signin = signin;
		
		vm.pin = null;
		vm.cardNumber = null;
		vm.lastName = null;
		
		function signin() {
			vm.submitted = true;
			vm.error = null;
			if($scope.signInForm.$invalid) {
				vm.error = "Please fill in all the fields";
				return;
			}
			if(!$scope.agreedToTerms) {
				vm.error = "You must agree to the terms";
				return;
			}

			if(globals.debugApp){
				console.log("Signing in with (cardnum, pin, last name): " + vm.cardNumber + ' / ' + vm.pin + ' / ' + vm.lastName);
			}

			kickbackRewardsService.signin(vm.cardNumber, vm.pin, vm.lastName).then(function(result){
				if(globals.debugApp){
					console.log(result);
				}
			}, function(data) {
				if(globals.debugApp){
					console.log('ERROR: ' + data.message);
				}
				vm.error = data.message;
			});
		}
		
	}
}());