(function() {
	angular.module('connect.link.account')
		.directive('linkAccount', linkAccountDirective)
		.controller('LinkAccountController', linkAccountController);

	linkAccountDirective.$inject = [];
	linkAccountController.$injectd = ['$scope', '$rootScope', '$http'];

	function linkAccountDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'linkAccount/connect.link.account.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) {

		}
	}

	function linkAccountController($scope, $rootScope, $http) {
		$scope.Submit = false;

		$scope.LinkAccount = function() {
			$scope.Submit = true;
			if (!$('#linkAccountForm').hasClass('ng-invalid')) {

				if (window.device.platform == 'Android') {
					var options = {
						label : "Processing.. Logging in",
						timeout: 120
					};
				} else {
					var options = {
						label : "Processing.. Logging in",
						color: '#000',
						spinnerColor: '#000',
						timeout: 120
					};
				}
				window.wizSpinner.show(options); 
				
				$http.post(GetItemFromLocalData('ClientURL'), soapMessageLinkAccount($scope.email, $scope.password), {timeout: 30000} ).then(function(response) {
					var validated = $(response.data).find('LinkAccountResult').children("Validated").text(); //indicates if the login credentials were valid

					if (validated == "true") {
						navigator.splashscreen.show();

						saveAccountDetailJson(response.data);
						$rootScope.RegisteredUser = true;

						console.log('DEBUG /// ' + getEmail() );

						function Sync() {
							setTimeout(function() {
           						navigator.splashscreen.hide();
       						}, 10000);

       						setTimeout(function() {
								loginSave();
								window.wizSpinner.hide();
							}, 600);
						}; //The Sync Now function which allows the user to force a sync. Sync Now updates the initialSyncDoneTimeout variable (defined in js/sync.js) to 45 seconds and removes the application data version (forces a full download sync) and game version (forces the game assets to be updated)
					
						Sync();	

					} else{
						window.wizSpinner.hide();
						alert('Incorrect email or password', function() {}); //use the custom alert function defined in js/sync.js
					}
				}, function(error) {
					window.wizSpinner.hide();
				
					setTimeout(function() {
						if(globals.debugApp){
							console.log("link account ERROR: " + error);
						}
						navigator.notification.confirm(
							'Server couldnt be reached..',
							callBackFunctionServerDown, // Specify a function to be called
							'Please check your internet signal, Would you like to Retry the login.', ["Yes", "No"]
						);

						function callBackFunctionServerDown(b) {
							if (b == 1) {
								$scope.LinkAccount();
							}
							else{
								// Do nothing
							}
						}
					}, 10);

				});
			}
		};

	}
})();