(function(){
	angular.module('connect.local.data')

	.factory('LocalData', connectLocalDataService);


	function connectLocalDataService(){

		return {

			saveLocalData : function(){
				SaveUserAccountToAppData( JSON.stringify(globals.userAccount) );
				if(globals.debugApp){
					console.log('DEBUG: Content Global.userAccount was saved : ' + JSON.stringify( globals.userAccount ) );
				}
			},

			getElectrumUniqueID : function(){
				var tempElectrumUniqueID; 

				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		tempElectrumUniqueID = globals.userAccount.get('ElectrumUniqueID');  //Get User Account Object	
				}
		      	else{
					tempElectrumUniqueID = localStorage.getItem('Electrum.Unique.ID');
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: getElectrumUniqueID() : ' + tempElectrumUniqueID);
				}
				//return data requested
				if (tempElectrumUniqueID){
					return tempElectrumUniqueID;
				}
				else{
					return '';
				}
			},
			setElectrumUniqueID : function(value){
				//Check if LocalStorage is enabled and SET data
				if( globals.localStorage == false){
		       		globals.userAccount.set('ElectrumUniqueID', value);  
				}
		      	else{
					localStorage.setItem('Electrum.Unique.ID', value);
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: setElectrumUniqueID() - Setting value: ' + value);
				}
			},


			//put in account array
			getUniqueID : function(){
				var tempUniqueID; 

				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		tempUniqueID = globals.userAccount.get('UniqueID');  //Get User Account Object
				}
		      	else{
					tempUniqueID = localStorage.getItem('UniqueID');
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: getUniqueID() : ' + tempUniqueID);
				}

				return tempUniqueID;
			},
			setUniqueID : function(value){
				//Check if LocalStorage is enabled and SET data
				if( globals.localStorage == false){
		       		globals.userAccount.set('UniqueID', value);  //Get User Account Object
				}
		      	else{
					localStorage.setItem('UniqueID', value);
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: setUniqueID() : ' + value);
				}
			},


			//put in account array
			getUserType : function(){
				var tempUserType;  

				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		tempUserType = globals.userAccount.get('UserType');  //Get User Account Object
				}
		      	else{
					tempUserType = localStorage.getItem('UserType');
				}

				
				if(globals.debugApp){
					console.log('USER ACCOUNT: getUserType() : ' + tempUserType);
				}

				return tempUserType;
			},
			setUserType : function(value){
				//Check if LocalStorage is enabled and SET data
				if( globals.localStorage == false){
		       		globals.userAccount.set('UserType', value);  //Get User Account Object
				}
		      	else{
					localStorage.setItem('UserType', value);
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: setUserType() : ' + value);
				}
			},


			//put in account array
			getUserStatus : function(){
				var tempUserStatus;  //Get User Account Object

				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		tempUserStatus = globals.userAccount.get('UserStatus');  //Get User Account Object
				}
		      	else{
					tempUserStatus = localStorage.getItem('UserStatus');
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: getUserStatus() : ' + tempUserStatus);
				}

				return tempUserStatus;
			},
			setUserStatus : function(value){
				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		globals.userAccount.set('UserStatus', value);  //Get User Account Object
				}
		      	else{
					localStorage.setItem('UserStatus', value);
				}

				if(globals.debugApp)
					console.log('USER ACCOUNT: setUserStatus() : ' + value);
			},


			//put in account array
			getReleaseDate : function(){
				var tempReleaseDate;  //Get User Account Object

				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		tempReleaseDate = globals.userAccount.get('ReleaseDate');  //Get User Account Object
				}
		      	else{
					tempReleaseDate = localStorage.getItem('ReleaseDate');
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: getReleaseDate() : ' + tempReleaseDate);
				}

				return tempReleaseDate;
			},
			setReleaseDate : function(value){
				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		globals.userAccount.set('ReleaseDate', value);  //Get User Account Object
				}
		      	else{
					localStorage.setItem('ReleaseDate', value);
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: setReleaseDate() : ' + value);
				}
			},


			getElectrumBarcode : function(){
				var tempElectrumBarcode = globals.userAccount.get('ElectrumBarcode');  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: getElectrumBarcode() : ' + tempElectrumBarcode);
				}

				if (tempElectrumBarcode){
					return tempElectrumBarcode;
				}
				else{
					return '';
				}
			},
			setElectrumBarcode : function(value){
				globals.userAccount.set('ElectrumBarcode', value);  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: getElectrumBarcode() : ' + value);
				}
			},



			getKickbackSignedIn : function(){
				var tempKickbackSignedIn = globals.userAccount.get('KickbackSignedIn');  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: getKickbackSignedIn() : ' + tempKickbackSignedIn);
				}

				if(tempKickbackSignedIn && tempKickbackSignedIn != ''){
					return tempKickbackSignedIn;
				}
				else{
					return 0;
				}
			},
			setKickbackSignedIn : function(value){
				globals.userAccount.set('KickbackSignedIn', value);  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: setKickbackSignedIn() : ' + value);
				}
			},
			getKickbackSignedIn : function(){
				var signedIn = localStorage.getItem('Kickback.SignedIn');
				if(signedIn){
					return signedIn;
				}
				else{
					return 0;
				}
			},

			getBeaconWatchID : function(){
				var tempBeaconWatchID = globals.userAccount.get('BeaconWatchID');  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: getBeaconWatchID() : ' + tempBeaconWatchID);
				}

				return tempBeaconWatchID;

			},
			setBeaconWatchID : function(value){
				globals.userAccount.set('BeaconWatchID', value);  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: setBeaconWatchID() : ' + value);
				}
			},



			getBeaconWatchIDLegacy : function(){
				var beaconwatchid = localStorage.getItem('Beacon.Watch.ID');
				return beaconwatchid;
			},
			
			getDataVersion : function(){ 
				var tempDataVersion = globals.userAccount.get('DataVersion');  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: getDataVersion() : ' + tempDataVersion);
				}

				return parseInt(tempDataVersion);
			},
			setDataVersion : function(value){
				globals.userAccount.set('DataVersion', value);  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: setDataVersion() : ' + value);
				}
			},

			/*
			getDataVersionLegacy : function(){ 
				var dataVersion = window.localStorage.getItem('DataVersion');
				
				return parseInt(dataVersion);
			},


			getSyncNow : function(){ 
				var tempSyncNow = globals.userAccount.get('SyncNow'); //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: getSyncNow() : ' + tempSyncNow);

				if (!tempSyncNow)
					return 0;
				else
					return parseInt(tempSyncNow);
			},
			setSyncNow : function(value){
				globals.userAccount.set('SyncNow', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setSyncNow() : ' + value);
			},


			getSyncNowLegacy : function(){ 
				var syncNow = window.localStorage.getItem('SyncNow');
				if (!syncNow)
					return 0;
				else
					return parseInt(syncNow);
			},
			
			getVerifyPrompt : function(){ // Flag to show email verify prompt
				var tempVerifyPrompt = globals.userAccount.get('VerifyPrompt');  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: getEmail() : ' + tempVerifyPrompt);

				if (!tempVerifyPrompt)
					return 0;
				else
					return parseInt(tempVerifyPrompt);
			},
			setVerifyPrompt : function(value){
				globals.userAccount.set('VerifyPrompt', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setVerifyPrompt() : ' + value);
			},
			getVerifyPromptLegacy : function(){ // Flag to show email verify prompt
				var verifyPrompt = window.localStorage.getItem('VerifyPrompt');
				if (!verifyPrompt)
					return 0;
				else
					return parseInt(verifyPrompt);
			},
			
			getRegisteredUser : function(){
				var tempAccountID = globals.userAccount.get('AccountID'); //Get User Account Object

				if(globals.debugApp)
					console.log('*** USER ACCOUNT: getRegisteredUser() : ' + tempAccountID != null && tempAccountID != '' );

				return tempAccountID != null && tempAccountID != '';
			},


			getAccountID : function(){
				var tempAccountID = globals.userAccount.get('AccountID');  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: getAccountID() : ' + tempAccountID);

				return tempAccountID;
			},
			setAccountID : function(value){
				globals.userAccount.set('AccountID', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setAccountID() : ' + value);
			},
			getRegisteredUserLegacy : function(){
				var accountid = window.localStorage.getItem('AccountID');
				return accountid != null && accountid != '' && accountid != undefined; //returns whether or not the user is registered by checking accountid
			},
			
			getEmail : function(){
				var tempEmail = globals.userAccount.get('Email'); //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: getEmail() : ' + tempEmail);

				return tempEmail;
			},
			setEmail : function(value){
				globals.userAccount.set('Email', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setEmail() : ' + value);
			},
			getEmailLegacy : function(){
				return window.localStorage.getItem('Email');
			},
			
			getFullName : function(){
				var tempFullName = globals.userAccount.get('FullName'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getFullName() : ' + tempFullName);

				return tempFullName;
			},
			setFullName : function(value){
				globals.userAccount.set('FullName', value);  //Get User Account Object
				window.localStorage.setItem('FullName', value);

				if(globals.debugApp)
					console.log('USER ACCOUNT: setFullName() : ' + value);
			},

			
			getFullNameLegacy : function(){
				return window.localStorage.getItem('FullName');
			},
			
			
			getGamePlays : function(){
				var tempGamePlays = globals.userAccount.get('GamePlays'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getGamePlays() : ' + tempGamePlays);

				if (!tempGamePlays)
					tempGamePlays = 0;
				else
					tempGamePlays = parseInt(tempGamePlays);

				return tempGamePlays;
			},
			setGamePlays : function(value){
				globals.userAccount.set('GamePlays', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setGamePlays() : ' + value);
			},
			
			getGamePlaysLegacy : function(){
				var GamePlays = window.localStorage.getItem('GamePlays');
				if (!GamePlays)
					GamePlays = 0;
				else
					GamePlays = parseInt(GamePlays);
				return GamePlays;
			},
			

			
			getNewPlayer : function(){
				var tempNewPlayer = globals.userAccount.get('NewPlayer'); 
				console.log('USER ACCOUNT: getNewPlayer() : ' + tempNewPlayer);

				//returns whether or not this is the first time the user is playing the game
				return parseInt(tempNewPlayer) == 1;
			},
			setNewPlayer : function(value){
				globals.userAccount.set('NewPlayer', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setNewPlayer() : ' + value);
			},
			getNewPlayerLegacy : function(){
				return parseInt(window.localStorage.getItem('NewPlayer')) == 1; //returns whether or not this is the first time the user is playing the game
			},
			
			getPointsLegacy : function(){
				var tempPoints = globals.userAccount.get('Points'); 
				console.log('USER ACCOUNT: getPoints() : ' + tempPoints);

				//returns whether or not this is the first time the user is playing the game
				return parseInt(tempPoints);
			},
			setPoints : function(value){
				globals.userAccount.set('Points', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPoints() : ' + value);
			},
			getPoints : function(){
				return parseInt(window.localStorage.getItem('Points'));
			},

			
			getPromoPlay : function(){
				var tempPromoPlay = globals.userAccount.get('PromoPlay'); 
				console.log('USER ACCOUNT: getPromoPlay() : ' + tempPromoPlay);

				//returns whether or not this is the first time the user is playing the game
				return parseInt(tempPromoPlay);
			},
			setPromoPlay : function(value){
				globals.userAccount.set('PromoPlay', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPromoPlay() : ' + value);
			},
			
			getPromoPlayLegacy : function(){
				return parseInt(window.localStorage.getItem('PromoPlay')); //returns whether or not instant prize is available for this game round
			},




			getGameCard : function(cardNumber){

				if(globals.debugApp)
					console.log('USER ACCOUNT: getGameCard() - Get Card - : ' + cardNumber );

				switch (cardNumber) {
				    case 0:
				        return globals.userAccount.get('card1');
				    case 1:
				        return globals.userAccount.get('card2');
				    case 2:
				        return globals.userAccount.get('card3');
				    case 3:
				        return globals.userAccount.get('card4');
				    case 4:
				        return globals.userAccount.get('card5');
				    case 5:
				        return globals.userAccount.get('card6');
				    case 6:
				        return globals.userAccount.get('card7');
				    case 7:
				        return globals.userAccount.get('card8');
				    case 8:
				        return globals.userAccount.get('card9');
				    case 9:
				        return globals.userAccount.get('card10');
				    case 10:
				        return globals.userAccount.get('card11');
				    case 11:
				        return globals.userAccount.get('card12');
				    case 12:
				        return globals.userAccount.get('card13');
				    default:
				    	return null;
				}
			},
			setGameCard : function(cardName, value){

				if(globals.debugApp)
					console.log('USER ACCOUNT: setGameCard() - Setting Card - : ' + cardName + ' to ' + value);

				switch (cardName) {
				    case 'bg1.png':
				        globals.userAccount.set('card1', value);
				        break;
				    case 'cardfront.png':
				        globals.userAccount.set('card2', value);
				        break;
				    case 'cardback.png':
				        globals.userAccount.set('card3', value);
				        break;
				    case 'cardfrontmatch.png':
				        globals.userAccount.set('card4', value);
				        break;
				    case 'promo.png':
				        globals.userAccount.set('card5', value);
				        break;
				    case '1.png':
				        globals.userAccount.set('card6', value);
				        break;
				    case '2.png':
				        globals.userAccount.set('card7', value);
				        break;
				    case '3.png':
				        globals.userAccount.set('card8', value);
				        break;
				    case '4.png':
				        globals.userAccount.set('card9', value);
				        break;
				    case '5.png':
				        globals.userAccount.set('card10', value);
				        break;
				    case '6.png':
				        globals.userAccount.set('card11', value);
				        break;
				    case '7.png':
				        globals.userAccount.set('card12', value);
				        break;
				    case '8.png':
				        globals.userAccount.set('card13', value);
				        break;
				    default:
				    	return null;
				}
			},


			
			getPushPromo : function(){ //returns the promo that came through a push message
				var tempPushPromo = globals.userAccount.get('PushPromo'); 
				console.log('USER ACCOUNT: getPushPromo() : ' + tempPushPromo);

				if (!tempPushPromo){
					return null; //there are many null returns in factories that indicate something does not exist or not to show or use something
				}
				else{
					tempPushPromo = JSON.parse(tempPushPromo);
					var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;
					var valid = (tempPushPromo.Uses == 0 || tempPushPromo.AccountUses < tempPushPromo.Uses) && now > tempPushPromo.DateStart && now < tempPushPromo.DateEnd; //make sure the promotion is valid before returning it
					if (valid)
						return tempPushPromo;
					else
						return null;
				}
			},
			setPushPromo : function(value){
				globals.userAccount.set('PushPromo', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPushPromo() : ' + value);
			}, 
			getPushPromoLegacy : function(){ //returns the promo that came through a push message
				var PushPromo = window.localStorage.getItem('PushPromo');

				if (!PushPromo)
					return null; //there are many null returns in factories that indicate something does not exist or not to show or use something
				else{
					PushPromo = JSON.parse(PushPromo);
					var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;
					var valid = (PushPromo.Uses == 0 || PushPromo.AccountUses < PushPromo.Uses) && now > PushPromo.DateStart && now < PushPromo.DateEnd; //make sure the promotion is valid before returning it
					if (valid)
						return PushPromo;
					else
						return null;
				}
			},


			//TODO: This should be in a service or a helper method for the Main Controller
			getFocusPromo : function(promos){ //return the promotion to be shown in the focus promotion time of day based now module
				var now = moment().hour();
				var message = ""; //holds the message to be shown in the now module based on the time of day
				if (5 <= now && now <= 10){
					now = 1;
					message = "Start Your Morning Right!";
				}
				else if (11 <= now && now <= 16){
					now = 2;
					message = "How About This for Lunch?";
				}
				else if (17 <= now && now <= 22){
					now = 3;
					message = "Join Us for Dinner!";
				}
				else{
					now = 4;
					message = "Late Night Snack?";
				}
				var focusPromos = [];
				for (var i = 0; i < promos.length; i++){
					if (promos[i].FocusTime == now){
						focusPromos.push(promos[i]); //go through all the promos we have (passed into this function) and get the ones that match this focus time
					}
				}
				if (focusPromos.length == 0) //no promos match the current focus time
					return null;
				else{
					var index = Math.floor(Math.random() * ((focusPromos.length - 1) - 0 + 1)) + 0;
					focusPromos[index].FocusMessage = message;
					return focusPromos[index]; //randomly select one focus promo and return it
				}
			},


			getPhone : function(){
				var tempPhone = globals.userAccount.get('Phone'); 
				console.log('USER ACCOUNT: getPhone() : ' + tempPhone);

				return tempPhone;
			},
			setPhone : function(value){
				globals.userAccount.set('Phone', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPhone() : ' + value);
			},
			getPhoneLegacy : function(){
				return window.localStorage.getItem('Phone');
			},

			
			getBirthday : function(){
				var tempBirthday = globals.userAccount.get('Birthday'); 
				console.log('USER ACCOUNT: getBirthday() : ' + tempBirthday);

				return tempBirthday;
			},
			setBirthday : function(value){
				globals.userAccount.set('Birthday', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setBirthday() : ' + value);
			},
			getBirthdayLegacy : function(){
				return parseInt(window.localStorage.getItem('Birthday'));
			},

			
			getGeoPromo : function(){
				var tempGeoPromo = globals.userAccount.get('GeoPromo'); 
				console.log('USER ACCOUNT: getGeoPromo() : ' + tempGeoPromo);

				return tempGeoPromo;
			},
			setGeoPromo : function(value){
				globals.userAccount.set('GeoPromo', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setGeoPromo() : ' + value);
			}, 
			getGeoPromoLegacy : function(){
				return window.localStorage.getItem('GeoPromo');
			},

			
			getPreferredGas : function(){ //get the user's preferred gas type for display with stores that have gas
				var gasType = globals.userAccount.get('PreferredGas');
				if (!gasType || gasType == '')
					return 'Regular';
				else
					return gasType;
			},
			setPreferredGas : function(value){
				globals.userAccount.set('PreferredGas', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPreferredGas() : ' + value);
			}, 
			getPreferredGasLegacy : function(){ //get the user's preferred gas type for display with stores that have gas
				var gasType = window.localStorage.getItem('PreferredGas');
				if (!gasType)
					return 'Regular';
				else
					return gasType;
			},


			getPushEnabled : function(){ //android only -- get whether or not the user has enabled push
				var tempPushEnabled = globals.userAccount.get('PushEnabled');
				if (!tempPushEnabled || tempPushEnabled == 'true')
					return true;
				else
					return false;
			},
			setPushEnabled : function(value){
				globals.userAccount.set('PushEnabled', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPushEnabled() : ' + value);
			},
			getPushEnabledLegacy : function(){ //android only -- get whether or not the user has enabled push
				var pushenabled = window.localStorage.getItem('PushEnabled');
				if (!pushenabled || pushenabled == 'true')
					return true;
				else
					return false;
			},


			//   RATING MODULE IS NOT BEING USED
			getShowRating : function(){ //get whether or not to show the Rating now module, it should be shown 1 week after the first time the user uses the app
				try{
					var now = moment().toDate().getTime();
					var first = parseInt( globals.userAccount.get('Rating') );
					if (first == 0)
						return false;
					else if ((now - first) > 604800000)
						return true;
					else
						return false;
				}
				catch (err){
					return false;
				}
			},
			setShowRating : function(value){
				parseInt( globals.userAccount.set('Rating', value) )  //Get User Account Object
				console.log('USER ACCOUNT: setShowRating() : ' + value);
			},
			getShowRating : function(){ //get whether or not to show the Rating now module, it should be shown 1 week after the first time the user uses the app
				try{
					var now = moment().toDate().getTime();
					var first = parseInt(window.localStorage.getItem('Rating'));
					if (first == 0)
						return false;
					else if ((now - first) > 604800000)
						return true;
					else
						return false;
				}
				catch (err){
					return false;
				}
			},

			//TODO: Move this to main directory
			getGreeting : function(){
				//var index = Math.floor(Math.random() * ((greetings.length - 1) - 0 + 1)) + 0; //randomly pick a greeting from js/greetings.js to show on the main/now screen header
				var now = moment().hour();
				var message = ""; //holds the message to be shown in the now module based on the time of day
				if (5 <= now && now <= 10){
					message = "Good Morning";
				}
				else if (11 <= now && now <= 16){
					message = "Good Afternoon";
				}
				else if (17 <= now && now <= 22){
					message = "Good Evening";
				}
				else{
					message = "Have a great late night";
				}

				return message;
			},


			getShowFasCash : function(){
				var tempShowFasCash = globals.userAccount.get('FasCash'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getShowFasCash() : ' + tempShowFasCash);

				return !tempShowFasCash;
			},
			setShowFasCash : function(value){
				globals.userAccount.set('FasCash', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setShowFasCash() : ' + value);
			}, 
			getShowFasCashLegacy : function(){
				return !window.localStorage.getItem('FasCash'); //indicates if the user has already registered for fascash in which case do not show the fascash now module (only used for Fas APP)
			},


			getFasCashApplication : function(){ //gets (if available) a saved in progress fas cash application
				var tempFasCashApplication = globals.userAccount.get('FasCashApplication'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getFasCashApplication() : ' + tempFasCashApplication);

				if (tempFasCashApplication){
					return JSON.parse(sjcl.decrypt("FasCashApplication", tempFasCashApplication));
				}
				else
					return null;
			},
			setFasCashApplication : function(){ //gets (if available) a saved in progress fas cash application
				globals.userAccount.set('FasCashApplication', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setFasCashApplication() : ' + tempFasCashApplication);
			},/*
			getFasCashApplicationLegacy : function(){ //gets (if available) a saved in progress fas cash application
				var application = window.localStorage.getItem('FasCashApplication');
				if (application){
					return JSON.parse(sjcl.decrypt("FasCashApplication", application));
				}
				else
					return null;
			},

			*/


			//get whether or not to show the now share module, should show up every week starting with the first time 
			//the app is launched. 
			//Does not need a SET function. 
			getShowShare : function(){ 
				var tempShowShare = globals.userAccount.get('ShowShare'); 

				if(globals.debugApp){
					console.log('USER ACCOUNT: getShowShare() : ' + tempShowShare);
				}
	
				var now = moment().toDate().getTime();

				if (tempShowShare){
					if (now - tempShowShare > 604800000){
						globals.userAccount.set('ShowShare', now);  //set
						return true;
					}
					else{
						return false;
					}
				}
				else{
					globals.userAccount.set('ShowShare', now);  //set
					return true;
				}
			},

			/*
			getShowShareLegacy : function(){ 
				//get whether or not to show the now share module, should show up every week starting with the first time 
				//the app is launched
				var sharelast = parseInt(window.localStorage.getItem('Share.Last'));
				var now = moment().toDate().getTime();
				if (sharelast){
					if (now - sharelast > 604800000){
						window.localStorage.setItem('Share.Last', now);
						return true;
					}
					else
						return false;
				}
				else{
					window.localStorage.setItem('Share.Last', now);
					return true;
				}
			},
			*/



			getAppVersion : function(){ //get the version of the app to show on the about screen
				var tempAppVersion = globals.userAccount.get('AppVersion'); 
				console.log('USER ACCOUNT: getProductVersion() : ' + tempAppVersion);

				if (tempAppVersion && tempAppVersion != ''){
					return tempAppVersion;
				}
				else{
					return '2.x';
				}
			},
			setAppVersion : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('AppVersion', value); 

				if(globals.debugApp){
					console.log('USER ACCOUNT: setAppVersion() : ' + value);
				}
			},

			/*
			getProductVersionLegacy : function(){ //get the version of the app to show on the about screen
				var productVersion = window.localStorage.getItem('AppVersion');
				if (productVersion)
					return productVersion;
				else
					return '2.x';
			},
			*/

/*
			getDeviceModel : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempDeviceModel = globals.userAccount.get('DeviceModel'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getDeviceModel() : ' + tempDeviceModel );

				return tempDeviceModel;
			},
			setDeviceModel : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('DeviceModel', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setDeviceModel() : ' + value);
			}, 

			getDeviceType : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempDeviceType = globals.userAccount.get('DeviceType'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getDeviceType() : ' + tempDeviceType );

				return tempDeviceType;
			},
			setDeviceType : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('DeviceType', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setDeviceType() : ' + value);
			}, 

			getDeviceVersion : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempDeviceVersion = globals.userAccount.get('DeviceVersion'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getDeviceVersion() : ' + tempDeviceVersion );

				return tempDeviceVersion;
			},
			setDeviceVersion : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('DeviceVersion', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setDeviceVersion() : ' + value);
			}, 

			getDeviceOS : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempDeviceOS = globals.userAccount.get('DeviceOS'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getDeviceOS() : ' + tempDeviceOS );

				return tempDeviceOS;
			},
			setDeviceOS : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('DeviceOS', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setDeviceOS() : ' + value);
			}, 





			getPushToken : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempPushToken = globals.userAccount.get('PushToken'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getPushToken() : ' + tempPushToken);

				return tempPushToken;
			},
			setPushToken : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('PushToken', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPushToken() : ' + value);
			}, 


			getTokenID : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempTokenID = globals.userAccount.get('TokenID'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getTokenID() : ' + tempTokenID);

				return tempTokenID;
			},
			setTokenID : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('TokenID', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setTokenID() : ' + value);
			}, 


			getUDID : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempUDID = globals.userAccount.get('UDID'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getUDID() : ' + tempUDID);

				return tempUDID;
			},
			setUDID : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('UDID', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setUDID() : ' + value);
			}, 	


			getAppRestart : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempAppRestart = globals.userAccount.get('AppRestart'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getAppRestart() : ' + tempClientLog);

				return tempAppRestart;
			},
			setAppRestart : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('AppRestart', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setAppRestart() : ' + value);
			}, 




			getPromosConstruct : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempPromosConstruct = globals.userAccount.get('PromosConstruct'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getPromosConstruct() : ' + tempPromosConstruct);

				return tempPromosConstruct;
			},
			setPromosConstruct : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('PromosConstruct', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPromosConstruct() : ' + value);
			}, 


			getStoreListRetry : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempStoreListRetry = globals.userAccount.get('StoreListRetry'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getStoreListRetry() : ' + tempStoreListRetry);

				return tempStoreListRetry;
			},
			setStoreListRetry : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('StoreListRetry', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setStoreListRetry() : ' + value);
			}, 


			getPromoRetry : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempPromoRetry = globals.userAccount.get('PromoRetry'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getPromoRetry() : ' + tempPromoRetry);

				return tempStoreListRetry;
			},
			setPromoRetry : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('PromoRetry', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPromoRetry() : ' + value);
			}, 



			getGameProgress : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempGameProgress = globals.userAccount.get('GameProgress'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getGameProgress() : ' + tempGameProgress);

				return tempGameProgress;
			},
			setGameProgress : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('GameVersion', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setGameProgress() : ' + value);
			},



			getVersion : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempVersion = globals.userAccount.get('Version'); 
				console.log('USER ACCOUNT: getVersion() : ' + tempVersion);

					return tempVersion;
			},
			setVersion : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('Version', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setVersion() : ' + value);
			},


			getGameVersion : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempGameVersion = globals.userAccount.get('GameVersion'); 
				console.log('USER ACCOUNT: getPoints() : ' + tempGameVersion);

				if (!tempGameVersion || tempGameVersion == '')
					return null;
				else
					return tempGameVersion;
			},
			setGameVersion : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('GameVersion', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setGameVersion() : ' + value);
			},

			*/

			getGameVersionLegacy : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var gameversion = window.localStorage.getItem('Game.Version');
				if (!gameversion){
					return null;
				}
				else{
					return gameversion;
				}
			}
		};
	}
})();