(function() {
		angular.module('connect.participating.stores')
			.directive('participatingStores', participatingStoresDirective)
			.controller('ParticipatingStoresController', participatingStoresController);

		participatingStoresDirective.$inject = [];

		participatingStoresController.$inject = ['$scope', '$rootScope', '$timeout', 'ClientSet', 'Loading'];

		function participatingStoresDirective() {
			var directive = {
				restrict: 'E',
				templateUrl: 'participatingStores/connect.participating.stores.html',
				link: link
			};

			return directive;

			function link(scope, element, attrs) {

			}
		}

		function participatingStoresController($scope, $rootScope, $timeout, ClientSet, Loading) {

			$('#participatingStores').on('pageinit', function(){
				$('#participatingStoresList').css('height', $(window).height() - 50);
			});	//set participating store list to exact height, participatingStoresList does not use data-iscroll since it tends to cause bugs


			$('#participatingStores').on('pageshow', function(){
				window.wizSpinner.hide();
				$('#participatingStoresList').listview().listview('refresh'); //refresh the list since it changes based on which store is being selected
			}); 


			$scope.chainFriendly = globals.Change.chainFriendly;
			$scope.Call = function(store) {
				window.location.href = 'tel:' + store.Phone;
				saveClientLog(53, store.StoreID, 0, '', 0, 'calling store');
			};

			$scope.Navigate = function(store) {
				if (window.device.platform == 'Android') {
					PhoneNavigator.doNavigate(store.Latitude, store.Longitude, function() {}, function() {});
				} else
					window.location.href = 'maps:daddr=' + store.Latitude + "," + store.Longitude;
				saveClientLog(57, store.StoreID, 0, '', 0, 'checking directions for store');
			};

			$scope.Share = function(store) {
				window.plugins.socialsharing.share('I went to the ' + store.Address1 + " " + store.Address2 + " " + store.City + ", " + store.State + " " + globals.Change.chainFriendly + "." + '\n' + ClientSet.getSocialShareURL(), 'Check out this great ' + globals.Change.chainFriendly + ' location.');
				saveClientLog(0, store.StoreID, 0, '', 0, 'user shared store');
			};

			$scope.Feedback = function(store) {
				$timeout(function() {
					$rootScope.FeedbackStore = store;
					$rootScope.AppFeedback = false;
				}, 1);
				$.mobile.changePage('#feedback');
			};

			$scope.Extra = 0;
			$scope.viewStoreDetails = function(store) {
				$timeout(function() {
					if ($scope.Extra == store.StoreID){
						$scope.Extra = 0;
					}
					else{
						$scope.Extra = store.StoreID;
					}

					saveClientLog(51, store.StoreID, 0, '', 0, 'viewed store details');
				});
			}

			//TODO: only resolve no reject
			Loading.then(function() {
				$scope.ShowGas = ClientSet.getShowGasPrice();
			});

			$scope.getGasPrice = function(Store) {
				var gasType = getPreferredGas();
				if (gasType == 'Plus') {
					if (Store.PlusPrice > 0){
						return 'Plus: $' + Store.PlusPrice.toFixed(2);
					}
					else{
						return '';
					}
				} else if (gasType == 'Premium') {
					if (Store.PremiumPrice > 0){
						return 'Prem: $' + Store.PremiumPrice.toFixed(2);
					}
					else{
						return '';
					}
				} else if (gasType == 'Diesel'){
					if (Store.DieselPrice > 0){
						return 'Dies: $' + Store.DieselPrice.toFixed(2);
					}
					else{
						return '';
					}
				} else if (gasType == 'Kerosene') {
					if (Store.KerosenePrice > 0){
						return 'Ker: $' + Store.KerosenePrice.toFixed(2);
					}
					else{
						return '';
					}
				} else {
					if (Store.RegularPrice > 0){
						return 'Reg: $' + Store.RegularPrice.toFixed(2);
					}
					else{
						return '';
					}
				}
			};


			$scope.getGasLastUpdate = function(GasLastUpdate) {

				var date = new Date(GasLastUpdate);
				var hour = date.getHours();
				var minute = date.getMinutes();
				var ap = "AM";
				if (hour > 11) {
					ap = "PM";
				}
				if (hour > 12) {
					hour = hour - 12;
				}
				if (hour == 0) {
					hour = 12;
				}
				//   if (hour   < 10) { hour   = "0" + hour;   }
				if (minute < 10) {
					minute = "0" + minute;
				}
				var timeString = hour + ':' + minute + ' ' + ap;
				var formattedDateString = (date.getMonth() + 1) + '/' + date.getDate() + ' ' + timeString; //date.format("m/dd h:MM Z");
				return formattedDateString;
			};

		}
})();