(function() {
	angular.module('connect.passwordchange')
		.directive('passwordChange', passwordChangeDirective)
		.controller('ChangePasswordController', passwordChangeController);

	passwordChangeDirective.$inject = [];

	passwordChangeController.$inject = ['$scope', '$http'];

	function passwordChangeDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'passwordChange/connect.passwordchange.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) {	}
	}

	function passwordChangeController($scope, $http) {

		// ON HIDE
		$('#changePassword').on('pagehide', function(){ //refresh the interests on the page on pagehide in case the user has updated them
			var scope = angular.element($("#changePassword")).scope();
			 scope.$apply(function(){
           	 scope.oldPassword = '';
	  		 scope.newPassword = '';
	  		 scope.Submit = false;
 		   });
		});
		// ON SHOW
		$('#changePassword').on('pageshow', function(){ //when the page is shown, update the form fields with the user's current info if available
			var scope = angular.element($("#changePassword")).scope();
			 scope.$apply(function(){
        	 scope.oldPassword = '';
	  	 	 scope.newPassword = '';
	   		 scope.Submit = false;
  			});
		}); 

		$scope.Submit = false;
		$scope.ChangePassword = function() {
			$scope.Submit = true;

			if (!$('#changePasswordForm').hasClass('ng-invalid')) {
				
				if (window.device.platform == 'Android') {
					var options = {
						label : "Changing Password...",
						timeout: 120
					};
				} else {
					var options = {
						label : "Changing Password...",
						color: '#000',
						spinnerColor: '#000',
						timeout: 120
					};
				}
				window.wizSpinner.show(options); 

				$http.post(GetItemFromLocalData('ClientURL'), soapMessageChangeAccountPassword($scope.oldPassword, $scope.newPassword), {timeout: 26000}).then(function(response) {
					window.wizSpinner.hide();

					var processed = $(response.data).find('ChangeAccountPasswordResult').children("Processed").text(); //indicates whether or not the web method was processed correctly (comes from the server)
					var error = $(response.data).find('Standard').children('MethodErrorMsg').text(); //indicates the error message (if any)
					if (processed == "true") {
						var successmessage = $(response.data).find('ChangeAccountPasswordResult').children("SuccessMsg").text();
						if (successmessage != ''){
							navigator.notification.alert(
								successmessage, // message
								function() {}, // callback
								'Success!', // title
								'Ok' // buttonName
							); //if the server sent back a success message then show it (note: go through the app and change any success messages like "Account Created" to success messages from the server, same with any error messages)
						}
						else{
							navigator.notification.alert(
								'Your password has been changed.', // message
								function() {}, // callback
								'Success!', // title
								'Ok' // buttonName
							); //if the server marks the request processed but did not send back a success message then show our own
						}
						setTimeout(function() {
							$scope.oldPassword = '';
							$scope.newPassword = '';
							$scope.Submit = false;
						}, 500); //clear the change password form
						$.mobile.changePage('#accountDetails');
					} else{
						alert(error, function() {});
					}
				}, function(error) {
					window.wizSpinner.hide();
					$rootScope.Error(globals.ajaxTimeoutMessage, function() {}, false, function() {});
				});
			}
		};
	}
})();