(function() {
	angular.module('connect.password.reset')
		.directive('passwordReset', passwordResetDirective)
		.controller('PasswordResetController', passwordResetController);

	passwordResetDirective.$inject = [];
	passwordResetController.$inject = ['$scope', '$http'];

	function passwordResetDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'passwordReset/connect.password.reset.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) { }
	}

	function passwordResetController($scope, $http) {
		var token;
		$scope.Submit = false;

		$scope.ResetPassword = function() {
			$scope.Submit = true;
			$scope.noError = false;

			if (!$('#passwordResetForm').hasClass('ng-invalid')) {
				$scope.noError = true;
				
				if (window.device.platform == 'Android') {
					var options = {
						label : "Processing.."
					};
				} else {
					var options = {
						label : "Processing..",
						color: '#000',
						spinnerColor: '#000'
					};
				}
				window.wizSpinner.show(options); 
				
				$http.post(GetItemFromLocalData('ClientURL'), soapMessageAccountPasswordResetStart($scope.email), {timeout: 22000}).then(function(response) {

					token = $(response.data).find('AccountPasswordResetStartResult').children("TokenID").text();

					$http.post(GetItemFromLocalData('ClientURL'), soapMessageAccountPasswordResetEnd(token, $scope.email), {timeout: 22000}).then(function(response) {
						
						window.wizSpinner.hide();
						var errormessage = $(response.data).find('Standard').children("MethodErrorMsg").text();
						if (errormessage == '') {
							var successmessage = $(response.data).find('AccountPasswordResetEndResult').children("SuccessMsg").text();
							if (successmessage != ''){
								navigator.notification.alert(
									successmessage, // message
									function() {}, // callback
									'Success!', // title
									'Ok' // buttonName
								);
							}
							else{
								navigator.notification.alert(
									"We've reset your password. A new one will be emailed to you. This may take up to 60 minutes to be processed.", // message
									function() {}, // callback
									'Success!', // title
									'Ok' // buttonName
								);
							}
							setTimeout(function() {
								$scope.email = '';
								$scope.Submit = false;
							}, 500);
							$.mobile.back();
						} else {
							alert(errormessage, function() {
								console.log("..");
							});
						}
					}, function(error) {
						window.wizSpinner.hide();
						$rootScope.Error(globals.ajaxTimeoutMessage, function() {
							if(globals.debugApp){
								console.log("..");
							}
						}, false, function() {
							if(globals.debugApp){
								console.log("..");
							}
						});
					});
				}, function(error) {
					window.wizSpinner.hide();
					$rootScope.Error(globals.ajaxTimeoutMessage, function() {
						if(globals.debugApp){
							console.log("..");
						}
					}, false, function() {
						if(globals.debugApp){
							console.log("..");
						}
					});
				});
			}
		};
	}
})();