(function() {
	angular.module('connect.prizes')
		.directive('prizes', prizesDirective)
		.controller('PrizesController', prizesController);

	prizesDirective.$inject = [];
	prizesController.$inject = ['$scope', '$rootScope', '$timeout', 'Loading', '$compile'];

	function prizesDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'prizes/connect.prizes.html',
			link: link
		};
		return directive;

		function link(scope, element, attrs) {}
	}

	function prizesController($scope, $rootScope, $timeout, Loading, $compile) {

		Loading.then(function(){
			$timeout(function(){
				$scope.showLatestPrizeData();
			}, 1);
		});

		$('#prizes').on('pageshow', function(){
			$("#prizes #prizesContainer").animate({opacity:1}, 400);

			saveClientLog(31, 0, 0, '', 0, 'viewed loyalty promotions');

			if( $('#prizescroller').iscrollview() ){
				$('#prizescroller').iscrollview('refresh');
			}
			//console.log('Prizes in scope (prizes directive) : ' + JSON.stringify( $scope.PrizeHeaders ) );
			
			$('#prizesLoading').animate({opacity:0}, 400);
			setTimeout(function(){
				$('#prizesLoading').hide();
			},380);
		});

		$("#prizes").on('pageinit', function(){
			//MAIN Screen Resize
			var height = $(window).height(); // android and ios
			var width = $(window).width(); 

			$("#prizes .ui-content").css('height', height - $('#prizes .ui-header').height() - $('#prizes .ui-footer').height() );
			$("#prizes .ui-content").css('width', width );
			$("#prizes #prizesPageContent").css('width', width );

			$("#prizes .prizeHeaderWrapper").css('width', width );
			$("#prizes .prizeHeader").css('width', width );
			$("#prizes #prHeaderContainer").css('width', width );
			$("#prizes #prizescroller").css('width', width );
			$("#prizes #prizesContainer").css('width', width * .333 - 5 );
			$("#prizes .prizeHeader").css('height', height * .038 );

			$("#prizes .prizetext").css('height',  height * .0355 );
			$("#prizes .prizeimage").css('width', width * .3333 - 3.5 );
			$("#prizes .prizeimage").css('height', ( width * .3333 ) - $('#prizes .prizetext').height() );
			$("#prizes .prizetext").css('width', $('#prizes .prizeimage').width() - 4 );
			$("#prizes .prizetext").css('bottom', $("#prizesPageContent .prizetext").height() );
			$("#prizes .prizetext").css('left', 0 );

			$("#prizes #prizesContainer").css('height', $("#prizesPageContent .prizeimage").height() +  $("#prizesPageContent .prizetext").height() + 4);
			$("#prizes #prHeaderContainer").css('height', 'auto' );

		});

		$('#prizes').on('pagehide', function(){
			$("#prizes #prizesContainer").animate({opacity:0}, 400);
			$('#prizesLoading').hide();
		});


		$scope.showLatestPrizeData = function() {

			if(globals.debugApp){
				console.log('PRIZES-Debug: Sorting the latest Prize Data.');
			}

			var prizes = getAllPromos(1, 'showLatestPrizeData() in scope..');
			var ip = prizes.filter(function(item) {
				return (item.PromoAccount == 1)
			});

			if (prizes.length > 0) {
				var prizeHeaders = [];
				prizes = prizes.filter(function(item) {
					return (item.PromoAccount != 1);
				});
				prizes.sort(function(a, b) {
					return a.Points - b.Points
				});
				prizeHeaders.push({
					Points: prizes[0].Points,
					Prizes: []
				});

				prizeHeaders[0].Prizes.push(prizes[0]);

				for (var i = 1; i < prizes.length; i++) {
					if (prizes[i].Points == prizeHeaders[prizeHeaders.length - 1].Points)
						prizeHeaders[prizeHeaders.length - 1].Prizes.push(prizes[i]);
					else {
						prizeHeaders.push({
							Points: prizes[i].Points,
							Prizes: []
						});
						prizeHeaders[prizeHeaders.length - 1].Prizes.push(prizes[i]);
					}
				}
				
				$timeout(function() {
					$scope.PrizeHeaders = prizeHeaders;
				}, 1);
			} else{
				$scope.PrizeHeaders = [];
				if(globals.debugApp){
					console.log('PRIZES-Debug: Prizes were empty!!!');
				}
			}
			if (ip.length > 0) {
				$timeout(function() {
					$rootScope.InstantPrize = ip[0];
				});
			}
		};


		$scope.getPoints = function() {
			return getPoints();
		};

		$scope.viewPromo = function(Prize) {
			if (window.device.platform == 'Android'){
				var options = {
					label : "Loading Prize"
				};
				window.wizSpinner.show(options);
			}
			if ($scope.getPoints() >= Prize.Points) {
				$rootScope.Promo = Prize;
				$rootScope.promoDialogPic = Prize.PhotoURL;
				$rootScope.PromoRedemption = false;
				$rootScope.PrizeRedemption = true;
				$rootScope.notRedeemable = Prize.PromoUse == 0;

				var coldestIndex = null;
				var coldestRatio = 0;
				try {
					myimage = new Image();
					myimage.src = $rootScope.Promo.PhotoURL;
					var colorThief = new ColorThief();
					var colors = colorThief.getPalette(myimage, 9);
					for (var i = 0; i < 9; i++) {
						if (((colors[i][2] / colors[i][0]) > coldestRatio) && (((colors[i][0] + colors[i][1] + colors[i][2]) / 3) < 200)) {
							coldestRatio = colors[i][2] / colors[i][0];
							coldestIndex = i;
						}
					}
				} catch (err) {
					if (coldestIndex == null)
						$('.promoDialogDescription').css('color', 'black');
					else {
						var r = colors[coldestIndex][0];
						var g = colors[coldestIndex][1];
						var b = colors[coldestIndex][2];
						$('.promoDialogDescription').css('color', 'rgb(' + r + ',' + g + ',' + b + ')');
					}
				}

				$timeout(function() {
					$.mobile.changePage('#promodog');
				});

				saveClientLog(32, $rootScope.Promo.PromoID, 0, '', 0, 'viewed loyalty promotion');
			}
		};

		$scope.prizesRefreshBut = function(){
			console.log("Refresh in PROMOS page was Called! ");
			$scope.promosIsSyncing = true;

			if (window.device.platform == 'Android'){
				var options = {
					label : "Updating and refreshing Prizes"
				};
			}
			else{
				var options = {
					label : "Updating and refreshing Prizes",
					color : '#000',
					spinnerColor : '#000'
				}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
			} 
			window.wizSpinner.show(options);

			$('#prizesLoading').show();
			$('#prizesLoading').animate({opacity:1}, 400);
			
			refreshPromoHead($scope, $rootScope, $timeout, $compile, 1 ); //refreshed and downloads header, promos, and promo images if there are new ones
		};

		$scope.prizePageRefresh = function(){

			setTimeout(function(){
				$("#prizeWrapper").html($compile( ' ' +
					'<div class = "prizeHeaderWrapper" ng-show="InstantPrize && validPrize(InstantPrize)">' +
						'<div id = "prHeaderContainer">' +
							'<div class="prizeHeader">' +
								'Instant Prize' +
							'</div>' +
							'<div id = "prizesrow">' +
								'<div id = "prizesContainer">' +
									'<a ng-click="viewPromo(InstantPrize)">' +
										'<div><img class="prizeimage" src="{{InstantPrize.PhotoURL}}"/></div>' +
										'<div id = "instantPrizeDescription" class="prizetext">{{InstantPrize.Descript1}}</div>' +
									'</a>' +
								'</div>' +
							'</div>' +
						'</div>' +
					'</div>' +
					'<div class = "prizeHeaderWrapper" ng-repeat="PrizeHeader in PrizeHeaders" ng-show="PrizeHeaders.length > 0">' +
						'<div id = "prHeaderContainer">' +
							'<div class="prizeHeader">' +
								'{{PrizeHeader.Points}}' +
							'</div>' +
							'<div id = "prizesrow">' +
								'<div ng-repeat="Prize in PrizeHeader.Prizes" ng-class="{\'disabledPrize\' : Prize.Points > getPoints()}" ng-show = "validPrize(Prize)">' +
									'<div id = "prizesContainer">' +
										'<a ng-click="viewPromo(Prize)">' +
											'<div><img class="prizeimage " src="{{Prize.PhotoURL}}"/></div>' +
											'<div class="prizetext"> {{Prize.Descript1}} </div>' +
										'</a>' +
									'</div>' +
								'</div>' +
							'</div>' +
						'</div>' +
					'</div>' +
					'<div id="prizePad"></div>' )($scope));   // Append new elements 
			
				$scope.$apply();
			}, 10);	


			setTimeout(function(){
				//PRIZE PAGE Screen Resize
				var height = $(window).height(); // android and ios
				var width = $(window).width(); 

				$("#prizes .ui-content").css('height', height - $('#prizes .ui-header').height() - $('#prizes .ui-footer').height() );
				$("#prizes .ui-content").css('width', width );
				$("#prizes #prizesPageContent").css('width', width );

				$("#prizes .prizeHeaderWrapper").css('width', width );
				$("#prizes .prizeHeader").css('width', width );
				$("#prizes #prHeaderContainer").css('width', width );
				$("#prizes #prizescroller").css('width', width );
				$("#prizes #prizesContainer").css('width', width * .333 - 5 );
				$("#prizes .prizeHeader").css('height', height * .038 );

				$("#prizes .prizetext").css('height',  height * .0355 );
				$("#prizes .prizeimage").css('width', width * .3333 - 3.5 );
				$("#prizes .prizeimage").css('height', ( width * .3333 ) - $('#prizes .prizetext').height() );
				$("#prizes .prizetext").css('width', $('#prizes .prizeimage').width() - 4 );
				$("#prizes .prizetext").css('bottom', $("#prizesPageContent .prizetext").height() );
				$("#prizes .prizetext").css('left', 0 );

				$("#prizes #prizesContainer").css('height', $("#prizesPageContent .prizeimage").height() +  $("#prizesPageContent .prizetext").height() + 4);
				$("#prizes #prHeaderContainer").css('height', 'auto' );

				if(globals.debugApp){
					console.log('STARTING PRIZES CAROUSEL ON PRIZES PAGE');
				}
				
				setTimeout(function(){
					$("#prizes #prizesContainer").animate({opacity:1}, 400);
					window.wizSpinner.hide();

					if(globals.debugApp){
						console.log('End of Prize Refresh');
					}

					$('#prizesLoading').animate({opacity:0}, 400);

					if($('#prizescroller').iscrollview() ){
						$('#prizescroller').iscrollview('refresh');
					}
				}, 10);	

				setTimeout(function(){
					$('#prizesLoading').hide();
				}, 400);	
				$rootScope.$apply();
			},120);
		}

		$scope.getPointsClass = function(Points) {
			var myPoints = getPoints();
			if (myPoints >= Points){
				return "prizePoints blue";
			}
			else{
				return "prizePoints red";
			}
		};

		$scope.validPrize = function(Prize) {
			var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;
			var valid = now > Prize.DateStart && now < Prize.DateEnd;
			return valid;
		};

	}

})();