(function() {
	angular.module('connect.promo.dialog')
		.directive('connectPromoDialog', connectPromoDialogDirective)
		//TODO: rename PromoDialogController to convention
		.controller('PromoDialogController', promoDialogController);

	connectPromoDialogDirective.$inject = [];
	promoDialogController.$inject = ['$scope', '$rootScope', '$http', '$timeout', 'ClientSet'];

	var ajaxTimeoutPromoMessage = 'We were unable to contact the server. May we suggest moving to an area with a stronger internet connection or try again later?'; //the message the user sees

	function connectPromoDialogDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'promoDialog/connect.promo.dialog.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) {  }
	}

	function promoDialogController($scope, $rootScope, $http, $timeout, ClientSet) {

		$scope.redeemNow = false; //determines if a redeemNow is in progress, certain things are shown/hidden or buttons disabled based on this (see main.html)
		var CouponRedemptionFilePart;
		var oldBrightVal;

		//function for opening external link (in case Descript2) is a link, this prevents the app from visiting a 
		//link within the same web view as PhoneGap and instead opens a new browser window on the device (this prevents 
		//the app from getting stuck on a web page since there is no back button, especially on ios)
		$scope.openExternalLink = function(PromoLink) {
			if (window.device.platform === 'Android') {
				navigator.app.loadUrl(PromoLink, {
					openExternal: true
				});
			} else {
				window.open(PromoLink, '_system');
			}
		} 


		$scope.Redeem = function() { //function for the redeem button
			if ($rootScope.RegisteredUser) {
				navigator.notification.confirm(
					'This offer displays for a limited amount of time. You should be at the register before redeeming this offer. Are you ready to redeem now?',
					callBackFunctionRedeem, // Specify a function to be called
					'Ready?', ["Yes", "No"]
				);

				function callBackFunctionRedeem(b) {
					if (b == 1) { //callback for the user choosing yes
						if (window.device.platform == 'Android'){
							var options = {
								label : "Loading Redemption"
							};
						}
						else{
							var options = {
								label : "Loading Redemption",
								color : '#000',
								spinnerColor : '#000'
							}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
						} 
						window.wizSpinner.show(options);

						$("#promopic").animate({
							opacity: 0
						}, 250);

						$("#promoDescriptionTwo").animate({
							opacity: 0
						}, 250); //animate out promo pic and descript2 so that the transition is smoother

						if ($rootScope.inStore) {
							$scope.Latitude = $rootScope.Latitude;
							$scope.Longitude = $rootScope.Longitude;
							$scope.Accuracy = $rootScope.Accuracy;
							$scope.StoreID = $rootScope.inStore.StoreID;
							redeemNow();
						} 
						else {
							navigator.geolocation.getCurrentPosition(function(position) {
								$scope.Latitude = position.coords.latitude;
								$scope.Longitude = position.coords.longitude;
								$scope.Accuracy = position.coords.accuracy;
								$scope.StoreID = 0;
								redeemNow();
							}, function(error) {
								navigator.geolocation.getCurrentPosition(function(position) {
									$scope.Latitude = position.coords.latitude;
									$scope.Longitude = position.coords.longitude;
									$scope.Accuracy = position.coords.accuracy;
									$scope.StoreID = 0;
									redeemNow();
								}, function(error) {
									$scope.Latitude = 0;
									$scope.Longitude = 0;
									$scope.Accuracy = 0;
									$scope.StoreID = 0;
									redeemNow();
								}, {
									enableHighAccuracy: false,
									maximumAge: 10000,
									timeout: 5000
								});
							}, {
								enableHighAccuracy: true,
								maximumAge: 10000,
								timeout: 5000
							});
						} //if the user is in store then take note of their location, otherwise try getting location again so 
						//we can determine store redemptions on the back end (this will later be replaced with beacons and gps will be back up for this scenario)
						

						function redeemNow() { //call web methods for redemptions

							if(globals.debugApp){
								console.log("RedeemNow() function has been launched!.. retreiving barcode...");
							}

							$http.post(GetItemFromLocalData('ClientURL'), soapMessagePromoRedeem($rootScope.Promo.PromoID, $scope.StoreID, $scope.Latitude, $scope.Longitude, $scope.Accuracy, 1), {timeout: 30000} ).then(function(response) {
								
								if(globals.debugApp){
									console.log("Server sent promo info...");
								}

								var error = $(response.data).find('Standard').children('MethodErrorMsg').text();

								if (parseInt($(response.data).find('PromoRedeemResult').children("PromoOK").text()) == 1) {
									var data1 = response.data; //store the response from the first web method call, redemption uses a 2 step process

									if(globals.debugApp){
										console.log("RedeemNow() First step successful.. Second step process started...");
									}

									$http.post(GetItemFromLocalData('ClientURL'), soapMessagePromoRedeem($rootScope.Promo.PromoID, $scope.StoreID, $scope.Latitude, $scope.Longitude, $scope.Accuracy, 2), {timeout: 30000} ).then(function(response) {
										
										if(globals.debugApp){
											console.log("RedeemNow() Second step successful.. ENTERING StartRedeemNow()...");
										}
										startRedeemNow(data1, response.data); //start redeem now on the client and pass in the data from both web methods response
									}, function(error) {
										
										//$rootScope.Error(ajaxTimeoutPromoMessage, function() {
										window.wizSpinner.hide();

										navigator.notification.confirm(
											'Server couldnt be reached..',
											callBackFunctionServerDown, // Specify a function to be called
											'Please check your internet signal, Would you like to Retry.', ["Yes", "No"]
										);

										$("#promopic").animate({
											opacity: 1
										}, 250);

										$("#promoDescriptionTwo").animate({
											opacity: 1
										}, 250); //animate out promo pic and descript2 so that the transition is smoother

										function callBackFunctionServerDown(b) {
											if (b == 1) {
												if (window.device.platform == 'Android'){
													var options = {
														label : "Loading Redemption"
													};
												}
												else{
													var options = {
														label : "Loading Redemption",
														color : '#000',
														spinnerColor : '#000'
													}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
												} 
												window.wizSpinner.show(options);
												redeemNow();
											}
											else{
												$.mobile.changePage('#promos');
											}
										}

										if(globals.debugApp){
											console.log("Promo Redeem error. error 2");
										}
									});
								} else {
									window.wizSpinner.hide();
									if(globals.debugApp){
										console.log("Promo invalid... error 1");
									}

									alert(error, function() {});

									navigator.notification.confirm(
										'Promo is invalid',
										callBackFunctionServerDown, // Specify a function to be called
										'Please try refreshing promos, Click "Sync Now" in the "More" Settings to refresh data', ["Ok"]
									);

									$("#promopic").animate({
										opacity: 1
									}, 250);

									$("#promoDescriptionTwo").animate({
										opacity: 1
									}, 250); //animate out promo pic and descript2 so that the transition is smoother

									function callBackFunctionServerDown(b) {
										if (b == 1) {
											//window.localStorage.setItem('PromoRetry',1); //set promoRetry and go to promos page, a promo sync will happen
											$.mobile.changePage('#settings');
										}
									}
								}
							}, function(error) {
								
								window.wizSpinner.hide();

								if(globals.debugApp){
									console.log("Promo Redeem error. 3");
								}

								navigator.notification.confirm(
									'Server couldnt be reached..',
									callBackFunctionServerDown, // Specify a function to be called
									'Please check your internet signal, Would you like to Retry.', ["Yes", "No"]
								);

								$("#promopic").animate({
									opacity: 1
								}, 250);

								$("#promoDescriptionTwo").animate({
									opacity: 1
								}, 250); //animate out promo pic and descript2 so that the transition is smoother

								function callBackFunctionServerDown(b) {
									if (b == 1) {
										if (window.device.platform == 'Android'){
											var options = {
												label : "Loading Redemption"
											};
										}
										else{
											var options = {
												label : "Loading Redemption",
												color : '#000',
												spinnerColor : '#000'
											}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
										} 
										window.wizSpinner.show(options);
										redeemNow();
									}
									else{
										$.mobile.changePage('#promos');
									}
								}
							});
						}//end of redeemNow()
					} else {}
				}//End of CallBackFunctionRedeem()

			} else { //if the user is not registered then show dialog and prompt user to register
				navigator.notification.confirm(
					'You must be a registered user to redeem this Special. Would you like to register or sign in now?',
					callBackFunctionRedeemRegister, // Specify a function to be called
					'Registration Required', ["Yes", "No"]
				);

				function callBackFunctionRedeemRegister(b) {
					if (b == 1) {
						$.mobile.changePage('#redeemRegisterAlert');
						$('#redeemRegisterAlert_back').show();
						$rootScope.redeemRegisterAlerted = true;
					}
				}
			}
		}

		function startRedeemNow(data1, data2){ //done with web method calls, now start redeem on the deivce

			//GENERATE timeStamp and store it in rootscope, this is displayed with the redemption
			//helper methods are located in sync.js
			var currentdate = new Date(); 
			var datetime = getMonth(currentdate) + " " + addOrd(currentdate.getDate()) + " " + " @ " + getTime(currentdate);
			$rootScope.timeStamp = datetime;

			$rootScope.Promo.AccountUses = $rootScope.Promo.AccountUses + 1; //update account uses for this promotion (does not update locally stored promotion yet)
			
			if ($rootScope.Promo == $rootScope.InstantPrize){
				$timeout(function(){
					$rootScope.InstantPrize = null; //if we are viewing the instant prize (see game) then set the instant prize to null because the user can only see it once
					resetScrollbar();
				});
			}

			//var p = JSON.parse( window.localStorage.getItem('Promos') );
			var p = LoadPromosFromAppData();
			for (var i = 0; i < p.length; i++){
				if (p[i].PromoID == $rootScope.Promo.PromoID){
					p[i].AccountUses = $rootScope.Promo.AccountUses; //update the locally stored promotion's accountuses
				}
			}

			if(globals.debugApp){
				console.log("RedeemNow() started..  #promopic and #redeemNow is now Shown.");
			}
			
			SavePromosToAppData(JSON.stringify(p) );

			//ACTIVATE brightness plugin and set it to 1
			//getBrightness();
			setBrightness(1);

			$scope.redeemNow = true; //redeem now is in progress

			$("#promopic").animate({opacity:1}, 250);
			$("#redeemNow").animate({opacity:1}, 250); //animate in content (see main.html)

			//window.localStorage.setItem('Points', $(data1).find('PromoRedeemResult').children("Points").text()); //update points in case this was a prize redemption
			setPoints( $(data1).find('PromoRedeemResult').children("Points").text() );

			saveLocalData(); //save to local data variable

			CouponRedemptionFilePart = $(data1).find('PromoRedeemResult').children("FilePart").text();
			if (CouponRedemptionFilePart){
				if(CouponRedemptionFilePart.substring(1, 3) == "9j")
					$rootScope.promoDialogPic = 'data:image/jpeg;base64,' + CouponRedemptionFilePart;
				else
					$rootScope.promoDialogPic = 'data:image/png;base64,' + CouponRedemptionFilePart;
			} //set the promoDialogPic based on the base64 encoded image string recieved by the server (for the coupon)
			else{
				$rootScope.promoDialogPic = ''; //no picture (probably just a PLU code)
				if(globals.debugApp){
					console.log("PLU Code is being used..");
				}
			}

			var CouponRedemptionRedeemText = $(data1).find('PromoRedeemResult').children("RedeemText").text();
			//replace descripttext with the coupon redemption text
			if(CouponRedemptionRedeemText != ''){
				$scope.DescriptText = CouponRedemptionRedeemText;
			}
			else{
				$scope.DescriptText = 'Show your coupon at the register to redeem this promotion.';
			}


			var CouponRedemptionDisplaySec = parseInt($(data1).find('PromoRedeemResult').children("DisplaySec").text()); //how long the coupon will display in seconds
			$scope.AllowedUses = parseInt($(data2).find('PromoRedeemResult').children("AllowedUses").text()); //how many redemptions are allowed per user for this coupon
			$scope.Uses = parseInt($(data2).find('PromoRedeemResult').children("Uses").text()); //how many uses the user has used, these 2 values are used to calculate remaining uses for the coupon
			var until = '+' + CouponRedemptionDisplaySec + 's'; //used in the countdown plugin to determine how long the countdown should last in seconds
			

			$('#promotimer').countdown({until: until, onExpiry: function(){ //callback after countdown finishes
				$rootScope.leavePromo();
				$scope.endRedeemNow();
			}, format: 'MS'}); //format is minutes and seconds
			
			setTimeout(function(){
				resetScrollbar();
				window.wizSpinner.hide();
				SaveAppDataJson(); //save to file
			}, 100);
		}

		//Brightness Plug-in SET//
		//----------------------//
		function setBrightness(value) {
		    // value should be float in range from 0 to 1.
		    window.brightness.setBrightness(value, setSuccess, setFail);
		}

		function setSuccess(status) {
		    //alert('SET BRIGHT- Success Message: ' + status);
		    if(globals.debugApp){
		    	console.log('SET BRIGHT- Success Message: ' + status);
		    }
		}

		function setFail(status) {
		    //alert('SET BRIGHT- Error: ' + status);
		    if(globals.debugApp){
		   		console.log('SET BRIGHT- Error: ' + status);
		   	}
		}

		$rootScope.leavePromo = function(){   //leave promo function defined in rootscope since used outside of promoscontroller
			
			setTimeout(function(){
				if ($.mobile.activePage.attr('id') == 'promodog'){ //make sure we are on the promo detail page (i.e. the user did not leave the promo redeem early)
					if ($rootScope.redeemRegisterAlerted){ //if this is after the user logged in or registered because they saw redeemRegisterAlerted then take them to promos
						$.mobile.changePage('#promos');
						$rootScope.redeemRegisterAlerted = false;
					}
					else{
						$.mobile.back();
					}
					$('#promotimer').countdown('destroy'); //destory the counter so it can start new when used again
				}
			}, 10);
		};

		$('#promodog').on('pagehide', function(){
			$scope.endRedeemNow(); //if the user leaves this page then call endRedeemNow
		});



		$('#promodog').on('pageshow', function(){
			window.wizSpinner.hide();

			if(globals.debugApp){
				console.log( 'Promo-Debug:  Does this promo have promo stores: '  + $rootScope.Promo.hasStores );
			}
			if($('#iscroller').iscrollview() ){
				$('#iscroller').iscrollview('refresh');
			}
		});

		$('#redeemRegisterAlert').on('pagehide', function(){ //when the redeem register alert page hides
			if ($.mobile.activePage.attr('id') == 'promodog'){ //if we are currently on the promos page (i.e. the user saw redeemRegisterAlert after attempting to redeem a promotion without an account)
				$rootScope.redeemRegisterAlerted = false; //set redeemRegisterAlerted back to false
			}
		});

		$scope.endRedeemNow = function () //not in redeemNow mode, put regular promo photo back instead of coupon
		{
			if(globals.debugApp){
				console.log('DEBUG: Changing brightness back to old value - ' + oldBrightVal);
			}

			setTimeout(function(){
				setBrightness(globals.userBrightness); //old value
			}, 500);

			$scope.redeemNow = false;
			$rootScope.PromoDialogPic = $rootScope.Promo.PhotoURL;
			$('#promoDescriptionTwo').css('opacity', 1);
			$('#redeemNow').css('opacity', 1);
		};

		$scope.getPoints = function(){ //returns points to show for prize promotions
			return getPoints();
		};

		$scope.Share = function(){ //function to share the promo using the social share plugin
			window.plugins.socialsharing.share($rootScope.Promo.Descript1 + '\n' + ClientSet.getSocialShareURL(), 'Check out this great offer from ' + ClientSet.getCompanyName() + '!', $rootScope.Promo.PhotoURL, null);
			saveClientLog(0, $rootScope.Promo.PromoID, 0, '', 0, 'user shared promo');
		}

		$scope.showParticipatingStores = function(){ //function to show the stores participating in this offer (if not all)

			var options = {
				label : "Loading Participating Stores"
			};

			window.wizSpinner.show(options);

			//Get Promo Stores HERE
			$rootScope.Promo.Stores = getPromoStores($rootScope.Promo);

			if ($rootScope.haveGPS && typeof google != 'undefined') {
				for (var i = 0; i < $rootScope.Promo.Stores.length; i++) {
					var PositionLatLng = new google.maps.LatLng($rootScope.Latitude, $rootScope.Longitude);
					var StoreLatLong = new google.maps.LatLng($rootScope.Promo.Stores[i].Latitude, $rootScope.Promo.Stores[i].Longitude);
					var Distance = google.maps.geometry.spherical.computeDistanceBetween(PositionLatLng, StoreLatLong);
					Distance *= 0.000621371;
					Distance = Math.round(Distance);
					$rootScope.Promo.Stores[i].Distance = Distance;
				} //for each store in this promotion (if this is a promotion available only in certain stores) calculate (if the user has gps) the distance between the user's current position and the store
			}
			$rootScope.Promo.Stores.sort(function(a, b) {
				return a.Distance - b.Distance
			}); //sort the stores by the nearest first


			$timeout(function(){
				$.mobile.changePage('#participatingStores');
			},5);

		};

		function getPromoStores(Promo){
			var p = LoadPromosFromAppData() ? LoadPromosFromAppData() : null; //Grab all promos with Stores

			//sort through old promo and match promo ID
			for (var i = 0; i < p.length; i++){
				if (p[i].PromoID == Promo.PromoID){
					if (p[i].PromoStore){
						var ps = LoadPromoStoresFromAppData() ? LoadPromoStoresFromAppData() : {};

						if (ps){
							ps = ps.filter(function(item){
								return (item.PromoID == p[i].PromoID);
							}); //get the promo stores that match this promo id
							if (ps.length > 0){
								var storeids = [];
								for (var k = 0; k < ps.length; k++){
									storeids.push(ps[k].StoreID);
								} //get the store ids for the stores that support this promo


								var s = globals.Stores;
								if (s){
									s = s.filter(function(item){
										return (storeids.indexOf(item.StoreID) != -1);
									}); //get the stores that have ids in the storeids array

									if (s.length > 0){
										return s;
									} //return all stores for this promo
									else{
										if(globals.debugApp){
											console.log('ERROR! : no promo stores to return in getPromoStores(Promo) within Promos Dir.')
										}
										
										return [];
									}
								}
							}
						}
					}
				}
			}
		}//End of getPromoStores(Promo)
	}
})();

