(function() {
	angular.module('connect.promos')
		.directive('connectPromos', promosDirective)
		.controller('PromosController', promosController);

	promosDirective.$inject = [];

	promosController.$inject = ['$scope', '$rootScope', '$timeout', 'Loading', '$compile'];

	function promosDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'promos/connect.promos.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) {  }
	}

	//IDEA FOR BUG - Have a switch to initialize a refresh ON page shown.
	function promosController($scope, $rootScope, $timeout, Loading, $compile) {

		$scope.promosRefreshed = false;
		$scope.onPage = false;
		
		$('#promos').on('pageshow', function(){
			if($scope.promosRefreshed == false){
				$('#promosLoading').hide();

				if( $('#iscroller').iscrollview() ){
					$('#iscroller').iscrollview('refresh');
				}
				setTimeout(function(){
					$scope.onPage = true;
				},10);
			}
			else{ //launch Promos Refresh method
				$scope.promoPageRefresh();
			}
		});

		$("#promos").on('pageinit', function(){

			if($scope.promosRefreshed  == false){ //if promos refreshed is true then we will be setting css anyways so lets skip it
				var height = $(window).height();
				var width = $(window).width();

				$("#promos .ui-content").css('height', height - $('#promos .ui-header').height() - $('#promos .ui-footer').height() -1 );
				$("#promos .ui-content").css('width', width );
				$("#promos .promosHeaderWrapper").css('width', width);
				$("#promos .promoPageHeader").css('width', width );
				$("#promos #headerContainer").css('width', width );
				$("#promos #promoContainer").css('width', width * .333 - 5 ); // the last arithmitic is for padding (see CSS/HTML page of this directive)
				$("#promos .promoPageHeader").css('height', height * .0384 );

				$("#promos .promotext").css('height', height * .044 );
				$("#promos .promoimage").css('width', width * .3333 - 3.5 );
				$("#promos .promoimage").css('height', ( width * .3333 ) - $('#promos .promotext').height() );
				$("#promos .promotext").css('width', $('#promos .promoimage').width() - 2 ); // take away 4 for padding
				$("#promos .promotext").css('bottom', $('#promos .promotext').height() );
				$("#promos .promotext").css('left', 0 );

				$("#promos #promoContainer").css('height', $('#promos .promoimage').height() + $('#promos .promotext').height() + 2);
				$("#promos #headerContainer").css('height', 'auto' );
			}
		}); 

		$('#promos').on('pagehide', function(){
			$('#promosLoading').hide();
			$scope.onPage = false;
		});

		Loading.then(function() {
			setTimeout(function(){
				if(globals.debugApp){
					console.log('Loading.then function in Promos page initiated');
				}
				$scope.Headers = getAllHeadersWithPromos('Promos Page loading method'); //get all headers with promos to show on the page, each header is a touchCarousel
				$scope.Promos = getAllPromos(0,'Promos Page loading method');
			},1);
		});


		// FOR PROMO PAGE
		$scope.promoPageRefresh = function(){

			if (window.device.platform == 'Android'){
				var options = {
					label : "Refreshing Specials"
				};
			}
			else{
				var options = {
					label : "Refreshing Specials",
					color : '#000',
					spinnerColor : '#000'
				}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
			} 
			window.wizSpinner.show(options);
			

			setTimeout(function(){
				$('#promosLoading').show();
				$('#promosLoading').animate({opacity:1}, 800);
				$("#wrapper").empty();
				$scope.Headers = getAllHeadersWithPromos('promoPageEvoke');
				$scope.Promos = getAllPromos(0, 'promoPageEvoke');

					setTimeout(function(){
					$("#wrapper").html($compile('<div class = "promosHeaderWrapper" ng-repeat="Header in Headers" ng-show="Headers.length > 0">' +
						'<div id = "headerContainer">' +
							'<div class="promoPageHeader">' +
								'{{::Header.Descript1}}' +
							'</div>' +
							'<div id = "promorow">' +
							'<div ng-repeat="Promo in Header.Promos" ng-class="{ \'disabledPromo \' : invalidPromo(Promo)}">' +
								'<div id = "promoContainer" >' +
									'<div id="{{::Promo.PromoID}}" ng-click="viewPromo(Promo)">' +
										'<div><img class="promoimage" src="{{::Promo.PhotoURL}}"/><div>' +
										'<div class="promotext"> {{::Promo.Descript1}} </div>' +
									'</div>' +
								'</div>' +
							'</div>' +
							'</div>' +
						'</div>' +
					'</div>' +
					'<div id="promoPad"></div>')($scope));    // Append new elements 
					
					$scope.$apply(); 

					setTimeout(function(){
						var height = $(window).height();
						var width = $(window).width();

						$("#promos .ui-content").css('height', height - $('#promos .ui-header').height() - $('#promos .ui-footer').height() );
						$("#promos .ui-content").css('width', width );
						$("#promos .promosHeaderWrapper").css('width', width);
						$("#promos .promoPageHeader").css('width', width );
						$("#promos #headerContainer").css('width', width );
						$("#promos #promoContainer").css('width', width * .333 - 5 ); // the last arithmitic is for padding (see CSS/HTML page of this directive)
						$("#promos .promoPageHeader").css('height', height * .0384 );

						$("#promos .promotext").css('height', height * .044 );
						$("#promos .promoimage").css('width', width * .3333 - 3.5 );
						$("#promos .promoimage").css('height', ( width * .3333 ) - $('#promos .promotext').height() );
						$("#promos .promotext").css('width', $('#promos .promoimage').width() - 2 ); // take away 4 for padding
						$("#promos .promotext").css('bottom', $('#promos .promotext').height() );
						$("#promos .promotext").css('left', 0 );

						$("#promos #promoContainer").css('height', $('#promos .promoimage').height() + $('#promos .promotext').height() + 2);
						$("#promos #headerContainer").css('height', 'auto' );

						setTimeout(function(){
							$('#promosLoading').animate({opacity:0}, 1200);
							if($('#iscroller').iscrollview() ){
								$('#iscroller').iscrollview('refresh');
							}
						}, 1);	

						setTimeout(function(){
							$('#promosLoading').hide();
							setTimeout(function(){
								window.wizSpinner.hide();   // Used for promos page refresh
							}, 200);	
							$scope.promosRefreshed = false;
						}, 1200);	

					}, 1);
				}, 1);
			}, 1);
		}


		$scope.promoRefreshBut = function(){
			console.log("Refresh in PROMOS page was Called! ");

			if (window.device.platform == 'Android'){
				var options = {
					label : "Updating and refreshing Specials"
				};
			}
			else{
				var options = {
					label : "Updating and refreshing Specials",
					color : '#000',
					spinnerColor : '#000'
				}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
			} 
			window.wizSpinner.show(options);

			$('#promosLoading').show();
			$('#promosLoading').animate({opacity:1}, 500);
			
			$("#wrapper").empty();
			refreshPromoHead($scope, $rootScope, $timeout, $compile, 0); //refreshed and downloads header, promos, and promo images if there are new ones
		};


		$scope.viewPromo = function(Promo) {
			if (!$scope.invalidPromo(Promo)) {

				$rootScope.Promo = Promo;
				$rootScope.promoDialogPic = Promo.PhotoURL;
				$rootScope.PromoRedemption = true;
				$rootScope.PrizeRedemption = false;
				$rootScope.notRedeemable = Promo.PromoUse == 0;

				/*  MOVED ALL STORE LOGIC TO PROMO DIALOG */
				var coldestIndex = null;
				var coldestRatio = 0;
				try {
					myimage = new Image();
					myimage.src = $rootScope.Promo.PhotoURL;
					var colorThief = new ColorThief();
					var colors = colorThief.getPalette(myimage, 9);
					for (var i = 0; i < 9; i++) {
						if (((colors[i][2] / colors[i][0]) > coldestRatio) && (((colors[i][0] + colors[i][1] + colors[i][2]) / 3) < 200)) {
							coldestRatio = colors[i][2] / colors[i][0];
							coldestIndex = i;
						}
					}
				} catch (err) {
					if (coldestIndex == null)
						$('.promoDialogDescription').css('color', 'black');
					else {
						var r = colors[coldestIndex][0];
						var g = colors[coldestIndex][1];
						var b = colors[coldestIndex][2];
						$('.promoDialogDescription').css('color', 'rgb(' + r + ',' + g + ',' + b + ')');
					}
				}
				$timeout(function() {
					$.mobile.changePage('#promodog');
				});
				saveClientLog(32, $rootScope.Promo.PromoID, 0, '', 0, 'viewed promotion');
			}
		};

		$scope.invalidPromo = function(Promo) { //function that determines if a promo is valid, if it is not then the promo is dimmed out (see main.html and main.css)
			var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;
			var valid = (Promo.Uses == 0 || Promo.AccountUses < Promo.Uses) && now > Promo.DateStart && now < Promo.DateEnd;
			return !valid;
		};

	}
})();