

(function(){
	angular.module('connect.register')
	.directive('connectRegister', connectRegister)
	.controller('RegisterController', connectRegisterCtrl);

	connectRegister.$inject = [];
	connectRegisterCtrl.$inject = ['$scope', '$rootScope', '$http'];


	function connectRegister(){
		var directive = {
			restrict: 'E',
			templateUrl: 'register/connect.register.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs){ }
	}

	// Register - Controller //
	//***********************//
	//controller for handling user registration (for unregistered user only)	
	function connectRegisterCtrl($scope, $rootScope, $http){

		//This checks the phone number input and auto insert the dashes (exp 999-999-9999)
		$('#regphone').keyup(function(e){

			if(globals.debugApp){
				console.log('DEBUG: Registration Phone number modified');
			}
		    
		      if ((e.keyCode > 47 && e.keyCode < 58) || (e.keyCode < 106 && e.keyCode > 95) ) {
		      	
		      	if(this.value.length <= 6){
			    	this.value = this.value.replace(/(\d{3})\-?/, '$1-');
			    	if(globals.debugApp){
			    		console.log('fired ---> success');
			    	}
		      	}
			    else{
			    	this.value = this.value.replace(/(\d{3})\-?(\d{3})\-?/,'$1-$2-');
			    	if(globals.debugApp){
			    		console.log('fired ---> success 2');
			    	}
			    }
			    return true;
			  }			  
			//remove all chars, except dash and digits
			this.value = this.value.replace(/[^\-0-9]/g, '');
		});

		$('#login').on('pageshow', function(){
			$('#birthdayRegister').mobiscroll({ preset: 'date'});
		});

		//property that determines whether or not the form has been submitted by the user (or attempted 
		//to be submitted) this is used throughout the app and is tied to showing or hiding form errors 
		//(i.e. if submit is false then do not show form errors but if submit is true then show form errors 
		//such as invalid email address or this field is required ...etc) ... $scope.Submit should be reset to 
		//false after the user is done with the form and the form has been cleared/reset, this is not currently 
		//implemented and should be implemented throughout the app.
		$scope.Submit = false; 

		$scope.Register = function(){ //function tied to the register button
			
			$scope.Submit = true; //the user has submitted the form, form errors (if any) will now be shown (see main.html for details)
			
			if (!$('#registrationForm').hasClass('ng-invalid')) //if the form is valid (no errors)
			{
				var birthday = $('#birthdayRegister').val(); //get the birthday using jQuery instead of Angular (scope/ng-model) this has been reliable with the mobiscroll date plugin but you might be able to just use angular
				if ($scope.BirthdayClub && birthday != undefined && birthday != "") { //if the user has opted in for the burthday club and they have provided a birthday
					birthday = moment(birthday).toDate().getTime(); //set birthday to the Unix epoch time
				}
				else{
					birthday = -2208739198680; //date in year 1900 sets null in server
				}
				if ($scope.geopromo){ //if the user selected to receive location based promotions
					var geopromo = 1; //set geopromo to 1
				}
				else{
					var geopromo = 0;
				}

				if ($scope.phone == undefined){
					$scope.phone = "";
				}


				$scope.geopromotion = geopromo; //used in verification dialog
				$scope.birthday = birthday; 

				if (window.device.platform == 'Android') {
					var options = {
						label : "Processing..",
						timeout: 120
					};
				} else {
					var options = {
						label : "Processing..",
						color: '#000',
						spinnerColor: '#000',
						timeout: 120
					};
				}
				
				window.wizSpinner.show(options); 

				//startLoader(); //start the AJAX loader (used whenever we are about to make calls to the server or when something will take time) the loader prevents the user from doing anything else until it hides
				$http.post(GetItemFromLocalData('ClientURL'), soapMessageCreateAccount($scope.email, $scope.password, $scope.fullname, $scope.phone, birthday, geopromo), {timeout: 30000}).then(function(response){ //call appropriate soapMessage function (see js/soapMessages.js) with the appropriate parameters
					
					window.wizSpinner.hide();

					var validated = $(response.data).find('CreateAccountResult').children("Validated").text(); //from the sevrer, indicates the account was created or not
					
					if(globals.debugApp){
						console.log(validated + "  " + $scope.fullname + " " + $scope.email + " " + $scope.password + " " + $scope.phone + " " + $scope.birthday + " " + $scope.geopromotion);
					}

					//If email verification is off, then go ahead and save account then go to interests page
					if (validated == "true"){
						saveAccountDetailJson(response.data); //save the account details to the device (function is defined in js/sync.js)
						
						//comment the line below out when email verificaton is 'ON'
						$rootScope.RegisteredUser = true; //set the user as registered

						navigator.notification.alert( //call to notification phonegap plugin
					    'Registration complete.',  // message
					    function(){
					      	$.mobile.changePage('#interestList', { transition: "fade"});
					   		 },         // callback
					  	   'Account created!',    // title
					   	   'Ok'                  // buttonName
						);

						if(globals.debugApp){
							console.log(" No verification is required "  );
						}

					}
					//TODO: Creat email verification Client Set for alternative message

					//If email verification is on and creation of email/account was successful
					/*else if (validated == "false" && $scope.email != null)
					{

						window.localStorage.setItem('verifyPrompt', 1); //save/set verify prompt to '1' so the verify checking method is set off

						$scope.verifyPrompt = getVerifyPrompt(); 

						// **USE THESE MESSAGES FOR WHEN EMAIL VERIFICATION IS DONE **
						//'We sent you an verification email to the account you provided.\n Click on the link in the email to finish registration.',  // message
						//'Registration submitted, Please check your email.'

						navigator.notification.alert( //call to notification phonegap plugin
					    'Account Created',  // message
					    function(){
					      	$.mobile.changePage('#main', { transition: "fade"});
					   		 },         // callback
					  	   'Registration submitted!',    // title
					   	   'Ok'                  // buttonName
						);

						console.log("Just registered. VerifyPrompt was set to " + $scope.verifyPrompt );
					}*/
					else{
						alert('It appears your account already exists, please sign in.', function(){
							$.mobile.changePage('#linkAccount', { transition: "slide"});
						});	 //if the server did not validate then the account likely exists, change the page to the linkaccount page (login)
					}

				}, function(error){ //indicates that the ajax function failed due to poor internet or something else
						window.wizSpinner.hide();//stop the loader
					$rootScope.Error(globals.ajaxTimeoutMessage, //the message to be shown on the error screen
					function(){ //callback
						if(globals.debugApp){
							console.log("..");
						}
					},
					false, //whether or not to show the try again button (used for game ending error)
					function(){
						if(globals.debugApp){
							console.log("..");
						}
						//try again call back
					}); //call the error method, defined in ErrorController below, shows the blue screen
				});
			}
		};
	}
})();