(function() {
	angular.module('connect.settings')
	.directive('connectSettings', connectSettingsDirective)
	.controller('connectSettingsController', connectSettingsController);

	connectSettingsDirective.$inject = [];
	connectSettingsController.$inject = ['$scope', '$rootScope', '$timeout', '$http', '$q', 'Loading', 'ClientSet'];

	function connectSettingsDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'settings/connect.settings.html',
			controller: connectSettingsController,
			link: function(){
			}
		}
		
		return directive;
	}

	function connectSettingsController($scope, $rootScope, $timeout, $http, $q, Loading, ClientSet) {

		$('#settings').on('pageshow', function(){
			$('#settingsControlGroup').controlgroup('refresh');
		});

		$('#settings').on('pageinit', function(){
			if ($(window).height() < 500){  //iphone 4
				$('[id^="settingsBut2"]').css('margin', '7px auto');
				$('[id^="settingsBut2"]').css('width', '70%');
				$('[id^="loginimage"]').css('width', '31%');
				$('[id^="loginimage"]').css('margin-top', '3px');
				$('[id^="loginimage"]').css('margin-bottom', '2px');
			}
		});

		$scope.sync = function() {
			globals.isRestart = true;
			setAppRestart(1);
			navigator.splashscreen.show();
			
			setSyncNow('true');
			saveLocalData();
			SaveAppDataJson();

			setTimeout(function() {
				navigator.splashscreen.hide();
			}, 7200);			

			setTimeout(function() {
       			window.location.href = window.location.href.substring(0, window.location.href.indexOf('#')); //reload main.html, basically restart the web app
			}, 2000);	
		}; //The Sync Now function which allows the user to force a sync. Sync Now updates the initialSyncDoneTimeout variable (defined in js/sync.js) to 45 seconds and removes the application data version (forces a full download sync) and game version (forces the game assets to be updated)
		

		Loading.then(function() { //you will see this in many controllers since many controller actions wait for the Loading factory promise to be resolved
			//we use $rootScope with ng-show (main.html) since it is more reliable than using $scope (at least from my experience)
			//$rootScope.showMapSetting = ClientSet.getShowMap(); //client set is not available until after Loading factory is complete, showMapSetting determines whether or not to give the user the option to edit now map settings (based on the client settings)
			$timeout(function(){
				//get device token to print
				$rootScope.deviceToken = getPushToken();
			}, 1);
		});

		$scope.Share = function() { //function for clicking the share module
			window.plugins.socialsharing.share(ClientSet.getSocialShareMessage() + '\n' + ClientSet.getSocialShareURL(), ClientSet.getSocialShareTitle(), null, null); //call the social sharing phonegap plugin
			$timeout(function() {
				resetScrollbar();
			}, 10000);
			saveClientLog(0, 0, 0, '', 'user shared app');
		};
	}
}());
