(function() {
	angular.module('connect.store')
		.directive('connectStore', storeDirective)
		.controller('StoreController', storeController);

	storeDirective.$inject = [];
	storeController.$inject = ['$scope', '$rootScope', '$timeout', 'ClientSet', 'GeoLocation', 'Loading', '$compile'];


	function storeDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'store/connect.store.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) { }
	}

	function storeController($scope, $rootScope, $timeout, ClientSet, GeoLocation, Loading, $compile) {

		$scope.storeRefreshBut = function(){

			if(globals.debugApp){
				console.log("Refresh in Store List was Called! ");
			}

			if (window.device.platform == 'Android'){
				var options = {
					label : "Updating Store List"
				};
			}
			else{
				var options = {
					label : "Updating Store List",
					color : '#000',
					spinnerColor : '#000'
				}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
			} 
			
			$('#storesLoading').show();
			$('#storesLoading').animate({opacity:1}, 400);
			window.wizSpinner.show(options);

			storeRefresh();

			setTimeout(function(){
				var scope = angular.element($("#storesDirective")).scope();
				scope.showLatestStoreData();

				setTimeout(function(){
					$('#storesLoading').animate({opacity:0}, 400);
					$('#storeList').listview('refresh');

					setTimeout(function(){
						setTimeout(function(){
							//servicesPageEvoke($scope);
							$rootScope.$apply();
						}, 100);

						$('#storesLoading').hide();
						window.wizSpinner.hide();
						$('#storeList').listview('refresh');

						if(globals.debugApp){
							console.log("ListView Refreshed! ");
						}
					}, 400); // about 3 secs is needed for showlateststoredata
				}, 700);
			}, 4000);

			setTimeout(function(){
				$('#storeList').listview('refresh');
			}, 6000);
		};

		
		$('#stores').on('pageinit', function($scope){

			if (window.device.platform == 'Android'){
				var options = {
					label : "Displaying Store List"
				};
			}
			else{
				var options = {
					label : "Displaying Store List",
					color : '#000',
					spinnerColor : '#000'
				}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
			} 

			$('#storesLoading').show();
			window.wizSpinner.show(options);

			//Now Screen Resize
			var height = $(window).height() - 17;
			$('#storesContent').css('height', height - $('#stores .ui-header').height() - $('#stores .ui-footer').height()  );

			var content = height - $('#stores .ui-header').height() - $('#stores .ui-footer').height();
			$('#optionsBox').css('height', content * .19 );
			$('#map').css('height', content - $('#optionsBox').height() );
			$('#storeList').css('height', content - $('#optionsBox').height() ); 
		});


		$("#stores").one('pageshow', function($scope){

			var scope = angular.element($("#storesDirective")).scope();
			scope.showLatestStoreData();

			if (window.device.platform == 'Android'){
				setTimeout(function(){
					$('#storesLoading').hide();
					window.wizSpinner.hide();
					$('#storeList').listview('refresh');

					if(globals.debugApp){
						console.log("ListView Refreshed! ");
					}
				}, 1000); // about 3 secs is needed for showlateststoredata
				
				setTimeout(function(){
					$('#storeList').listview('refresh');
				}, 2000);
			}
			else{
				setTimeout(function(){
					$('#storeList').listview('refresh');
					$('#storesLoading').hide();
					window.wizSpinner.hide();
				}, 1000);
				setTimeout(function(){
					$('#storeList').listview('refresh');
				}, 2000);
			}
		});



		$("#stores").on('pageshow', function($scope){
			//storeList
			if ($('#map').is(':visible')){
				$('#mapbutton').removeClass('ui-btn-active');
				$('#mapbutton').addClass('ui-btn-active');
			}
			else{
				$('#listbutton').removeClass('ui-btn-active');
				$('#listbutton').addClass('ui-btn-active');
			} 
			$('#storeList').listview('refresh');
		});	//highlight the map or list toggle button on pageshow based on which element (map or list) is shown (currently not working, 
		//bug added to pivotal tracker)

		$scope.chainFriendly = globals.Change.chainFriendly;

		$scope.Call = function(store) {
			window.location.href = 'tel:' + store.Phone;
			saveClientLog(53, store.StoreID, 0, '', 0, 'calling store');
		};
		$scope.Navigate = function(store) {
			if (window.device.platform == 'Android') {
				PhoneNavigator.doNavigate(store.Latitude, store.Longitude, function() {}, function() {});
			} else{
				window.location.href = 'maps:daddr=' + store.Latitude + "," + store.Longitude;
			}
			saveClientLog(57, store.StoreID, 0, '', 0, 'checking directions for store');
		};
		$scope.Share = function(store) {
			window.plugins.socialsharing.share('I went to the ' + store.Address1 + " " + store.Address2 + " " + store.City + ", " + store.State + " " + globals.Change.chainFriendly + "." + '\n' + ClientSet.getSocialShareURL(), 'Check out this great ' + globals.Change.chainFriendly + ' location.');
			saveClientLog(0, store.StoreID, 0, '', 0, 'user shared store');
		};
		$scope.Feedback = function(store) {
			$timeout(function() {
				$rootScope.FeedbackStore = store;
				$rootScope.AppFeedback = false;
			}, 1);
			$.mobile.changePage('#feedback');
		};

		$scope.showLatestStoreData = function() {

			var stores = getAllStores($scope);
			globals.Stores = stores;

			GeoLocation.setCurrentPosition().then(function() {
				var yourStartLatLng;
				if ($rootScope.haveGPS && typeof google != 'undefined') {

					if(globals.debugApp){
						console.log('STORES-DEBUG: Setting STORE DISTANCE');
					}

					for (var i = 0; i < stores.length; i++) {
						var PositionLatLng = new google.maps.LatLng($rootScope.Latitude, $rootScope.Longitude);
						var StoreLatLong = new google.maps.LatLng(stores[i].Latitude, stores[i].Longitude);
						var Distance = google.maps.geometry.spherical.computeDistanceBetween(PositionLatLng, StoreLatLong);
						Distance *= 0.000621371;
						Distance = Math.round(Distance);
						stores[i].Distance = Distance;
					}
					yourStartLatLng = new google.maps.LatLng($rootScope.Latitude, $rootScope.Longitude);
				} 
				else {
					if(globals.debugApp){
						console.log('STORES-DEBUG: ERROR - Could not set STORE DISTANCE');
					}

					if (typeof google != 'undefined') {
						yourStartLatLng = new google.maps.LatLng(36.318877, -78.409205);
					}
				}

				stores.sort(function(a, b) {
					return a.Distance - b.Distance
				});
				$scope.Stores = stores;
				if (typeof google != 'undefined') {
					map = new google.maps.Map($('#map')[0], {
						'center': yourStartLatLng,
						zoom: 10,
						mapTypeId: google.maps.MapTypeId.ROADMAP,
						zoomControl: false,
						mapTypeControl: false,
						streetViewControl: false
					});
					updateMapStores();
				}
			});

			$scope.hasSelectedServices = function(store) {
				var output = true;
				for (var i = 0; i < $rootScope.Services.length; i++) {
					if ($rootScope.Services[i].Selected) {
						output = false;
						for (var j = 0; j < store.Services.length; j++) {
							if (store.Services[j].ServiceID == $rootScope.Services[i].ServiceID) {
								output = true;
								break;
							} else
								output = false;
						}
						if (output == false)
							return false;
					}
				}
				return output;
			};

			function updateMapStores() {
				if(globals.debugApp){
					console.log('STORES-DEBUG: Updating MAP STORES');
				}

				var availableTags = [];
				for (var i = 0; i < $scope.Stores.length; i++) {
					if ($scope.hasSelectedServices($scope.Stores[i])) {
						availableTags.push({
							'label': $scope.Stores[i].Address1 + " " + $scope.Stores[i].Address2 + ", " + $scope.Stores[i].City + ", " + $scope.Stores[i].State + " " + $scope.Stores[i].Zip,
							'value': $scope.Stores[i]
						});
						addMarker($scope.Stores[i].Latitude, $scope.Stores[i].Longitude, $scope.Stores[i])
					}
				}

				$("#search-mini").autocomplete({
					source: availableTags,
					messages: {
						noResults: '',
						results: function() {}
					}
				});
			}

			function addMarker(longitude, latitude, Store) {
				var marker = new google.maps.Marker({
					position: new google.maps.LatLng(longitude, latitude),
					map: map,
					icon: globals.Change.flagIcon,
					Store: Store
				});
				google.maps.event.addListener(marker, 'click', function() {
					$timeout(function() {
						$scope.Store = Store;
					}, 1);
				});
			}

			$("#map").hide();
			$("#mapsearch").hide();

			$("#mapbutton").tap(function() {
				if ($(this).hasClass('ui-btn-active')){
					return false;
				}

				$(this).addClass('ui-btn-active');
				$('#listbutton').removeClass('ui-btn-active');
				$("#list").hide();
				$("#map").show();
				$('#storeRefresh').hide();
				$("#mapsearch").show();

				try {
					var center = map.getCenter();
					google.maps.event.trigger(map, "resize");
					map.setCenter(center);
				} catch (err) {}
				setTimeout(function() {
					$('#map a').attr('href', '');
				}, 5000);
			});
			$("#listbutton").tap(function() {
				if ($(this).hasClass('ui-btn-active')){
					return false;
				}

				$(this).addClass('ui-btn-active');
				$('#mapbutton').removeClass('ui-btn-active');
				$("#map").hide();
				$("#mapsearch").hide();
				$('#storeRefresh').show();
				$("#list").show();
				$('#storeList').listview('refresh');
			});

			$("#search-mini").on("autocompleteselect", function(event, ui) {
				event.preventDefault();
				map.setCenter(new google.maps.LatLng(ui.item.value.Latitude, ui.item.value.Longitude));
				$('#search-mini').val(ui.item.label);
			});

			$('.ui-input-text').keyup(function() {
				$('.ui-input-text').val($(this).val());
			});

			$timeout(function() {
				$scope.ShowGas = ClientSet.getShowGasPrice();
				$scope.HideStoreCall = !ClientSet.getShowStoreCall();

				if(globals.debugApp){
					console.log('$scope.ShowGas = ' + $scope.ShowGas);
				}
			}, 150); // give clientset time to load
		};


		$scope.Extra = 0;
		$scope.viewStoreDetails = function(store) {
			$timeout(function() {

				if ($scope.Extra == store.StoreID){
					$scope.Extra = 0;
				}
				else{
					$scope.Extra = store.StoreID;
				}
				saveClientLog(51, store.StoreID, 0, '', 0, 'viewed store details');
			});
		}

		$scope.getGasPrice = function(Store) {
			var gasType = getPreferredGas();

			if(globals.debugApp){
				console.log('DEBUG (STORE): Gas Type returned is ---> ' + gasType);
			}

			if (gasType == 'Plus') {
				if (Store.PlusPrice > 0){
					return 'Plus: $' + Store.PlusPrice.toFixed(2);
				}
				else{
					return '';
				}
			} else if (gasType == 'Premium') {
				if (Store.PremiumPrice > 0){
					return 'Prem: $' + Store.PremiumPrice.toFixed(2);
				}
				else{
					return '';
				}
			} else if (gasType == 'Diesel') {
				if (Store.DieselPrice > 0){
					return 'Dies: $' + Store.DieselPrice.toFixed(2);
				}
				else{
					return '';
				}
			} else if (gasType == 'Kerosene') {
				if (Store.KerosenePrice > 0){
					return 'Ker: $' + Store.KerosenePrice.toFixed(2);
				}
				else{
					return '';
				}
			} else {
				if (Store.RegularPrice > 0){
					return 'Reg: $' + Store.RegularPrice.toFixed(2);
				}
				else{
					return '';
				}
			}
		};

		$scope.getGasLastUpdate = function(GasLastUpdate) {

			var date = new Date(GasLastUpdate);
			var hour = date.getHours();
			var minute = date.getMinutes();
			var ap = "AM";
			if (hour > 11) {
				ap = "PM";
			}
			if (hour > 12) {
				hour = hour - 12;
			}
			if (hour == 0) {
				hour = 12;
			}
			//if (hour   < 10) { hour   = "0" + hour;   }
			if (minute < 10) {
				minute = "0" + minute;
			}
			var timeString = hour + ':' + minute + ' ' + ap;
			var formattedDateString = (date.getMonth() + 1) + '/' + date.getDate() + ' ' + timeString; //date.format("m/dd h:MM Z");
			return formattedDateString;
		};
	}

})();