(function() {
	angular.module('connect.store.feedback')
		.directive('storeFeedback', storeFeedbackDirective)
		.controller('FeedbackController', storeFeedbackController);

	storeFeedbackDirective.$inject = [];

	storeFeedbackController.$inject = ['$scope', '$rootScope', '$http', '$timeout', 'Loading'];

	function storeFeedbackDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'storeFeedback/connect.store.feedback.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) { }
	}

	function storeFeedbackController($scope, $rootScope, $http, $timeout, Loading) {
		$scope.Contact = 0;

		$scope.editContact = function() {
			if ($scope.Contact){
				$scope.Contact = 0;
			}
			else{
				$scope.Contact = 1;
			}
			resetScrollbar();
		};

		$('#feedback').on('pageshow', function() {
			if ($rootScope.FeedbackStore) {
				$('#feedbackStoreID').val($rootScope.FeedbackStore.StoreID);
				$('#feedbackStoreID').selectmenu('refresh', true);
			} else if ($rootScope.inStore) {
				$('#feedbackStoreID').val($rootScope.inStore.StoreID);
				$('#feedbackStoreID').selectmenu('refresh', true);
			} else {
				$('#feedbackStoreID').val("");
				$('#feedbackStoreID').selectmenu('refresh', true);
			}
		});

		$('#feedback').on('pagehide', function() {
			$rootScope.FeedbackStore = null;
		});

		$rootScope.FeedbackBack = false;
		$scope.Submit = false;

		Loading.then(function() {
			$timeout(function(){
				$scope.Stores = globals.Stores;
			}, 1);
		});

		$scope.Send = function() {
			$scope.Submit = true;
			if (!$('#feedbackForm').hasClass('ng-invalid')) {
				
				if (window.device.platform == 'Android'){
					var options = {
						label : "Sending Feedback..."
					};
				}
				else{
					var options = {
						label : "Sending Feedback..",
						color : '#000',
						spinnerColor : '#000'
					}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
				} 
				window.wizSpinner.show(options);

				if ($rootScope.AppFeedback) {
					var storeID = 0;
					var Latitude = 0;
					var Longitude = 0;
					var Accuracy = 0;
					var feedbackType = 1;
					//Append User Device info
					$scope.Comment = $scope.Comment + "\n.. App Version: " + globals.appVersion + ". Device Platform: " + window.device.platform + ". OS Version: " + window.device.version + ". Make: " + window.device.manufacturer + ".";

				} else {
					if ($('#feedbackStoreID').val() == undefined)
						var storeID = 0;
					else
						var storeID = $('#feedbackStoreID').val();

					var Latitude = $rootScope.Latitude;
					var Longitude = $rootScope.Longitude;
					var Accuracy = $rootScope.Accuracy;
					var feedbackType = 0;
				}
				if ($scope.Rating == undefined)
					$scope.Rating = 0;
				if ($rootScope.RegisteredUser) {

					$scope.Name = GetItemFromLocalData('FullName');
					$scope.Email = GetItemFromLocalData('Email');
					$scope.Phone = GetItemFromLocalData('Phone');
				} 
				else if (!$scope.Contact) {
					$scope.Name = '';
					$scope.Email = '';
					$scope.Phone = '';
				}
				
				//lod ID to send
				var LogID = uuid.v1();

				//Message to send
				var FeedbackMessage = soapMessageSaveFeedback(LogID, storeID, $scope.Contact, $scope.Name, $scope.Email, $scope.Phone, parseInt($scope.Rating), $scope.Comment, Latitude, Longitude, Accuracy, feedbackType);
				
				$http.post(GetItemFromLocalData('ClientURL'), FeedbackMessage, {timeout: 18000}).then(function(response) {

					$scope.Submit = false;
					$('#feedbackStoreID').val('');
					$('#feedbackStoreID').selectmenu('refresh', true);
					$('#feedbackRating').val('');
					$('#feedbackRating').selectmenu('refresh', true);
					$scope.Rating = 0;
					$scope.Contact = 0;
					$('#feedbackContact').attr('checked', false).checkboxradio('refresh');
					$scope.Name = '';
					$scope.Email = '';
					$scope.Phone = '';
					$scope.Comment = '';
					
					window.wizSpinner.hide();

					navigator.notification.alert(
						'Your feedback has been received.', // message
						function() {
							if ($rootScope.AppFeedback) {
								$.mobile.back();
								setTimeout(function() {
									$.mobile.back();
									setTimeout(function() {
										$.mobile.back();
									}, 250);
								}, 250);
							} else {
								$.mobile.back();
								setTimeout(function() {
									if ($.mobile.activePage.attr('id') == 'feedbackprompt') {
										$.mobile.back();
									}
								}, 250);
							}
						}, // callback
						'Thank You!', // title
						'Ok' // buttonName
					);
				}, function(error) {
					$scope.Submit = false;
					$('#feedbackStoreID').val('');
					$('#feedbackStoreID').selectmenu('refresh', true);
					$('#feedbackRating').val('');
					$('#feedbackRating').selectmenu('refresh', true);
					$scope.Rating = 0;
					$scope.Contact = 0;
					$('#feedbackContact').attr('checked', false).checkboxradio('refresh');
					$scope.Name = '';
					$scope.Email = '';
					$scope.Phone = '';
					$scope.Comment = '';

					window.wizSpinner.hide();
					navigator.notification.alert(
						'Your feedback has been recorded.', // message
						function() {
							if ($rootScope.AppFeedback) {
								$.mobile.back();
								setTimeout(function() {
									$.mobile.back();
									setTimeout(function() {
										$.mobile.back();
									}, 250);
								}, 250);
							} else {
								$.mobile.back();
								setTimeout(function() {
									if ($.mobile.activePage.attr('id') == 'feedbackprompt') {
										$.mobile.back();
									}
								}, 250);
							}
							
							var FeedbackSoapMessages = localStorage.getItem('Feedback') ? JSON.parse(window.localStorage.getItem('Feedback')) : null;
							//var FeedbackSoapMessages = GetItemFromLocalData('Feedback') ? JSON.parse( GetItemFromLocalData('Feedback') ) : null;

							window.localStorage.removeItem('Feedback');
							//SetItemInLocalData('Feedback', null);

							if (!FeedbackSoapMessages)
								FeedbackSoapMessages = [];

							FeedbackSoapMessages.push(FeedbackMessage);

							window.localStorage.setItem('Feedback', JSON.stringify(FeedbackSoapMessages) );
							//SetItemInLocalData('Feedback', JSON.stringify(FeedbackSoapMessages) );
							
						}, // callback
						'Thank You!', // title
						'Ok' // buttonName
					);
				});
			}
		};
		$(".feedbackInput").keydown(function() {
			if (event.keyCode == 13) {
				$scope.Send();
			}
		});

	}
})();