/* 
   File system manager
*/
//window.resolveLocalFileSystemURL(cordova.file.dataDirectory, function(dir){ CreateFilesystem(dir); });
//Initialize this here, since filesystem is loaded before app.js



//Initialize this here, since filesystem is loaded before app.js
//This extends the Array class with the 'get()' method defined below
//It will let you retreive a value by passing in the key... example: arr.get(name) 
Array.prototype.get = function(itemName) {
    for (var i=0, len=this.length; i<len; i++) {
        if (typeof this[i] != "object") continue;
        if (this[i].itemName === itemName) return this[i].itemValue;
    }
};

//This extends the Array class with the 'set()' method defined below
//It will let you set a value by passing in the key and the new alue... example: arr.get(name) 
Array.prototype.set = function(itemName, itemValue) {
    for (var i=0, len=this.length; i<len; i++) {
        if (typeof this[i] != "object") continue;
        if (this[i].itemName === itemName){
        	this[i].itemValue = itemValue;
        }
    }
};


//  File Plugin Methods  //
//-----------------------//
function CreateFilesystem(dir){

	if(globals.debugApp){
		console.log("got main dir for filesystem.. ", dir);
	}
	//Create appData.txt file
	dir.getFile("appData.txt", {create:true}, function(file) {
		if(globals.debugApp){
			console.log("FILESYSTEM-DEBUG: Created the appData file.");
		}
		globals.appDataFile = file;	
		LoadAppDataJson(); //store data from file into a global variable	
	});
}

//TODO Create a method to localstorage transfer user info to File system
function LocalStorageToFileSystem(){

	if (window.localStorage.getItem('AccountID') === null){ 
		//do nothing
		if(globals.debugApp){
			console.log('DEBUG: ' + 'Nothing to transfer in LocalStorageToFileSystem() ...');
		}
	}
	else{
		console.log('FILESYSTEM-DEBUG: ' + 'Data is being transfered from LocalStorage into FileSystem... in LocalStorageToFileSystem() ...');

		setAccountID( window.localStorage.getItem('AccountID') );
		setEmail( window.localStorage.getItem('Email') );
		setFullName( window.localStorage.getItem('FullName') );
		setPhone( window.localStorage.getItem('Phone') );
		setUniqueID( window.localStorage.getItem('UniqueID') );
		setPoints( window.localStorage.getItem('Points') );
		setGamePlays( window.localStorage.getItem('GamePlays') );
		setUserType( window.localStorage.getItem('UserType') );
		setUserStatus( window.localStorage.getItem('UserStatus') );
		setBirthday( window.localStorage.getItem('Birthday') ); //birthday in the app is stored as Unix milliseconds
		setGeoPromo( window.localStorage.getItem('GeoPromo') );
		setNewPlayer( window.localStorage.getItem('NewPlayer') ); //NewPlayer indicates whether or not the user has every played the game on this app (i.e. should we show the game tutorial dialog?)

		if (window.localStorage.getItem('DataVersion') === null){ //The DataVersion determines whether or not the app requires a download sync or just a regular promo sync
			setDataVersion('install'); 
		}
		else{
			setDataVersion( window.localStorage.getItem('DataVersion') ); 
		}

		if(globals.debugApp){
			console.log('FILESYSTEM-DEBUG:' + ' Some variables read are ---> points: ' + getPoints() + ' Some variables read are ---> AccountID: ' + getAccountID()  );
		}
		//Save user accout data and remove local storage data
		saveLocalData();
		LocalStorageRemoval();
	}
}



function LoadAppDataJson(){
	//UnLoad data from file
	globals.appDataFile.file(function(file) {
		var reader = new FileReader();

		reader.onloadend = function(e) {
			if(globals.debugApp){
				//console.log('appData file contents: ' + this.result);
				console.log('SUCCESS: APP DATA File was loaded/read');
			}

			if(this.result){
				globals.appDataJson = this.result; // Loads String
				if(globals.debugApp){
					console.log('FILESYSTEM-DEBUG: FILE WAS FOUND... It was LOADED.');
					//console.log('JSON.stringify(globals.appDataJson) : ' +  this.result );
				}

				startApp(); //Start App here
				//for testing,  set an account id for local storage here
				//transfer data from local storage to file system and clear local storage (if needed)
				LocalStorageToFileSystem();
			}
			else{
				//Create App Data Json Global if it doesnt exist
				globals.appDataJson = null;
				var userAccount = SetUpUserAccount(); // Sets up the user acct array with blank values for each key
				var temp = { 'Headers': [],'Promos': [], 'PromoStores': [],'PromoImages': {}, 'Stores': [], 'StoreServices': [], 
					'Services': [], 'ClientSets': {}, 'UserAccount' : userAccount };
				globals.appDataJson = JSON.stringify(temp); //Creates String Json

				if(globals.debugApp){
					console.log('FILESYSTEM-DEBUG: NEW USE - NEW FILE WAS CREATED');
					console.log('FILESYSTEM-DEBUG: APP DATA was empty, Creating new Client Data - ' + globals.appDataJson );
				}

				startApp(); //Start App here
				//for testing,  set an account id for local storage here
				//transfer data from local storage to file system and clear local storage (if needed)
				LocalStorageToFileSystem();
			}

			globals.userAccount = LoadUserAccountFromAppData();// Load user account into the official array here
		};
		reader.readAsText(file);
	}, fileFailed);
}



//       Start Angular App          //
//----------------------------------//
function startApp(){
	if( window.localStorage.getItem('appRestart') == 1){
		if(globals.debugApp){
			console.log('DEBUG: App was Restarted..');
		}
		window.localStorage.setItem('appRestart', 0);

		if (window.angular.bootstrap) {
			if(globals.debugApp){
				console.log('DEBUG: AngularJS is already loaded..');
			}
			angular.element(document).ready(function() {
            	angular.bootstrap(document, ['ConnectApp']); 
            });
		}
		else{
			if(globals.debugApp){
				console.log('DEBUG: AngularJS is being loaded..');
			}
		}
	}
	else{
		if(globals.debugApp){
			console.log('DEBUG: AngularJS init..(not appRestart');
		}
		angular.element(document).ready(function() {
            angular.bootstrap(document, ['ConnectApp']);
        });
	}
	if(globals.debugApp){
		console.log("App started, loading Angular modules");
	}
}




//Removes localdata variables that are not being used no more as of version 2.7.3
function LocalStorageRemoval(){
	console.log('FILESYSTEM-DEBUG: Removing localstorage data if it exists.');
	window.localStorage.removeItem('ClientSets');
	window.localStorage.removeItem('Promos');
	window.localStorage.removeItem('Headers');
	window.localStorage.removeItem('PromoImages');
	window.localStorage.removeItem('PromoStores');
	window.localStorage.removeItem('Services');
	window.localStorage.removeItem('StoreServices');
	window.localStorage.removeItem('Stores');
	window.localStorage.removeItem('AccountID');
	window.localStorage.removeItem('Email');
	window.localStorage.removeItem('Phone');
	window.localStorage.removeItem('UniqueID');
	window.localStorage.removeItem('Points');
	window.localStorage.removeItem('GamePlays');
	window.localStorage.removeItem('UserType');
	window.localStorage.removeItem('UserStatus');
	window.localStorage.removeItem('Birthday'); //Birthday on the device is saved in Unix time
	window.localStorage.removeItem('GeoPromo'); //Indicates whether or not the user would like to receive location based promotions, not currently used but will likely be used with iBeacons
	window.localStorage.removeItem('Interests');
	window.localStorage.removeItem('ClientLog');
	window.localStorage.removeItem('DataVersion');
	window.localStorage.removeItem('FullName'); // Delete Greeting (this one time for local storage removal method)
}


function SaveAppDataJson(){
	
	if(!globals.appDataJson) return; //if JSON wasnt created because of some error, exit
	var dataToSave = globals.appDataJson; //Json String loaded to be saved

	if(globals.debugApp){
		console.log('SaveAppDataJson was called to save all data into a file..');
		//console.log('DEBUG: SaveAppDataJson() - Saving Client Data: ' + dataToSave );
	}

	globals.appDataFile.createWriter(function(fileWriter) {
		fileWriter.seek(0);
		var blob = new Blob([dataToSave], {type:'text/plain'});
		fileWriter.write(blob);

		if(globals.debugApp){
			console.log("SUCCESS: SaveAppDataJson() (All DATA) worked");
		}
	}, fileFailed);
}

function DeleteAppData(){

	window.localStorage.removeItem('FullName'); // Delete Greeting
	globals.appDataJson = null;
	var userAccount = SetUpUserAccount(); // Sets up the user acct array with blank values for each key
	var temp = { 'Headers': [],'Promos': [], 'PromoStores': [],'PromoImages': {}, 'Stores': [], 'StoreServices': [], 
		'Services': [], 'ClientSets': {}, 'UserAccount' : userAccount };
	globals.appDataJson = JSON.stringify(temp); //Creates String Json

	if(globals.debugApp){
		console.log('FILESYSTEM-DEBUG: APP DATA DELETED. Fresh data initialized.');
	}

	globals.userAccount = LoadUserAccountFromAppData();// Load user account into the official array here
	SaveAppDataJson();
}





function SavePromoImagesToAppData(str){
	if(globals.appDataJson){

		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = JSON.parse(str);
		tempObj.PromoImages = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: SavePromoImagesToAppData(arr) Called');
			//console.log('FILESYSTEM: SavePromoImagesToAppData(arr) - ' +  str );
		}
	}
	
}
function SavePromosToAppData(str){
	if(globals.appDataJson){

		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = JSON.parse(str);
		tempObj.Promos = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: SavePromosToAppData(arr) Called');
			//console.log('FILESYSTEM: SavePromosToAppData(arr) Results - ' +  str );
		}
	}
}
function SavePromoStoresToAppData(str){
	if(globals.appDataJson){

		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = JSON.parse(str);
		tempObj.PromoStores = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: SavePromoStoresToAppData(arr) Called ' );
			//console.log('FILESYSTEM: SavePromoStoresToAppData(arr) Results - ' +  str );
		}
	}
}
function SaveHeadersToAppData(str){
	if(globals.appDataJson){

		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = JSON.parse(str);
		tempObj.Headers = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: SaveHeadersToAppData(arr) Called ' );
			//console.log('FILESYSTEM: SaveHeadersToAppData(arr) Results - ' +  str );
		}
	}
}
function SaveStoresToAppData(str){
	if(globals.appDataJson){

		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = JSON.parse(str);
		tempObj.Stores = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: SaveStoresToAppData(arr) Called ' );
			//console.log('FILESYSTEM: SaveStoresToAppData(arr) - ' +  str );
		}
	}
}
function SaveStoreServicesToAppData(str){

	if(globals.appDataJson){

		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = JSON.parse(str);
		tempObj.StoreServices = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: SaveStoreServicesToAppData(arr) Called ' );
			//console.log('FILESYSTEM: SaveStoreServicesToAppData(arr) - ' +  str );
		}
	}
}
function SaveServicesToAppData(str){

	if(globals.appDataJson){

		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = JSON.parse(str);
		tempObj.Services = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: SaveServicesToAppData(arr) Called ' );
			//console.log('FILESYSTEM: SaveServicesToAppData(arr) - ' +  str );
		}
	}
}
function SaveClientSetsToAppData(str){

	if(globals.appDataJson){

		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = JSON.parse(str);

		tempObj.ClientSets = tempObjElement;
		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: SaveClientSetsToAppData(arr) Called ' );
			//console.log('FILESYSTEM: SaveClientSetsToAppData(arr) - ' +  str );
		}
	}
}
function SaveUserAccountToAppData(str){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = JSON.parse(str);

		tempObj.UserAccount = tempObjElement;
		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: SaveUserAccountToAppData(arr) Called ' );
			console.log('DEBUG: Content Global.userAccount results: ' + JSON.stringify( globals.userAccount ) );
		}
	}
}



function LoadPromoImagesFromAppData(){

	if(globals.appDataJson){

		var tempObj = JSON.parse(globals.appDataJson);
		var dataToLoad = JSON.stringify(tempObj.PromoImages);

		if(globals.debugApp){
			//console.log('FILESYSTEM: LoadPromoImagesFromAppData() Loaded: ' +  dataToLoad );
		}

		if(dataToLoad){
			return JSON.parse(dataToLoad);
		}
		else{
			if(globals.debugApp){
				console.log('FILESYSTEM-DEBUG: Returning null value for PromoImages..');
			}

			return null;
		}
	}
	else{
		return null;
	}
}
function LoadPromosFromAppData(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var dataToLoad = JSON.stringify(tempObj.Promos);

		if(dataToLoad){
			return JSON.parse(dataToLoad);
		}
		else{
			if(globals.debugApp){
				console.log('FILESYSTEM-DEBUG: Returning null value for Headers..');
			}

			return null;
		}
	}
	else{
		return null;
	}
}
function LoadPromoStoresFromAppData(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var dataToLoad = JSON.stringify(tempObj.PromoStores);

		if(dataToLoad){
			return JSON.parse(dataToLoad);
		}
		else{
			if(globals.debugApp){
				console.log('FILESYSTEM-DEBUG: Returning null value for PromoStores..');
			}

			return null;
		}
	}
	else{
		return null;
	}
}
function LoadHeadersFromAppData(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var dataToLoad = JSON.stringify(tempObj.Headers);

		if(dataToLoad){
			return JSON.parse(dataToLoad);
		}
		else{
			if(globals.debugApp){
				console.log('FILESYSTEM-DEBUG: Returning null value for Headers..');
			}

			return null;
		}
	}
	else{
		return null;
	}
}
function LoadStoresFromAppData(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var dataToLoad = JSON.stringify(tempObj.Stores);

		if(dataToLoad){
			return JSON.parse(dataToLoad);
		}
		else{
			if(globals.debugApp){
				console.log('FILESYSTEM-DEBUG: Returning null value for Stores..');
			}

			return null;
		}
	}
	else{
		return null;
	}
}
function LoadStoreServicesFromAppData(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var dataToLoad = JSON.stringify(tempObj.StoreServices);

		if(globals.debugApp){
			console.log('Storeservices bering loaded in LoadStoreServicesFromAppData(): ' + dataToLoad);
		}

		if(dataToLoad){
			return JSON.parse(dataToLoad);
		}
		else{
			if(globals.debugApp){
				console.log('FILESYSTEM-DEBUG: Returning null value for StoreServices..');
			}

			return null;
		}
	}
	else{
		if(globals.debugApp){
			console.log('FILESYSTEM-DEBUG: Returning null value for ALL DATA..');
		}

		return null;
	}
}
function LoadServicesFromAppData(trace){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var dataToLoad = JSON.stringify(tempObj.Services);

		if(globals.debugApp){
			//console.log('calling LoadServicesFromAppData() from - ' + trace);
			//console.log('Storeservices bering loaded in LoadServicesFromAppData(): ' + dataToLoad);
		}

		if(dataToLoad){
			return JSON.parse(dataToLoad);
		}
		else{
			if(globals.debugApp){
				console.log('FILESYSTEM-DEBUG: Returning null value for Services..');
			}

			return null;
		}
	}
	else{
		return null;
	}
}
function LoadClientSetsFromAppData(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var dataToLoad = JSON.stringify(tempObj.ClientSets);
		if(globals.debugApp){
			//console.log('FILESYSTEM: ClientSets Loaded from file - ' +  dataToLoad );
		}

		if(dataToLoad){
			if(globals.debugApp){
				console.log('FILESYSTEM-DEBUG: Clientsets loaded from Filesystem.');
			}

			return JSON.parse(dataToLoad);
		}
		else{
			if(globals.debugApp){
				console.log('FILESYSTEM-DEBUG: Returning null value for Clientsets..');
			}

			return null;
		}
	}
	else{
		return null;
	}
}
function LoadUserAccountFromAppData(){

	if(globals.appDataJson){

		var tempObj = JSON.parse(globals.appDataJson);
		var dataToLoad = JSON.stringify(tempObj.UserAccount);

		if(dataToLoad){
			if(globals.debugApp){
				console.log('FILESYSTEM-DEBUG: UserAccount loaded from Filesystem.');
			}
			return JSON.parse(dataToLoad);
		}
		else{
			if(globals.debugApp){
				console.log('FILESYSTEM-DEBUG: Returning null value for UserAccount.');
			}

			return null;
		}
	}
	else{
		return null;
	}
}



function DeletePromoImagesJson(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = {};
		tempObj.PromoImages = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: DeletePromoImagesJson() - PromoImages Deleted');
		}
	}
}
function DeletePromosJson(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = [];
		tempObj.Promos = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: DeletePromosJson() - Promos Deleted');
		}
	}
}
function DeletePromoStoresJson(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = [];
		tempObj.PromoStores = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: DeletePromoStoresJson() - PromoStores Deleted');
		}
	}
}
function DeleteHeadersJson(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = [];
		tempObj.Headers = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: DeleteHeadersJson() - Headers Deleted');
		}
	}
}
function DeleteStoresJson(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = [];
		tempObj.Stores = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: DeleteServicesJson() - Stores Deleted');
		}
	}
}
function DeleteStoreServicesJson(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = [];
		tempObj.StoreServices = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: DeleteServicesJson() - StoreServices Deleted');
		}
	}
}
function DeleteServicesJson(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = [];
		tempObj.Services = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: DeleteServicesJson() - Services Deleted');
		}
	}
}
function DeleteClientSetsJson(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = {};
		tempObj.ClientSets = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: DeleteClientSetsJson() - ClientSets Deleted');
		}
	}
}
function DeleteUserAccountJson(){

	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = SetUpUserAccount(); //set as new user account array
		tempObj.UserAccount = tempObjElement;

		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: DeleteUserAccountJson() - UserAccount Deleted');
		}
	}
	SaveAppDataJson();
}


//This method sets up and initializes the User Account Array with all data that will be saved and loaded in the app.
//Add to this when new data needs to be saved, this is to replace local data storage
function SetUpUserAccount(){

	if(globals.debugApp){
		console.log('FILESYSTEM-DEBUG: User Account Array was initialized.');
	}

	var tempUserAccount =  [{itemName:'AccountID', itemValue:''},{itemName:'Email', itemValue:''},{itemName:'FullName',itemValue:''},
	{itemName:'Phone', itemValue:''},{itemName:'UniqueID', itemValue:''},{itemName:'Points', itemValue:0}, {itemName:'GamePlays', itemValue:''},
	{itemName:'UserStatus', itemValue:''},{itemName:'Birthday', itemValue:0},{itemName:'GeoPromo', itemValue:''},{itemName:'ElectrumUniqueID', itemValue:null},
	{itemName:'ElectrumBarcode', itemValue:null},{itemName:'KickbackSignedIn', itemValue:null},{itemName:'BeaconWatchID', itemValue:null},{itemName:'DataVersion', itemValue:null},
	{itemName:'SyncNow', itemValue:null},{itemName:'VerifyPrompt', itemValue:null},{itemName:'PromoPlay', itemValue:null},{itemName:'NewPlayer', itemValue:null},
	{itemName:'PushPromo', itemValue:null},{itemName:'PreferredGas', itemValue:null},{itemName:'PushEnabled', itemValue:'true'},{itemName:'Rating', itemValue:null},
	{itemName:'FasCash', itemValue:null},{itemName:'FasCashApplication', itemValue:null},{itemName:'ShowShare', itemValue:null},{itemName:'AppVersion', itemValue:''},
	{itemName:'UserType', itemValue:null},{itemName:'GameProgress', itemValue:null},{itemName:'GameVersion', itemValue:null},{itemName:'ReleaseDate', itemValue:''},
	{itemName:'PromosConstruct', itemValue:0},{itemName:'StoreListRetry', itemValue:0},{itemName:'PromoRetry', itemValue:0},{itemName:'Version', itemValue:null},
	{itemName:'UDID', itemValue:''},{itemName:'card1', itemValue:null},{itemName:'card2', itemValue:null},{itemName:'card3', itemValue:null},
	{itemName:'card4', itemValue:null},{itemName:'card5', itemValue:null},{itemName:'card6', itemValue:null},{itemName:'card7', itemValue:null},{itemName:'card8', itemValue:null},
	{itemName:'card9', itemValue:null},{itemName:'card10', itemValue:null},{itemName:'card11', itemValue:null},{itemName:'card12', itemValue:null},{itemName:'card13', itemValue:null},
	{itemName:'DeviceOS', itemValue:''},{itemName:'DeviceModel', itemValue:''},{itemName:'DeviceType', itemValue:''},{itemName:'DeviceVersion', itemValue:''},
	{itemName:'PushToken', itemValue:''},{itemName:'TokenID', itemValue:null},{itemName:'CheckInTime', itemValue:null},{itemName:'Interests', itemValue:null},
	{itemName:'ClientURL', itemValue:null},{itemName:'ClientLog', itemValue:null}];

	return tempUserAccount;
}


function fileFailed(){
	if(globals.debugApp)
		console.log("FILESYSTEM ERROR: File R/W failed!");
}

function checkArrString(str){
	var badStr = '[]'; //check if JSON string starts with [] right before JSON array, it happens sometimes. Get rid of it.

	if(globals.debugApp){
		console.log('str.indexOf(badStr) condition is ' + str.indexOf(badStr) > -1);
		console.log('str.indexOf(badStr) = ' + str.indexOf(badStr));
	}

	//if it returns greater than -1 then it contains the badString at the beginning
	if(str.indexOf(badStr) > -1){
		var tempStr = str.replace('[]','');

		if(globals.debugApp){
			console.log('Debug: String had to be repaired');
			console.log('checkArrString() corrected string = ' + str);
		}

		return tempStr;
	}
	else{
		return str;
	}
}




//    SET and GET Methods    //

function saveLocalData(){
	SaveUserAccountToAppData( JSON.stringify(globals.userAccount) );

	if(globals.debugApp){
		console.log('DEBUG: Content Global.userAccount was saved. ' );
	}
}

function GetItemFromLocalData(item){
	if(globals.debugApp){
		console.log('USER ACCOUNT: Getting item: ' + item + '.. it is returning this value: ' + globals.userAccount.get(item) );
	}

	return globals.userAccount.get(item); 
}

function SetItemInLocalData(item, value){
	if(globals.debugApp){
		console.log('USER ACCOUNT: Setting item: ' + item + ' - with value ' + value);
	}

	globals.userAccount.set(item, value);  //Get User Account Object
}



function loginSave(){
	if(globals.debugApp){
		console.log('DEBUG: Login save initiated.. (filesystemManager)' );
	}

	globals.isRestart = true;
	setAppRestart(1);
	setSyncNow('true');

	var str = JSON.stringify(globals.userAccount);

	//Save to variable
	if(globals.appDataJson){
		var tempObj = JSON.parse(globals.appDataJson);
		var tempObjElement = JSON.parse(str);

		tempObj.UserAccount = tempObjElement;
		globals.appDataJson = JSON.stringify(tempObj);

		if(globals.debugApp){
			console.log('FILESYSTEM: loginSave() Called ' );
			console.log('DEBUG: Content Global.userAccount results: ' + JSON.stringify( globals.userAccount ) );
		}
	}

	//Now write to file
	if(!globals.appDataJson) return; //if JSON wasnt created because of some error, exit
	var dataToSave = globals.appDataJson; //Json String loaded to be saved

	if(globals.debugApp)
		console.log('DEBUG: SaveAppDataJson() - Saving Client Data: ' + dataToSave );

	globals.appDataFile.createWriter(function(fileWriter) {
		fileWriter.seek(0);
		var blob = new Blob([dataToSave], {type:'text/plain'});
		fileWriter.write(blob);

		if(globals.debugApp){
			console.log("SUCCESS: loginSave() (Save File) worked");
			console.log("SUCCESS: RELUANCHING APP and logging in");
		}
	}, fileFailed);

	setTimeout(function() {
		window.location.href = window.location.href.substring(0, window.location.href.indexOf('#')); //reload main.html, basically restart the web app
	}, 4000);
}



// HELPER METHODS //

// USE THESE TO SET AND LOAD DATA INSTEAD OF THE METHODS ABOVE.

function getElectrumUniqueID(){
	var tempElectrumUniqueID = globals.userAccount.get('ElectrumUniqueID');  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getElectrumUniqueID() : ' + tempElectrumUniqueID);
	}

	if (tempElectrumUniqueID){
		return tempElectrumUniqueID;
	}
	else{
		return '';
	}
}
function setElectrumUniqueID(value){
	globals.userAccount.set('ElectrumUniqueID', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setElectrumUniqueID() - Setting value: ' + value);
	}
}



//put in account array
function getUniqueID(){
	var tempUniqueID = globals.userAccount.get('UniqueID');  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getUniqueID() : ' + tempUniqueID);
	}

	return tempUniqueID;
}
function setUniqueID(value){
	globals.userAccount.set('UniqueID', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setUniqueID() : ' + value);
	}
}

//put in account array
function getUserType(){
	var tempUserType = globals.userAccount.get('UserType');  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getUserType() : ' + tempUserType);
	}

	return tempUserType;
}
function setUserType(value){
	globals.userAccount.set('UserType', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setUserType() : ' + value);
	}
}

//put in account array
function getUserStatus(){
	var tempUserStatus = globals.userAccount.get('UserStatus');  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getUserStatus() : ' + tempUserStatus);
	}

	return tempUserStatus;
}
function setUserStatus(value){
	globals.userAccount.set('UserStatus', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setUserStatus() : ' + value);
	}
}


//put in account array
function getReleaseDate(){
	var tempReleaseDate = globals.userAccount.get('ReleaseDate');  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getReleaseDate() : ' + tempReleaseDate);
	}

	return tempReleaseDate;
}
function setReleaseDate(value){
	globals.userAccount.set('ReleaseDate', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setReleaseDate() : ' + value);
	}
}


function getElectrumBarcode(){
	var tempElectrumBarcode = globals.userAccount.get('ElectrumBarcode');  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getElectrumBarcode() : ' + tempElectrumBarcode);
	}

	if (tempElectrumBarcode){
		return tempElectrumBarcode;
	}
	else{
		return '';
	}
}
function setElectrumBarcode (value){
	globals.userAccount.set('ElectrumBarcode', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getElectrumBarcode() : ' + value);
	}
}

function getKickbackSignedIn(){
	var signedIn = localStorage.getItem('Kickback.SignedIn');

	if(signedIn){
		return signedIn;
	}
	else{
		return 0;
	}
}

function getBeaconWatchID(){
	var tempBeaconWatchID = globals.userAccount.get('BeaconWatchID');  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getBeaconWatchID() : ' + tempBeaconWatchID);
	}

	return tempBeaconWatchID;

}
function setBeaconWatchID(value){
	globals.userAccount.set('BeaconWatchID', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setBeaconWatchID() : ' + value);
	}
}

function getDataVersion(){ 
	var tempDataVersion = globals.userAccount.get('DataVersion');  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getDataVersion() : ' + tempDataVersion);
	}

	return parseInt(tempDataVersion);
}
function setDataVersion(value){
	globals.userAccount.set('DataVersion', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setDataVersion() : ' + value);
	}
}


function getSyncNow(){ 
	var tempSyncNow = globals.userAccount.get('SyncNow'); //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getSyncNow() : ' + tempSyncNow);
	}

	if (!tempSyncNow){
		return false;
	}
	else{
		return true;
	}
}
function setSyncNow(value){
	globals.userAccount.set('SyncNow', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setSyncNow() : ' + value);
	}
}

function getVerifyPrompt(){ // Flag to show email verify prompt
	var tempVerifyPrompt = globals.userAccount.get('VerifyPrompt');  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getEmail() : ' + tempVerifyPrompt);
	}

	if (!tempVerifyPrompt)
		return 0;
	else
		return parseInt(tempVerifyPrompt);
}
function setVerifyPrompt(value){
	globals.userAccount.set('VerifyPrompt', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setVerifyPrompt() : ' + value);
	}
}


//NEEDED as Helper Method for checking Registered user
function getRegisteredUser(){
	var tempAccountID = globals.userAccount.get('AccountID'); //Get User Account Object

	if(globals.debugApp){
		console.log('*** USER ACCOUNT: getRegisteredUser() : ' + tempAccountID != null && tempAccountID != '' );
	}

	return tempAccountID != null && tempAccountID != '';
}


function getAccountID(){
	var tempAccountID = globals.userAccount.get('AccountID');  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getAccountID() : ' + tempAccountID);
	}

	return tempAccountID;
}
function setAccountID(value){
	globals.userAccount.set('AccountID', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setAccountID() : ' + value);
	}
}

function getEmail(){
	var tempEmail = globals.userAccount.get('Email'); //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: getEmail() : ' + tempEmail);
	}

	return tempEmail;
}
function setEmail(value){
	globals.userAccount.set('Email', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setEmail() : ' + value);
	}
}

function getFullName(){
	var tempFullName = globals.userAccount.get('FullName'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getFullName() : ' + tempFullName);
	}

	return tempFullName;
}
function setFullName(value){
	globals.userAccount.set('FullName', value);  //Get User Account Object
	window.localStorage.setItem('FullName', value); //Save here too (used for loading screen)

	if(globals.debugApp){
		console.log('USER ACCOUNT: setFullName() : ' + value);
	}
}

function getGamePlays(){
	if(globals.userAccount){
		var tempGamePlays = globals.userAccount.get('GamePlays'); 
	}
	else{
		var tempGamePlays = '0';
	}

	if(globals.debugApp){
		console.log('USER ACCOUNT: getGamePlays() : ' + tempGamePlays);
	}

	if (!tempGamePlays){
		tempGamePlays = 0;
	}
	else{
		tempGamePlays = parseInt(tempGamePlays);
	}

	return tempGamePlays;
}
function setGamePlays(value){
	globals.userAccount.set('GamePlays', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setGamePlays() : ' + value);
	}
}


function getNewPlayer(){
	var tempNewPlayer = globals.userAccount.get('NewPlayer'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getNewPlayer() : ' + tempNewPlayer);
	}

	//returns whether or not this is the first time the user is playing the game
	return parseInt(tempNewPlayer) == 1;
}
function setNewPlayer(value){
	globals.userAccount.set('NewPlayer', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setNewPlayer() : ' + value);
	}
}


function setPoints(value){
	if(value == null){
		globals.userAccount.set('Points', 0);  //Get User Account Object
	}
	else{
		globals.userAccount.set('Points', value);  //Get User Account Object
	}

	if(globals.debugApp){
		console.log('USER ACCOUNT: setPoints() : ' + value);
	}
}
function getPoints(){
	var tempPoints = globals.userAccount.get('Points'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getPoints() : ' + tempPoints);
	}

	//returns whether or not this is the first time the user is playing the game
	return parseInt(tempPoints);
}


function getPromoPlay(){
	var tempPromoPlay = globals.userAccount.get('PromoPlay'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getPromoPlay() : ' + tempPromoPlay);
	}

	//returns whether or not this is the first time the user is playing the game
	return parseInt(tempPromoPlay);
}
function setPromoPlay(value){
	globals.userAccount.set('PromoPlay', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setPromoPlay() : ' + value);
	}
} 

//KEEP , It is needed for the Game
function getGameCard(cardName){

	if(globals.debugApp){
		console.log('USER ACCOUNT: getGameCard() - Get Card - : ' + cardName );
	}

	switch (cardName) {
	    case 'bg1.png':
	        return globals.userAccount.get('card1');
	    case 'cardfront.png':
	        return globals.userAccount.get('card2');
	    case 'cardback.png':
	        return globals.userAccount.get('card3');
	    case 'cardfrontmatch.png':
	        return globals.userAccount.get('card4');
	    case 'promo.png':
	        return globals.userAccount.get('card5');
	    case '1.png':
	        return globals.userAccount.get('card6');
	    case '2.png':
	        return globals.userAccount.get('card7');
	    case '3.png':
	        return globals.userAccount.get('card8');
	    case '4.png':
	        return globals.userAccount.get('card9');
	    case '5.png':
	        return globals.userAccount.get('card10');
	    case '6.png':
	        return globals.userAccount.get('card11');
	    case '7.png':
	        return globals.userAccount.get('card12');
	    case '8.png':
	        return globals.userAccount.get('card13');
	    default:
	    	return null;
	}
}


//KEEP , It is needed for the Game
function setGameCard(cardName, value){

	if(globals.debugApp){
		console.log('USER ACCOUNT: setGameCard() - Setting Card - : ' + cardName + ' to ' + value);
	}

	switch (cardName) {
	    case 'bg1.png':
	        globals.userAccount.set('card1', value);
	        break;
	    case 'cardfront.png':
	        globals.userAccount.set('card2', value);
	        break;
	    case 'cardback.png':
	        globals.userAccount.set('card3', value);
	        break;
	    case 'cardfrontmatch.png':
	        globals.userAccount.set('card4', value);
	        break;
	    case 'promo.png':
	        globals.userAccount.set('card5', value);
	        break;
	    case '1.png':
	        globals.userAccount.set('card6', value);
	        break;
	    case '2.png':
	        globals.userAccount.set('card7', value);
	        break;
	    case '3.png':
	        globals.userAccount.set('card8', value);
	        break;
	    case '4.png':
	        globals.userAccount.set('card9', value);
	        break;
	    case '5.png':
	        globals.userAccount.set('card10', value);
	        break;
	    case '6.png':
	        globals.userAccount.set('card11', value);
	        break;
	    case '7.png':
	        globals.userAccount.set('card12', value);
	        break;
	    case '8.png':
	        globals.userAccount.set('card13', value);
	        break;
	    default:
	    	return null;
	}
}



function getPushPromo(){ //returns the promo that came through a push message
	var tempPushPromo = globals.userAccount.get('PushPromo'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getPushPromo() : ' + tempPushPromo);
	}

	if (!tempPushPromo){
		return null; //there are many null returns in factories that indicate something does not exist or not to show or use something
	}
	else{
		tempPushPromo = JSON.parse(tempPushPromo);
		var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;
		var valid = (tempPushPromo.Uses == 0 || tempPushPromo.AccountUses < tempPushPromo.Uses) && now > tempPushPromo.DateStart && now < tempPushPromo.DateEnd; //make sure the promotion is valid before returning it
	
		if (valid){
			return tempPushPromo;
		}
		else{
			return null;
		}
	}
}
function setPushPromo(value){
	globals.userAccount.set('PushPromo', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setPushPromo() : ' + value);
	}
}


function getPhone(){
	var tempPhone = globals.userAccount.get('Phone'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getPhone() : ' + tempPhone);
	}

	return tempPhone;
}
function setPhone(value){
	globals.userAccount.set('Phone', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setPhone() : ' + value);
	}
}


function getBirthday(){
	var tempBirthday = globals.userAccount.get('Birthday'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getBirthday() : ' + tempBirthday);
	}
	
	return tempBirthday;
}
function setBirthday(value){
	globals.userAccount.set('Birthday', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setBirthday() : ' + value);
	}
}


function getGeoPromo(){
	var tempGeoPromo = globals.userAccount.get('GeoPromo'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getGeoPromo() : ' + tempGeoPromo);
	}

	return tempGeoPromo;
}
function setGeoPromo(value){
	globals.userAccount.set('GeoPromo', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setGeoPromo() : ' + value);
	}
}


function getPreferredGas(){ //get the user's preferred gas type for display with stores that have gas
	var gasType = globals.userAccount.get('PreferredGas');

	if (!gasType || gasType == ''){
		return 'Regular';
	}
	else{
		return gasType;
	}
}
function setPreferredGas(value){
	globals.userAccount.set('PreferredGas', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setPreferredGas() : ' + value);
	}
}


function getPushEnabled(){ //android only -- get whether or not the user has enabled push
	var tempPushEnabled = globals.userAccount.get('PushEnabled');

	if (!tempPushEnabled || tempPushEnabled == 'true'){
		return true;
	}
	else{
		return false;
	}
}
function setPushEnabled(value){
	globals.userAccount.set('PushEnabled', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setPushEnabled() : ' + value);
	}
}


//get whether or not to show the Rating now module, it should be shown 1 week after the first time the user uses the app
//TODO - MOVE TO HELPER METHOD
function getShowRating(){ 
	try{
		var now = moment().toDate().getTime();
		var first = parseInt(window.localStorage.getItem('Rating'));

		if (first == 0){
			return false;
		}
		else if ((now - first) > 604800000){
			return true;
		}
		else{
			return false;
		}
	}
	catch (err){
		return false;
	}
}


function getShowFasCash(){
	var tempShowFasCash = globals.userAccount.get('FasCash'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getShowFasCash() : ' + tempShowFasCash);
	}

	return !tempShowFasCash;
}
function setShowFasCash(value){
	globals.userAccount.set('FasCash', value);  //Get User Account Object

	if(globals.debugApp){
		console.log('USER ACCOUNT: setShowFasCash() : ' + value);
	}
}


function getFasCashApplication(){ //gets (if available) a saved in progress fas cash application
	var tempFasCashApplication = globals.userAccount.get('FasCashApplication'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getFasCashApplication() : ' + tempFasCashApplication);
	}

	if (tempFasCashApplication){
		return JSON.parse(sjcl.decrypt("FasCashApplication", tempFasCashApplication));
	}
	else{
		return null;
	}
}
function setFasCashApplication(){ //gets (if available) a saved in progress fas cash application
	globals.userAccount.set('FasCashApplication', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setFasCashApplication() : ' + tempFasCashApplication);
	}
}


//get whether or not to show the now share module, should show up every week starting with the first time 
//the app is launched. 
//Does not need a SET function. 
//TODO Move to Main
function getShowShare(){ 
	var tempShowShare = globals.userAccount.get('ShowShare'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getShowShare() : ' + tempShowShare);
	}

	var now = moment().toDate().getTime();

	if (tempShowShare){
		if (now - tempShowShare > 604800000){
			globals.userAccount.set('ShowShare', now);  //set
			return true;
		}
		else{
			return false;
		}
	}
	else{
		globals.userAccount.set('ShowShare', now);  //set
		return true;
	}
}



function getAppVersion(){ //get the version of the app to show on the about screen
	var tempAppVersion = globals.userAccount.get('AppVersion'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getProductVersion() : ' + tempAppVersion);
	}

	if (tempAppVersion && tempAppVersion != ''){
		return tempAppVersion;
	}
	else{
		return '2.x';
	}
}
function setAppVersion(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('AppVersion', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setAppVersion() : ' + value);
	}
}



function getDeviceModel(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempDeviceModel = globals.userAccount.get('DeviceModel'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getDeviceModel() : ' + tempDeviceModel );
	}

	return tempDeviceModel;
}
function setDeviceModel(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('DeviceModel', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setDeviceModel() : ' + value);
	}
}

function getDeviceType(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempDeviceType = globals.userAccount.get('DeviceType'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getDeviceType() : ' + tempDeviceType );
	}

	return tempDeviceType;
}
function setDeviceType(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('DeviceType', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setDeviceType() : ' + value);
	}
}

function getDeviceVersion(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempDeviceVersion = globals.userAccount.get('DeviceVersion'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getDeviceVersion() : ' + tempDeviceVersion );
	}

	return tempDeviceVersion;
}
function setDeviceVersion(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('DeviceVersion', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setDeviceVersion() : ' + value);
	}
}

function getDeviceOS(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempDeviceOS = globals.userAccount.get('DeviceOS'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getDeviceOS() : ' + tempDeviceOS );
	}

	return tempDeviceOS;
}
function setDeviceOS(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('DeviceOS', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setDeviceOS() : ' + value);
	}
}




function getPushToken(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempPushToken = globals.userAccount.get('PushToken'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getPushToken() : ' + tempPushToken);
	}

	return tempPushToken;
}
function setPushToken(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('PushToken', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setPushToken() : ' + value);
	}
}


function getTokenID(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempTokenID = globals.userAccount.get('TokenID'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getTokenID() : ' + tempTokenID);
	}

	return tempTokenID;
}
function setTokenID(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('TokenID', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setTokenID() : ' + value);
	}
}


function getUDID(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempUDID = globals.userAccount.get('UDID'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getUDID() : ' + tempUDID);
	}

	return tempUDID;
}
function setUDID(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('UDID', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setUDID() : ' + value);
	}
}


function getAppRestart(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempAppRestart = globals.userAccount.get('AppRestart'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getAppRestart() : ' + tempAppRestart);
	}

	return tempAppRestart;
}
function setAppRestart(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('AppRestart', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setAppRestart() : ' + value);
	}
}




function getPromosConstruct(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempPromosConstruct = globals.userAccount.get('PromosConstruct'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getPromosConstruct() : ' + tempPromosConstruct);
	}

	return tempPromosConstruct;
}
function setPromosConstruct(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('PromosConstruct', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setPromosConstruct() : ' + value);
	}
}


function getStoreListRetry(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempStoreListRetry = globals.userAccount.get('StoreListRetry'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getStoreListRetry() : ' + tempStoreListRetry);
	}

	return tempStoreListRetry;
}
function setStoreListRetry(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('StoreListRetry', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setStoreListRetry() : ' + value);
	}
}


function getPromoRetry(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempPromoRetry = globals.userAccount.get('PromoRetry'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getPromoRetry() : ' + tempPromoRetry);
	}

	return tempPromoRetry;
}
function setPromoRetry(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('PromoRetry', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setPromoRetry() : ' + value);
	}
}



function getGameProgress(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempGameProgress = globals.userAccount.get('GameProgress'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getGameProgress() : ' + tempGameProgress);
	}

	return tempGameProgress;
}
function setGameProgress(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('GameVersion', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setGameProgress() : ' + value);
	}
}



function getVersion(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempVersion = globals.userAccount.get('Version'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getVersion() : ' + tempVersion);
	}

		return tempVersion;
}
function setVersion(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('Version', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setVersion() : ' + value);
	}
}


function getGameVersion (){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
	var tempGameVersion = globals.userAccount.get('GameVersion'); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: getGameVersion() : ' + tempGameVersion);
	}

	if (!tempGameVersion || tempGameVersion == ''){
		return null;
	}
	else{
		return tempGameVersion;
	}
}
function setGameVersion(value){ //get the version of the app to show on the about screen
	globals.userAccount.set('GameVersion', value); 

	if(globals.debugApp){
		console.log('USER ACCOUNT: setGameVersion() : ' + value);
	}
} 




