//These are the SOAP Messages used throughout the app (referenced in js/app.js and js/sync.js to communicate with the server). Follow this format when adding a
//new soap message, do not forget the "\" at the end of lines in the output variable (except the last line) since it prevents misinterpretation of the string.
//For more details about the SOAP message formatting, check out the web service specification for various web service methods at:
//http://74.208.209.112/Market_GreenSquare_001/WebService/WebService1.asmx

function soapMessageAccountPasswordResetEnd(token, email){
	var hash = CryptoJS.HmacSHA256(token, 'sjdsf09usa0d9DFKdshF97ADS(D6ASdysadoh^%Ds4');
 	var hashInBase64 = CryptoJS.enc.Base64.stringify(hash);
	var output =
			'<?xml version="1.0" encoding="utf-8"?>\
				<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
				  <soap:Body>\
				    <AccountPasswordResetEnd xmlns="http://UpwardWebService.org/">\
				      <Request>\
				        <TokenID>' + token + '</TokenID>\
				        <TokenIDEnc>' + hashInBase64 + '</TokenIDEnc>\
				        <EncryptType>1</EncryptType>\
				        <Email>' + email + '</Email>\
				        <Standard>\
				          <UDID>' + getUDID() + '</UDID>\
				          <AccountID></AccountID>\
				        </Standard>\
				      </Request>\
				    </AccountPasswordResetEnd>\
				  </soap:Body>\
				</soap:Envelope>';
	return output;
}

function soapMessageAccountPasswordResetStart(email){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
				<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
				  <soap:Body>\
				    <AccountPasswordResetStart xmlns="http://UpwardWebService.org/">\
				      <Request>\
				        <Email>' + email + '</Email>\
				        <Standard>\
				          <UDID>' + getUDID() + '</UDID>\
				          <AccountID></AccountID>\
				        </Standard>\
				      </Request>\
				    </AccountPasswordResetStart>\
				  </soap:Body>\
				</soap:Envelope>';
	return output;
}

function soapMessageChangeAccountDetail(password, newfullname, newphone, newbirthday, newgeopromo){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
				<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
				  <soap:Body>\
				    <ChangeAccountDetail xmlns="http://UpwardWebService.org/">\
				      <Request>\
				        <Password>' + password + '</Password>\
				        <FullName>' + newfullname + '</FullName>\
				        <Phone>'+ newphone + '</Phone>\
				        <Birthday>1900</Birthday>\
				        <BirthdayTicks>' + epochToTicks(newbirthday) + '</BirthdayTicks>\
				        <GeoPromo>' + newgeopromo + '</GeoPromo>\
				        <Standard>\
				          <UDID>' + getUDID() + '</UDID>\
				          <AccountID>' + decryptAccountID() + '</AccountID>\
				        </Standard>\
				      </Request>\
				    </ChangeAccountDetail>\
				  </soap:Body>\
				</soap:Envelope>';
	return output;
}

function soapMessageChangeAccountEmail(password, newemail){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
				<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
				  <soap:Body>\
				    <ChangeAccountEmail xmlns="http://UpwardWebService.org/">\
				      <Request>\
				        <Password>' + password + '</Password>\
        				<NewEmail>' + newemail + '</NewEmail>\
				        <Standard>\
				          <UDID>' + getUDID() + '</UDID>\
				          <AccountID>' + decryptAccountID() + '</AccountID>\
				        </Standard>\
				      </Request>\
				    </ChangeAccountEmail>\
				  </soap:Body>\
				</soap:Envelope>';
	return output;
}

function soapMessageChangeAccountPassword(oldpassword, newpassword){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
				<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
				  <soap:Body>\
				    <ChangeAccountPassword xmlns="http://UpwardWebService.org/">\
				      <Request>\
				        <OldPassword>' + oldpassword + '</OldPassword>\
        				<NewPassword>' + newpassword + '</NewPassword>\
				        <Standard>\
				          <UDID>' + getUDID() + '</UDID>\
				          <AccountID>' + decryptAccountID() + '</AccountID>\
				        </Standard>\
				      </Request>\
				    </ChangeAccountPassword>\
				  </soap:Body>\
				</soap:Envelope>';
	return output;
}

function soapMessageCheckInGPSStart(){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <CheckInGPSStart xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <Standard>\
			        	<UDID>' + getUDID() + '</UDID>\
				      	<AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </CheckInGPSStart>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}

function soapMessageCheckInGPSEnd(tokenid, latitude, longitude, accuracy, type){
	var hash = CryptoJS.HmacSHA256(tokenid, 'sjdsf09usa0d9DFKdshF97ADS(D6ASdysadoh^%Ds4');
 	var tokenidenc = CryptoJS.enc.Base64.stringify(hash);
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <CheckInGPSEnd xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <TokenID>' + tokenid + '</TokenID>\
			        <TokenIDEnc>' + tokenidenc + '</TokenIDEnc>\
			        <EncryptType>' + 1 + '</EncryptType>\
			        <Latitude>' + latitude + '</Latitude>\
			        <Longitude>' + longitude + '</Longitude>\
			        <Accuracy>' + accuracy + '</Accuracy>\
					<CheckInType>' + type + '</CheckInType>\
			        <Standard>\
			          	<UDID>' + getUDID() + '</UDID>\
				    	<AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </CheckInGPSEnd>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}

function soapMessageClientSetAll(){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <ClientSetAll xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <Standard>\
			        	<UDID>' + getUDID() + '</UDID>\
				        <AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </ClientSetAll>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}

function soapMessageCreateAccount(email, password, fullname, phone, birthday, geopromo){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <CreateAccount xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <Email>' + email + '</Email>\
			        <Password>' + password + '</Password>\
			        <FullName>' + fullname + '</FullName>\
			        <Phone>' + phone + '</Phone>\
			        <Birthday>' + 1900 + '</Birthday>\
			        <BirthdayTicks>' + epochToTicks(birthday) + '</BirthdayTicks>\
			        <GeoPromo>' + geopromo + '</GeoPromo>\
			        <Standard>\
			          <UDID>' + getUDID() + '</UDID>\
			          <AccountID></AccountID>\
			        </Standard>\
			      </Request>\
			    </CreateAccount>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}

function soapMessageGameEnd(playerPoints, turnsLeft, wonPromo){
	var promoWon;
	if (wonPromo == true)
		PromoWon = 1;
	else
		PromoWon = 0;

	var hash = CryptoJS.HmacSHA256( getTokenID() , 'sjdsf09usa0d9DFKdshF97ADS(D6ASdysadoh^%Ds4');
 	var hashInBase64 = CryptoJS.enc.Base64.stringify(hash);

 	if(globals.debugApp){
 		console.log('hashInBase64 being sent - ' + hashInBase64);
 	}

	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <GameEnd xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <PointsWon>' + playerPoints + '</PointsWon>\
			        <Plays>' + turnsLeft + '</Plays>\
			        <PromoWon>' + PromoWon + '</PromoWon>\
			        <TokenID>' + getTokenID() + '</TokenID>\
			        <TokenIDEnc>' + hashInBase64 + '</TokenIDEnc>\
			        <EncryptType>1</EncryptType>\
			        <Standard>\
			          	<UDID>' + getUDID() + '</UDID>\
						<AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </GameEnd>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}

function soapMessageGameStart(){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <GameStart xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <Standard>\
			        	<UDID>' + getUDID() + '</UDID>\
						<AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </GameStart>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}

function soapMessageGetAccountDetail(){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <GetAccountDetail xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <Standard>\
			          <UDID>' + getUDID() + '</UDID>\
			          <AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </GetAccountDetail>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}

function soapMessageGetAccountID(email){
	var output =
	'<?xml version="1.0" encoding="utf-8"?>\
		<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
		  <soap:Body>\
		    <GetAccountID xmlns="http://UpwardWebService.org/">\
		      <Request>\
		        <Email>' + email + '</Email>\
		        <Standard>\
		          <UDID>' + getUDID() + '</UDID>\
		          <AccountID></AccountID>\
		        </Standard>\
		      </Request>\
		    </GetAccountID>\
		  </soap:Body>\
		</soap:Envelope>';
	return output;
}


//Gets Verify flag if user has veried thier email
function soapMessageGetEmailVerify(email){
	var output =
	'<?xml version="1.0" encoding="utf-8"?>\
		<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
		  <soap:Body>\
		    <GetEmailVerify xmlns="http://UpwardWebService.org/">\
		      <Request>\
		        <Email>' + email + '</Email>\
		        <Standard>\
			    	<UDID>' + getUDID() + '</UDID>\
			        <AccountID>' + decryptAccountID() + '</AccountID>\
			    </Standard>\
		      </Request>\
		    </GetEmailVerify>\
		  </soap:Body>\
		</soap:Envelope>';
	return output;
}


function soapMessageGetFileChunk(folder, filename){
	var output =
	'<?xml version="1.0" encoding="utf-8"?>\
		<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
		  <soap:Body>\
		    <GetFileChunk xmlns="http://UpwardWebService.org/">\
		      <Request>\
		        <SyncFolder>' + folder + '</SyncFolder>\
		        <Filename>' + filename + '</Filename>\
		        <Offset>0</Offset>\
		        <ChunkSize>0</ChunkSize>\
		        <Compress>false</Compress>\
		        <Standard>\
		          <UDID>' + getUDID() + '</UDID>\
			      <AccountID>' + decryptAccountID() + '</AccountID>\
		        </Standard>\
		      </Request>\
		    </GetFileChunk>\
		  </soap:Body>\
		</soap:Envelope>';
	return output;
}

function soapMessageLinkAccount(email, password){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
				<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
				  <soap:Body>\
				    <LinkAccount xmlns="http://UpwardWebService.org/">\
				      <Request>\
				        <Email>' + email + '</Email>\
				        <Password>' + password + '</Password>\
				        <Standard>\
				          <UDID>' + getUDID() + '</UDID>\
				          <AccountID></AccountID>\
				        </Standard>\
				      </Request>\
				    </LinkAccount>\
				  </soap:Body>\
				</soap:Envelope>';
	return output;
}



function soapMessagePromoHeadListAll(){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
				<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
				  <soap:Body>\
				    <PromoHeadListAll xmlns="http://UpwardWebService.org/">\
				      <Request>\
				        <Standard>\
				          <UDID>' + getUDID() + '</UDID>\
				          <AccountID>' + decryptAccountID() + '</AccountID>\
				        </Standard>\
				      </Request>\
				    </PromoHeadListAll>\
				  </soap:Body>\
				</soap:Envelope>';
	return output;
}


function soapMessagePromoList2(){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <PromoList2 xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <Standard>\
			          <UDID>' + getUDID() + '</UDID>\
			          <AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </PromoList2>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}

function soapMessagePromoRedeem(PromoID, StoreID, Latitude, Longitude, Accuracy, Phase){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <PromoRedeem xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <PromoID>' + PromoID + '</PromoID>\
			        <StoreID>' + StoreID + '</StoreID>\
			        <Latitude>' + Latitude + '</Latitude>\
			        <Longitude>' + Longitude + '</Longitude>\
			        <Accuracy>' + Accuracy + '</Accuracy>\
			        <Phase>' + Phase + '</Phase>\
			        <Standard>\
			          <UDID>' + getUDID() + '</UDID>\
			          <AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </PromoRedeem>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}

function soapMessageSaveAccountInterest(interests){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
				<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
				  <soap:Body>\
				    <SaveAccountInterest xmlns="http://UpwardWebService.org/">\
				      <Request>\
				      	<AccountInterestList>' + interests +
				      	'</AccountInterestList>\
				        <Standard>\
				          <UDID>' + getUDID() + '</UDID>\
				          <AccountID>' + decryptAccountID() + '</AccountID>\
				        </Standard>\
				      </Request>\
				    </SaveAccountInterest>\
				  </soap:Body>\
				</soap:Envelope>';
	return output;
}

function soapMessageSaveClientLog(logs){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <SaveClientLog xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <ClientLogList>' + logs +
			        '</ClientLogList>\
			        <Standard>\
			          <UDID>' + getUDID() + '</UDID>\
				      <AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </SaveClientLog>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}

function soapMessageClientLog(logtype, promoid, storeid, beaconudid, beaconloc, comment){
	var logdate = moment.tz(moment(), 'America/New_York').format("YYYY-MM-DD");
	logdate = logdate + "T" + moment.tz(moment(), 'America/New_York').format("hh:mm:ss");
	var output =
		'<RClientLogServer>\
            <LogID>' + uuid.v1() + '</LogID>\
            <LogType>' + logtype + '</LogType>\
            <LogDate>' + logdate + '</LogDate>\
            <LogDateTicks>0</LogDateTicks>\
            <PromoID>' + promoid + '</PromoID>\
            <StoreID>' + storeid + '</StoreID>\
            <CompStoreID>0</CompStoreID>\
            <Latitude>0</Latitude>\
            <Longitude>0</Longitude>\
            <Accuracy>0</Accuracy>\
			<BeaconUDID>' + beaconudid + '</BeaconUDID>\
			<BeaconLoc>' + beaconloc + '</BeaconLoc>\
            <Comment>' + comment + '</Comment>\
          </RClientLogServer>';
	return output;
}





function soapMessageSaveFeedback(LogID, StoreID, Contact, FullName, Email, Phone, Rating, Comment, Latitude, Longitude, Accuracy, feedbackType){
	var logdate = moment.tz(moment(), 'America/New_York').format("YYYY-MM-DD");
	logdate = logdate + "T" + moment.tz(moment(), 'America/New_York').format("hh:mm:ss");
	var now = moment.tz(moment(), 'America/New_York').toDate();
	var nowhours = now.getHours();
	now = now.getTime();
	if (nowhours >= 4 && nowhours < 12)
		var timeframe = "Morning";
	else if (nowhours >= 12 && nowhours < 6)
		var timeframe = "Afternoon";
	else
		var timeframe = "Evening";
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <SaveFeedback xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <FeedbackList>\
			          <RFeedbackServer>\
			            <LogID>' + LogID + '</LogID>\
			            <StoreID>' + StoreID + '</StoreID>\
			            <LogDate>' + logdate + '</LogDate>\
			            <LogDateTicks>0</LogDateTicks>\
			            <Contact>' + Contact + '</Contact>\
			            <FullName>' + FullName + '</FullName>\
			            <Email>' + Email + '</Email>\
			            <Phone>' + Phone + '</Phone>\
			            <Latitude>' + Latitude + '</Latitude>\
			            <Longitude>' + Longitude + '</Longitude>\
			            <Accuracy>' + Accuracy + '</Accuracy>\
			            <TimeFrame>' + timeframe + '</TimeFrame>\
			            <Rating>' + Rating + '</Rating>\
			            <Comment>' + Comment + '</Comment>\
			            <FeedbackType>' + feedbackType + '</FeedbackType>\
			          </RFeedbackServer>\
			        </FeedbackList>\
			        <Standard>\
			          	<UDID>' + getUDID() + '</UDID>\
						<AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </SaveFeedback>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}




function soapMessageServerOK(){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
				<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
				  <soap:Body>\
				    <ServerOK xmlns="http://UpwardWebService.org/" />\
				  </soap:Body>\
				</soap:Envelope>';
	return output;
}

function soapMessageServiceListAll(){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <ServiceListAll xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <Standard>\
			          	<UDID>' + getUDID() + '</UDID>\
						<AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </ServiceListAll>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}

function soapMessageStoreListAllByDescript(){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <StoreListAllByDescript xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <Standard>\
			          	<UDID>' + getUDID() + '</UDID>\
						<AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </StoreListAllByDescript>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}

function soapMessageStoreServiceListAll(){
	var output =
	'<?xml version="1.0" encoding="utf-8"?>\
		<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
		  <soap:Body>\
		    <StoreServiceListAll xmlns="http://UpwardWebService.org/">\
		      <Request>\
		        <Standard>\
		          	<UDID>' + getUDID() + '</UDID>\
					<AccountID>' + decryptAccountID() + '</AccountID>\
		        </Standard>\
		      </Request>\
		    </StoreServiceListAll>\
		  </soap:Body>\
		</soap:Envelope>';
	return output;
}

function soapMessageSyncEnd(){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <SyncEnd xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <PushToken>' + getPushToken() + '</PushToken>\
			        <Standard>\
			          	<UDID>' + getUDID()+ '</UDID>\
						<AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </SyncEnd>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}
function soapMessageSetPush(){
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			<soap:Body>\
				<SetPush xmlns="http://UpwardWebService.org/">\
				<Request>\
					<PushToken>' + getPushToken() + '</PushToken>\
					<Standard>\
						<UDID>' + getUDID() + '</UDID>\
						<AccountID>' + decryptAccountID() + '</AccountID>\
					</Standard>\
				</Request>\
				</SetPush>\
			</soap:Body>\
			</soap:Envelope>';
	return output;
}


//We do not use Release (Build) version, we only increment app version at this time
function soapMessageSyncStart(){

	if(globals.debugApp){
		console.log('Sync Start Soap Message was called, sending: name - ' + getFullName() + ' - release date - ' + getReleaseDate() );
	}
	
	var output =
		'<?xml version="1.0" encoding="utf-8"?>\
			<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema" xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/">\
			  <soap:Body>\
			    <SyncStart xmlns="http://UpwardWebService.org/">\
			      <Request>\
			        <ReleaseVersion>' + '1' + '</ReleaseVersion>\
			        <ReleaseDate>' + getReleaseDate() + '</ReleaseDate>\
			        <DeviceModel>' + getDeviceModel() + '</DeviceModel>\
			        <DeviceType>' + getDeviceType() + '</DeviceType>\
			        <DeviceVersion>' + getDeviceVersion() + '</DeviceVersion>\
			        <DeviceOS>' + getDeviceOS() + '</DeviceOS>\
			        <PushToken>' + getPushToken() + '</PushToken>\
			        <FullName>' + getFullName() + '</FullName>\
			        <Email>' + getEmail() + '</Email>\
			        <Phone>' + getPhone() + '</Phone>\
			        <AppVersion>' + getAppVersion() + '</AppVersion>\
			        <ClientDate>' + moment.tz(moment(), 'America/New_York').format("MM/DD/YYYY hh:mm:ss a") + '</ClientDate>\
			        <Standard>\
			        	<UDID>' + getUDID() + '</UDID>\
						<AccountID>' + decryptAccountID() + '</AccountID>\
			        </Standard>\
			      </Request>\
			    </SyncStart>\
			  </soap:Body>\
			</soap:Envelope>';
	return output;
}


function soapMessageNPC(achcard, bankaccount, bankrouting, birthday, city, driverslicense, driverslicensestate, email, firstname, homephone, lastname, mobilephone, pin, promotioncode, securityanswer, securityquestion, state, street, zip){
	var output =
		'<soapenv:Envelope xmlns:soapenv="http://schemas.xmlsoap.org/soap/envelope/" xmlns:tem="http://tempuri.org/" xmlns:npc="http://schemas.datacontract.org/2004/07/NPC.EnrollmentServiceLibrary">\
		   <soapenv:Header/>\
		   <soapenv:Body>\
		      <tem:Enroll>\
		         <tem:member>\
		            <npc:ACHCard>' + achcard + '</npc:ACHCard>\
		            <npc:BankAccount>' + bankaccount + '</npc:BankAccount>\
		            <npc:BankRouting>' + bankrouting + '</npc:BankRouting>\
		            <npc:BirthDay>' + birthday + '</npc:BirthDay>\
		            <npc:City>' + city + '</npc:City>\
		            <npc:DriversLicense>' + driverslicense + '</npc:DriversLicense>\
		            <npc:DriversLicenseState>' + driverslicensestate + '</npc:DriversLicenseState>\
		            <npc:Email>' + email + '</npc:Email>\
		            <npc:FirstName>' + firstname + '</npc:FirstName>\
		            <npc:HomePhone>' + homephone + '</npc:HomePhone>\
		            <npc:LastName>' + lastname + '</npc:LastName>\
		            <npc:MobilePhone>' + mobilephone + '</npc:MobilePhone>\
		            <npc:PIN>' + pin + '</npc:PIN>\
		            <npc:PromotionCode>' + promotioncode + '</npc:PromotionCode>\
		            <npc:SecurityAnswer>' + securityanswer + '</npc:SecurityAnswer>\
		            <npc:SecurityQuestion>' + securityquestion + '</npc:SecurityQuestion>\
		            <npc:Standard>\
		               <npc:DeviceOS>' + window.device.platform + '</npc:DeviceOS>\
		               <npc:MerchantID>' + LoadClientSetsFromAppData()['ach.merchantid'] + '</npc:MerchantID>\
		               <npc:ReleaseVersion>' + '1' + '</npc:ReleaseVersion>\
		            </npc:Standard>\
		            <npc:State>' + state + '</npc:State>\
		            <npc:Street>' + street + '</npc:Street>\
		            <npc:Zip>' + zip + '</npc:Zip>\
		         </tem:member>\
		      </tem:Enroll>\
		   </soapenv:Body>\
		</soapenv:Envelope>';
	return output;
}
