/*
	This file contains functions related to sync and other common functions used in the app 
	(mainly js/app.js)
*/
//calculate the timeZoneOffset of Eastern US time (where the server is based so that we adjust datetimes 
//recieved from the server to the client's correct time)


/*





// Get All Headers with Promos - Function //

//TODO: MOVE THIS TO ANGULAR SERVICE AND DEPENDENCY INJECTION
function getAllHeadersWithPromos(trace){ //returns all headers with their promotions (used on the promo screen) stored on the device

	if(trace)
		console.log('DEBUG-SYNC: calling getAllHeadersWithPromos() from - ' + trace);

	console.log("getAllHeadersWithPromos() initiated");

	var finalHeaders = []; //array to hold the result sent to the user
	//var headers = localStorage.getItem('Headers') ? JSON.parse(window.localStorage.getItem('Headers')) : null;
	// Get methods next
	//var headers = globals.HeadersArr ? JSON.parse( globals.HeadersArr ) : null;
	var headers = LoadHeadersFromAppData() ? LoadHeadersFromAppData() : null;

	if (headers){
		headers.sort(function(a, b){
			return a.SortOrder - b.SortOrder;
		}); //sort headers by their sort order
		var promos = getAllPromos(0, 'getAllHeadersWithPromos()'); //get all regular promotions (not prizes)
		for (var i = 0; i < headers.length; i++){
			headers[i].Promos = promos.filter(function(item){
				return (item.HeadID == headers[i].HeadID);
			});
		} //for each header, push the promotions that have that header's headerid
		for (var i = 0; i < headers.length; i++){
			if (headers[i].Promos.length > 0)
				finalHeaders.push(headers[i]);
		} //for each header only use the ones that have promotions
	}

	return finalHeaders;
}


// Update Promo Link / Video / Photo - Function //
//----------------------------------------------//
//TODO: MOVE THIS TO ANGULAR SERVICE AND DEPENDENCY INJECTION
function updatePromoLinkVideoPhoto(p){ //helper function for checking and updating promotions that have a link and/or youtube video as part of the Descript2 such as: [http://www.google.com]Check out Google!
 	var Descript2 = p.Descript2;
	if (Descript2.indexOf('[') == -1){ //if there is no bracket then this is a regular Descript2 (with no link)
		var PromoLink = '';
		var PromoVideo = '';
		var PromoVideoImage = '';
	}
	else{
		if (Descript2.indexOf('youtube') == -1){ //this is a regular link (not youtube video)
			var PromoLink = Descript2.substring(1, Descript2.indexOf(']'));
			var PromoVideo = '';
			var PromoVideoImage = '';
		}
		else{ //this is a youtube video link
			var PromoLink = '';
			var PromoVideo = Descript2.substring(1, Descript2.indexOf(']'));
			var youtubeID = Descript2.substring(Descript2.indexOf('=') + 1, Descript2.indexOf(']')); //extract the youtube video id from the url
			var PromoVideoImage = 'http://img.youtube.com/vi/' + youtubeID + '/0.jpg'; //if this is a youtube link, use the youtube API to set the promovideoimage as the video thumbnail
		}
		Descript2 = Descript2.substring(Descript2.indexOf(']') + 1); //set the Descript2 to the text after the [link]
	}

	p.Descript2 = Descript2;
	p.PromoLink = PromoLink;
	p.PromoVideo = PromoVideo;
	p.PromoVideoImage = PromoVideoImage;
	
	return p;
 }


 // Get Age - Function //

//returns the age of the user (if available)
function getAge(){ 
	console.log('DEBUG-SYNC: Getting Age in getAge()')
	//var birthdayEpoch = parseInt(window.localStorage.getItem('Birthday')); //get birthday from local storage which is stored as unix epoch time
	var birthdayEpoch = parseInt(getBirthday()); 

	if (!birthdayEpoch)
		return 0;
	else{
		var fromNow = moment(birthdayEpoch).month(0).from(moment().month(0)); //get the difference between the user's birthday and today
		if (fromNow.indexOf('years') == -1) //no years string in fromNow
			return 0; //the user is 0 years old
		else
			return parseInt(fromNow.substring(0, fromNow.indexOf('y') - 1)); //return the number of years to show the age
	}
}


//TODO: GLOBAL FUNCTION TO ANGULAR JS SERVICE
//Function for getting all promotions saved on the device by type (0 is a regular promo and 1 is a prize)
function getAllPromos(type, trace){ 

	if(trace)
		console.log('DEBUG-SYNC: calling getAllPromos() from - ' + trace);

	console.log("Getting all Promos in (getAllPromos())..");

	var use = []; //array to hold the promos that will be sent back
	//var p = globals.PromosArr ? JSON.parse(globals.PromosArr) : null;
	//var pi = globals.PromoImagesArr ? JSON.parse( globals.PromoImagesArr ) : null; 

	var p = LoadPromosFromAppData() ? LoadPromosFromAppData() : null; 
	var pi = LoadPromoImagesFromAppData() ? LoadPromoImagesFromAppData() : null; 

	if(globals.debugApp)
		console.log('getAllPromos:  p = ' + p + ' // pi =' + pi);

	console.log('getAllPromos:  p = ' + p );
	
	if (p && pi){
		//console.log('promoimages test - ' + JSON.stringify( pi ) );
		p = p.filter(function(item){
			return (item.PromoType == type);
		}); //filter promos based on type
		
		if (p.length){
			for (var i = 0; i < p.length; i++){
				p[i] = updatePromoLinkVideoPhoto(p[i]); //see function definition above
				var myInterests = getInterests();
				var myAge = getAge();
				var promoInterestID = p[i].InterestID;
				var promoAge = p[i].Age;
				var usePromo = false;

				if (promoInterestID){
					for (var j = 0; j < myInterests.length; j++){
						if (myInterests[j].InterestID == promoInterestID)
							usePromo = true;
					}
				} //if the promo has an interest id only use it if it is part of the user's interests
				else{
					usePromo = true;
				}

				p[i].PhotoURL = pi[p[i].PhotoFile]; //set the promo PhotoURL to the matching value in the PromoImages object
				console.log("SYNC-DEBUG: promo photofile being processed in getAllPromos()" + i + ' -- ' + pi[p[i].PhotoFile]); // do not use

				if (usePromo && ((promoAge && myAge < promoAge) || !p[i].PhotoURL)) {
					//if the promo has the age flag set (promoAge) make sure the user is the right age and 
					//make sure the photo exists from promo images
					usePromo = false;
					console.log("promoImage was invalid!!! (promoAge) ..  in getAllPromos() (sync.js - 302)");
				}

				if (usePromo){
					use.push(p[i]); //push the promo to the array we will send back

					
					if (p[i].PromoStore){ //if the promo store flag is set on this promotion (i.e. this promo is only available in certain stores) perhaps it would be better to not send back the promotion until after we determine the promostores for this promo (if any)
						//console.log("globals.PromoStoresArr JSON in getAllPromos() = " );
						var ps = LoadPromoStoresFromAppData() ? LoadPromoStoresFromAppData() : {}; 

						if (ps){
							ps = ps.filter(function(item){
								return (item.PromoID == p[i].PromoID);
							}); //get the promo stores that match this promo id
							if (ps.length > 0){
								var storeids = [];
								for (var k = 0; k < ps.length; k++){
									storeids.push(ps[k].StoreID);
								} //get the store ids for the stores that support this promo


								var s = getAllStores('getAllPromos()');
								if (s){
									s = s.filter(function(item){
										return (storeids.indexOf(item.StoreID) != -1);
									}); //get the stores that have ids in the storeids array
									if (s.length > 0){
										use[use.length - 1].Stores = s;
									} //add the Stores as a property of the latest promo in use (this promo)
								}
							}
						}
					}
					

					if (!use[use.length - 1].Stores){
						use[use.length - 1].Stores = []; //if no stores have been added, add an empty array as the stores property
					}
				}
				else{
					console.log("promo couldnt be used!! in getAllPromos() sync.js");
				}
			}
		}
		else{
			console.log("p.length was null or zero in getAllPromos()");
		}
	}
	else{
		console.log("promos or promo images arrays were empty!!! in getAllPromos() : sync.js");
	}
	return use;
}


//this function is used throughout the app to reset the scrollbar when page content changes, it is important to
//reset the scroll bar everytime something shows or hides
function resetScrollbar(){
	try{
		$('.ui-content').iscrollview('refresh');
	}
	catch (err){}
}




//TODO: This should be inside a angular service instead of a global function and dependency injected
// Get All Services - Function //

//function to get all Services stored on the device
function getAllServices(){ 

	var services = LoadServicesFromAppData('getAllServices()') ? LoadServicesFromAppData('getAllServices()') : null;

	if (!services || services.length < 2){
		console.log('DEBUG-SYNC: DEFAULT Services was loaded -- getAllServices()');
		services = installServices;

		services.sort(function(a, b){
			return a.SortOrder - b.SortOrder;
		});
		console.log('DEBUG-SYNC: sorting finished-- getAllServices()');

		//make sure all Services are not selected by default (the user selects and deselects services to filter stores on the stores screen)
		for (var i = 0; i < services.length; i++){
			services[i].Selected = false;
		} 
		console.log('DEBUG-SYNC: defaulting selected finished -- getAllServices()');

	}
	else{
		console.log('DEBUG-SYNC: Services was loaded from file in getAllServices()');
	}
	return services;
}




//TODO: GLOBAL FUNCTION. SHOULD BE USED IN A SERVICE WHEN EVERYTHING IS WORKING AND INJECTED
function getAllStores($scope, trace){ 

	if(trace)
		console.log('DEBUG-SYNC: calling getAllStores() from - ' + trace);

	var stores = LoadStoresFromAppData() ? LoadStoresFromAppData() : null;

	if (!stores || stores.length < 2){
		console.log('DEBUG-SYNC: Using default Store List!! ');
		stores = installStores; //if no stores are saved on the device (due to perhaps lack of internet that caused the sync process to fail or this is the first time using the app and the stores are still being downloaded in the background) then use the stores in js/installTables.js
	}
	else {
		console.log('DEBUG-SYNC: A saved d/l Store List was found!! ');
	}

	var storeservices = LoadStoreServicesFromAppData() ? LoadStoreServicesFromAppData() : null;
	console.log('DEBUG-SYNC: store services was loaded in getAllStores()');

	if (!storeservices || storeservices.length < 2){
		storeservices = installStoreServices;
		console.log('DEBUG-SYNC: USING DEFAULT store services file ---- in getAllStores()');
	}


	var s = getAllServices();

	for (var i = 0; i < stores.length; i++){ //for each store
		var temp = storeservices.filter(function(item){
			return (item.StoreID == stores[i].StoreID);
		}); //get all StoreServices that match this Store's id

		s = s.filter(function(item){
			return (inThisStore(item.ServiceID));
		}); //filter all services to only include services in this store
		function inThisStore(serviceid){ //helper function to check if a service is in the current store (by checking if the serviceid is in the temp array of StoreServices which was filtered to only show StoreServices for this store)
			for (var k = 0; k < temp.length; k++){
				if (temp[k].ServiceID == serviceid){
					return true;
				}
			}
			return false;
		}
		stores[i].Services = []; //add a Services property to the store with an empty array
		for (var j = 0; j < s.length; j++){
			stores[i].Services.push(s[j]);
		} //add all the services we found above
	}

	console.log('Finished getting all stores in - getAllStores()');

	return stores;
}


//TODO: Move this method to a service and inject where it is needed
//function for getting interests
function getInterests(){ 
	//var interests = window.localStorage.getItem('Interests');
	var interests = GetItemFromLocalData('Interests');

	if (!interests)
		return [];
	else
		return JSON.parse(interests);
}


// FUNCTION: ALERT //
//redefined the regular javascript alert method to call the native notification plugin and call a 
//custom callback function
function alert(message, callback){
	navigator.notification.alert(
	    message,  // message
	    function(){
	    	callback();
	    },         // callback
	    'Error',            // title
	    'Ok'                  // buttonName
	);
} 


//tells PhoneGap to allow cross origin domain requests via HTTP
$( document ).bind( "mobileinit", function() {
	$.support.cors = true;
    $.mobile.allowCrossDomainPages = true;
}); 




// FUNCTION:  PARSE SERVER OK //
//used in js/app.js to determine if the Server is Ready based on the response from the ServerOK web method
function parseServerOK(data) {
	var output;
	if ($(data).find('ServerOKResult').children("Accessed").text() == 'true')
		output = true;
	else
		output = false;
	return output;
}



//var TempDataVersion = window.localStorage.getItem('DataVersion'); //TempDataVersion starts with the current client data version
var TempDataVersion;

function setSyncVersion(){
	TempDataVersion = GetItemFromLocalData('DataVersion');
}



//FUNCTION: PARSE SYNC START //
//used in js/app.js to determine if the data versions match (no download sync needed) or not (download sync is needed)
function parseSyncStart(data) {

		var output = false;
		var AlwaysSync = parseInt($(data).find('SyncStartResult').children("AlwaysSync").text());
		var DataVersion = $(data).find('SyncStartResult').children("DataVersion").text();

		//if (AlwaysSync == 1 || DataVersion != window.localStorage.getItem('DataVersion')){
		console.log('DataVersion compared: ' + DataVersion + '  / ' + GetItemFromLocalData('DataVersion') );

		if (AlwaysSync == 1 || DataVersion != GetItemFromLocalData('DataVersion') ){
			TempDataVersion = DataVersion; //set TempDataVersion to the server data version so that the client data version can be updated later (see syncend function on this page)
			output = true;
		}

		return output; //return whether or not we need a download sync
}//END




// Downloads / Syncs //


// FUNCTION: DOWNLOAD CLIENT SET //
//AJAX function for downloading client settings, used only in a download sync, called in promosdone function below
function downloadClientSet(deferred, $rootScope, $timeout) {
	//console.log("Client Set download Reuested");
	var error = false;

	$.ajax({
		url: GetItemFromLocalData('ClientURL'), //the ClientURL we stored earlier
		type: "POST", //Alway use POST, the web service is SOAP based not RESTful
		dataType: "xml", //Always xml, the webservice does not use JSON
		timeout : 9000, //The ajaxTimeout object is defined in js/app.js
		data: soapMessageClientSetAll(), //soap messages are defined in js/soapMessages.js
		success: function(data){ //ajax function successs callback (i.e. the function did not time out for lack of internet or something 
			//else happened that caused an error in the actual web service call like the server is down, ..etc)
			error = false;
			console.log("SUCCESS: downloadClientSet() was downloaded.");
			saveClientLog(26, 0, 0, 'SUCCESS: downloadClientSet() was downloaded.');
			var cs = {};
			$(data).find('RClientSetServer').each(function() //for each RclientSetServer object in the XML response (for more details on response format for various web methods, see the webservice specification: http://74.208.209.112/Market_GreenSquare_001/WebService/WebService1.asmx)
			{
				var ItemName = $(this).children("ItemName").text(); //The name of the setting
				var ItemValue = $(this).children("ItemValue").text(); //The value of the setting
				cs[ItemName] = ItemValue; //Save the setting as a property of the cs object defined above; the ItemName is the key and the ItemValue is the value
			});

			//save to localStorage, localStorage is basically the local database for this application; 
			//JSON.stringify converts arrays or objects into json string literals, localStorage can only save strings
			// SaveClientSetsToFile( JSON.stringify(cs) ); 
			SaveClientSetsToAppData( JSON.stringify(cs) );
		},
		error: function(data){
			console.log("ERROR: downloadClientSet() was not downloaded.");
			saveClientLog(54, 0, 0, '', 0, 'ERROR: downloadClientSet() - Could not connect.');
			error = true;
			globals.ajaxTimedOut = true; //error suggests that ajaxTimedOut
			//window.localStorage.setItem('StoreListRetry',1);
			SetItemInLocalData('StoreListRetry', 1 );

			if (!globals.initialSyncDone){
				globals.initialSyncDone = true;

				//window.localStorage.setItem('PromosConstruct', 1 );
				SetItemInLocalData('PromosConstruct', 1 );

				$rootScope.$apply(function(){
					deferred.resolve();
					syncEnd();
				});
			}
		},
		contentType: "text/xml; charset=utf-8"
	}).done(function(){
		console.log("ClientSet download DONE");
		if (!error){
			downloadPromoHead(deferred, $rootScope, $timeout); //if no ajax error was thrown, go onto downloadpromo
		}
	});
} //END



var TempStores = null; //global variable
//FUNCTION: DOWNLOAD STORE LIST //
//AJAX function for downloading stores, used only in a download sync, called in promosdone function below
function downloadStoreList(){ //removed deffered

	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 10000,
		data: soapMessageStoreListAllByDescript(),
		success: function(data){

			var stuff = []; //local array to hold the stores
			console.log("SUCCESS: Store List was downloaded");
			saveClientLog(19, 0, 0, 'SUCCESS: Store List was downloaded');

			//console.log('Stores Data: '+xmlToString(data)+"--"+window.localStorage.getItem('ClientURL')+"--"+soapMessageStoreListAllByDescript());
			$(data).find('RStoreServer').each(function(index)
			{
				var StoreID = parseInt($(this).children("StoreID").text());
				var Descript = $(this).children("Descript").text();
				//parseInt is used when saving the value if the expected value is an int

				var Address1 = $(this).children("Address1").text();
				var Address2 = $(this).children("Address2").text();
				var City = $(this).children("City").text();
				var State = $(this).children("State").text();
				var Zip = $(this).children("Zip").text();
				var Phone = $(this).children("Phone").text();
				var Latitude = parseFloat($(this).children("Latitude").text()); //parseFloat is used when saving the value if the expected value is a real number (i.e. not an int but has decimals)
				var Longitude = parseFloat($(this).children("Longitude").text());
				var RegularPrice = Math.round(parseFloat($(this).children("RegularPrice").text())*100)/100; //Math.round limits the decimal number to two places
				var PlusPrice = Math.round(parseFloat($(this).children("PlusPrice").text())*100)/100;
				var PremiumPrice = Math.round(parseFloat($(this).children("PremiumPrice").text())*100)/100;
				var DieselPrice = Math.round(parseFloat($(this).children("DieselPrice").text())*100)/100;
				var KerosenePrice = Math.round(parseFloat($(this).children("KerosenePrice").text())*100)/100;
				var GasLastUpdate = $(this).children("GasLastUpdate").text();
				stuff.push({
					StoreID : StoreID,
					Descript: Descript,
					Address1 : Address1,
					Address2 : Address2,
					City : City,
					State : State,
					Zip : Zip,
					Phone : Phone,
					Latitude : Latitude,
					Longitude : Longitude,
					RegularPrice : RegularPrice,
					PlusPrice : PlusPrice,
					PremiumPrice : PremiumPrice,
					DieselPrice : DieselPrice,
					KerosenePrice : KerosenePrice,
					GasLastUpdate : GasLastUpdate
				});
			});

			//GENERATE timeStamp and store it in rootscope, this is displayed with the redemption
			var currentdate = new Date(); 
			var storesSyncDate = "StoreList last synced: " + getMonth(currentdate) + " " + addOrd(currentdate.getDate()) + " " + " @ " + getTime(currentdate);
		    window.localStorage.setItem('StoresSyncDate', storesSyncDate);

		    //save the stringified stores in the global TempStores variable, TempStores will replace local Storage stores in the sync end function
			TempStores = JSON.stringify(stuff); 
			//we do not save localStorage automatically here so that Stores, Services, and StoreServices are all saved at the 
			//same time and are on the same DataVersion.. call syncEnd to indicate that one of the asynchrous functions has finished
			syncEnd();
			downloadServices();
		},
		error: function(data){
			console.log("ERROR: Store List was not downloaded");
			saveClientLog(53, 0, 0, '', 0, 'ERROR: downloadStoreList() - Could not connect.');
			//window.localStorage.setItem('StoreListRetry', 1);
			//setStoreListRetry (1);
			SetItemInLocalData('StoreListRetry', 1);

			globals.ajaxTimedOut = true;

			if(!globals.initialSyncDone){
				globals.initialSyncDone = true;
				$rootScope.$apply(function(){
					deferred.resolve();
					syncEnd();
				});
			}

			syncEnd();
		},
		contentType: "text/xml; charset=utf-8"
	});
}//END



// FUNCTION: XML TO STRING
function xmlToString(xmlData) {
    var xmlString;
    //IE
    if (window.ActiveXObject){
        xmlString = xmlData.xml;
    }
    // code for Mozilla, Firefox, Opera, etc.
    else{
        xmlString = (new XMLSerializer()).serializeToString(xmlData);
    }
    return xmlString;
}//END




var TempServices = null;
//FUNCTION DOWNLOAD SERVICES
//AJAX function for downloading services, used only in a download sync, called in promosdone function below
function downloadServices(){ //removed deffered
	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 9000,
		data: soapMessageServiceListAll(),
		success: function(data){
			console.log('SUCCESS: Services downloaded');
			saveClientLog(19, 0, 0, 'SUCCESS: Services downloaded' );
			var stuff = [];
			$(data).find('RServiceServer').each(function(index)
			{
				var ServiceID = $(this).children("ServiceID").text();
				var Descript1 = $(this).children("Descript1").text();
				var SortOrder = parseInt($(this).children("SortOrder").text());
				stuff.push({
					ServiceID : ServiceID,
					Descript1 : Descript1,
					SortOrder : SortOrder
				});
			});

			TempServices = JSON.stringify(stuff);
			syncEnd();
			downloadStoreServices();
		},
		error: function(data){
			console.log('ERROR: Services was not downloaded');
			saveClientLog(52, 0, 0, '', 0, 'ERROR: downloadServices() - Could not connect.');
			globals.ajaxTimedOut = true;
			//window.localStorage.setItem('StoreListRetry',1);
			setStoreListRetry (1);

			if (!globals.initialSyncDone){
				globals.initialSyncDone = true;
				$rootScope.$apply(function(){
					deferred.resolve();
					syncEnd();
				});
			}

			syncEnd();
		},
		contentType: "text/xml; charset=utf-8"
	});
}//END


var TempStoreServices = null;
//FUNCTION: DOWNLOAD STORE SERVICES //
//AJAX function for downloading storeservices, used only in a download sync, called in promosdone function below
function downloadStoreServices() { //removed deffered
	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 9000,
		data: soapMessageStoreServiceListAll(),
		success: function(data){
			console.log('SUCCESS: Store services downloaded');

			saveClientLog(19, 0, 0, 'SUCCESS: Store services downloaded' );
			var stuff = [];
			$(data).find('RStoreServiceServer').each(function(index)
			{
				var ServiceID = $(this).children("ServiceID").text();
				var StoreID = parseInt($(this).children("StoreID").text());
				stuff.push({
					ServiceID : ServiceID,
					StoreID : StoreID
				});
			});
			TempStoreServices = JSON.stringify(stuff);
			syncEnd();
		},
		error: function(data){
			console.log('ERROR: Store services was not downloaded');
			saveClientLog(51, 0, 0, '', 0, 'ERROR: downloadStoreServices() - Could not connect.');
			globals.ajaxTimedOut = true;
			
			SetItemInLocalData('StoreListRetry', 1);
			
			if (!globals.initialSyncDone){
				globals.initialSyncDone = true;
				$rootScope.$apply(function(){
					deferred.resolve();
					syncEnd();
				});
			}
			syncEnd();
	},
		contentType: "text/xml; charset=utf-8"
	});
}



//FUNCTION: SEND PUSH TOKEN TO SERVER //
//AJAX function for downloading promo headers, used only in a download sync, called in js/app.js
var tokenRetry = 0;
function sendPushTokenToServer() {
	$.ajax({ //ajax call for set push web method
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 8000,
		data: soapMessageSetPush(),
		success: function(data){
			saveClientLog(12, 0, 0, 'push token that was received by server : ' + globals.userAccount.get('PushToken') );
			console.log('SUCCESS: push token sent to server: ' + globals.userAccount.get('PushToken') );
			//sendPushResponseCallBack(true,'success');
		},
		error: function(error){
			saveClientLog(13, 0, 0, 'push token was not sent to server: ' + error);
			console.log('ERROR: pushing token was not sent to server' + error);
			//sendPushResponseCallBack(false,error);

			//push token retry (retry on)
			if(tokenRetry < 4){
				tokenRetry = tokenRetry + 1;
				setTimeout(function(){
					sendPushTokenToServer();
				},10000);
			}
		},
		contentType: "text/xml; charset=utf-8"
	});
}//END



//FUNCTION: DOWNLOAD PROMO HEAD //
//AJAX function for downloading promo headers, used only in a download sync, called in js/app.js
function downloadPromoHead(deferred, $rootScope, $timeout) { //removed deffered
	console.log("downloadPromoHead() initiated");
	var error = false;

	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 9000,
		data: soapMessagePromoHeadListAll(),
		success: function(data){
			console.log("SUCCESS: Promo Head Downloaded via downloadPromoHead()");
			saveClientLog(18, 0, 0, 'SUCCESS: Promo Head Downloaded via downloadPromoHead()' );
			error = false;
			var stuff = [];
			$(data).find('RPromoHeadServer').each(function(index){
				var HeadID = $(this).children("HeadID").text();
				var Descript1 = $(this).children("Descript1").text();
				var SortOrder = parseInt($(this).children("SortOrder").text());
				//console.log("promo header received: " + HeadID + ":" + Descript1 + ":" + SortOrder);
				
				stuff.push({
					HeadID : HeadID,
					Descript1 : Descript1,
					SortOrder : SortOrder
				});
			});
			//SaveHeadersToFile( JSON.stringify(stuff) );
			SaveHeadersToAppData( JSON.stringify(stuff) );

		},
		error: function(data){
			console.log("ERROR: Promo Head was not Downloaded");
			saveClientLog(17, 0, 0, 'ERROR: Promo Head was not Downloaded: ' + data);
			if (!globals.initialSyncDone){ //checks to see if the sync has already been marked complete (i.e. the loading screen is gone and the Loading Angular factory promise has been resolved), this is either triggered by the sync completing or a web method throwing an error (not all web methods mark the sync complete if an error occurs), or the max time for the sync has been reached (10 seconds for regular sync and 45 seconds for forced syncnow)
				globals.initialSyncDone = true; //mark sync complete due to an error
				error = true;
				globals.ajaxTimedOut = true;

				SetItemInLocalData('PromosConstruct', 1);
				SetItemInLocalData('PromoRetry', 1);

				deferred.resolve(); //deferred is passed from Angular and is the Loading factory's promise
			}
		},
		contentType: "text/xml; charset=utf-8"
	}).done(function(){
		console.log("downloadPromoHead() DONE - going into downloadPromo()");
		if (!error)
			downloadPromo(deferred, $rootScope, $timeout, true); //if no ajax error was thrown, go onto downloadpromo
	});
}//END


function addOrd(n) { //helper method for the timestamp of a redemption
		var ords = [,'st','nd','rd'];
		var ord, m = n%100;
	return n + ((m > 10 && m < 14)? 'th' : ords[m%10] || 'th');
}
function getMonth(currentdate){ //helper method for the timestamp of a redemption
	var monthNames = ["January", "February", "March", "April", "May", "June", "July", "August", 
	"September", "October", "November", "December"];

	return monthNames[currentdate.getMonth()];
}
function getMinutes(n){ //helper method for the timestamp of a redemption
	if(n < 10)
		return '0' + n;
	else
		return n;
}
function getTime(currentdate){ //helper method for the timestamp of a redemption
	if( currentdate.getHours() < 12 ){
		return currentdate.getHours() + ":" + getMinutes( currentdate.getMinutes() ) + "am"; 
	}
	else{
		if(currentdate.getHours() > 12){
			return ( currentdate.getHours() - 12 ) + ":" + getMinutes( currentdate.getMinutes() ) + "pm"; 
		}
		else{
			return currentdate.getHours()  + ":" + getMinutes( currentdate.getMinutes() ) + "pm"; 
		}
	}
}


// FUNCTION: DOWNLOAD PROMO //
//AJAX function for download promos, called on every sync either from downloadPromoHead (in which case downloadSync is set to true) or from js/app.js in which case it is set to false
function downloadPromo(deferred, $rootScope, $timeout, downloadSync){ 
	var error;

	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 10000,
		data: soapMessagePromoList2(),
		success: function(data){
			console.log("SUCCESS: Promos downloaded");
			saveClientLog(18, 0, 0, 'SUCCESS: Promo Info downloaded' );
			error = false;
			var savepromos = [];	//the promos that will be saved to localstorage
			var newpromos = [];		//promos that are new
			var savepromostores = []; //promostores that will be saved to localstorage
			//gets the promoimage object from localstorage or creates a new one if not available, JSON.parse converts a 
			//string into a javascript array or object (it is the opposite of JSON.stringify)
			//////var PromoImages =  globals.PromoImagesArr ? JSON.parse( globals.PromoImagesArr ) : {}; 

			var PromoImages = LoadPromoImagesFromAppData() ? LoadPromoImagesFromAppData() : {}; 

			//var PromoImages =  LoadPromoImagesFile() ? JSON.parse( LoadPromoImagesFile() ) : {}; 

			var promoImagesDone = 0; //indicates how many promo images have been downloaded from the server
			$(data).find('RPromoServer2').each(function(index){
				var PromoID = $(this).children("PromoID").text();
				var preDescText=$(this).children("Descript1").text();
				var Descript1 =preDescText;
				var Descript2 = $(this).children("Descript2").text();
				var PromoType = parseInt($(this).children("PromoType").text());
				var HeadID = $(this).children("HeadID").text();
				var InterestID = $(this).children("InterestID").text();
				var PromoStore = parseInt($(this).children("PromoStore").text());
				var PromoUse = parseInt($(this).children("PromoUse").text());
				var PromoAccount = parseInt($(this).children("PromoAccount").text());
				var DateStart = ticksToEpoch(parseInt($(this).children("DateStartTicks").text()));
				var DateEnd = ticksToEpoch(parseInt($(this).children("DateEndTicks").text()));
				var DisplaySec = parseInt($(this).children("DisplaySec").text());
				var Uses = parseInt($(this).children("Uses").text());
				var AccountUses = parseInt($(this).children("AccountUses").text());
				var Age = parseInt($(this).children("Age").text());
				var Points = parseInt($(this).children("Points").text());
				var DetailHTMLFile = $(this).children("DetailHTMLFile").text();
				var PhotoFile = $(this).children("PhotoFile").text();
				var ThumbFile = $(this).children("ThumbFile").text();
				var DescriptPush = $(this).children("DescriptPush").text();
				var FocusTime = $(this).children("FocusTime").text();

				if(InterestID){
					console.log("SYNC-PROMOS: WARNING - InterestID " + InterestID + "  (Warning! this promo is using an Interest only ID!");
				}

				if (FocusTime){
					FocusTime = parseInt(FocusTime); //focus time indicates if this promotion can be used in the focus now module: 0 indicates no, 1 is breakfast, 2 is lunch, 3 is dinner, and 4 is late night
				}
				else{
					FocusTime = 0;
				}

				var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;

				if ((Uses == 0 || AccountUses < Uses) && now > DateStart && now < DateEnd){ 
				//make sure the promotion is valid (i.e. today's date is between the promo start and end date, also make sure the promo 
				//is not a redeemable promo (Uses == 0) OR that the user has enough AccountUses to redeem the promotion)				
				//console.log("promo saved: " + PromoID);
					savepromos.push({
						PromoID : PromoID,
						Descript1 : Descript1,
						Descript2 : Descript2,
						PromoType : PromoType,
						HeadID : HeadID,
						InterestID : InterestID,
						PromoStore : PromoStore,
						PromoUse : PromoUse,
						PromoAccount : PromoAccount,
						DateStart : DateStart,
						DateEnd : DateEnd,
						DisplaySec : DisplaySec,
						Uses : Uses,
						AccountUses : AccountUses,
						Age : Age,
						Points : Points,
						DetailHTMLFile : DetailHTMLFile,
						PhotoFile : PhotoFile,
						ThumbFile : ThumbFile,
						DescriptPush : DescriptPush,
						FocusTime : FocusTime
					});
				}
				else{
					console.log("SYNC-PROMOS: Invalid promo received: " + PromoID);
				}
			});
			

			
		    //var op =  globals.PromosArr ? JSON.parse( globals.PromosArr ) : null; 
		    var op =  LoadPromosFromAppData() ? LoadPromosFromAppData() : null; 
		    //console.log("globals.PromosArr - " + globals.PromosArr);

		    if( op != null ){
		    	var oldpromos = op;
		    	console.log("SYNC-PROMOS: There were Old promos grab");
		    }

			//determine which promos are new (i.e. they have not been saved to the app before)
			for (var i = 0; i < savepromos.length; i++){
				if (!inPromos(savepromos[i].PromoID, oldpromos)){
					newpromos.push(savepromos[i]);
					console.log("SYNC-PROMOS: A New Promo was saved");
				}
			} 

			//saves the promostores of the newpromos in oldpromos
			if (newpromos.length > 0){

				console.log('SYNC-PROMOS: There were new promos made..');

				$(data).find('RPromoStoreServer2').each(function(index){
					var PromoID = $(this).children("PromoID").text();
					var StoreID = parseInt($(this).children('StoreID').text());
					savepromostores.push({
						PromoID : PromoID,
						StoreID : StoreID
					});
				});

				// **** SAVE Promo Stores and put them into a temp variable **** //
				//SavePromoStoresToFile(JSON.stringify(savepromostores));
				SavePromoStoresToAppData( JSON.stringify(savepromostores) );

				//download and save all promostores if there are any new promotions, we do not only download promostores for newpromos 
				//because the  to check whether or not this promostore is for a new or old promo would likely be slower than just 
				//downloading and saving all of them
				promoImagesDone = 0;
				var i = 0;

				downloadPromoImage(newpromos, i, function(){

					if(promoImagesDone >= newpromos.length){ //success call back for the downloadpromoimage function, if all the new promo images have been downloaded then save them and call promosDone function (defined below)
						console.log("SYNC-PROMOS: SUCCESS in downloading all new promo imgs.");
						saveClientLog(89, 0, 0, 'SUCCESS in downloading all new promo imgs.' );
						//GENERATE timeStamp and store it in rootscope, this is displayed with the redemption
						var currentdate = new Date(); 
						var promosSyncDate = "Promos last synced: " + getMonth(currentdate) + " " + addOrd(currentdate.getDate()) + " " + " @ " + getTime(currentdate);
						window.localStorage.setItem('PromosSyncDate', promosSyncDate);

						SavePromoImagesToAppData( JSON.stringify(PromoImages) );

						promosDone();
					}
				}, function(){  //error call back for the download promo image function

					if (!globals.initialSyncDone){
						globals.initialSyncDone = true;
						error = true;
						globals.ajaxTimedOut = true;

						SetItemInLocalData('PromosConstruct', 1);
						SetItemInLocalData('PromoRetry', 1);

						console.log("ERROR in downloading promo imgs. Going straight to app.(1)");
						saveClientLog(88, 0, 0, 'ERROR in downloading promo imgs. Going straight to app.(1)' );

						deferred.resolve(); //go to app
					}
				});

				//This block of code will catch newPromos[] that are Incomplete in their downloads 
				/*
				if(promoImagesDone < newpromos.length && !globals.initialSyncDone){ 

					console.log("The downloading of new promo images is not done yet. Going straight to app.(2)");
					saveClientLog(32, 0, 0, 'SUCCESS: in PromosDone. Saving Promos now' );
				}
			}
			else{
				saveClientLog(32, 0, 0, 'SUCCESS: But no new promos' );
				console.log('SYNC-PROMOS: There were No new promos made..');
				console.log('SUCCESS: But no new promos' );

				//GENERATE timeStamp and store it in rootscope, this is displayed with the redemption
				var currentdate = new Date(); 
				var promosSyncDate = "Promos last synced: " + getMonth(currentdate) + " " + addOrd(currentdate.getDate()) + " " + " @ " + getTime(currentdate);
				window.localStorage.setItem('PromosSyncDate', promosSyncDate);

				promosDone(); //if there are no new promos then just call promosdone right away
			}

			function promosDone(){
				console.log("SYNC-PROMOSDONE: initiated");
				saveClientLog(32, 0, 0, 'SUCCESS: in PromosDone. Saving Promos now' );
				//clear data and data
				//make sure no AJAX functions threw an error before saving the data (so we do not for example save a promo when the corresponding promo image was not downloaded) we also don't want to call
				//remaining AJAX download sync functions since the user likely has bad or no internet at this time
				if(!error){
					console.log("SYNC-DEBUG: No errors found, proceeding with Storelist DL");
					if (downloadSync){		
						downloadStoreList(); // this will chain and also get services and store services
					}
				}
				else{
					console.log("ERROR: error in promosDone(): " + error);
				}

				if(savepromos.length > 0 && !error){
					console.log('SYNC-PROMOSDONE: New promos were saved in promosDone().');

					//SavePromosToFile(JSON.stringify(savepromos));  //Old File System syntax
					SavePromosToAppData(JSON.stringify(savepromos)); 
				}

				console.log("SYNC-PROMOSDONE: globals.initialSyncDone in promosDone() = " + globals.initialSyncDone);

				if (!globals.initialSyncDone){
					
					SetItemInLocalData('PromosConstruct', 1);
					globals.initialSyncDone = true;

					console.log("SYNC-PROMOSDONE: Approaching resolve()");

					$rootScope.$apply(function(){
						deferred.resolve();
						syncEnd();
					});
				}
				else{
					SetItemInLocalData('PromosConstruct', 1);
				}

			}


			function downloadPromoImage(photo, counter, callback, errorcallback){ //helper function for downloading a promo image

				if(counter < newpromos.length){
					console.log('Debug: image download test [' + counter + '] - ' + photo[counter].PhotoFile ); 

					$.ajax({
						url: GetItemFromLocalData('ClientURL'),
						type: "POST",
						dataType: "xml",
						timeout : 12000,
						data: soapMessageGetFileChunk('Image', photo[counter].PhotoFile), //this as well as the function updateGameAssets (in js/app.js) uses the GetFileChunk web method which returns the image as a base64 encoded string
						success: function(data){
							console.log("SUCCESS: A promo-image was downloaded via downloadpromoimage()");
							saveClientLog(44, 0, 0, "SUCCESS: A promo-image was downloaded via downloadpromoimage()");

							var error = $(data).find('Standard').children('MethodErrorLevel').text();
							if (error == "None"){
								if (photo[counter].PhotoFile.substring(photo[counter].PhotoFile.indexOf('.') + 1) == 'png') //check if the photofile name is png or jpg and save accordingly
									PromoImages[photo[counter].PhotoFile] = "data:image/png;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();
								else{
									PromoImages[photo[counter].PhotoFile] = "data:image/jpeg;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();
								}
								promoImagesDone++; //increments promoImagesDone which is used in the success call back to determine if all promo images have been downloaded
								
								console.log("Image Download successful (line1059/sync.js) : " + photo[counter].PhotoFile +  "  :  "+ promoImagesDone);
							}
							else{
								console.log("ERROR: could not download promo image: "  + photo[counter].PhotoFile + " - Error = " + error);
								saveClientLog(45, 0, 0, "ERROR: promo image downloaded but caused an error: "  + photo[counter].PhotoFile + " - Error = " + error);
							}

							var next = counter + 1;
							callback();

							downloadPromoImage(photo, next, callback, errorcallback);
						},
						contentType: "text/xml; charset=utf-8",
						error: function(data){
							//var next = counter + 1;
							console.log("error! in downloadPromoImage()");
							console.log("ERROR: could not connect to download promo image: "  + photo[counter].Photofile + " - Error = " + data);
							saveClientLog(46, 0, 0, "ERROR: could not connect to download promo image: "  + photo[counter].Photofile + " - Error = " + data);
							errorcallback();

							//downloadPromoImage(photo, next, callback, errorcallback);
						}
					});
				}
			}

			function inPromos(promoid, promos){ //helper function to check if a promoid is in a promos array
				if (!promos)
					return false;
				for (var i = 0; i < promos.length; i++){
					if (promos[i].PromoID == promoid)
						return true;
				}
				return false;
			}
		},
		error: function(data){
			if (!globals.initialSyncDone){
				console.log("ERROR: in downloadPromo()");
				saveClientLog(62, 0, 0, 'ERROR: in downloadPromo() - Promo information was not downloaded.' );

				globals.initialSyncDone = true;
				error = true;
				globals.ajaxTimedOut = true;

				SetItemInLocalData('PromosConstruct', 1);
				SetItemInLocalData('PromoRetry', 1);

				deferred.resolve();
			}
		},
		contentType: "text/xml; charset=utf-8"
	});
} //END



var syncCount = 0; //globals variable used to determine if syncEnd should be called

// FUNCTION SYNC END //
function syncEnd(){
	syncCount++;
	if (syncCount == 4){ //all web methods that need to run before syncEnd can be called are done
		
		saveStoreData(); 

		$.ajax({ //ajax call for syncend web method
			url: GetItemFromLocalData('ClientURL'),
			type: "POST",
			dataType: "xml",
			timeout : 10000,
			data: soapMessageSyncEnd(),
			success: function(data){
				saveClientLog(12, 0, 0, '', 0, 'syncend ok');
				console.log("SYNCEND-SUCCESS: syncend() launched");
					
				SetItemInLocalData('DataVersion', TempDataVersion);
				console.log('Set DataVersion to: ' + TempDataVersion);

				//if syncend is successful then set the client's dataversion to tempdataversion (which was set to the server's data 
				//version earlier for a downloadsync or is just the same dataversion for a non-download sync)
			},
			error: function(error){
				saveClientLog(13, 0, 0, '', 0, 'syncend error');
				console.log("SYNCEND-ERROR: syncend() did not connect");
			},

			contentType: "text/xml; charset=utf-8"
		});
	}
}//END of syncEnd()


//--------------------//
//  REFRESH METHODS   //
//--------------------//

function refreshClientSet() {
	//console.log("Client Set download Requested");
	var error=false;
	$.ajax({
		url: GetItemFromLocalData('ClientURL'), //the ClientURL we stored earlier
		type: "POST", //Alway use POST, the web service is SOAP based not RESTful
		dataType: "xml", //Always xml, the webservice does not use JSON
		timeout : 10000, //The ajaxTimeout object is defined in js/app.js
		data: soapMessageClientSetAll(), //soap messages are defined in js/soapMessages.js
		success: function(data){ //ajax function successs callback (i.e. the function did not time out for lack of internet or something 
			//else happened that caused an error in the actual web service call like the server is down, ..etc)
			error = false;
			console.log("SUCCESS: REFRESH ClientSet() was downloaded.");
			saveClientLog(90, 0, 0, '', 0, 'SUCCESS: REFRESH ClientSet() was downloaded.');
			var cs = {};
			$(data).find('RClientSetServer').each(function() //for each RclientSetServer object in the XML response (for more details on response format for various web methods, see the webservice specification: http://74.208.209.112/Market_GreenSquare_001/WebService/WebService1.asmx)
			{
				var ItemName = $(this).children("ItemName").text(); //The name of the setting
				var ItemValue = $(this).children("ItemValue").text(); //The value of the setting
				cs[ItemName] = ItemValue; //Save the setting as a property of the cs object defined above; the ItemName is the key and the ItemValue is the value
			});

			//save to localStorage, localStorage is basically the local database for this application; 
			//JSON.stringify converts arrays or objects into json string literals, localStorage can only save strings
			//window.localStorage.setItem('ClientSets', JSON.stringify(cs)); 

			SaveClientSetsToAppData( JSON.stringify(cs) );

			refreshStoreList();// Move to storelist now
		},
		error: function(data){
			console.log("ERROR: downloadClientSet() was not downloaded.");
			saveClientLog(91, 0, 0, '', 0, 'ERROR: REFRESH downloadClientSet() was not downloaded.');
		},
		contentType: "text/xml; charset=utf-8"
	}).done(function(){
		console.log("ClientSet download DONE");
	});
} //END


//AJAX function for downloading stores, used only in a download sync
function refreshStoreList(){
	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 10000,
		data: soapMessageStoreListAllByDescript(),
		success: function(data){

			var stuff = []; //local array to hold the stores
			console.log("SUCCESS: Store List was downloaded");
			saveClientLog(94, 0, 0, '', 0, 'SUCCESS: REFRESH Store List was downloaded');

			//console.log('Stores Data: '+xmlToString(data)+"--"+window.localStorage.getItem('ClientURL')+"--"+soapMessageStoreListAllByDescript());
			$(data).find('RStoreServer').each(function(index){
				var StoreID = parseInt($(this).children("StoreID").text());
				var Descript = $(this).children("Descript").text();
				//parseInt is used when saving the value if the expected value is an int

				var Address1 = $(this).children("Address1").text();
				var Address2 = $(this).children("Address2").text();
				var City = $(this).children("City").text();
				var State = $(this).children("State").text();
				var Zip = $(this).children("Zip").text();
				var Phone = $(this).children("Phone").text();
				var Latitude = parseFloat($(this).children("Latitude").text()); //parseFloat is used when saving the value if the expected value is a real number (i.e. not an int but has decimals)
				var Longitude = parseFloat($(this).children("Longitude").text());
				var RegularPrice = Math.round(parseFloat($(this).children("RegularPrice").text())*100)/100; //Math.round limits the decimal number to two places
				var PlusPrice = Math.round(parseFloat($(this).children("PlusPrice").text())*100)/100;
				var PremiumPrice = Math.round(parseFloat($(this).children("PremiumPrice").text())*100)/100;
				var DieselPrice = Math.round(parseFloat($(this).children("DieselPrice").text())*100)/100;
				var KerosenePrice = Math.round(parseFloat($(this).children("KerosenePrice").text())*100)/100;
				var GasLastUpdate = $(this).children("GasLastUpdate").text();
				stuff.push({
					StoreID : StoreID,
					Descript: Descript,
					Address1 : Address1,
					Address2 : Address2,
					City : City,
					State : State,
					Zip : Zip,
					Phone : Phone,
					Latitude : Latitude,
					Longitude : Longitude,
					RegularPrice : RegularPrice,
					PlusPrice : PlusPrice,
					PremiumPrice : PremiumPrice,
					DieselPrice : DieselPrice,
					KerosenePrice : KerosenePrice,
					GasLastUpdate : GasLastUpdate
				});
			});

			//GENERATE timeStamp and store it in rootscope, this is displayed with the redemption
			var currentdate = new Date(); 
			var storesSyncDate = "StoreList last synced: " + getMonth(currentdate) + " " + addOrd(currentdate.getDate()) + " " + " @ " + getTime(currentdate);
		    window.localStorage.setItem('StoresSyncDate', storesSyncDate);

			TempStores = JSON.stringify(stuff); //save the stringified stores in the globals TempStores variable, TempStores will replace local Storage stores in the sync end function
			//we do not save localStorage automatically here so that Stores, Services, and StoreServices are all saved at the same time and are on the same DataVersion

			SaveStoresToAppData( TempStores );
			TempStores = null;

			SetItemInLocalData('StoreListRetry', 0);

			refreshServices();

		},
		error: function(data){
			console.log("ERROR: Store List was not downloaded");
			saveClientLog(93, 0, 0, '', 0, 'ERROR: REFRESH Store List was not downloaded');
			globals.ajaxTimedOut = true;
		},
		contentType: "text/xml; charset=utf-8"
	});
}//END



function refreshStoreServices() {
	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 10000,
		data: soapMessageStoreServiceListAll(),
		success: function(data){
			console.log('SUCCESS: Store services downloaded');
			saveClientLog(95, 0, 0, '', 0, 'SUCCESS: Store services downloaded');
			var stuff = [];
			$(data).find('RStoreServiceServer').each(function(index)
			{
				var ServiceID = $(this).children("ServiceID").text();
				var StoreID = parseInt($(this).children("StoreID").text());
				stuff.push({
					ServiceID : ServiceID,
					StoreID : StoreID
				});
			});
			TempStoreServices = JSON.stringify(stuff);

			SaveStoreServicesToAppData( TempStoreServices );
			TempStoreServices = null;
		},
		error: function(data){
			console.log('ERROR: Store services was not downloaded');
			saveClientLog(96, 0, 0, '', 0, 'ERROR: Store services was not downloaded');
			globals.ajaxTimedOut = true;
		},
		contentType: "text/xml; charset=utf-8"
	});
}


function refreshServices() {
	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 10000,
		data: soapMessageServiceListAll(),
		success: function(data){
			console.log('SUCCESS: REFRESH Services downloaded');
			saveClientLog(97, 0, 0, '', 0, 'SUCCESS: REFRESH Services downloaded');
			var stuff = [];
			$(data).find('RServiceServer').each(function(index)
			{
				var ServiceID = $(this).children("ServiceID").text();
				var Descript1 = $(this).children("Descript1").text();
				var SortOrder = parseInt($(this).children("SortOrder").text());
				stuff.push({
					ServiceID : ServiceID,
					Descript1 : Descript1,
					SortOrder : SortOrder
				});
			});
			TempServices = JSON.stringify(stuff);

			SaveServicesToAppData( TempServices );
			TempServices = null;

			refreshStoreServices();
		},
		error: function(data){
			console.log('ERROR: Services was not downloaded');
			saveClientLog(97, 0, 0, '', 0, 'ERROR: Services was not downloaded');
			globals.ajaxTimedOut = true;
		},
		contentType: "text/xml; charset=utf-8"
	});
}//END




function screenRefresh($scope, $rootScope, $timeout, $compile){
	
	$("#wrapper").html($compile('<div id = "headerwrap" class = "promosHeaderWrapper" ng-repeat="Header in Headers" ng-show="Headers.length > 0" >'+
		'<div class="promoHeader">'+
			'{{Header.Descript1}}'+
		'</div>'+
		'<div id = "promoCarousel" class="touchcarousel minimal-light promosCarousel">'+
			'<ul class="touchcarousel-container">'+
				'<li ng-repeat="Promo in Header.Promos" class="touchcarousel-item" ng-class="{\'disabledPromo\' : invalidPromo(Promo)}">'+
					'<a id="{{Promo.PromoID}}" ng-click="viewPromo(Promo)">'+
						'<img class="tcimage promoCarouselImage" src="{{Promo.PhotoURL}}"/>'+
						'<div class="tctext"><span class="tctext-inner">{{Promo.Descript1}}</span></div>'+
					'</a>'+
				'</li>'+
			'</ul>'+
		'</div>'+
	'</div>'+
	'<div id="scroll_place_holder"></div>')($scope));     // Append new elements 
	
	$scope.$apply(); 
	
	setTimeout(function(){
		var height = $(window).height(); // android and ios // MAIN Screen Resize
		$("#promos .ui-content").css('height', height - $('#promos .ui-header').height() - $('#promos .ui-footer').height() - 2);
		$("#promos .ui-content").css('width', $('#promos .ui-header').width() );
		$("#promos .tcimage").css('height', $('#promos .ui-content').height() * .26 );
		$("#promos .tcimage").css('width', $('#promos .tcimage').height() * 1.26 );
		$("#promos .promosCarousel").css('height', $('#promos .tcimage').height() );
		$("#promos .promosCarousel .touchcarousel-item").css('height', $('#promos .tcimage').height() );
		$("#promos .promosCarousel .touchcarousel-item").css('width', $('#promos .tcimage').width() + 6 );
		$("#promos .promosCarousel .tctext").css('width', $('#promos .tcimage').width() );
		$("#promos .promosCarousel .touchcarousel-item").css('position', "relative" );
		$("#promos .promosCarousel").css('margin-left', $('#promos .ui-content').width() * .16 );
		$("#promos .promosCarousel").css('width', $('#promos .ui-content').width() * .7 );
		$("#promos .touchcarousel-container").css('width', $('#promos .ui-content').width() );
		$("#promos .promosHeaderWrapper").css('width', $('#promos .ui-content').width() );

		$rootScope.PromosSyncDate = window.localStorage.getItem('PromosSyncDate');

		if(!$rootScope.PromosSyncDate)
			$rootScope.PromosSyncDate = "Promo's have not yet synced.. Please check your connection."

		$scope.promosIsSyncing = false;
		$rootScope.$apply();
		console.log("promos last sync text: " + $rootScope.PromosSyncDate);
	
		if (!$('#promos .promosHeaderWrapper').hasClass('ng-hide')){

			sliderInstance = $('#promos .promosCarousel').touchCarousel({
				pagingNav: true,
				directionNav: true,
				snapToItems: true,
				scrollbar: false,
				transitionSpeed: 350,
				useWebkit3d: true
			}).data("touchCarousel");

			setTimeout(function(){
				$("#promos .promosCarousel").animate({opacity:1}, 600);

				//if(sliderInstance)	
					//sliderInstance.updateCarouselSize();

				//if($('#iscroller').iscrollview() )
					//$('#iscroller').iscrollview('refresh');
				window.wizSpinner.hide();
			}, 10);	
		}
	}, 100);	

}



function refreshPromoHead($scope, $rootScope, $timeout, $compile){
	console.log("refreshPromoHead()  initiated");
	var error = false;

	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 10000,
		data: soapMessagePromoHeadListAll(),
		success: function(data){
			console.log("SUCCESS: REFRESH Promo Head Downloaded via refreshPromoHead()");
			saveClientLog(97, 0, 0, '', 0, 'ERROR: REFRESH Promo Head Downloaded via refreshPromoHead()');
			error = false;
			var stuff = [];
			$(data).find('RPromoHeadServer').each(function(index){
				var HeadID = $(this).children("HeadID").text();
				var Descript1 = $(this).children("Descript1").text();
				var SortOrder = parseInt($(this).children("SortOrder").text());
				//console.log("promo header received: " + HeadID + ":" + Descript1 + ":" + SortOrder);

				stuff.push({
					HeadID : HeadID,
					Descript1 : Descript1,
					SortOrder : SortOrder
				});
			});

			//SaveHeadersToFile( JSON.stringify(stuff) );
			SaveHeadersToAppData( JSON.stringify(stuff) );

		},
		error: function(data){
			console.log("ERROR: REFRESH Promo Head was not Downloaded");
			saveClientLog(98, 0, 0, '', 0, 'ERROR: REFRESH Promo Head was not Downloaded');
			setTimeout(function(){	
				screenRefresh($scope, $rootScope, $timeout, $compile);
			}, 1000);

		},
		contentType: "text/xml; charset=utf-8"
	}).done(function(){
		console.log("refreshPromoHead()  DONE - going into refreshPromo()");

		refreshPromo($scope, $rootScope, $timeout, $compile); //if no ajax error was thrown, go onto downloadpromo
	});
}//END


function storeRefresh(){
	refreshClientSet(); //starts with Clientsets and ends with Store Services
}


function refreshPromo($scope, $rootScope, $timeout, $compile){ 
	var error;

	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 15000,
		data: soapMessagePromoList2(),
		success: function(data){
			console.log("SUCCESS: REFRESH Promos downloaded");
			saveClientLog(99, 0, 0, '', 0, 'SUCCESS: REFRESH Promos downloaded');
			error = false;
			var savepromos = []; //the promos that will be saved to localstorage
			var newpromos = [];	//promos that are new
			var savepromostores = []; //promostores that will be saved to localstorage
			//var PromoImages = globals.PromoImagesArr ? JSON.parse(globals.PromoImagesArr) : null;
			//gets the promoimage object from localstorage or creates a new one if not available, JSON.parse converts a string into a javascript array or object (it is the opposite of JSON.stringify)
			//var PromoImages = getImagesFromDb() ? JSON.parse(getImagesFromDb()) : {}; 

			var PromoImages = LoadPromoImagesFromAppData() ? LoadPromoImagesFromAppData() : {}; 

			var promoImagesDone = 0; //indicates how many promo images have been downloaded from the server
			$(data).find('RPromoServer2').each(function(index){
				var PromoID = $(this).children("PromoID").text();
				var preDescText=$(this).children("Descript1").text();
				var Descript1 =preDescText;
				var Descript2 = $(this).children("Descript2").text();
				var PromoType = parseInt($(this).children("PromoType").text());
				var HeadID = $(this).children("HeadID").text();
				var InterestID = $(this).children("InterestID").text();
				var PromoStore = parseInt($(this).children("PromoStore").text());
				var PromoUse = parseInt($(this).children("PromoUse").text());
				var PromoAccount = parseInt($(this).children("PromoAccount").text());
				var DateStart = ticksToEpoch(parseInt($(this).children("DateStartTicks").text()));
				var DateEnd = ticksToEpoch(parseInt($(this).children("DateEndTicks").text()));
				var DisplaySec = parseInt($(this).children("DisplaySec").text());
				var Uses = parseInt($(this).children("Uses").text());
				var AccountUses = parseInt($(this).children("AccountUses").text());
				var Age = parseInt($(this).children("Age").text());
				var Points = parseInt($(this).children("Points").text());
				var DetailHTMLFile = $(this).children("DetailHTMLFile").text();
				var PhotoFile = $(this).children("PhotoFile").text();
				var ThumbFile = $(this).children("ThumbFile").text();
				var DescriptPush = $(this).children("DescriptPush").text();
				var FocusTime = $(this).children("FocusTime").text();

				//console.log("promo received: " + PromoID + ":" + Descript1 + ":" + DateStart);
				//console.log("promo age: " +  Age + " - photo file: " +  PhotoFile); 

				if(InterestID)
					console.log("InterestID " + InterestID + " for " + Descript1 + " (Warning! this promo is using an Interest only ID!");

				if (FocusTime){
					FocusTime = parseInt(FocusTime); //focus time indicates if this promotion can be used in the focus now module: 0 indicates no, 1 is breakfast, 2 is lunch, 3 is dinner, and 4 is late night
				}
				else{
					FocusTime = 0;
				}

				var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;

				if ((Uses == 0 || AccountUses < Uses) && now > DateStart && now < DateEnd){ 
				//make sure the promotion is valid (i.e. today's date is between the promo start and end date, also make sure the promo 
				//is not a redeemable promo with zero 'Uses' OR that the user has enough AccountUses to redeem the promotion)
					savepromos.push({
						PromoID : PromoID,
						Descript1 : Descript1,
						Descript2 : Descript2,
						PromoType : PromoType,
						HeadID : HeadID,
						InterestID : InterestID,
						PromoStore : PromoStore,
						PromoUse : PromoUse,
						PromoAccount : PromoAccount,
						DateStart : DateStart,
						DateEnd : DateEnd,
						DisplaySec : DisplaySec,
						Uses : Uses,
						AccountUses : AccountUses,
						Age : Age,
						Points : Points,
						DetailHTMLFile : DetailHTMLFile,
						PhotoFile : PhotoFile,
						ThumbFile : ThumbFile,
						DescriptPush : DescriptPush,
						FocusTime : FocusTime
					});
				}
				else{
					console.log("Promo is either invalid (date/uses) or not redeemable (event): " + PromoID);
				}
			});

			//GENERATE timeStamp and store it in rootscope, this is displayed with the redemption
			var currentdate = new Date(); 
			var promosSyncDate = "Promos last synced: " + getMonth(currentdate) + " " + addOrd(currentdate.getDate()) + " " + " @ " + getTime(currentdate);
		    window.localStorage.setItem('PromosSyncDate', promosSyncDate);

		    //var op =  globals.PromosArr ? JSON.parse( globals.PromosArr ) : null; 
		    //console.log("globals.PromosArr -  " + globals.PromosArr);

		    var op =  LoadPromosFromAppData() ? LoadPromosFromAppData() : null; 

		    if(!PromoImages){
		    	op = null;
		    	PromoImages = {};
		    	console.log("promo images arr was empty. grabbing all images");
		    }

		    if( op != null ){
		    	var oldpromos = op;
		    	console.log("There were Old promos grab");
		    }

			//determine which promos are new (i.e. they have not been saved to the app before)
			for (var i = 0; i < savepromos.length; i++){
				if (!inPromos(savepromos[i].PromoID, oldpromos))
					newpromos.push(savepromos[i]);
			} 

			if (newpromos.length > 0){
				$(data).find('RPromoStoreServer2').each(function(index){
					var PromoID = $(this).children("PromoID").text();
					var StoreID = parseInt($(this).children('StoreID').text());
					savepromostores.push({
						PromoID : PromoID,
						StoreID : StoreID
					});
				});
				//download and save all promostores if there are any new promotions, we do not only download promostores for newpromos 
				//because the logic to check whether or not this promostore is for a new or old promo would likely be slower than just 
				//downloading and saving all of them
				//Clear Promos
				//window.localStorage.removeItem('PromoStores');
				//window.localStorage.setItem('PromoStores', JSON.stringify(savepromostores)); 
				SavePromoStoresToAppData(JSON.stringify(savepromostores));
				
				promoImagesDone = 0;
				var i = 0;

				downloadPromoImage(newpromos, i, function(){

					if(promoImagesDone >= newpromos.length){ //success call back for the downloadpromoimage function, if all the new promo images have been downloaded then save them and call promosDone function (defined below)
						console.log("SUCCESS in downloading all new promo imgs.");
						saveClientLog(89, 0, 0, 'SUCCESS in downloading all new promo imgs.' );
						

						//window.localStorage.setItem('PromoImages', JSON.stringify(PromoImages) ); //Save Promo images

						if (!error){ 
							//if there are any promos to be saved, save them to localStorage
							SavePromoImagesToAppData( JSON.stringify(PromoImages) ); //Save Promo images
							SavePromosToAppData(JSON.stringify(savepromos)); 
						}
						else{
							console.log("error in Refresh Promos: " + error);
						}

						storeRefresh();
						setTimeout(function(){
							$scope.Headers = getAllHeadersWithPromos('refreshPromos()'); 

							setTimeout(function(){
								$scope.Promos = getAllPromos(0,'refreshPromos()');
									
								setTimeout(function(){	
									screenRefresh($scope, $rootScope, $timeout, $compile);
								}, 1400);
							}, 40);
						}, 1000);	

						console.log("SUCCESS: Promos/StoreList/Services/StoreServices were refreshed");
						
					}
				}, function(){  //error call back for the download promo image function

					if (!globals.initialSyncDone){
						globals.initialSyncDone = true;
						error = true;
						globals.ajaxTimedOut = true;

						console.log("ERROR in downloading promo imgs. Going straight to app.(1)");
						saveClientLog(88, 0, 0, 'ERROR in downloading promo imgs. Going straight to app.(1)' );
					}
				});

				
			}
			else{
				console.log("There were no new promos to refresh");
				setTimeout(function(){	
					screenRefresh($scope, $rootScope, $timeout, $compile);
				}, 1000);
			}




			function downloadPromoImage(photo, counter, callback, errorcallback){ //helper function for downloading a promo image

				if(counter < newpromos.length){
					console.log('Debug: image download test [' + counter + '] - ' + photo[counter].PhotoFile ); 

				$.ajax({
					url: GetItemFromLocalData('ClientURL'),
					type: "POST",
					dataType: "xml",
					timeout : 12000,
					data: soapMessageGetFileChunk('Image', photo[counter].PhotoFile), //this as well as the function updateGameAssets (in js/app.js) uses the GetFileChunk web method which returns the image as a base64 encoded string
					success: function(data){
						console.log("SUCCESS: A promo-image was downloaded via downloadpromoimage()");
						saveClientLog(44, 0, 0, "SUCCESS: A promo-image was downloaded via downloadpromoimage()");

						var error = $(data).find('Standard').children('MethodErrorLevel').text();
						if (error == "None"){
							if (photo[counter].PhotoFile.substring(photo[counter].PhotoFile.indexOf('.') + 1) == 'png') //check if the photofile name is png or jpg and save accordingly
								PromoImages[photo[counter].PhotoFile] = "data:image/png;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();
							else{
								PromoImages[photo[counter].PhotoFile] = "data:image/jpeg;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();
							}
							promoImagesDone++; //increments promoImagesDone which is used in the success call back to determine if all promo images have been downloaded
							
							console.log("Image Download successful (line1059/sync.js) : " + photo[counter].PhotoFile +  "  :  "+ promoImagesDone);
						}
						else{
							console.log("ERROR: could not download promo image: "  + photo[counter].PhotoFile + " - Error = " + error);
							saveClientLog(45, 0, 0, "ERROR: promo image downloaded but caused an error: "  + photo[counter].PhotoFile + " - Error = " + error);
						}

						var next = counter + 1;
						callback();

						downloadPromoImage(photo, next, callback, errorcallback);
					},
					contentType: "text/xml; charset=utf-8",
					error: function(data){
						//var next = counter + 1;
						console.log("error! in downloadPromoImage()");
						console.log("ERROR: could not connect to download promo image: "  + photo[counter].Photofile + " - Error = " + data);
						saveClientLog(46, 0, 0, "ERROR: could not connect to download promo image: "  + photo[counter].Photofile + " - Error = " + data);
						errorcallback();
					}
				});
				}
			}

			function inPromos(promoid, promos){ //helper function to check if a promoid is in a promos array
				if (!promos)
					return false;
				for (var i = 0; i < promos.length; i++){
					if (promos[i].PromoID == promoid)
						return true;
				}
				return false;
			}

		},
		error: function(data){
			console.log("ERROR: in Refresh downloadPromo()");
			saveClientLog(59, 0, 0, '', 0, 'ERROR: in Refresh downloadPromo()');

			setTimeout(function(){	
				screenRefresh($scope, $rootScope, $timeout, $compile);
			}, 1000);
		},
		contentType: "text/xml; charset=utf-8"
	});
}



function PromoHeadOnly(){
	console.log("PromoHeadOnly()  initiated");
	var error = false;

	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 10000,
		data: soapMessagePromoHeadListAll(),
		success: function(data){
			console.log("SUCCESS: Promo Head Downloaded via PromoHeadOnly() ");
			saveClientLog(71, 0, 0, '', 0, "SUCCESS: Promo Head Downloaded via PromoHeadOnly() ");
			error = false;
			var stuff = [];
			$(data).find('RPromoHeadServer').each(function(index){
				var HeadID = $(this).children("HeadID").text();
				var Descript1 = $(this).children("Descript1").text();
				var SortOrder = parseInt($(this).children("SortOrder").text());
				//console.log("promo header received: " + HeadID + ":" + Descript1 + ":" + SortOrder);

				stuff.push({
					HeadID : HeadID,
					Descript1 : Descript1,
					SortOrder : SortOrder
				});
			});


			SaveHeadersToAppData( JSON.stringify(stuff) );
		},
		error: function(data){
			console.log("ERROR: Promo Head Only was not Downloaded");
			saveClientLog(72, 0, 0, '', 0, "ERROR: Promo Head Only was not Downloaded");		
		},
		contentType: "text/xml; charset=utf-8"
	}).done(function(){
	});
}


function saveStoreData(){
	if (TempStores)
		SaveStoresToAppData(TempStores);
	
	if (TempStoreServices)
		SaveStoreServicesToAppData(TempStoreServices);
	
	if (TempServices)
		SaveServicesToAppData( TempServices );
	
	SaveAppDataJson(); 

	console.log('SYNC-END - DEBUG : ## ALL STORE/SERVICES DATA was Saved..');
	TempStores = null;
	TempServices = null;
	TempStoreServices = null;
}


//Used in setupLocalData($rootScope) when a full download sync is flagged
function clearStoreAndPromoData(){
	DeletePromoImagesJson();
	DeletePromosJson();
	DeletePromoStoresJson();
	DeleteHeadersJson();
	DeleteStoresJson();
	DeleteStoreServicesJson();
	DeleteServicesJson();
	DeleteClientSetsJson();
}



function ClearDataAndLogOut(){
	//clearStoreAndPromoData(); //clear all data
	//clear user account data
	//DeleteUserAccountJson();

	DeleteAppData();
	window.localStorage.removeItem('FullName'); // Delete Greeting
}





// FUNCTION DECRYPT ACCOUNT IF //
//helper function to decrypt accountid, used in js/soapMessages.js
function decryptAccountID() {
	if (globals.userAccount.get('AccountID') != ''){
		console.log('AccountID utilized : ' + sjcl.decrypt("AccountID", globals.userAccount.get('AccountID') ) );
		return sjcl.decrypt("AccountID", globals.userAccount.get('AccountID') );
	}
	else{
		console.log('AccountID utilized : Empty');
		return '';
	}
}



// FUNCTION SAVE ACCOUNT DETAIL //
//helper function to save save account details, used in js/app.js in web methods that return the account object as 
//part of the response (such as SyncStart, LinkAccount, CreateAccount, ChangeAccountDetail, GetAccountID) 

function saveAccountDetailJson(data){

	var AccountID = $(data).find("AccountID").text();
	var Email = $(data).find("Email").text();
	var FullName = $(data).find("FullName").text();
	var Phone = $(data).find("Phone").text();
	var UniqueID = parseInt($(data).find("UniqueID").text());
	var Points = parseInt($(data).find("Points").text());
	var GamePlays = parseInt($(data).find("GamePlays").text());
	var UserType = $(data).find("UserType").text();
	var UserStatus = $(data).find("UserStatus").text();
	var Birthday = $(data).find("Birthday").text();

	console.log("AccountID received from server : " + AccountID);
	console.log("Email received from server : " + Email);
	console.log("FullName received from server : " + FullName);
	console.log("Points received from server : " + Points);
	console.log("Gameplays received from server : " + GamePlays);



	if (Birthday != "0001-01-01T00:00:00") //make sure the birthday is set
		var BirthdayTicks = ticksToEpoch(parseInt($(data).find("BirthdayTicks").text())); //see below for details about ticksToEpoch
	else
		BirthdayTicks = 0; //if the user has not specified a birthday, save birthday as 0

	var GeoPromo = parseInt($(data).find("GeoPromo").text());
	var encryptedAccountID = sjcl.encrypt("AccountID", AccountID); //always encrypt AccountID before saving


	SetItemInLocalData('AccountID', encryptedAccountID);
	SetItemInLocalData('Email', Email);
	SetItemInLocalData('FullName', FullName);
	SetItemInLocalData('Phone', Phone);
	SetItemInLocalData('UniqueID', UniqueID);
	SetItemInLocalData('Points', Points);
	SetItemInLocalData('GamePlays', GamePlays);
	SetItemInLocalData('UserType', UserType);
	SetItemInLocalData('Birthday', Birthday);
	SetItemInLocalData('GeoPromo', GeoPromo);

	window.localStorage.setItem('FullName', FullName);


	//saveLocalData(); // Save Data

	saveInterests(data); // Function below
}


// FUNCTION: SAVE INTERESTS //
//helper function for saving the user's interests (returned as part of the Account object in the XML response)
function saveInterests(data){
	var Interests = [];
	$(data).find('RInterestServer').each(function(){
		var InterestID = $(this).children("InterestID").text();
		var Descript1 = $(this).children("Descript1").text();
		var Selected = parseInt($(this).children("Selected").text());
		Interests.push({
			InterestID:InterestID,
			Descript1:Descript1,
			Selected:Selected
		});
	});

	//window.localStorage.setItem('Interests', JSON.stringify(Interests));

	SetItemInLocalData('Interests', JSON.stringify(Interests) );
	saveLocalData();
}



// FUNCTIONS EPOCH TO TICKS and TICKS TO EPOCH
//The below two helper functions convert between "Ticks" which are sent back from the server for Dates/Times (e.x. BirthdayTicks) 
//which represent C# ticks and "Epoch" which is Unix epoch time
function epochToTicks(e){
	return (e * 10000) + 621355968000000000;
}
function ticksToEpoch(t){
    return (t - 621355968000000000) / 10000;
}


// FUNCTIONS - START AND STOP LOADER //
//These two helper functions show and hide the loader, note that when the loader is up, the
//user is unable to interact with the app since the loader is 100% width and height and should have the highest z-index

function startLoader(){
	$('#ajaxWaiting').show();
}
function stopLoader(){
	$('#ajaxWaiting').hide();
}


//   FUNTION: SAVE CLIENT LOG   //
//  SAVE CLENTLOG IN LOCAL DATA //
function saveClientLog(logtype, promoid, storeid, beaconudid, beaconloc, comment){ //function used throughout the app to save client log, clientlogs are pushed to the server (see js/app/js) after every sync
	//these are helpful for monitoring errors. To query for errors on the server, search for client logs or type 1
	var soap = soapMessageClientLog(logtype, promoid, storeid, beaconudid, beaconloc, comment);
	//var clientlog = window.localStorage.getItem('ClientLog');
	var clientlog = GetItemFromLocalData('ClientLog');

	if (clientlog == null)
		SetItemInLocalData('ClientLog', soap );
	else{
		clientlog = clientlog + soap;
		//window.localStorage.setItem('ClientLog', clientlog);
		SetItemInLocalData('ClientLog', clientlog );
	}
}
*/



// END OF SCRIPT - sync.js //

