(function () {
	angular.module('connect.kickback-rewards', []);
} ());
(function () {
	angular.module('connect.kickback-rewards').directive('kickbackPunchCard', kickbackPunchCard);

	kickbackPunchCard.$inject = ['$timeout', '$rootScope'];


	function kickbackPunchCard($timeout, $rootScope) {
		return {
			restrict: 'EA',
			templateUrl: 'kickback-rewards/kickback-home/kickback-punch-cards/kickback-punch-card/connect.kickback-rewards.kickback-punch-card.html',
			scope: {
				punchCard: '='
			},
			link: function (scope, element, attrs) {
				scope.selectPunchCard = selectPunchCard;
				scope.closePunchCard = closePunchCard;

				$rootScope.$on('kickback:select-punch-card', function (event, data) {
					if (scope.$id !== data.scopeId) {
						$(element).css('display', 'none').css('opacity', '0').css('margin-top', '25px');
					}
				});

				$rootScope.$on('kickback:close-punch-card', function (event, data) {
					if (scope.$id !== data.scopeId) {
						$(element).css('display', 'inline-block');
						$timeout(function () {
							$(element).css('opacity', '1').css('margin-top', '0px');
						}, 215);
					}
				});

				$timeout(function () {
					$(element).find('.progress-bar').progressbar({
						value: scope.punchCard._progressPercent
					});
				});

				function selectPunchCard() {
					if(scope.isOpen)
						return;
					scope.isOpen = true;

					var punchscope = angular.element($("#kickback-punch-cards")).scope();
					punchscope.isOpen = true;
					
					$(element).addClass('open');
					$rootScope.$emit('kickback:select-punch-card', { scopeId: scope.$id });
				}

				function closePunchCard() {
					$(element).removeClass('open');
					$rootScope.$emit('kickback:close-punch-card', { scopeId: scope.$id });
					$timeout(function(){
						scope.isOpen = false;
						
						var punchscope = angular.element($("#kickback-punch-cards")).scope();
						punchscope.isOpen = false;
					});
				}

			}
		}
	}
} ());
(function () {
	angular.module('connect.kickback-rewards').directive('kickbackPunchCards', kickbackPunchCards);

	kickbackPunchCards.$inject = [];
	kickbackPunchCardsCtrl.$inject = ['$scope', '$timeout', 'kickbackRewardsService', 'Loading', 'ClientSet', '$rootScope', '$sce'];

	function kickbackPunchCards() {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/kickback-home/kickback-punch-cards/connect.kickback-rewards.kickback-punch-cards.html',
			scope: {
				cardNumber: '=',
				pin: '=',
				lastName: '='
			},
			link: function (scope, element, attrs) {  },
			controller: kickbackPunchCardsCtrl,
			controllerAs: 'kickbackPunchCardsCtrl'
		}
	}

	function kickbackPunchCardsCtrl($scope, $timeout, kickbackRewardsService, Loading, ClientSet, $rootScope, $sce) {
		var vm = this;
		vm.punchCardsReady = false;

		$scope.$on('kickback-rewards:refresh', loadPunchCardStatus);
		$scope.$on('kickback-rewards:refresh', updateKbGame);

		var kickbackState = kickbackRewardsService.getKickbackState();
		vm.kickbackUser = kickbackState.kickbackUser;

		Loading.then(function(){
			// *KB Game Client Sets init* //
			setTimeout(function(){
				updateKbGame();
			},10);
		}); //End of Loading Function

		function updateKbGame(){
			// *KB Game Client Sets init* //
			console.log('updateKbGame was Fired');

			$scope.kbGameHide = ClientSet.getKBGameHide();

			if($scope.kbGameHide === 0){   //change it back to 0 and in html
				if(globals.debugApp){
					console.log( 'KB GAME was initiated. with url ' + $scope.kbGameURL);   //   http://www.handymartrewardsgames.com/poker/?program=handymart&mobile=true&cardnumber=
				}

				$scope.kbGameURL = $sce.trustAsResourceUrl( ClientSet.getKBGameURL() + vm.kickbackUser.CardNumber + '/' ); //URL + their cardnumber appended to the game's URL
				//$scope.kbGameURL = ClientSet.getKBGameURL() ; //URL + their cardnumber appended to the game's URL
				
				$scope.kbGamePoker = ClientSet.getKBGamePoker();
				$scope.kbGameFootball = ClientSet.getKBGameFootball();

				if(globals.debugApp){
					console.log( 'KB GAME was initiated. with New EMBEDDED Url ' + $scope.kbGameURL);   //   http://www.handymartrewardsgames.com/poker/?program=handymart&mobile=true&cardnumber=
				}

				//Load Game image Button for KB rewards page
				if($scope.kbGamePoker === 1){
					$scope.kbGameImage = 'images/kickback-poker.png';
				}
				else if($scope.kbGameFootball === 1){
					$scope.kbGameImage = 'images/kickback-football.png';
				}
				else{
					// Nothing
				}

				if(globals.debugApp){
					console.log( 'KB GAME Image: ' + $scope.kbGameImage );
				}
			}
		}


		$scope.showGameUrl = function(){
     
     		if(globals.debugApp){
           		console.log( "GAME Button was clicked for KB Rewards."); 
           	}

            setTimeout(function(){
				$.mobile.changePage('#kickbackIframe');  // Go to Iframe page
			});
		};

		setTimeout(function(){
			if(globals.debugApp){
				console.log('KICKBACK-DEBUG: Loading Punch Card status in - kickbackPunchCardsCtrl');
			}

			loadPunchCardStatus();
		},1100);

		function loadPunchCardStatus() {
			vm.punchCardsReady = false;
			kickbackRewardsService.getPunchStatus($scope.cardNumber, $scope.pin, $scope.lastName).then(function (punchCards) {
				vm.punchCards = punchCards;
				vm.punchCardsReady = true;
			}, function (err) {
				//we are making the assumtion that they are not verified
				vm.error = 'You are now Registered. Please restart app.'; // This msg used to warn the user to validate registration in their email, not anymore.
				setTimeout(function(){
					$scope.$broadcast('kickback-rewards:refresh');
				},250);
			});
		}
	}
} ());
(function () {
	angular.module('connect.kickback-rewards').directive('kickbackBarcode', kickbackBarcode);

	kickbackBarcode.$inject = [];

	function kickbackBarcode() {
		return {
			restrict: 'E',
			template: '<img></img>',
			scope: {
				cardNumber: '='
			},
			link: function (scope, element, attrs) {
				var UPC_A = kickbackCardNumberToUPC_A(scope.cardNumber);


				JsBarcode($(element).find('img'), UPC_A, {
					width: 2,
					height: 95,
					quite: 10,
					format: "UPC",
					displayValue: true,
					font: "monospace",
					textAlign: "center",
					fontSize: 12,
					backgroundColor: "#FFFFFF",
					lineColor: "#000"
				});
				
				/**
				 * @description logic ported from C# implementation
				 */
				function kickbackCardNumberToUPC_A(cardNumber) {
					var str = '4' + cardNumber.substring(6, 16),
						even = [],
						odd = [];

					for (var i = 0, len = str.length; i < len; i++) {
						if ((i % 2) == 0)
							odd.push(parseInt(str[i]));
						else
							even.push(parseInt(str[i]));
					}

					var evenSum = even.reduce(function (previousValue, currentValue, index, array) {
						return previousValue + currentValue;
					}),
						oddSum = odd.reduce(function (previousValue, currentValue, index, array) {
							return previousValue + currentValue;
						});
					return str + ((10 - ((oddSum * 3 + evenSum) % 10)) % 10);
				}
			}
		}
	}
} ());
(function(){
	angular.module('connect.kickback-rewards').directive('kickbackTerms', kickbackTerms);
	
	kickbackTerms.$inject = [];
	kickbackTermsCtrl.$inject = ['$scope', 'kickbackRewardsService', 'ClientSet', '$sce'];
	
	function kickbackTerms() {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/kickback-terms/connect.kickback-rewards.kickback-terms.html',
			scope: {
				hideTerms: '&'
			},
			controller: kickbackTermsCtrl,
			controllerAs: 'kickbackTermsCtrl'
		}
	}
	
	function kickbackTermsCtrl($scope, kickbackRewardsService, ClientSet, $sce) {
		$scope.terms = $sce.trustAsHtml( '<style> ul.a{list-style-type: circle;}</style><div style="text-align:left"> <h2 style="text-align:center">Terms and Conditions</h2> <div style="text-align:center">EJ Pope & Son, Inc. DBA Handy Mart</div>' + 
		'<br>PLEASE READ THESE TERMS AND CONDITIONS SET OUT BELOW BEFORE USING WWW.HANDYMARTS.COM, HANDY MART APP, and HANDY MART REWARDS.</br>' +
		'<h3 style="text-align:center">General Conditions</h3>' + 
		'<br>Handy Mart maintains internet website (\"handymarts.com\"), mobile app (\"Handy Mart\"), and loyalty service (\"Handy Mart Rewards\") for your own lawful personal entertainment, information, education and communication.' + 
		'By accessing the above listed services and/or by purchasing orders through these services, you acknowledge your acceptance of the legal terms and conditions outlined herein which shall be governed by the laws of North Carolina.</br>' + 
		'<br>Handy Mart reserves the right to modify or change the terms and conditions from time to time without prior notice to you.Your use of and browsing in this website, app, or Handy Mart Rewards are at your own risk.' +  
		'Handy Mart nor any other party involved in the creation, production or delivery of the website, app, or Handy Mart Rewards is liable for any direct, indirect, incidental, consequential or punitive damages arising out of your access to, or use of, these services.</br>' + 
		'<br>Handy Mart also assumes no responsibility and shall not be liable for any damages to, use of, or your downloading of any materials, data, text, images, video or audio materials from these services. Handy Mart strives to make every effort to ensure that the content of the website, app, or Handy Mart Rewards is current and accurate.' + 
		'However, Handy Mart does not guarantee that the information contained in this website, app, or Handy Mart Rewards will not contain errors, inaccuracies or omissions. These errors may relate to pricing, product description or availability.</br>' + 
		'<br>All photographs, copy and prices within these services are based on the latest information available at the time the information is posted to handymart.com website, Handy Mart app, Handy Mart Rewards. Despite our best efforts, errors can occur.' +
		'Handy Mart does not accept liability for pictorial or typographical errors. Although Handy Mart attempts to display the colours of the products shown on these services as accurately as possible, we cannot guarantee that the colour you see matches the product color, as the display of color depends, in part, upon the type of computer monitor used by you.</br>' +
		'<br>We rely on the information you provide though handymart.com website, Handy Mart app, Handy Mart Rewards, including registration information (name and email address), payment information (credit card numbers and expiration dates), and transaction-related information, which must be true, accurate, current and complete.' + 
		'You will be solely responsible and liable for any and all loss, damage, and additional costs that you, we or any other person may incur as a result of your submission of any false, incorrect or incomplete information or your failure to update your registration information and payment information within 30 days of any change.' +
		'In addition to any other rights or remedies available to Handy Mart and without any liability whatsoever, Handy Mart, in its sole discretion, at any time and without notice may terminate or restrict your access to any component of handymart.com website, Handy Mart app, Handy Mart Rewards.</br>' +
		'<br>Handy Mart maintains internet website (\"handymarts.com\"), mobile app (\"Handy Mart\"), and loyalty service (\"Handy Mart Rewards\") for your own lawful personal entertainment, information, education and communication.' +
		'By accessing the above listed services and/or by purchasing orders through these services, you acknowledge your acceptance of the legal terms and conditions outlined herein which shall be governed by the laws of North Carolina. Handy Mart reserves the right to modify or change the terms and conditions from time to time without prior notice to you.' +
		'Your use of and browsing in this website, app, or Handy Mart Rewards are at your own risk. Handy Mart nor any other party involved in the creation, production or delivery of the website, app, or Handy Mart Rewards is liable for any direct, indirect, incidental, consequential or punitive damages arising out of your access to, or use of, these services. Handy Mart also assumes no responsibility and shall not be liable for any damages to, use of, or your downloading of any materials, data, text, images, video or audio materials from these services.' +
		'Handy Mart strives to make every effort to ensure that the content of the website, app, or Handy Mart Rewards is current and accurate. However, Handy Mart does not guarantee that the information contained in this website, app, or Handy Mart Rewards will not contain errors, inaccuracies or omissions. These errors may relate to pricing, product description or availability. </br>' +
		'<br>All photographs, copy and prices within these services are based on the latest information available at the time the information is posted to handymart.com website, Handy Mart app, Handy Mart Rewards. Despite our best efforts, errors can occur. ' +
		'Handy Mart does not accept liability for pictorial or typographical errors. Although Handy Mart attempts to display the colours of the products shown on these services as accurately as possible, we cannot guarantee that the colour you see matches the product color, as the display of color depends, in part, upon the type of computer monitor used by you.</br>' +
		'<br>We rely on the information you provide though handymart.com website, Handy Mart app, Handy Mart Rewards, including registration information (name and email address), payment information (credit card numbers and expiration dates), and transaction-related information, which must be true, accurate, current and complete. You will be solely responsible and liable for any and all loss, damage, and additional costs that you, we or any other person may incur as a result of your submission of any false, incorrect or incomplete information or your failure to update your registration information and payment information within 30 days of any change.' +
		'In addition to any other rights or remedies available to Handy Mart and without any liability whatsoever, Handy Mart, in its sole discretion, at any time and without notice may terminate or restrict your access to any component of handymart.com website, Handy Mart app, Handy Mart Rewards.</br>' +
		'<h3 style="text-align:center">Intellectual Property and Usage</h3>' +
		'<br>All content, including without limitation, all text, design, graphics, drawings, photographs, code and software and all organization and presentation of such content, which forms part of this website, app, or Handy Mart Rewards, are subject to intellectual property rights, including copyright and trade-marks, trade names, words, slogans, logos held by or licensed to Handy Mart or any of its affiliates. All such rights are expressly reserved. Use of certain other trade-marks, trade names, logos and images are the property of their respective owners and except as expressly authorized, shall constitute a violation of the rights of the respective owner of the property.</br>' +
		'<br>www.handymart.com website, Handy Mart App, and Handy Mart Rewards may not, in whole or in part, be copied, reproduced, republished, uploaded, posted, transmitted or distributed without the written permission from Handy Mart, except that you may download, display and print the materials presented on handymart.com website, Handy Mart app, Handy Mart Rewards for your personal, non-commercial use only. Unauthorized use of handymart.com, Handy Mart app, Handy Mart Rewards and/or the materials contained on these services may violate applicable copyright, trade-mark or other intellectual property laws or other laws. You must retain all copyright and trademark notices, ' +
		'including any other proprietary notices, contained in the materials. The use of such materials on any other website or in any environment of networked computers is prohibited.</br>' +
		'<h3 style="text-align:center">Third Party Links</h3>' +
		'The internet site, app, and loyalty service may contain third party links which have been provided for your convenience. These website links are strictly independent and Handy Mart expressly disclaims any liability for such sites or their content and makes no representation or warranty as to any products, services or terms and conditions offered by such third-party sites. A complete review of the terms and conditions of such other sites is highly recommended.' +
		'<h3 style="text-align:center">Pricing</h3>' +
		'<br>Handy Mart reserves the right to alter retail prices at any time without prior notice. Items in your shopping cart will reflect the most recent price displayed on the items \"Detailed View\" page. Please note that all prices are in U.S. dollars and reflect the cost of the item before taxes. Taxes are not included. Handy Mart cannot confirm the price of an item until you order. All applicable taxes will be added once your order is being processed. Despite Handy Mart best efforts for accuracy, occasionally an item\'s price on handymart.com website, Handy Mart app, Handy Mart Rewards may be inaccurate. Handy Mart will not charge your credit card' +
		'until the order goes to the shipping process. If an item\'s true price is lower than the one displayed on the website, app, or Handy Mart Rewards, Handy Mart will charge you the correct lower price. If a product\'s correct retail price is higher than the price displayed on the \"Detailed View\"' +
		'screen, Handy Mart will contact you by telephone and/or e-mail before shipping to notify you of the cancellation of the order. This policy applies to products sold and shipped by Handy Mart. </br>' +
		'<br>Changes to the website, app, and loyalty service sale prices take effect at midnight Mountain Time.' +
		'Advertisements on Handymart.com website, Handy Mart app, Handy Mart Rewards are invitations to you to make offers to purchase products and services on Handymart.com website, Handy Mart app, Handy Mart Rewards and are not offers to sell. Your properly completed and delivered order form constitutes your offer to purchase the products or services referenced in your order. Your order will be deemed to be accepted only if and when we send a confirmation to your email address. That confirmation email constitutes our acceptance of your order and forms a legally binding contract with EJ Pope & Son, Inc. DBA as Handy Mart.' +
		'We reserve the right to limit quantities available for sale or sold, and that at any time to correct, cancel, reject or terminate any order for any reason whatsoever at our sole discretion, whether or not the order has been submitted, confirmed and/or charged to your credit card. We will promptly issue a credit to your credit card if an order has been charged for a purchase and subsequently cancelled. </br>' +
		'<h3 style="text-align:center">Product Availability</h3>' +
		'<br>Please note some products may require special order; may not be available in certain regions; may not be available in both official languages and are so indicated. We reserve the right to change the availability status of a product without notice. ' +
		'Handy Mart reserves the right to limit quantities, refuse orders, terminate accounts and/or cancel orders in its discretion. Batteries/tapes/adapters/accessories/CDs are not included unless otherwise indicated.</br>' +
		'<h3 style="text-align:center">Your Privacy</h3>' +
		'<br>This privacy policy sets out how Handy Mart uses and protects any information that you provide. Handy Mart is committed to ensuring that your privacy is protected. We will never sell your information.  Should we ask you to provide certain information by which you can be identified when using our applications, then you can be assured that it will only be used in accordance with this privacy statement. Handy Mart may change this policy from time to time by updating this page. You should check this page from time to time to ensure that you are happy with any changes. This policy is effective from November11th, 2015.</br>' +
		'<h3 style="text-align:center">We may collect the following information:</h3>' +
		'<ul "class=a"> <li>name</li>' +
		'<li>contact information including email address</li>' +
		'<li>purchase history</li>' +
		'<li>demographic information such as postcode, preferences and interests</li>' +
		'<li>other information relevant to customer surveys and/or offers</li>' +
		'<h3 style="text-align:center">We require this information to understand your needs and provide you with a better service, and in particular for the following reasons:</h3>' +
		'<li>Internal record keeping.</li>' +
		'<li>Fulfilling user actions from within a website and app.</li>' +
		'<li>We may use the information to improve our products and services.</li>' +
		'<li>We may periodically send promotional email about new products, special offers or other information which we think you may find interesting using the email address which you have provided.</li>' +
		'<li>From time to time, we may also use your information to contact you for market research purposes. We may contact you by email, phone, fax or mail.</li>' +
		'<li>We may use the information to customize the website and app according to your interests.</li>' +
		'<li>We may provide your information to our third party partners for marketing or promotional purposes.</li>' +
		'<li>We will never sell your information.</li></ul> </div>');
 	}
}());
(function(){
	angular.module('connect.kickback-rewards').directive('kickbackSignin', kickbackSignin);
	
	kickbackSignin.$inject = [];
	kickbackSigninCtrl.$inject = ['$scope', 'kickbackRewardsService'];
	
	function kickbackSignin() {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/kickback-signin/connect.kickback-rewards.kickback-signin.html',
			scope: {
				goToRegister: '&',
				showTerms: '&'
			},
			controller: kickbackSigninCtrl,
			controllerAs: 'kickbackSigninCtrl'
		}
	}
	
	function kickbackSigninCtrl($scope, kickbackRewardsService) {

		$scope.Chain = globals.Change.chainFriendly;

		var vm = this;
		vm.kickbackState = kickbackRewardsService.getKickbackState();
		vm.signin = signin;
		
		vm.pin = null;
		vm.cardNumber = null;
		vm.lastName = null;
		
		function signin() {
			vm.submitted = true;
			vm.error = null;
			if($scope.signInForm.$invalid) {
				vm.error = "Please fill in all the fields";
				return;
			}
			if(!$scope.agreedToTerms) {
				vm.error = "You must agree to the terms";
				return;
			}

			if(globals.debugApp){
				console.log("Signing in with (cardnum, pin, last name): " + vm.cardNumber + ' / ' + vm.pin + ' / ' + vm.lastName);
			}

			kickbackRewardsService.signin(vm.cardNumber, vm.pin, vm.lastName).then(function(result){
				if(globals.debugApp){
					console.log(result);
				}
			}, function(data) {
				if(globals.debugApp){
					console.log('ERROR: ' + data.message);
				}
				vm.error = data.message;
			});
		}
		
	}
}());
(function(){
	angular.module('connect.kickback-rewards').directive('kickbackSettings', kickbackSettings);
	
	kickbackSettings.$inject = [];
	kickbackSettingsCtrl.$inject = ['$scope', '$rootScope', 'kickbackRewardsService'];
	
	function kickbackSettings() {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/kickback-settings/connect.kickback-rewards.kickback-settings.html',
			scope: {
				showTerms: '&',
				refresh: '&'
			},
			controller: kickbackSettingsCtrl,
			controllerAs: 'kickbackSettingsCtrl'
		}
	}
	
	function kickbackSettingsCtrl($scope, $rootScope, kickbackRewardsService) {
		var vm = this;
		vm.signOut = signOut;
		
		function signOut() {
			kickbackRewardsService.signout();
			$scope.$emit('kickback-settings:close');
		}
	}
}());
(function(){
	angular.module('connect.kickback-rewards').directive('kickbackRegisterHome', kickbackRegisterHome);
	
	kickbackRegisterHome.$inject = [];
	kickbackRegisterHomeCtrl.$inject = ['$scope', '$timeout', 'ClientSet', '$rootScope'];
	
	function kickbackRegisterHome($scope, $rootScope) {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/kickback-register-home/connect.kickback-rewards.kickback-register-home.html',
			scope: {
				goToSignIn: '&',
				goToRegister: '&',
				kickbackImage: '@'
			},
			controller: kickbackRegisterHomeCtrl,
			controllerAs: 'kickbackRegisterHomeCtrl'
		}
	}
	
	function kickbackRegisterHomeCtrl($scope, $timeout, ClientSet, $rootScope) { 

		setTimeout(function() {
			$scope.Chain = globals.Change.chainFriendly;
			var vm = this;
			vm.companyName = globals.Change.chainFriendly;
			vm.kickbackImage = globals.Change.kickbackImage;
			$rootScope.kickbackImage = ClientSet.getKickbackImage();
		}, 800);
		
	}
}());
(function () {
	angular.module('connect.kickback-rewards').directive('kickbackRegister', kickbackRegister);

	kickbackRegister.$inject = [];
	kickbackRegisterCtrl.$inject = ['$scope','kickbackRewardsService', 'KickbackRegistrationUser'];

	function kickbackRegister() {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/kickback-register/connect.kickback-rewards.kickback-register.html',
			scope: {
				goToSignIn: '&',
				showTerms: '&'
			},
			controller: kickbackRegisterCtrl,
			controllerAs: 'kickbackRegisterCtrl'
		}
	}

	function kickbackRegisterCtrl($scope, kickbackRewardsService, KickbackRegistrationUser) {

		//This checks the phone number input and auto insert the dashes (exp 999-999-9999)
		$('#ssn').keyup(function(e){
			if(globals.debugApp){
				console.log('DEBUG: KB Phone number modified');
			}
		    
		      if ((e.keyCode > 47 && e.keyCode < 58) || (e.keyCode < 106 && e.keyCode > 95) ) {

		      	
		      	if(this.value.length <= 6){
			    	this.value = this.value.replace(/(\d{3})\-?/, '$1-');
			    	if(globals.debugApp){
			    		console.log('fired ---> success');
			    	}
		      	}
			    else{
			    	this.value = this.value.replace(/(\d{3})\-?(\d{3})\-?/,'$1-$2-');
			    	if(globals.debugApp){
			    		console.log('fired ---> success 2');
			    	}
			    }

			  	//this.value = this.value.replace(/(\d{3})\-?(\d{3})\-?(\d{4})/,'$1-$2-$3');
			    return true;
			  }
			//remove all chars, except dash and digits
			this.value = this.value.replace(/[^\-0-9]/g, '');
		});




		$scope.Chain = globals.Change.chainFriendly;

		var vm = this;
		vm.getSecurityQuestions = getSecurityQuestions;
		vm.register = register;
		vm.selectSecurityQuestion = selectSecurityQuestion;
		vm.kickbackRegistrationUserModel = new KickbackRegistrationUser({});
		vm.currentStep = 'registration';
		vm.selectedSecurityQuestion1 = null;
		vm.selectedSecurityQuestion2 = null;

		function getSecurityQuestions() {
			vm.submittedRegisterForm = true;
			vm.error = null;
			if ($scope.registerForm.$invalid) {
				vm.error = "Please fill in all the fields";
				return;
			}
			if (!$scope.agreedToTerms) {
				vm.error = "You must agree to the terms";
				return;
			}
			if ($scope.registerForm.email.$error.email) {
				vm.error = "Must be a valid email";
				return;
			}
			kickbackRewardsService.securityquestions(vm.kickbackRegistrationUserModel.cardnumber).then(function (securityQuestions) {
				vm.securityQuestions = securityQuestions;
				var i,
					securityQuestionsLength = vm.securityQuestions.length;
				vm.availableSecuityQuestions1 = new Array(securityQuestionsLength);
				vm.availableSecuityQuestions2 = new Array(securityQuestionsLength);
				for (i = 0; i < securityQuestionsLength; i++) {
					//replace the html escaped text
					securityQuestions[i].question = $('<div>').html(securityQuestions[i].question).text();
					vm.availableSecuityQuestions1[i] = securityQuestions[i];
					vm.availableSecuityQuestions2[i] = securityQuestions[i];
				}
				vm.submittedRegisterForm = false;
				vm.error = null;
				vm.currentStep = 'security questions';

				if(globals.debugApp){
					console.log('getSecurityQuestions() fired' + ' .. Going to ' + vm.currentStep);
				}
			}, function (err) {
				vm.error = err;
			});
		}

		function register() {
			vm.submittedRegisterForm = true;
			if(globals.debugApp){
				console.log('register() fired');
			}

			if ($scope.secuirtyQuestionsForm.$invalid) {
				vm.error = "Please fill in all the fields";
				return;
			}

			vm.error = null;

			kickbackRewardsService.register(vm.kickbackRegistrationUserModel).then(function () {
				//nothing, the main module will use kickbackState.registered from the service and show another view	
			}, function (data) {
				vm.error = data.message;
			});
		}

		$scope.backToBeginning = function() {
			vm.submittedRegisterForm = false;
			vm.currentStep = 'registration';

			if(globals.debugApp){
				console.log('goBack() from Security questions was fired' + ' .. Going back to ' + vm.currentStep);
			}
		}

		function selectSecurityQuestion() {
			vm.availableSecuityQuestions1.splice(0, vm.availableSecuityQuestions1.length);
			vm.availableSecuityQuestions2.splice(0, vm.availableSecuityQuestions2.length);
			for (var i = 0, len = vm.securityQuestions.length; i < len; i++) {
				if (!vm.selectedSecurityQuestion1 || vm.securityQuestions[i].id !== vm.selectedSecurityQuestion1.id) {
					vm.availableSecuityQuestions2.push(vm.securityQuestions[i]);
				}
				if (!vm.selectedSecurityQuestion2 || vm.securityQuestions[i].id !== vm.selectedSecurityQuestion2.id) {
					vm.availableSecuityQuestions1.push(vm.securityQuestions[i]);
				}

			}
			if (vm.selectedSecurityQuestion1) {
				vm.securityQuestionText1 = vm.selectedSecurityQuestion1.question;
				vm.kickbackRegistrationUserModel.security1_id = vm.selectedSecurityQuestion1.id;
			} else {
				vm.securityQuestionText1 = null; 
				vm.kickbackRegistrationUserModel.security1_id = null;
			}
			if (vm.selectedSecurityQuestion2) {
				vm.securityQuestionText2 = vm.selectedSecurityQuestion2.question;
				vm.kickbackRegistrationUserModel.security2_id = vm.selectedSecurityQuestion2.id;
			} else {
				vm.securityQuestionText2 = null;
				vm.kickbackRegistrationUserModel.security2_id = null;
			}

		}
	}
} ());
(function(){
	angular.module('connect.kickback-rewards').directive('kickbackHome', kickbackHome);

	
	kickbackHome.$inject = [];
	kickbackHomeCtrl.$inject = ['kickbackRewardsService', 'KickbackRegistrationUser', 'Loading'];
	
	function kickbackHome() {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/kickback-home/connect.kickback-rewards.kickback-home.html',
			scope: {},
			controller: kickbackHomeCtrl,
			controllerAs: 'kickbackHomeCtrl'
		}
	}
	
	function kickbackHomeCtrl(kickbackRewardsService, KickbackRegistrationUser, Loading) {
		var vm = this;
		var kickbackState = kickbackRewardsService.getKickbackState();
		vm.kickbackUser = kickbackState.kickbackUser;
	}
}());
(function(){
	angular.module('connect.game.matchingGame', []);
}());
(function() {
	angular.module('connect.game.matchingGame')
		.directive('connectGameMatchingGame', connectGameMatchingGameDirective)
		.controller('connectGameMatchingGameController', connectGameMatchingGameController);

	connectGameMatchingGameDirective.$inject = [];
	connectGameMatchingGameController.$inject = ['$scope', '$rootScope', '$http', '$timeout', 'Loading', 'ClientSet'];

	function connectGameMatchingGameDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'game/matchinggame/connect.game.matchinggame.html',
			controller: 'connectGameMatchingGameController'
		};
		return directive;
	}

	function connectGameMatchingGameController($scope, $rootScope, $http, $timeout, Loading, ClientSet) {
		var insufficientPlays = false;

		function gameAssetsReady() {

			if(globals.debugApp){
				console.log('Game Assets ready??  -  ' + getGameCard('bg1.png') != null && getGameCard('cardfront.png') != null && getGameCard('cardback.png') != null && getGameCard('cardfrontmatch.png') != null && getGameCard('promo.png') != null && getGameCard('1.png') != null && getGameCard('2.png') != null && getGameCard('3.png') != null && getGameCard('4.png') != null && getGameCard('5.png') != null && getGameCard('6.png') != null && getGameCard('7.png') != null && getGameCard('8.png') != null );
			}

			return getGameCard('bg1.png') != null && getGameCard('cardfront.png') != null && getGameCard('cardback.png') != null && getGameCard('cardfrontmatch.png') != null && getGameCard('promo.png') != null && getGameCard('1.png') != null && getGameCard('2.png') != null && getGameCard('3.png') != null && getGameCard('4.png') != null && getGameCard('5.png') != null && getGameCard('6.png') != null && getGameCard('7.png') != null && getGameCard('8.png') != null;
		}

		var gameReady = false;

		function updateGameAssets($rootScope, version) {
			storeImage('bg1.png');
			storeImage('cardfront.png');
			storeImage('cardback.png');
			storeImage('cardfrontmatch.png');
			storeImage('promo.png');
			storeImage('1.png');
			storeImage('2.png');
			storeImage('3.png');
			storeImage('4.png');
			storeImage('5.png');
			storeImage('6.png');
			storeImage('7.png');
			storeImage('8.png');
			var newAssets = {};

			function storeImage(imageID) {
				$.ajax({
					url: GetItemFromLocalData('ClientURL'),
					type: "POST",
					dataType: "xml",
					timeout: 40000,
					data: soapMessageGetFileChunk('GameImage', imageID),
					success: function(data) {
						var error = $(data).find('Standard').children('MethodErrorLevel').text();
						if (error == "None") {
							newAssets[imageID] = "data:image/png;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();

							if(globals.debugApp){
								console.log("SUCCESS: A Game Asset Image Downloaded");
							}
							saveClientLog(74, 0, 0, '', 0,  "SUCCESS: A Game Asset Image Downloaded");
						}
						else{

							if(globals.debugApp){
								console.log("ERROR: A Game Asset Image was not Downloaded - " + error);
							}

							saveClientLog(75, 0, 0, '', 0, "ERROR: A Game Asset Image was not Downloaded - " + error);
						}
					},
					contentType: "text/xml; charset=utf-8"
				}).done(function() {
					if (Object.keys(newAssets).length == 13) {

						for (var prop in newAssets) {
							setGameCard(prop, newAssets[prop]);
						}

						setGameVersion(version);
						saveLocalData();

						setTimeout(function(){
							SaveAppDataJson(); // Save all the Data that was initialized into the FILE
						}, 100);

						if (gameAssetsReady() && !gameReady) {
							gameReady = true;

							if(globals.debugApp){
								console.log('Game Ready is TRUE');
							}

							loadGame($rootScope);
						}
					}
				})
			}
		}

		$('#mainContainer').on('tap', function() {
			if ($('#cards').css('pointer-events') == 'none' && insufficientPlays) {
				navigator.notification.alert(
					"Sorry, you don't have any plays available. Try back later, or check-in at a store for more plays.", // message
					function() {}, // callback
					'Insufficient Plays', // title
					'Ok' // buttonName
				);
			} else if ($('#cards').css('pointer-events') == 'none' && !insufficientPlays) {
				navigator.notification.alert(
					"Sorry, we were unable to load your game progress. This is likey due to a poor internet connection.", // message
					function() {}, // callback
					'Game Unavailable', // title
					'Ok' // buttonName
				);
			}
		});

		Loading.then(function() {
			$timeout(function(){
				if (!ClientSet.getGameHide()) {
					
					$scope.GameTitle = ClientSet.getGameTitle();
					$rootScope.CardValues = ClientSet.getGameValueOne();
					$scope.playing = false;
					if (gameAssetsReady()) {
						gameReady = true;
						loadGame($rootScope);
					}

					if(globals.debugApp){
						console.log( ' ClientSet.getGameVersion = ' + ClientSet.getGameVersion() + ' / getGameVersion = ' + getGameVersion() );
					}

					if (!gameAssetsReady() || (ClientSet.getGameVersion() != getGameVersion())) {
						$timeout(function() {
							updateGameAssets($rootScope, ClientSet.getGameVersion());
							if(globals.debugApp){
								console.log("Updating and grabbing Game Assets from server");
							}
						}, 1);
					}
				}
			}, 1);
		});

		$('#fun').on('pageinit', function() {
			var height = $(window).height(); // android and ios
			$("#fun .ui-content").css('height', height - $('#fun .ui-header').height() - $('#fun .ui-footer').height() - 2 );
		});
		
		$('#fun').on('pageshow', function() {
			if (gameReady) {
				beginGame();
			} else {
				alert('Game assets are unavailable at this time. The game requires an internet connection for play.', function() {
					$.mobile.back({ transition: "slide", reverse: true});
				});
			}

			function beginGame() {
				$timeout(function() {
					$rootScope.playsLeft = getGamePlays();
					$rootScope.totalPoints = getPoints();
					$rootScope.pointsWon = 0;
				});
				if (getNewPlayer()) {
					if (window.device.platform == 'Android') {
						var m = 'Welcome to the Match Game. Select two cards. Each incorrect guess will cost 1 play.';
					} else {
						var m = 'Welcome to the Match Game. Select two cards. Each incorrect guess will cost 1 play. \n\nApple is not a sponsor nor is involved in any way with this game or prizes.';
					}
					navigator.notification.alert(
						m, // message
						function() {
							setNewPlayer('0');
							saveLocalData();

							setTimeout(function(){
								SaveAppDataJson(); // Save all the Data that was initialized into the FILE
							}, 100);
							$scope.playNow();
						}, // callback
						'Welcome!', // title
						'Play' // buttonName
					);
				} else{
					saveLocalData();

					setTimeout(function(){
						SaveAppDataJson(); // Save all the Data that was initialized into the FILE
					}, 100);
					$scope.playNow();
				}
			}
		});


		$('#fun').on('pagehide', function() {
			if ($scope.playing) {
				$rootScope.endGame(1);
			}
		});


		$scope.playNow = function() {
			if (window.device.platform == 'Android'){
				var options = {
					label : "Loading Game"
				};
			}
			else{
				var options = {
					label : "Loading Game",
					color : '#000',
					spinnerColor : '#000'
				}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
			} 

			window.wizSpinner.show(options);

			var GameProgress = getGameProgress();

			if (GameProgress != null) {
				GameProgress = JSON.parse(GameProgress);
				saveClientLog(71, 0, 0, '', 0, 'calling end game on unsaved game progress with ' + GameProgress.pointsWon + ' points won and ' + GameProgress.playsLeft + ' plays left and ' + GameProgress.wonPromo + ' promo');
				$http.post(GetItemFromLocalData('ClientURL'), soapMessageGameEnd(GameProgress.pointsWon, GameProgress.playsLeft, GameProgress.wonPromo), {timeout: 25000} ).then(function(response) {
					
					var processed = parseInt($(response.data).find('GameEndResult').children("Processed").text());
					setPoints( parseInt($(response.data).find('GameEndResult').children("Points").text()) );
					setGamePlays( parseInt($(response.data).find('GameEndResult').children("Plays").text()) );
					setPromoPlay( parseInt($(response.data).find('GameEndResult').children("PromoPlay").text()) );


					var error = $(response.data).find('Standard').children('MethodErrorMsg').text();
					if (processed == 1) {
						//window.localStorage.removeItem('GameProgress');
						setGameProgress(null); //remove GameProgress
					}

					saveLocalData();

					setTimeout(function(){
						SaveAppDataJson(); // Save all the Data that was initialized into the FILE
					}, 100);

					callGameStart();
				}, function(error) {
					alert(error, function() {});
					callGameStart();
				});
			} else{
				callGameStart();
			}

			function callGameStart() {

				$http.post(GetItemFromLocalData('ClientURL'), soapMessageGameStart(), {timeout: 25000} ).then(function(response) {
					var processed = parseInt($(response.data).find('GameStartResult').children("Processed").text());
					if (processed == 1) {

						//window.localStorage.setItem('PromoPlay', parseInt($(response.data).find('GameStartResult').children("PromoPlay").text()) );
						setPromoPlay( parseInt($(response.data).find('GameStartResult').children("PromoPlay").text()) );

						$rootScope.promoPlay = getPromoPlay();
						
						if ($rootScope.promoPlay) {
							$('.card').each(function() {
								if ($(this).attr('num') == '1')
									$(this).find(".frontImg").backstretch(getGameCard('promo.png'));
							});
						} else {
							$('.card').each(function() {
								if ($(this).attr('num') == '1')
									$(this).find(".frontImg").backstretch(getGameCard('1.png'));
							});
						}

						setTokenID( $(response.data).find('GameStartResult').children("TokenID").text() );
						setVersion( $(response.data).find('GameStartResult').children("Version").text() );
						setPoints( parseInt($(response.data).find('GameStartResult').children("Points").text()) );
						setGamePlays( parseInt($(response.data).find('GameStartResult').children("Plays").text()) );
						
						saveLocalData();

						setTimeout(function(){
							SaveAppDataJson(); // Save all the Data that was initialized into the FILE
						}, 100);

						$rootScope.playsLeft = getGamePlays();
						$rootScope.totalPoints = getPoints();
						$rootScope.wonPromo = false;
						$rootScope.pointsWon = 0;
						$('#cards').css('pointer-events', '');
						$scope.playing = true;
						saveClientLog(70, 0, 0, '', 0, 'user started game with ' + getPoints() + ' points and ' + $rootScope.playsLeft + ' plays');

						if(globals.debugApp){
							console.log('user started game with ' + getPoints() + ' points and ' + $rootScope.playsLeft + ' plays');
						}
					} else {
						var error = $(response.data).find('Standard').children('MethodErrorMsg').text();
						if (error.indexOf('enough plays') != -1) {
							$('#cards').css('pointer-events', 'none');
							insufficientPlays = true;
						} else {
							alert(error, function() {
								$('#cards').css('pointer-events', 'none');
							});
							insufficientPlays = false;
						}
					}

					setTimeout(function() {
						$('.card').css('opacity', 1);
						//stopLoader();
						window.wizSpinner.hide();
					}, 10);
				}, function(error) {
					$('#cards').css('pointer-events', 'none');
					setTimeout(function() {
						$('.card').css('opacity', 1);
						//stopLoader();
						window.wizSpinner.hide();

						console.log("Game Server error. 1");
						navigator.notification.confirm(
							'Server couldnt be reached..',
							callBackFunctionServerDown, // Specify a function to be called
							'Please check your internet signal, Would you like to Retry.', ["Yes", "No"]
						);

						function callBackFunctionServerDown(b) {
							if (b == 1) {
								$scope.playNow();
							}
							else{
								// DO NOTHING
							}
						}

					}, 100);
					insufficientPlays = false;
				});
			}
		};

		function retry() {
			setTimeout(function() {
				$http.post(GetItemFromLocalData('ClientURL'), soapMessageGameEnd($rootScope.pointsWon, $rootScope.playsLeft, $rootScope.wonPromo), {timeout: 25000} ).then(function(response) {
					var processed = parseInt($(response.data).find('GameEndResult').children("Processed").text());
					
					setPoints( parseInt($(response.data).find('GameEndResult').children("Points").text()) );
					setGamePlays( parseInt($(response.data).find('GameEndResult').children("Plays").text()) );
					setPromoPlay( parseInt($(response.data).find('GameEndResult').children("PromoPlay").text()) );
					
					saveLocalData();

					setTimeout(function(){
						SaveAppDataJson(); // Save all the Data that was initialized into the FILE
					}, 100);

					var error = $(response.data).find('Standard').children('MethodErrorMsg').text();
					if (processed != 1)
						alert(error, function() {});
					else {
						//window.localStorage.removeItem('GameProgress');
						setGameProgress(null); //remove GameProgress

						if($rootScope.wonPromo){
							updateInstantPrize();
						}
					}
				}, function(error) {
					window.wizSpinner.hide();

					if(globals.debugApp){
						console.log("Game Server error. 2");
					}
				});
			}, 2000);
		}


		$rootScope.endGame = function(pageHide) {
			$scope.playing = false;
			$timeout(function() {

				$('.card-flipped').removeClass('card-flipped');
				$('.card-flipped1').removeClass('card-flipped1');
				$('.card-removed').removeClass('card-removed');
				$('.noclick').removeClass('noclick');
				$("img[src$='cardfrontmatch.png']").attr('src', getGameCard('cardfront'));

				var cardPositions = [];

				for (var i = 0; i < 16; i++)
					cardPositions.push({
						left: $($('.card')[i]).css('left'),
						top: $($('.card')[i]).css('top')
					});
				cardPositions.sort(function() {
					return 0.5 - Math.random();
				});

				for (var i = 0; i < 16; i++) {
					$($('.card')[i]).css('left', cardPositions[i].left);
					$($('.card')[i]).css('top', cardPositions[i].top);
				}
			}, 10);

			saveClientLog(71, 0, 0, '', 0, 'user ended game with ' + $rootScope.pointsWon + ' points won and ' + $rootScope.playsLeft + ' plays left and ' + $rootScope.wonPromo + ' promo');

			$http.post(GetItemFromLocalData('ClientURL'), soapMessageGameEnd($rootScope.pointsWon, $rootScope.playsLeft, $rootScope.wonPromo), {timeout: 25000}).then(function(response) {
				var processed = parseInt($(response.data).find('GameEndResult').children("Processed").text());

				if(globals.debugApp){
					console.log('points received from the server: (game.end) ' + $(response.data).find('GameStartResult').children("Points").text() );
				}

				setPoints( parseInt($(response.data).find('GameEndResult').children("Points").text()) );
				setGamePlays( parseInt($(response.data).find('GameEndResult').children("Plays").text()) );
				setPromoPlay( parseInt($(response.data).find('GameEndResult').children("PromoPlay").text()) );
				saveLocalData();

				setTimeout(function(){
					SaveAppDataJson(); // Save all the Data that was initialized into the FILE
				}, 100);

				var error = $(response.data).find('Standard').children('MethodErrorMsg').text();
				if (processed != 1){
					alert(error, function() {});
				}
				else {
					setGameProgress(null); //remove GameProgress
					$rootScope.pointsWon = 0;

					if ($rootScope.wonPromo) {
						updateInstantPrize();
					}
					if (getGamePlays() > 0 && pageHide == 0){
						$scope.playNow();
					}
				}

			}, function(error) {

				if(globals.debugApp){
					console.log('ERROR: End game error: Server was not reached.');
				}
				
				retry();
			});
		};


		function updateInstantPrize() {
			var ip = null;
			$.ajax({
				url: GetItemFromLocalData('ClientURL'),
				type: "POST",
				dataType: "xml",
				timeout: 16000,
				data: soapMessagePromoList2(),
				success: function(data) {
					$(data).find('RPromoServer2').each(function(index) {
						var PromoID = $(this).children("PromoID").text();
						var Descript1 = $(this).children("Descript1").text();
						var Descript2 = $(this).children("Descript2").text();
						var PromoType = parseInt($(this).children("PromoType").text());
						var HeadID = $(this).children("HeadID").text();
						var InterestID = $(this).children("InterestID").text();
						var PromoStore = parseInt($(this).children("PromoStore").text());
						var PromoUse = parseInt($(this).children("PromoUse").text());
						var PromoAccount = parseInt($(this).children("PromoAccount").text());
						var DateStart = ticksToEpoch(parseInt($(this).children("DateStartTicks").text()));
						var DateEnd = ticksToEpoch(parseInt($(this).children("DateEndTicks").text()));
						var DisplaySec = parseInt($(this).children("DisplaySec").text());
						var Uses = parseInt($(this).children("Uses").text());
						var AccountUses = parseInt($(this).children("AccountUses").text());
						var Age = parseInt($(this).children("Age").text());
						var Points = parseInt($(this).children("Points").text());
						var DetailHTMLFile = $(this).children("DetailHTMLFile").text();
						var PhotoFile = $(this).children("PhotoFile").text();
						var ThumbFile = $(this).children("ThumbFile").text();
						var DescriptPush = $(this).children("DescriptPush").text();
						var PhotoURL = null;
						if (PromoType == 1 && PromoAccount == 1) {
							$.ajax({
								url: GetItemFromLocalData('ClientURL'),
								type: "POST",
								dataType: "xml",
								timeout: 16000,
								data: soapMessageGetFileChunk('Image', PhotoFile),
								success: function(data) {
									var error = $(data).find('Standard').children('MethodErrorLevel').text();
									if (error == "None") {
										if (PhotoFile.substring(PhotoFile.indexOf('.') + 1) == 'png')
											PhotoURL = "data:image/png;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();
										else {
											PhotoURL = "data:image/jpeg;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();
										}
										ip = {
											PromoID: PromoID,
											Descript1: Descript1,
											Descript2: Descript2,
											PromoType: PromoType,
											HeadID: HeadID,
											InterestID: InterestID,
											PromoStore: PromoStore,
											PromoUse: PromoUse,
											PromoAccount: PromoAccount,
											DateStart: DateStart,
											DateEnd: DateEnd,
											DisplaySec: DisplaySec,
											Uses: Uses,
											AccountUses: AccountUses,
											Age: Age,
											Points: Points,
											DetailHTMLFile: DetailHTMLFile,
											PhotoFile: PhotoFile,
											PhotoURL: PhotoURL,
											ThumbFile: ThumbFile,
											DescriptPush: DescriptPush,
										}
									}
								},
								contentType: "text/xml; charset=utf-8"
							}).done(function() {
								if (ip) {
									ip = updatePromoLinkVideoPhoto(ip);
									$timeout(function() {
										$rootScope.InstantPrize = ip;
										resetScrollbar();
									});
								}
							});
						}
					});
				},
				error: function(data) {
					$rootScope.Error(globals.ajaxTimeoutMessage, function() {}, false, function() {});
				},
				contentType: "text/xml; charset=utf-8"
			});
		}
	}
}());
(function(){
	angular.module('connect.game.gamehelp', []);
}());
(function(){
	angular.module('connect.game.gamehelp')
	.directive('connectGameHelp', connectGameHelpDirective);

	connectGameHelpDirective.$inject = [];

	function connectGameHelpDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'game/gamehelp/connect.game.gamehelp.html'
		};
		return directive;
	}
}());
(function(){
	angular.module('connect.electrum.page', []);
})();
(function() {
	angular.module('connect.electrum.page')
		.directive('electrumPage', electrumPageDirective)
		.controller('ElectrumNavigationController', electrumNavigationController);

	electrumPageDirective.$inject = [];

	electrumNavigationController.$inject = ['$scope', '$rootScope', '$timeout', 'Loading', 'ClientSet'];

	function electrumPageDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'electrum/electrumPage/connect.electrum.page.html',
			link: link
		};
		return directive;

		function link(scope, element, attrs) {}
	}

	function electrumNavigationController($scope, $rootScope, $timeout, Loading, ClientSet) {

		if (globals.Change.electrumImage) {
			$rootScope.ElectrumImage = globals.Change.electrumImage;
		}

		Loading.then(function() {
			$timeout(function(){
				$rootScope.ElectrumOptions = ClientSet.getElectrumOptions();
			},1);
		});

		$('#electrum').on('pageinit', function() {
			$("#ElectrumMain #electrumContent").css('width', $(window).width() );
			$("#ElectrumMain #electrumWrapper").css('width', $(window).width() );
			$("#ElectrumMain #electrumNavigationControlGroup").css('width', $(window).width() );
			$("#ElectrumMain #electrumContent").css('height', $(window).height() - $('#ElectrumMain .ui-header').height() - $('#ElectrumMain .ui-footer').height()  );
			$("#ElectrumMain #electrumBarcodeImage").css('width', $(window).width() - 30 );
			$("#ElectrumMain #electrumBarcodeImage").css('margin-right', '4px' );
			$("#ElectrumMain #electrumNavigationControlGroup .ui-btn").css('margin-right',  $(window).width() * .125 );
			$("#ElectrumMain #electrumBarcodeImage").css('padding-bottom', '16px' );
			$("#ElectrumMain #electrumBarcodeImage").css('padding-top', '3px' );

			$('#ElectrumMain #storesLoading').hide();
		});
		

		var frame = document.getElementById('electrumIframe');

		$scope.ElectrumRequest = function(trancode, text) {
			$rootScope.electrumTranCode = trancode;
			if (!$rootScope.Latitude) {
				$rootScope.Latitude = 0;
			}
			if (!$rootScope.Longitude) {
				$rootScope.Longitude = 0;
			}
			var DeviceType;
			if (window.device.platform == 'Android') {
				DeviceType = 1;
			} else {
				DeviceType = 0;
			}

			$rootScope.ElectrumRequestPayload = '%3Cpayload%3E%3CRequest%3E%3CApplicationId%3E' + $rootScope.electrumAppID + '%3C%2FApplicationId%3E%3CTranCodeId%3E' + trancode + '%3C%2FTranCodeId%3E%3CValue%3E%3C%2FValue%3E%3CUniqueId%3E' + getElectrumUniqueID() + '%3C%2FUniqueId%3E%3CDevice%3E%3CAccountId%3E' + decryptAccountID() + '%3C%2FAccountId%3E%3CGPSCoord%3E' + $rootScope.Latitude + '%2C' + $rootScope.Longitude + '%3C%2FGPSCoord%3E%3CDeviceType%3E' + DeviceType + '%3C%2FDeviceType%3E%3C%2FDevice%3E%3C%2FRequest%3E%3C%2Fpayload%3E';
			$rootScope.electrumOption = text;
			
			if (window.device.platform == 'Android') {
				var options = {
					label : "Loading Content",
					timeout: 60
				};
			} else {
				var options = {
					label : "Loading Content",
					color: '#000',
					spinnerColor: '#000',
					timeout: 60
				};
			}
			
			window.wizSpinner.show(options); 

			if(globals.debugApp){
				console.log("electrumURL : " + $rootScope.electrumURL);
			}

			var frame = document.getElementById('electrumIframe');
			frame.src = $rootScope.electrumURL;

			frame.onload = function() {

				setTimeout(function() { 
					var iframe = document.getElementById('electrumIframe');
					iframe.contentWindow.scrollTo(0,0);

					if(globals.debugApp){
						console.log("content height adjusted");
					}
				}, 100);

				$('#electContent').css('top', 0);
				frame.contentWindow.Ready($rootScope.ElectrumRequestPayload);
			}

			setTimeout(function() {
				$.mobile.changePage('#electrumIframePage');
				if(globals.debugApp){
					console.log("Loading electrumIframePage");
				}
			}, 100);
		};
	}
})();


//end
(function(){
	angular.module('connect.electrum.iframe', []);
})();
(function() {
	angular.module('connect.electrum.iframe')
		.directive('electrumIframe', electrumIframeDirective)
		//TODO: change ElectrumController to correct format
		//.controller('electrumIframeController', electrumIframeController);
		.controller('ElectrumController', electrumIframeController);

	electrumIframeDirective.$inject = [];
	electrumIframeController.$inject = ['$scope', '$rootScope', '$timeout', 'ClientSet'];

	function electrumIframeDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'electrum/electrumIFramePage/connect.electrum.iframe.html',
			link: link
		};
		return directive;

		function link(scope, element, attrs) { }
	}

	function electrumIframeController($scope, $rootScope, $timeout, ClientSet) {

		
		var frame = document.getElementById('electrumIframe');

		$('#electrumIframePage').on('pagebeforeshow', function() {

			$("#electrumIframePage .ui-content").css('height', $(window).height() - $('#electrumIframePage .ui-header').height() - 50 );
			$("#electrumIframePage #electrumIframeWrapper").css('height', $('#electrumIframePage .ui-content').height() );
			$("#electrumIframePage #electrumIframe").css('height', $('#electrumIframePage .ui-content').height() );
			$("#electrumIframePage #electrumIframe").css('width', $(window).width() );

			console.log('Now connecting to URL - ' + $rootScope.ElectrumURL );

			var electrumCounter = 0;
			var electrumIframeInterval = setInterval(function() {
				if (electrumCounter == 60) {
					clearInterval(electrumIframeInterval);
					window.wizSpinner.hide();
					navigator.notification.alert(
						$rootScope.electrumServerErr, // message
						function() {
							$.mobile.changePage('#electrum');
						}, // callback
						'Error', // title
						'Ok' // buttonName
					);
				} else if (frame.contentWindow.document.body.innerHTML.replace(/(\r\n|\n|\r)/gm, "")) {
					clearInterval(electrumIframeInterval);
					window.wizSpinner.hide();
					console.log("Iframe loaded");
					
				} else {
					electrumCounter++;
				}
			}, 1000);
		});


		window.addEventListener("message", function(event) {

			if(globals.debugApp){
				console.log("Electrum Iframe 'Message' method fired.");
			}

			// alert('The value of Mobile_Host_Response is: ' + frame.contentWindow.Mobile_Host_Response);
			$("#electrumNavigationControlGroup .ui-btn").remove();

			var response = frame.contentWindow.Mobile_Host_Response;
			response = $($.parseXML(response));
			var uniqueID = response.find('UniqueId').text();
			var barcode = response.find('ACCT_NUM_IMAGE').text();
			var errorDescription = response.find('ErrorDescription').text();
			var errorNumber = response.find('ErrorNumber').text();

			if (uniqueID || barcode) {
				setElectrumUniqueID(uniqueID);
				setElectrumBarcode('data:image/x-ms-bmp;base64,' + barcode);
				saveLocalData();
				
				$timeout(function() {
					$rootScope.ElectrumOptions = ClientSet.getElectrumOptions();
					$rootScope.electrumBarcode = getElectrumBarcode();
					$('#electrum #storesLoading').show();

					$('#electrumIframePage').on('pagehide', function() {
						$("#electrumNavigationControlGroup a").button();
						$("#electrumNavigationControlGroup a").css('color', '#2f3e46');
						$("#electrumNavigationControlGroup").controlgroup("refresh");

						setTimeout(function(){
							$('#electrum #storesLoading').hide();
							//Save All Data to File
							SaveAppDataJson(); 
							if(globals.debugApp){
								console.log('Saving ELECTRUM DATA');
							}
						}, 60);
					});

				},100);
			}
			if (errorDescription) {
				navigator.notification.alert(
					errorDescription,
					function() {}, // callback
					'Error', // title
					'Ok' // buttonName
				);
				saveClientLog(90, 0, 0, '', 0, $rootScope.electrumTranCode + ', ' + errorNumber + ', ' + errorDescription);
			}
		}, false);

	}
})();
(function(){
	angular.module('connect.terms.of.use', []);
})();
(function(){
	angular.module('connect.terms.of.use')
	.directive('termsOfUse', termsOfUseDirective)
	.controller('TermsController', termsOfUseController);

	termsOfUseDirective.$inject = [];

	termsOfUseController.$inject = ['$scope', '$timeout', 'Loading'];

	function termsOfUseDirective(){
		var directive = {
			restrict: 'E',
			templateUrl: 'termsOfUse/connect.terms.of.use.html',
			link: link
		};
		return directive;

		function link(scope, element, attrs){ }
	}

	function termsOfUseController($scope, $timeout, Loading){
		Loading.then(function(){
			$timeout(function(){
				$scope.Chain = globals.Change.chainFriendly;
			},1);
		});
	}
})();
(function(){
	angular.module('connect.sync', []);
})();
//      SUMMARY:      
//the loading factory is the main factory for the application, the sync process gets called here ...
//many controllers rely on the Loading factory promise to be resolved which indicates that the 
//sync process is complete and that data is available for controllers to access (or the process 
//eited due to an ajax error or initialSyncDoneTimeout caused the factory promise to be resolved
//and the loading page to hide but the sync is still running in the background, if this is case 
//the user might see slightly outdated data)



(function() {
	angular.module('connect.sync')

	.factory('Sync', syncService);

	syncService.$inject = ['$http', '$rootScope', '$timeout', '$compile', 'ClientSet'];


	function syncService($http, $rootScope, $timeout, $compile, ClientSet) {

		if(globals.debugApp){
			console.log("SYNCSERVICE-DEBUG: SYNC SERVICE LOADED");
		}

		//Create array to hold sync completes states
		var downloadStage = { "serverOK":false, "gameProgress":false, "clientSets":false, "promoHeaders":false, "promos":false, "newPromos":false, "promoImages":false, 
		"storeList":false, "storeServices":false, "services":false, "syncEnd":false, 'promoPage':false, 'promoCarousel':false, 'storePage':false, 'finished':false };


		function startSync($scope, Sync){

			setTimeout(function(){
				var op = LoadPromoImagesFromAppData() ? LoadPromoImagesFromAppData() : null; 

				if(globals.debugApp){
					console.log('TO DETERMINE SPINNER: ' + JSON.stringify( op ) + 'op length = ' + op.length );
				}

				if(op != null && JSON.stringify( op ) != '{}' && window.device.platform != 'Android'){
					stopPromoCarouselLoader(); 
				}
				else{
					startPromoCarouselLoader(); 
					if(globals.debugApp){
						console.log('STARTING SPINNER INITIATED..');
					}
				}

				if(globals.debugApp){
					console.log("SYNCSERVICE-DEBUG: Start Sync() Fired");
				}
				serverOK($scope, Sync);
			}, 1);
		}


		function serverOK($scope, Sync){

			if( globals.syncIsDone == false){

				$http.post(GetItemFromLocalData('ClientURL'), soapMessageServerOK(), {timeout: 20000} ).then(function(response) { 
					if(globals.debugApp){
						console.log('SYNCSERVICE-DEBUG: Server connection was successful in serverOK()');
					}

					if (parseServerOK(response.data)) { 
						var GameProgress = GetItemFromLocalData('GameProgress'); 

						if (GameProgress != null) { //check if the user has any saved game progress that was not synced to the server
							GameProgress = JSON.parse(GameProgress);
							if(globals.debugApp){
								console.log( 'calling end game on unsaved game progress with ' + GameProgress.pointsWon + ' points won and ' + GameProgress.playsLeft + ' plays left and ' + GameProgress.wonPromo + ' promo');
							}
							//saveClientLog(71, 0, 0, '', 0, 'calling end game on unsaved game progress with ' + GameProgress.pointsWon + ' points won and ' + GameProgress.playsLeft + ' plays left and ' + GameProgress.wonPromo + ' promo');
						
							gameProgress(GameProgress, $scope, Sync);
							downloadStage.serverOK = true;
						}
						else{
							//mark GameProgress as true and go to sync type method
							syncType($scope, Sync);
							downloadStage.serverOK = true;
						}
					}
					else{
						if(globals.debugApp){
							console.log('SYNCSERVICE-ERROR: Server connection was FAILED in serverOK() !!!');
						}
						serverOK($scope, Sync); //retry
					}

				}, function(error) {
					globals.timeouts = globals.timeouts + 1;

					if(globals.timeouts > 30){
						if(globals.debugApp){
							console.log('SYNCSERVICE-ERROR: TOO MANY TIMEOUTS. GOING TO OFFLINE MODE. !!!');
						}

						CancelSync();
					}
					else{
						serverOK($scope, Sync);	//retry
						if(globals.debugApp){
							console.log('SYNCSERVICE-ERROR: Server connection was FAILED in serverOK() !!!  TIMEOUTS = ' + globals.timeouts);
						}
					}
				});

			}
		}

		//NOTE- his is Used for too many TimeOuts
		function CancelSync(){
			//set all progress states to true
			downloadStage.clientSet = true;
			downloadStage.serverOK = true;
			downloadStage.gameProgress = true;
			downloadStage.promoHeaders = true;
			downloadStage.promos = true;
			downloadStage.promoImages = true;
			downloadStage.storeList = true;
			downloadStage.storeServices = true;
			downloadStage.services = true;
			downloadStage.syncEnd = true;
			downloadStage.promoCarousel = true;
			downloadStage.storePage = true;
			downloadStage.syncEnd = true;
			downloadStage.promoPage = true;
			downloadStage.finished = true;

			alert( "Offline mode: Could not connect to server after 30 attempts. \nPlease check your data and then go to 'More' and tap on 'Sync Now' to restart the sync. \n" +
				" TIP: Make sure Airplane mode is 'Off', and turn Wifi 'On'", function(){} );
		}



		// GAMEPROGRESS METHOD //
		function gameProgress(GameProgress, $scope, Sync){

			if( globals.syncIsDone == false){

				$http.post(GetItemFromLocalData('ClientURL'), soapMessageGameEnd(GameProgress.pointsWon, GameProgress.playsLeft, GameProgress.wonPromo), {timeout: 22000} ).then(function(response) {

					if (parseServerOK(response.data)) { 

						if(globals.debugApp){
							console.log("SUCCESS: Game Progress was updated!");
						}

						var processed = parseInt($(response.data).find('GameEndResult').children("Processed").text()); //returned by the web method, determines if the server has properly processed the gameend request
						
						SetItemInLocalData('Points', parseInt($(response.data).find('GameStartResult').children("Points").text()) );
						SetItemInLocalData('GamePlays', parseInt($(response.data).find('GameStartResult').children("Plays").text()) );
						SetItemInLocalData('PromoPlay', parseInt($(response.data).find('GameStartResult').children("PromoPlay").text()) );


						//save points, plays , and promoplay from the GameEnd web method response
						var error = $(response.data).find('Standard').children('MethodErrorMsg').text();
						if (processed == 1) {
							//remove saved progress since it has been synced with the server and the app points, plays, and promoplay have been updated
							SetItemInLocalData('GameProgress', '');
						}

						syncType($scope, Sync);
						downloadStage.gameProgress = true;
					}
					else{
						if(globals.debugApp){
							console.log('SYNCSERVICE-ERROR: data was bad in serverOK() !!!');
						}
						gameProgress(GameProgress, $scope, Sync);
					}

				}, function(error) {

					if(globals.debugApp){
						console.log('SYNCSERVICE-ERROR: Server connection was FAILED in serverOK() !!!');
					}
					gameProgress(GameProgress, $scope, Sync);
				}); 

			}
		}

		var fullDownload = false;
		function syncType( $scope, Sync){

			if( globals.syncIsDone == false){
				$http.post(GetItemFromLocalData('ClientURL'), soapMessageSyncStart(), {timeout: 22000} ).then(function(response) { 
					if(globals.debugApp){
						console.log("Now Downloading ClientSets...");
						//console.log('DEBUG-SYNC: data - ' + response.data);
					}
					saveClientLog(15, 0, 0, '', 0, 'Now Downloading ClientSets.');
					fullDownload = true;
					
					downloadClientSet($rootScope, $timeout, $scope, Sync);

					if ($rootScope.RegisteredUser){ //if this is a registered user save the account details returned by the server's syncstart method
						saveAccountDetailJson(response.data);
						$rootScope.RegisteredUser = true;
					}
				}, function(error) {
					syncType( $scope, Sync);
					if(globals.debugApp){
						console.log('SYNCSERVICE-ERROR: Server connection was FAILED in syncType() !!!');
					}
				});
			}
		}



		function syncEnd($scope, Sync){

			if( globals.syncIsDone == false){

				$.ajax({ //ajax call for syncend web method
					url: GetItemFromLocalData('ClientURL'),
					type: "POST",
					dataType: "xml",
					timeout : 21000,
					data: soapMessageSyncEnd(),
					success: function(data){
						saveClientLog(12, 0, 0, '', 0, 'syncend ok');
						if(globals.debugApp){
							console.log("SYNCEND-SUCCESS: syncend() launched");
						}

						saveStoreData(); 
						syncProg = setInterval(syncProgress( Sync, $scope, $rootScope, $timeout, $compile, ClientSet), 1);
						downloadStage.syncEnd = true;
							
						SetItemInLocalData('DataVersion', TempDataVersion); //filesystem save

						if(globals.debugApp){
							console.log('Set DataVersion to: ' + TempDataVersion);
						}
						//if syncend is successful then set the client's dataversion to tempdataversion (which was set to the server's data 
						//version earlier for a downloadsync or is just the same dataversion for a non-download sync)
					},
					error: function(error){
						saveClientLog(13, 0, 0, '', 0, 'syncend error');
						if(globals.debugApp){
							console.log("SYNCEND-ERROR: syncend() did not connect");
						}
						syncEnd($scope, Sync)
					},

					contentType: "text/xml; charset=utf-8"
				});
			}
		}





		// FUNCTION: DOWNLOAD CLIENT SET //
		//AJAX function for downloading client settings, used only in a download sync, called in promosdone function below
		function downloadClientSet($rootScope, $timeout, $scope, Sync) {
			//console.log("Client Set download Reuested");
			var error = false;

			if( globals.syncIsDone == false){

				$.ajax({
					url: GetItemFromLocalData('ClientURL'), //the ClientURL we stored earlier
					type: "POST", //Alway use POST, the web service is SOAP based not RESTful
					dataType: "xml", //Always xml, the webservice does not use JSON
					timeout : 24000, //The ajaxTimeout object is defined in js/app.js
					data: soapMessageClientSetAll(), //soap messages are defined in js/soapMessages.js
					success: function(data){ //ajax function successs callback (i.e. the function did not time out for lack of internet or something 
						//else happened that caused an error in the actual web service call like the server is down, ..etc)
						error = false;

						if(globals.debugApp){
							console.log("SUCCESS: downloadClientSet() was downloaded.");
						}

						saveClientLog(26, 0, 0, 'SUCCESS: downloadClientSet() was downloaded.');
						var cs = {};

						$(data).find('RClientSetServer').each(function() //for each RclientSetServer object in the XML response (for more details on response format for various web methods, see the webservice specification: http://74.208.209.112/Market_GreenSquare_001/WebService/WebService1.asmx)
						{
							var ItemName = $(this).children("ItemName").text(); //The name of the setting
							var ItemValue = $(this).children("ItemValue").text(); //The value of the setting
							cs[ItemName] = ItemValue; //Save the setting as a property of the cs object defined above; the ItemName is the key and the ItemValue is the value
						});

						//save to localStorage, localStorage is basically the local database for this application; 
						//JSON.stringify converts arrays or objects into json string literals, localStorage can only save strings
						downloadStage.clientSet = true;
						SaveClientSetsToAppData( JSON.stringify(cs) );
						downloadPromoHead( $rootScope, $timeout, $scope, Sync);
					},
					error: function(data){
						if(globals.debugApp){
							console.log("ERROR: downloadClientSet() was not downloaded.");
						}

						saveClientLog(54, 0, 0, '', 0, 'ERROR: downloadClientSet() - Could not connect.');
						downloadClientSet($rootScope, $timeout, $scope, Sync);
					},
					contentType: "text/xml; charset=utf-8"
				}).done(function(){
					if(error){
						if(globals.debugApp){
							console.log("ClientSet download HAD AN ERROR");
						}
					}
				});
			}
		} //END


		//FUNCTION: DOWNLOAD STORE LIST //
		//AJAX function for downloading stores, used only in a download sync, called in promosdone function below
		function downloadStoreList($scope, Sync){ 

			if( globals.syncIsDone == false){

				$.ajax({
					url: GetItemFromLocalData('ClientURL'),
					type: "POST",
					dataType: "xml",
					timeout : 23000,
					data: soapMessageStoreListAllByDescript(),
					success: function(data){

						var stuff = []; //local array to hold the stores
						if(globals.debugApp){
							console.log("SUCCESS: Store List was downloaded");
						}
						saveClientLog(19, 0, 0, 'SUCCESS: Store List was downloaded');

						//console.log('Stores Data: '+xmlToString(data)+"--"+window.localStorage.getItem('ClientURL')+"--"+soapMessageStoreListAllByDescript());
						$(data).find('RStoreServer').each(function(index)
						{
							var StoreID = parseInt($(this).children("StoreID").text());
							var Descript = $(this).children("Descript").text();
							//parseInt is used when saving the value if the expected value is an int

							var Address1 = $(this).children("Address1").text();
							var Address2 = $(this).children("Address2").text();
							var City = $(this).children("City").text();
							var State = $(this).children("State").text();
							var Zip = $(this).children("Zip").text();
							var Phone = $(this).children("Phone").text();
							var Latitude = parseFloat($(this).children("Latitude").text()); //parseFloat is used when saving the value if the expected value is a real number (i.e. not an int but has decimals)
							var Longitude = parseFloat($(this).children("Longitude").text());
							var RegularPrice = Math.round(parseFloat($(this).children("RegularPrice").text())*100)/100; //Math.round limits the decimal number to two places
							var PlusPrice = Math.round(parseFloat($(this).children("PlusPrice").text())*100)/100;
							var PremiumPrice = Math.round(parseFloat($(this).children("PremiumPrice").text())*100)/100;
							var DieselPrice = Math.round(parseFloat($(this).children("DieselPrice").text())*100)/100;
							var KerosenePrice = Math.round(parseFloat($(this).children("KerosenePrice").text())*100)/100;
							var GasLastUpdate = $(this).children("GasLastUpdate").text();

							stuff.push({
								StoreID : StoreID,
								Descript: Descript,
								Address1 : Address1,
								Address2 : Address2,
								City : City,
								State : State,
								Zip : Zip,
								Phone : Phone,
								Latitude : Latitude,
								Longitude : Longitude,
								RegularPrice : RegularPrice,
								PlusPrice : PlusPrice,
								PremiumPrice : PremiumPrice,
								DieselPrice : DieselPrice,
								KerosenePrice : KerosenePrice,
								GasLastUpdate : GasLastUpdate
							});
						});

						//GENERATE timeStamp and store it in rootscope, this is displayed with the redemption
						var currentdate = new Date(); 
						var storesSyncDate = "StoreList last synced: " + getMonth(currentdate) + " " + addOrd(currentdate.getDate()) + " " + " @ " + getTime(currentdate);
					    window.localStorage.setItem('StoresSyncDate', storesSyncDate);

					    //save the stringified stores in the global TempStores variable, TempStores will replace local Storage stores in the sync end function
						globals.TempStores = JSON.stringify(stuff); 
						downloadStage.storeList = true;
						//we do not save localStorage automatically here so that Stores, Services, and StoreServices are all saved at the 
						//same time and are on the same DataVersion.. call syncEnd to indicate that one of the asynchrous functions has finished
						downloadServices($scope, Sync);
					},
					error: function(data){
						if(globals.debugApp){
							console.log("ERROR: Store List was not downloaded");
						}
						saveClientLog(53, 0, 0, '', 0, 'ERROR: downloadStoreList() - Could not connect.');
						downloadStoreList($scope, Sync); //RETRY
					},
					contentType: "text/xml; charset=utf-8"
				});

			}
		}//END


		//FUNCTION DOWNLOAD SERVICES
		//AJAX function for downloading services, used only in a download sync, called in promosdone function below
		function downloadServices($scope, Sync){ //removed deffered

			if( globals.syncIsDone == false){

				$.ajax({
					url: GetItemFromLocalData('ClientURL'),
					type: "POST",
					dataType: "xml",
					timeout : 23000,
					data: soapMessageServiceListAll(),
					success: function(data){
						if(globals.debugApp){
							console.log('SUCCESS: Services downloaded');
						}

						saveClientLog(19, 0, 0, 'SUCCESS: Services downloaded' );
						var stuff = [];

						$(data).find('RServiceServer').each(function(index)
						{
							var ServiceID = $(this).children("ServiceID").text();
							var Descript1 = $(this).children("Descript1").text();
							var SortOrder = parseInt($(this).children("SortOrder").text());
							stuff.push({
								ServiceID : ServiceID,
								Descript1 : Descript1,
								SortOrder : SortOrder
							});
						});

						globals.TempServices = JSON.stringify(stuff);

						downloadStage.services = true;

						downloadStoreServices($scope, Sync);
					},
					error: function(data){
						if(globals.debugApp){
							console.log('ERROR: Services was not downloaded');
						}
						saveClientLog(52, 0, 0, '', 0, 'ERROR: downloadServices() - Could not connect.');
						downloadServices($scope, Sync); //RETRY
					},
					contentType: "text/xml; charset=utf-8"
				});
			}
		}//END


		//FUNCTION: DOWNLOAD STORE SERVICES //
		//AJAX function for downloading storeservices, used only in a download sync, called in promosdone function below
		function downloadStoreServices($scope, Sync) { //removed deffered

			if( globals.syncIsDone == false){

				$.ajax({
					url: GetItemFromLocalData('ClientURL'),
					type: "POST",
					dataType: "xml",
					timeout : 23000,
					data: soapMessageStoreServiceListAll(),
					success: function(data){
						if(globals.debugApp){
							console.log('SUCCESS: Store services downloaded');
						}

						saveClientLog(19, 0, 0, 'SUCCESS: Store services downloaded' );
						var stuff = [];
						$(data).find('RStoreServiceServer').each(function(index)
						{
							var ServiceID = $(this).children("ServiceID").text();
							var StoreID = parseInt($(this).children("StoreID").text());
							stuff.push({
								ServiceID : ServiceID,
								StoreID : StoreID
							});
						});

						globals.TempStoreServices = JSON.stringify(stuff);
						downloadStage.storeServices = true;
						syncEnd($scope, Sync);
					},
					error: function(data){

						if(globals.debugApp){
							console.log('ERROR: Store services was not downloaded');
						}

						saveClientLog(51, 0, 0, '', 0, 'ERROR: downloadStoreServices() - Could not connect.');
						downloadStoreServices($scope, Sync);
				},
					contentType: "text/xml; charset=utf-8"
				});
			}
		}



		//FUNCTION: DOWNLOAD PROMO HEAD //
		//AJAX function for downloading promo headers, used only in a download sync, called in js/app.js
		function downloadPromoHead( $rootScope, $timeout, $scope, Sync) { //removed deffered

			if(globals.debugApp){
				console.log("downloadPromoHead() initiated");
			}
			var error = false;

			if( globals.syncIsDone == false){
				$.ajax({
					url: GetItemFromLocalData('ClientURL'),
					type: "POST",
					dataType: "xml",
					timeout : 24000,
					data: soapMessagePromoHeadListAll(),
					success: function(data){
						if(globals.debugApp){
							console.log("SUCCESS: Promo Head Downloaded via downloadPromoHead()");
						}

						saveClientLog(18, 0, 0, 'SUCCESS: Promo Head Downloaded via downloadPromoHead()' );
						error = false;
						var stuff = [];

						$(data).find('RPromoHeadServer').each(function(index){
							var HeadID = $(this).children("HeadID").text();
							var Descript1 = $(this).children("Descript1").text();
							var SortOrder = parseInt($(this).children("SortOrder").text());
							//console.log("promo header received: " + HeadID + ":" + Descript1 + ":" + SortOrder);
							
							stuff.push({
								HeadID : HeadID,
								Descript1 : Descript1,
								SortOrder : SortOrder
							});
						});

						SaveHeadersToAppData( JSON.stringify(stuff) );
						downloadStage.promoHeaders = true;
						downloadPromo($rootScope, $timeout, $scope, Sync); //if no ajax error was thrown, go onto downloadpromo
					},
					error: function(data){
						if(globals.debugApp){
							console.log("ERROR: Promo Head was not Downloaded");
						}

						saveClientLog(17, 0, 0, 'ERROR: Promo Head was not Downloaded: ' + data);
						error = true;
						downloadPromoHead( $rootScope, $timeout, $scope, Sync); //RETRY
					},
					contentType: "text/xml; charset=utf-8"
				}).done(function(){
					if (error){
						if(globals.debugApp){
							console.log("downloadPromoHead() Had an error!");
						}
					}
				});
			}
		}//END


		//TODO: Check for unused promo or duplicate promo images and get rid of them

		// FUNCTION: DOWNLOAD PROMO //
		//AJAX function for download promos, called on every sync either from downloadPromoHead (in which case downloadSync is set to true) or from js/app.js in which case it is set to false
		function downloadPromo($rootScope, $timeout, $scope, Sync){ 
			var error;

			if(globals.debugApp){
				console.log("downloadPromo() initiated");
			}

			if( globals.syncIsDone == false){
				$.ajax({
					url: GetItemFromLocalData('ClientURL'),
					type: "POST",
					dataType: "xml",
					timeout : 30000,
					data: soapMessagePromoList2(),
					success: function(data){
						if(globals.debugApp){
							console.log("SUCCESS: Promos downloaded");
						}
						saveClientLog(18, 0, 0, 'SUCCESS: Promo Info downloaded' );
						error = false;

						var savepromos = [];	//the promos that will be saved to localstorage
						var newpromos = [];		//promos that are new
						var savepromostores = []; //promostores that will be saved to localstorage

						//gets the promoimage object from localstorage or creates a new one if not available, JSON.parse converts a 
						//string into a javascript array or object (it is the opposite of JSON.stringify)
						var PromoImages = LoadPromoImagesFromAppData() ? LoadPromoImagesFromAppData() : {}; 
						var promoImagesDone = 0; //indicates how many promo images have been downloaded from the server

						$(data).find('RPromoServer2').each(function(index){
							var PromoID = $(this).children("PromoID").text();
							var preDescText=$(this).children("Descript1").text();
							var Descript1 =preDescText;
							var Descript2 = $(this).children("Descript2").text();
							var PromoType = parseInt($(this).children("PromoType").text());
							var HeadID = $(this).children("HeadID").text();
							var InterestID = $(this).children("InterestID").text();
							var PromoStore = parseInt($(this).children("PromoStore").text());
							var PromoUse = parseInt($(this).children("PromoUse").text());
							var PromoAccount = parseInt($(this).children("PromoAccount").text());
							var DateStart = ticksToEpoch(parseInt($(this).children("DateStartTicks").text()));
							var DateEnd = ticksToEpoch(parseInt($(this).children("DateEndTicks").text()));
							var DisplaySec = parseInt($(this).children("DisplaySec").text());
							var Uses = parseInt($(this).children("Uses").text());
							var AccountUses = parseInt($(this).children("AccountUses").text());
							var Age = parseInt($(this).children("Age").text());
							var Points = parseInt($(this).children("Points").text());
							var DetailHTMLFile = $(this).children("DetailHTMLFile").text();
							var PhotoFile = $(this).children("PhotoFile").text();
							var ThumbFile = $(this).children("ThumbFile").text();
							var DescriptPush = $(this).children("DescriptPush").text();
							var FocusTime = $(this).children("FocusTime").text();

							if(InterestID){
								if(globals.debugApp){
									console.log("SYNC-PROMOS: WARNING - InterestID " + InterestID + "  (Warning! this promo is using an Interest only ID!");
								}
							}

							if (FocusTime){
								FocusTime = parseInt(FocusTime); //focus time indicates if this promotion can be used in the focus now module: 0 indicates no, 1 is breakfast, 2 is lunch, 3 is dinner, and 4 is late night
							}
							else{
								FocusTime = 0;
							}

							var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;

							if ((Uses == 0 || AccountUses < Uses) && now > DateStart && now < DateEnd){ 
								//make sure the promotion is valid (i.e. today's date is between the promo start and end date, also make sure the promo 
								//is not a redeemable promo (Uses == 0) OR that the user has enough AccountUses to redeem the promotion)	
								if(globals.debugApp){
									console.log("promo saved: " + PromoID);
								}

								savepromos.push({
									PromoID : PromoID,
									Descript1 : Descript1,
									Descript2 : Descript2,
									PromoType : PromoType,
									HeadID : HeadID,
									InterestID : InterestID,
									PromoStore : PromoStore,
									PromoUse : PromoUse,
									PromoAccount : PromoAccount,
									DateStart : DateStart,
									DateEnd : DateEnd,
									DisplaySec : DisplaySec,
									Uses : Uses,
									AccountUses : AccountUses,
									Age : Age,
									Points : Points,
									DetailHTMLFile : DetailHTMLFile,
									PhotoFile : PhotoFile,
									ThumbFile : ThumbFile,
									DescriptPush : DescriptPush,
									FocusTime : FocusTime
								});
							}
							else{
								if(globals.debugApp){
									console.log("SYNC-PROMOS: Invalid promo received: " + PromoID);
								}
							}
						});

						//Simple implemtation to clear images when a small excess of Promo images is incumulated 
						//This can be replaced with a sort alg later
						if( ( savepromos.length * 2.5 ) < PromoImages.length ){
							PromoImages = null;
							if(globals.debugApp){
								console.log('SYNC-DEBUG: PromoImages were wiped.');
							}
						}
								

						// **** Grab Promos and put them into a temp variable -- globals.PromoImagesArr **** //
					    var op =  LoadPromosFromAppData() ? LoadPromosFromAppData() : null; 

					    if(!PromoImages){ //Check to see if PromoImages are empty, if so then Old promos array has to be null
					    	op = null;
					    	PromoImages = {};
					    	if(globals.debugApp){
					    		console.log("promo images arr was empty. grabbing all images");
					    	}
					    }


					    if( op != null ){ // Check to see if old promos exist
					    	var oldpromos = op;
					    	globals.emptyCarousel = false;
					    	if(globals.debugApp){
					    		console.log("There were Old promos grab");
					    	}
					    }
					    else{
					    	var oldpromos = null;
					    	globals.emptyCarousel = true;
					    	if(globals.debugApp){
					    		console.log("No Old promos grab");
					    	}
					    }

						//determine which promos are new (i.e. they have not been saved to the app before)
						for (var i = 0; i < savepromos.length; i++){
							if (!inPromos(savepromos[i].PromoID, oldpromos)){
								newpromos.push(savepromos[i]);
							}
						} 

						if (newpromos.length > 0){
							$(data).find('RPromoStoreServer2').each(function(index){
								var PromoID = $(this).children("PromoID").text();
								var StoreID = parseInt($(this).children('StoreID').text());
								savepromostores.push({
									PromoID : PromoID,
									StoreID : StoreID
								});
							});
						}

						if( oldpromos != null ){ // Check to see if old promos exist
					    	//A block of code to detect a change of promo image name, if there is one
					    	for (var i = 0; i < savepromos.length; i++){
					    		//Check if saved and old promos have the same PromoID
								for (var j = 0; j < oldpromos.length; j++){
									if (oldpromos[j].PromoID == savepromos[i].PromoID){
									
										//CHeck if promos do not contain the same image name, if not then
										if(savepromos[i].PhotoFile != oldpromos[j].PhotoFile){
											if(globals.debugApp){
												console.log("Sync-Debug: !! A new photofile was found for an Old Promo. Let's update it..");
											}

											newpromos.push(savepromos[i]);//push this promo into new promos so the image will be updated
										}
									}
								}
							} 
					    }


						if (newpromos.length > 0){
							if(globals.debugApp){
								console.log('SYNC-PROMOS: There were NEW promos made..');
							}

							downloadStage.newPromos = true;

							//download and save all promostores if there are any new promotions, we do not only download promostores for newpromos 
							//because the logic to check whether or not this promostore is for a new or old promo would likely be slower than just 
							//downloading and saving all of them
							//Clear Promos
							SavePromoStoresToAppData(JSON.stringify(savepromostores));
							
							promoImagesDone = 0;
							var i = 0;

							downloadPromoImage(newpromos, i, function(){

								if(promoImagesDone >= newpromos.length){ //success call back for the downloadpromoimage function, if all the new promo images have been downloaded then save them and call promosDone function (defined below)
									
									//refreshAjax($scope);   // 

									if(globals.debugApp){
										console.log("SYNC-PROMOS: SUCCESS in downloading all new promo imgs.");
									}
									saveClientLog(89, 0, 0, 'SUCCESS in downloading all new promo imgs.' );

									//GENERATE timeStamp and store it in rootscope, this is displayed with the redemption
									var currentdate = new Date(); 
									var promosSyncDate = "Promos last synced: " + getMonth(currentdate) + " " + addOrd(currentdate.getDate()) + " " + " @ " + getTime(currentdate);
									window.localStorage.setItem('PromosSyncDate', promosSyncDate);

									if( globals.syncIsDone == false){

										SavePromoImagesToAppData( JSON.stringify(PromoImages) );
										SavePromosToAppData(JSON.stringify(savepromos)); 
										downloadStage.promoImages = true;
										downloadStage.promos = true;

										promosDone($scope, Sync);
									}
								}
							}, function(){  //error call back for the download promo image function
								error = true;
								if(globals.debugApp){
									console.log("ERROR in downloading promo imgs.");
								}
							});
						}
						else{

							//refreshAjax($scope);

							if( globals.syncIsDone == false){ //check to see if sync was cancled because of logging in or out

								//Important: Always save New data over old so new descriptions and meta data are udated each time.
								if(globals.debugApp){
									console.log('SYNC-PROMOS: No new images downloaded, but lets save all new promo data and refresh pages anyways.. SAVING.');
								}

								SavePromosToAppData(JSON.stringify(savepromos)); 
								SavePromoImagesToAppData( JSON.stringify(PromoImages) );
								downloadStage.newPromos = false; // Flag new promos, so the deleted ones get refreshed off the pages

								saveClientLog(32, 0, 0, 'SUCCESS: But no new promos' );
								if(globals.debugApp){
									console.log('SYNC-PROMOS: There were No new promos made..');
								}

								downloadStage.promos = true;
								downloadStage.promoImages = true;

								//GENERATE timeStamp and store it in rootscope, this is displayed with the redemption
								var currentdate = new Date(); 
								var promosSyncDate = "Promos last synced: " + getMonth(currentdate) + " " + addOrd(currentdate.getDate()) + " " + " @ " + getTime(currentdate);
								window.localStorage.setItem('PromosSyncDate', promosSyncDate);

								promosDone($scope, Sync); //if there are no new promos then just call promosdone right away
							}
						}

						function promosDone($scope, Sync){
							if(globals.debugApp){
								console.log("SYNC-PROMOSDONE: initiated");
							}
							saveClientLog(32, 0, 0, 'SUCCESS: in PromosDone. Saving Promos now' );

							//clear data and data
							//make sure no AJAX functions threw an error before saving the data (so we do not for example save a promo when the corresponding promo image was not downloaded) we also don't want to call
							//remaining AJAX download sync functions since the user likely has bad or no internet at this time
							if(!error && globals.syncIsDone == false){

								if(globals.debugApp){
									console.log("SYNC-DEBUG: No errors found, proceeding with Storelist DL");
								}

								if(fullDownload){
									downloadStoreList($scope, Sync); // this will chain and also get services and store services
								}
								else{
									if(globals.debugApp){
										console.log('Sync-Debug: Skipping storelist and related downloads as this is not a FullDownload.');
									}

									downloadStage.storeServices = true;
									downloadStage.services = true;
									downloadStage.storeList = true;

									syncEnd($scope, Sync);
								}
							}
							else{
								if(globals.debugApp){
									console.log("ERROR: error in promosDone(): " + error);
								}
								downloadPromo($rootScope, $timeout, $scope, Sync); //RETRY PROMO METHOD FROM BEGINNING
							}
						}//END OF PROMOSDONE

						function downloadPromoImage(photo, counter, callback, errorcallback){ //helper function for downloading a promo image

							if(counter < newpromos.length){
								if(globals.debugApp){
									console.log('Debug: image download test [' + counter + '] - ' + photo[counter].PhotoFile ); 
								}

								if( globals.syncIsDone == false){

									$.ajax({
										url: GetItemFromLocalData('ClientURL'),
										type: "POST",
										dataType: "xml",
										timeout : 42000,
										data: soapMessageGetFileChunk('Image', photo[counter].PhotoFile), //this as well as the function updateGameAssets (in js/app.js) uses the GetFileChunk web method which returns the image as a base64 encoded string
										success: function(data){
											if(globals.debugApp){
												console.log("SUCCESS: A promo-image was downloaded via downloadpromoimage()");
											}
											saveClientLog(44, 0, 0, "SUCCESS: A promo-image was downloaded via downloadpromoimage()");

											var error = $(data).find('Standard').children('MethodErrorLevel').text();
											if (error == "None"){
												if (photo[counter].PhotoFile.substring(photo[counter].PhotoFile.indexOf('.') + 1) == 'png') //check if the photofile name is png or jpg and save accordingly
													PromoImages[photo[counter].PhotoFile] = "data:image/png;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();
												else{
													PromoImages[photo[counter].PhotoFile] = "data:image/jpeg;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();
												}
												promoImagesDone++; //increments promoImagesDone which is used in the success call back to determine if all promo images have been downloaded
												
												if(globals.debugApp){
													console.log("Image Download successful (line1059/sync.js) : " + photo[counter].PhotoFile +  "  :  "+ promoImagesDone);
												}
											}
											else{
												if(globals.debugApp){
													console.log("ERROR: could not download promo image: "  + photo[counter].PhotoFile + " - Error = " + error);
												}
												saveClientLog(45, 0, 0, "ERROR: promo image downloaded but caused an error: "  + photo[counter].PhotoFile + " - Error = " + error);
											}

											var next = counter + 1;
											callback();

											downloadPromoImage(photo, next, callback, errorcallback);
										},
										contentType: "text/xml; charset=utf-8",
										error: function(data){
											//var next = counter + 1;
											if(globals.debugApp){
												console.log("error! in downloadPromoImage()");
												console.log("ERROR: could not connect to download promo image: "  + photo[counter].Photofile + " - Error = " + data);
											}
											saveClientLog(46, 0, 0, "ERROR: could not connect to download promo image: "  + photo[counter].Photofile + " - Error = " + data);
											errorcallback();

											downloadPromoImage(photo, counter, callback, errorcallback);
										}
									});
								}
							}
						}

						function inPromos(promoid, promos){ //helper function to check if a promoid is in a promos array
							if (!promos){
								return false;
							}

							for (var i = 0; i < promos.length; i++){
								if (promos[i].PromoID == promoid){
									return true;
								}
							}
							return false;
						}
					},
					error: function(data){
						saveClientLog(62, 0, 0, 'ERROR: in downloadPromo() - Promo information was not downloaded.' );
						if(globals.debugApp){
							console.log('ERROR: in downloadPromo() - Promo information was not downloaded.' );
						}

						error = true;
						downloadPromo($rootScope, $timeout);
					},
					contentType: "text/xml; charset=utf-8"
				});
			}
		} //END



		return {
		    start: function($scope, Sync) {
		    	setTimeout(function(){
			    	if(globals.debugApp){
			      	    console.log("Start FUNCTION FIRED!");
			      	}
			      	startSync($scope, Sync); // Start App's Sync Background Process
		      	},1);
		    },

		    //In main page of app, get
		    getGameProgressState: function(){
		    	if(globals.debugApp){
		    		console.log("getGameProgressState FUNCTION FIRED! - Returning bool value of downloadStage.gameProgress : " + downloadStage.gameProgress);
		    	}
		    	return downloadStage.gameProgress;
		    },
		    getPromoHeadersState: function(){
		    	if(globals.debugApp){
		    		console.log("getPromoHeadersState FUNCTION FIRED! - Returning bool value of downloadStage.promoHeaders : " + downloadStage.promoHeaders);
		    	}
		    	return downloadStage.promoHeaders;
		    },
		    getClientSets: function(){
		    	if(globals.debugApp){
		    		console.log("getClientSets FUNCTION FIRED! - Returning bool value of downloadStage.clientSets : " + downloadStage.clientSets);
		    	}
		    	return downloadStage.clientSets;
		    },
		    getPromosState: function(){
		    	if(globals.debugApp){
		    		console.log("getPromosState FUNCTION FIRED! - Returning bool value of downloadStage.promos : " + downloadStage.promos);
		    	}
		    	return downloadStage.promos;
		    },
		    getPromosImagesState: function(){
		    	if(globals.debugApp){
		    		console.log("getPromoImagesState FUNCTION FIRED! - Returning bool value of downloadStage.promoImages : " + downloadStage.promoImages);
		    	}
		    	return downloadStage.promoImages;
		    },
		    getStoreListState: function(){
		    	if(globals.debugApp){
		    		console.log("getStoreListState FUNCTION FIRED! - Returning bool value of downloadStage.storeList : " + downloadStage.storeList);
		    	}
		    	return downloadStage.storeList;
		    },
		    getStoreServicesState: function(){
		    	if(globals.debugApp){
		    		console.log("getStoreServicesState FUNCTION FIRED! - Returning bool value of downloadStage.storeServices : " + downloadStage.storeServices);
		    	}
		    	return downloadStage.storeServices;
		    },
		    getServicesState: function(){
		    	if(globals.debugApp){
		    		console.log("getServicesState FUNCTION FIRED! - Returning bool value of downloadStage.services : " + downloadStage.services);
		    	}
		    	return downloadStage.services;
		    },
		    getSyncEndState: function(){
		    	if(globals.debugApp){
		    		console.log("getSyncEndState FUNCTION FIRED! - Returning bool value of downloadStage.syncEnd : " + downloadStage.syncEnd);
		    	}
		    	return downloadStage.syncEnd;
		    },
		    getPromoPageState: function(){
		    	if(globals.debugApp){
		    		console.log("getPromoPageState FUNCTION FIRED! - Returning bool value of downloadStage.promoPage : " + downloadStage.promoPage);
		    	}
		    	return downloadStage.promoPage;
		    },
		    setPromoPageState: function(value){
		    	if(globals.debugApp){
		    		console.log("setPromoPageState FUNCTION FIRED! - Returning bool value of downloadStage.promoPage : " + downloadStage.promoPage);
		    	}
		    	downloadStage.promoPage = value;
		    },
		    getStorePageState: function(){
		    	if(globals.debugApp){
		    		console.log("getStorePageState FUNCTION FIRED! - Returning bool value of downloadStage.storePage : " + downloadStage.storePage);
		    	}
		    	return downloadStage.storePage;
		    },
		    setStorePageState: function(value){
		    	if(globals.debugApp){
		    		console.log("setStorePageState FUNCTION FIRED! - Returning bool value of downloadStage.storePage : " + downloadStage.storePage);
		    	}
		    	downloadStage.storePage = value;
		    },
		    getPromoCarouselState: function(){
		    	if(globals.debugApp){
		    		console.log("getPromoCarouselState FUNCTION FIRED! - Returning bool value of downloadStage.promoCarousel : " + downloadStage.promoCarousel);
		    	}
		    	return downloadStage.promoCarousel;
		    },
		    setPromoCarouselState: function(value){
		    	if(globals.debugApp){
		    		console.log("getPromoCarouselState FUNCTION FIRED! - Returning bool value of downloadStage.promoCarousel : " + downloadStage.promoCarousel);
		    	}
		    	downloadStage.promoCarousel = value;
		    },
		    getFinishedState: function() {
		    	if(globals.debugApp){
		       		console.log("Get Finished FUNCTION FIRED!");
		       	}
		      	//Create an alert for testing
		      	return downloadStage.finished;
		    },
		    setFinishedState: function(value) {
		    	if(globals.debugApp){
		       		console.log("Set Finished FUNCTION FIRED!");
		       	}
		      	//Create an alert for testing
		      	downloadStage.finished = value;
		    },
		    getNewPromosState: function() {
		    	if(globals.debugApp){
		       		console.log("Get newPromos FUNCTION FIRED!");
		       	}
		      	//Create an alert for testing
		      	return downloadStage.newPromos;
		    },
		    setNewPromosState: function(value) {
		    	if(globals.debugApp){
		       		console.log("Set newPromos FUNCTION FIRED!");
		       	}
		      	//Create an alert for testing
		      	downloadStage.newPromos = value;
		    }
		};
	}
})();
//End of FACTORY

function stopPromoCarouselLoader(){
	if(globals.spinner){
		globals.spinner.stop();
	}
		$('#pCarouselLoading').hide(); 
		globals.spinnerIsActive = false;

		if(globals.debugApp){
			console.log('Sync-Debug: Spinner was stopped');
		}
}

function startPromoCarouselLoader(){

	var opts = {
		  lines: 14 // The number of lines to draw
		, length: 15 // The length of each line
		, width: 8 // The line thickness
		, radius: 24 // The radius of the inner circle
		, scale: .5 // Scales overall size of the spinner
		, corners: 1 // Corner roundness (0..1)
		, color: '#000' // #rgb or #rrggbb or array of colors
		, opacity: 0.25 // Opacity of the lines
		, rotate: 32 // The rotation offset
		, direction: 1 // 1: clockwise, -1: counterclockwise
		, speed: 1 // Rounds per second
		, trail: 60 // Afterglow percentage
		, fps: 20 // Frames per second when using setTimeout() as a fallback for CSS
		, zIndex: 2e9 // The z-index (defaults to 2000000000)
		, className: 'spinner' // The CSS class to assign to the spinner
		, top: '64%' // Top position relative to parent
		, left: '50%' // Left position relative to parent
		, shadow: false // Whether to render a shadow
		, hwaccel: false // Whether to use hardware acceleration
		, position: 'absolute' // Element positioning
	}
	var target = document.getElementById('carouselLoader');
	globals.spinner = new Spinner(opts).spin(target);

	if(globals.debugApp){
		console.log('Sync-Debug: Spinner started via startPromoCarouselLoader();');
	}

	$('#pCarouselLoading').show(); 
	globals.spinnerIsActive = true;
}


function syncProgress(SyncObj, $scope, $rootScope, $timeout, $compile, ClientSet){
	if(globals.debugApp){
		console.log('syncProgress called');
	}
	intervalId = setInterval(syncRun, 600);

	function syncRun() {

		if(globals.debugApp){
			console.log('Sync-Debug: sync check ran');
		}

		//check to see if store related sync is finished
		if( SyncObj.getStoreServicesState() && SyncObj.getStoreListState() && SyncObj.getServicesState() && !SyncObj.getStorePageState() ){

			//Evoke refresh of store page
			storePageEvoke($scope);
			servicesPageEvoke($scope)
			SyncObj.setStorePageState(true);

			//Evoke Loyalty settings if exist (KICKBACK)
			//var tempKickbackSignedIn = globals.userAccount.get('KickbackSignedIn')
			//if(getKickbackSignedIn() == 1){
			kickbackGameEvoke(ClientSet);
			console.log('KB user account exist');
			//}

			//Evoke Loyalty settings if exist (ELECTRUM)
			ElectrumEvoke(ClientSet, $rootScope);

			if(globals.debugApp){
				console.log('setStorePagelState set to TRUE');
				//alert('setStorePagelState set to TRUE');
			}
		}

		if( SyncObj.getPromoHeadersState() && SyncObj.getPromosState() && SyncObj.getPromosImagesState() && !SyncObj.getPromoPageState() ){

			if( SyncObj.getNewPromosState() || window.device.platform == 'Android' ){ //Android needs Loader everytime
				
				promoPageEvoke($scope,0);
				prizePageEvoke($scope);

				SyncObj.setPromoPageState(true);

				if(globals.debugApp){
					console.log('setPromoPageState set to TRUE');
				}

				//Evoke refresh of promo carousel
				promoCarouselEvoke($scope, $rootScope, $timeout, $compile); // PROMO CAROUSEL EVOKE			

				SyncObj.setPromoCarouselState(true);

				if(globals.debugApp){
					console.log('setPromoCarouselState set to TRUE');
					//alert('setPromoPageState and setPromoCarouselState set to TRUE');
				}
			}
			else{
				if(globals.debugApp){
					console.log('no new promos - no need to evoke Promo content');
					//alert('no new promos - no need to evoke Promo content');
				}

				promoPageEvoke($scope,0);
				prizePageEvoke($scope);
				
				SyncObj.setPromoCarouselState(true);
				SyncObj.setPromoPageState(true);
			}
		}

		//Set 'FINISH STATE'
		if( SyncObj.getPromoPageState() && SyncObj.getStorePageState() && SyncObj.getPromoCarouselState() && SyncObj.getSyncEndState() ){
			//Set finish state
			SyncObj.setFinishedState(true);

			if(globals.debugApp){
				console.log('Finished State set to TRUE');
				//alert('Finished State set to TRUE');
			}
		}

		if( SyncObj.getFinishedState() ){
			//cancle this interval method
			if(globals.debugApp){
				console.log('interval cleared. SYNC FINISHED. SAVING DATA.');
			}

			globals.syncIsDone = true;
			//alert('SYNC FINISHED. SAVING DATA.');

			//SAVE DATA
			saveLocalData(); //save user account
			setTimeout(function(){
				SaveAppDataJson(); // Save all the Data that was initialized into the FILE
			}, 100);

			clearInterval(intervalId);
		}
	};
}

function stopSync(){
	if(globals.syncIsDone == false){
		clearInterval(intervalId); //clear interval that checks sync progress
		globals.syncIsDone = true;// helps to cancel ajax calls 

		if(globals.debugApp){
			console.log('SYNC DEBUG: stopSync was called. SYNCING WAS CANCELED. INTERVAL CLEARED.');
		}
	}
}

function isSyncFinished(){
	return globals.syncIsDone;
}



// GLOBAL SYNC FUNCTIONS //
//----------------------/-/

function refreshAjax($scope){
	//TODO Refresh KB game URL after register and log ins.

	if(globals.page == 'Specials'){
		if(window.device.platform == 'Android'){
			var options = {
				label : "Refreshing specials.."
			};
		}
		else{
			var options = {
				label : "Refreshing specials..",
				color : '#000',
				spinnerColor : '#000'
			}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
		} 
	}
	else{
		if(window.device.platform == 'Android'){
			var options = {
				label : "..."
			};
		}
		else{
			var options = {
				label : "...",
				color : '#000',
				spinnerColor : '#000'
			}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
		} 
	}

	window.wizSpinner.show(options);
}

function kickbackGameEvoke(ClientSet){ //Use this when user is a KB club member

	var kickBackShow = ClientSet.getKickbackURL() && ClientSet.getKickbackUser() && ClientSet.getKickbackPass();

	if(kickBackShow){
		//TODO : CHECK TO SEE IF KICKBACK IS ENABLED
		//var scope = angular.element($("#kickback-punch-card")).scope();
		//scope.updateKbGame();

		var scope = angular.element($("#kbIframeDirective")).scope();
		scope.updateKbGameURL();

		var scope = angular.element($("#connect-kickback-rewards")).scope();
		scope.$broadcast('kickback-rewards:refresh');//for kb clients	

		console.log('kickbackGameEvoke fired.');
	}
}

function ElectrumEvoke(ClientSet, $rootScope){
	//update URL, the only setting that gets changed
	// *Electrum Client Sets Init* //
	$rootScope.enableElectrum = ClientSet.getElectrumURL() && ClientSet.getElectrumAppID();

	if($rootScope.enableElectrum ){
		$rootScope.electrumMenuMain = ClientSet.getElectrumMenuMain();
		$rootScope.electrumMenu47 = ClientSet.getElectrumMenu47();
		$rootScope.electrumURL = ClientSet.getElectrumURL();
		$rootScope.electrumAppID = ClientSet.getElectrumAppID();
		$rootScope.electrumServerErr = ClientSet.getElectrumServerErr();
		$rootScope.electrumBarcode = getElectrumBarcode();
		$rootScope.electrumPoints = false; // will replace with ClientSet when this feature is fully implemented
		$rootScope.electrumNow47 = ClientSet.getElectrumNow47();
		$rootScope.ElectrumImage = globals.Change.electrumImage;

		console.log('Electrum was refreshed - ElectrumEvoke()');
		console.log("** Electrum URL received: " + $rootScope.electrumURL );

		if(globals.debugApp){
			console.log("** Electrum URL received: " + $rootScope.electrumURL );
			console.log("** Electrum APP ID received: " + $rootScope.electrumAppID );
			console.log("** Electrum Enabled: " + $rootScope.enableElectrum );
			console.log("**** Electrum Barcode: " + $rootScope.electrumBarcode );
		}
	}
	else{
		console.log('Electrum refresh is not needed so it will Not refresh. - ElectrumEvoke()');
	}
}

// PAGE EVOKE FUNCTIONS //
function storePageEvoke($scope){
	var scope = angular.element($("#storesDirective")).scope();
	scope.showLatestStoreData();
}


function prizePageEvoke($scope){
	$("#prizeWrapper").empty();
	//console.log('Prizes in scope (prizes REFRESH) : ' + JSON.stringify( $scope.PrizeHeaders ) );
	var scope = angular.element($("#prizesDirective")).scope();
	scope.showLatestPrizeData();

	setTimeout(function(){ //PRIZE PAGE REFRESH WITH SCOPE.APPLY
		scope.prizePageRefresh();
	},10);
}//END of prizePageEvoke


function promoPageEvoke($scope, type){
	var scopeOnPage = angular.element($("#PromosDirective")).scope(); // Grab the scope on Promo Page that has 'onPage' variable

	if(type == 1 || scopeOnPage.onPage == true){  //if type is 1 or when user is on the promos screen
		var proScope = angular.element($("#PromosDirective")).scope(); // Grab the scope on Promo Page that has 'promoPageRefresh()' method
		proScope.promoPageRefresh();
	}
	else{
		var proScope = angular.element($("#PromosDirective")).scope(); // Grab the scope on Promo Page that has 'promosRefreshed' variable
		proScope.promosRefreshed = true;
	}
}//END of prizePageEvoke



// PAGE EVOKE FUNCTIONS //
function servicesPageEvoke($scope){
	var serScope = angular.element($("#StoreServDirective")).scope();
	serScope.showLatestServicesData();
}



function promoCarouselEvoke($scope, $rootScope, $timeout, $compile){
	if( !globals.spinnerIsActive ){
		startPromoCarouselLoader();
	}

	$scope.Promos = getAllPromos(0, 'promoPageEvoke');

	if(globals.debugApp){
		if($scope.Promos.length > 0){
			console.log('Now-Carousel-Success: Promos exist for the NOW CAROUSEL');
		}
		else{
			console.log('Now-Carousel-Error: Promos DO NOT exist for the NOW CAROUSEL!!');
		}
	}

	// ** Now Promo Carousel ** //
	var contentheight = $('#main .ui-content').height();

	// CAROUSEL START UP //
    if( globals.emptyCarousel ){
		$('#mainCarousel').data('touchCarousel').destroy(); //destroy the static carousel (important as it doesnt support resizing or adding/sub)
    }
	
	$("#mainCarouselWrapper #cWrapper").empty();

	var carouselHTMLcontainer = '<div id="mainCarousel" class="touchcarousel minimal-light">' +
	    	'<ul id = "nowScreenCarousel" class="touchcarousel-container">' + 
	    		'<li class = "touchcarousel-item" ng-repeat = "Promo in Promos | limitTo: 8">' +
		    		'<img class = "tcimage mainCarouselImage" src = "{{Promo.PhotoURL}}"/>' +
	    		'</li>' +
	   		'</ul>' +
		'</div>';

	setTimeout(function(){

		var scope = angular.element($("#main")).scope();
		scope.setPromosForCarousel($scope.Promos);
		$("#mainCarouselWrapper #cWrapper").html( $compile ( carouselHTMLcontainer )( $scope ) ); //Append new elements

		setTimeout(function(){
			
			// ** Now Promo Carousel ** //
			$("#mainCarouselWrapper .ui-grid-b").css('height', contentheight * .333);
			$("#pCarouselLoading").css('height', $("#mainCarouselWrapper .ui-grid-b").height() );
			var promoModHeight = $('#mainCarouselWrapper .ui-grid-b').height();
			$("#mainCarouselWrapper #cWrapper").css('height', promoModHeight);
			$("#mainCarouselWrapper .tcimage").css('height', promoModHeight );

			var promowidth = Math.ceil(promoModHeight * 1.25);
			$("#mainCarouselWrapper .tcimage").css('width', promowidth + 'px' );
			$("#mainCarousel .touchcarousel-wrapper").css('height', promoModHeight );
			$("#mainCarouselWrapper .touchcarousel-item").css('height', promoModHeight );
			$("#mainCarouselWrapper .touchcarousel-item").css('width', $('.nowPromoModule .tcimage').width() );
			$("#mainCarouselWrapper .touchcarousel").css('height', promoModHeight);

			setTimeout(function(){
			
				if (!$('#mainCarouselWrapper').hasClass('ng-hide') && $scope.Promos.length > 0 ){ //checking to see if the carousel will be shown
					if(globals.debugApp){
						console.log('STARTING PROMO CAROUSEL NOW MODULE');
					}

					$('#mainCarousel').touchCarousel({ 
						pagingNav: false,
						directionNav: false,
						snapToItems: true,
						scrollbar: false,
						loopItems: true,
						autoplay: true,
						Delay: 1500,
						transitionSpeed: 400,
						scrollToLast: true,
						useWebkit3d: true
					});

					setTimeout(function(){
						$('#mainCarousel').css('margin-left', ( $(window).width() * .5 - $("#mainCarouselWrapper .tcimage").width() / 1.82 ) );  //centering the touch carousel so that the focused image is in the horizontal center of the page
						
						setTimeout(function(){
							$("#mainCarousel").animate({opacity:1}, 500);

							setTimeout(function(){
								stopPromoCarouselLoader(); //Stop loader in now promo carousel
							}, 100);
						}, 10);
					}, 30);
				}
			}, 100);
		},600);	
	},100);
}//End of promoCarouselEvoke



//NOTE: MAKE SURE TO SAVE / LOAD PRESORTED ARRAY  (NVM , MIGHT NOT NEED TO)


// Get All Headers with Promos - Function //
//****************************************//
//TODO: MOVE THIS TO ANGULAR SERVICE AND DEPENDENCY INJECTION
function getAllHeadersWithPromos(trace){ //returns all headers with their promotions (used on the promo screen) stored on the device
	if(globals.debugApp){
		if(trace){
			console.log('DEBUG-SYNC: calling getAllHeadersWithPromos() from - ' + trace);
		}
		console.log("getAllHeadersWithPromos() initiated");
	}

	var finalHeaders = []; //array to hold the result sent to the user
	var headers = LoadHeadersFromAppData() ? LoadHeadersFromAppData() : null;

	if (headers){
		headers.sort(function(a, b){
			return a.SortOrder - b.SortOrder;
		}); //sort headers by their sort order

		var promos = getAllPromos(0, 'getAllHeadersWithPromos()'); //get all regular promotions (not prizes)

		for (var i = 0; i < headers.length; i++){
			headers[i].Promos = promos.filter(function(item){
				return (item.HeadID == headers[i].HeadID);
			});
		} //for each header, push the promotions that have that header's headerid
		for (var i = 0; i < headers.length; i++){
			if (headers[i].Promos.length > 0){
				finalHeaders.push(headers[i]);
			}
		} //for each header only use the ones that have promotions
	}

	return finalHeaders;
}


// Update Promo Link / Video / Photo - Function //
//----------------------------------------------//
//TODO: MOVE THIS TO ANGULAR SERVICE AND DEPENDENCY INJECTION
function updatePromoLinkVideoPhoto(p){ //helper function for checking and updating promotions that have a link and/or youtube video as part of the Descript2 such as: [http://www.google.com]Check out Google!
 	var Descript2 = p.Descript2;
	if (Descript2.indexOf('[') == -1){ //if there is no bracket then this is a regular Descript2 (with no link)
		var PromoLink = '';
		var PromoVideo = '';
		var PromoVideoImage = '';
	}
	else{
		if (Descript2.indexOf('youtube') == -1){ //this is a regular link (not youtube video)
			var PromoLink = Descript2.substring(1, Descript2.indexOf(']'));
			var PromoVideo = '';
			var PromoVideoImage = '';
		}
		else{ //this is a youtube video link
			var PromoLink = '';
			var PromoVideo = Descript2.substring(1, Descript2.indexOf(']'));
			var youtubeID = Descript2.substring(Descript2.indexOf('=') + 1, Descript2.indexOf(']')); //extract the youtube video id from the url
			var PromoVideoImage = 'http://img.youtube.com/vi/' + youtubeID + '/0.jpg'; //if this is a youtube link, use the youtube API to set the promovideoimage as the video thumbnail
		}
		Descript2 = Descript2.substring(Descript2.indexOf(']') + 1); //set the Descript2 to the text after the [link]
	}

	p.Descript2 = Descript2;
	p.PromoLink = PromoLink;
	p.PromoVideo = PromoVideo;
	p.PromoVideoImage = PromoVideoImage;
	
	return p;
 }


 // Get Age - Function //
//*******************//
//returns the age of the user (if available)
function getAge(){ 
	if(globals.debugApp){ 
		console.log('DEBUG-SYNC: Getting Age in getAge()')
	}
	//var birthdayEpoch = parseInt(window.localStorage.getItem('Birthday')); //get birthday from local storage which is stored as unix epoch time
	var birthdayEpoch = parseInt(getBirthday()); 

	if (!birthdayEpoch){
		return 0;
	}
	else{
		var fromNow = moment(birthdayEpoch).month(0).from(moment().month(0)); //get the difference between the user's birthday and today
		if (fromNow.indexOf('years') == -1){ //no years string in fromNow
			return 0; //the user is 0 years old
		}
		else{
			return parseInt(fromNow.substring(0, fromNow.indexOf('y') - 1)); //return the number of years to show the age
		}
	}
}


//TODO: GLOBAL FUNCTION TO ANGULAR JS SERVICE
//Function for getting all promotions saved on the device by type (0 is a regular promo and 1 is a prize)
function getAllPromos(type, trace){ 
	if(globals.debugApp){
		if(trace){
			console.log('DEBUG-SYNC: calling getAllPromos() from - ' + trace);
		}
		console.log("Getting all Promos in (getAllPromos())..");
	}

	var use = []; //array to hold the promos that will be sent back
	var p = LoadPromosFromAppData() ? LoadPromosFromAppData() : null; 
	var pi = LoadPromoImagesFromAppData() ? LoadPromoImagesFromAppData() : null; 

	//console.log('getAllPromos:  p = ' + JSON.stringify(p) );
	
	if (p && pi){
		//console.log('promoimages test - ' + JSON.stringify( pi ) );
		p = p.filter(function(item){
			return (item.PromoType == type);
		}); //filter promos based on type
		
		if (p.length){

			var myAge = getAge();
			var myInterests = getInterests();
			var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;

			for (var i = 0; i < p.length; i++){
				p[i] = updatePromoLinkVideoPhoto(p[i]); //see function definition above
				var promoInterestID = p[i].InterestID;
				var promoAge = p[i].Age;
				var usePromo = false;
				var endDate = p[i].DateEnd; //promo end date

				if(now > p.DateStart && now < p.DateEnd){
					usePromo = false;
					if(globals.debugApp){
						console.log('GetAllPromos-Debug: A promo was expired or was not valid yet');
					}
				}

				if (promoInterestID){
					for (var j = 0; j < myInterests.length; j++){
						if (myInterests[j].InterestID == promoInterestID){
							usePromo = true;
						}
					}
				} //if the promo has an interest id only use it if it is part of the user's interests
				else{
					usePromo = true;
				}

				p[i].PhotoURL = pi[p[i].PhotoFile]; //set the promo PhotoURL to the matching value in the PromoImages object
				//console.log("SYNC-DEBUG: promo photofile being processed in getAllPromos()" + i + ' -- ' + pi[p[i].PhotoFile]); // do not use

				if (usePromo && ((promoAge && myAge < promoAge) || !p[i].PhotoURL)) {
					//if the promo has the age flag set (promoAge) make sure the user is the right age and 
					//make sure the photo exists from promo images
					usePromo = false;
					if(globals.debugApp){
						console.log("GetAllPromos-Debug: promoImage was missing or the age filter was used..");
					}
				}

				if (usePromo){
					use.push(p[i]); //push the promo to the array we will send back

					if (p[i].PromoStore){ 
						use[use.length - 1].hasStores = true;  //promo has Stores FLAG
					}
					else{
						use[use.length - 1].hasStores = false;  //promo has Stores FLAG
					}

					/* GET RID OF GRABBING STORES FOR PROMO - MOVE TO PROMO SPECIFIC PAGE  - DONE */
					if (!use[use.length - 1].Stores){
						use[use.length - 1].Stores = []; //if no stores have been added, add an empty array as the stores property
					}
				}
				else{
					if(globals.debugApp){
						console.log("GetAllPromos-Debug: promo couldnt be used!! in getAllPromos() sync.js");
					}
				}
			}
		}
		else{
			if(globals.debugApp){
				console.log("GetAllPromos-Debug: p.length was null or zero in getAllPromos()" );
			}
		}
	}
	else{
		if(globals.debugApp){
			console.log("GetAllPromos-Debug: Promos or promo images arrays were empty!!! in getAllPromos()" );
		}
	}
	return use;
}


//TODO: This should be inside a angular service instead of a global function and dependency injected
// Get All Services - Function //
//****************************//
//function to get all Services stored on the device
function getAllServices(){ 
	var services = LoadServicesFromAppData('getAllServices()') ? LoadServicesFromAppData('getAllServices()') : null;

	if (!services || services.length < 1){
		//console.log('DEBUG-SYNC: DEFAULT Services was loaded -- getAllServices()');
		services = globals.installServices;

		services.sort(function(a, b){
			return a.SortOrder - b.SortOrder;
		});
		//console.log('DEBUG-SYNC: sorting finished-- getAllServices()');

		//make sure all Services are not selected by default (the user selects and deselects services to filter stores on the stores screen)
		for (var i = 0; i < services.length; i++){
			services[i].Selected = false;
		} 
		if(globals.debugApp){
			console.log('DEBUG-SYNC: defaulting selected finished -- getAllServices()');
		}

	}
	else{
		if(globals.debugApp){
			console.log('DEBUG-SYNC: Services was loaded from file in getAllServices()');
		}
	}
	return services;
}



//TODO: GLOBAL FUNCTION. SHOULD BE USED IN A SERVICE WHEN EVERYTHING IS WORKING AND INJECTED
function getAllStores($scope, trace){ 
	if(globals.debugApp){
		if(trace){
			console.log('DEBUG-SYNC: calling getAllStores() from - ' + trace);
		}
	}

	var stores = LoadStoresFromAppData() ? LoadStoresFromAppData() : null;

	if (!stores || stores.length < 2){
		if(globals.debugApp){
			console.log('DEBUG-SYNC: Using default Store List!! ');
		}
		stores = globals.installStores; //if no stores are saved on the device (due to perhaps lack of internet that caused the sync process to fail or this is the first time using the app and the stores are still being downloaded in the background) then use the stores in js/installTables.js
	}
	else {
		if(globals.debugApp){
			console.log('DEBUG-SYNC: A saved d/l Store List was found!! ');
		}
	}

	var storeservices = LoadStoreServicesFromAppData() ? LoadStoreServicesFromAppData() : null;

	if(globals.debugApp){
		console.log('Store Services Debug: store services was loaded in getAllStores()');
		//console.log('Store Services Debug: store services  = ' + JSON.stringify( storeservices ) ); //Comment out when not debugging Store Services
	}

	if (!storeservices || storeservices.length < 1){
		storeservices = globals.installStoreServices;
		if(globals.debugApp){
			console.log('Store Services Debug: USING DEFAULT store services file ---- in getAllStores()');
		}
	}

	var servicesArr = getAllServices(); // Get all services that were created for the app's services filter

	for (var i = 0; i < stores.length; i++){ //for each store
		var temp = storeservices.filter(function(item){
			return (item.StoreID == stores[i].StoreID);
		}); //get all StoreServices that match this Store's id

		var s;// Get all services that were created for the app's services filter

		s = servicesArr.filter(function(item){
			return (inThisStore(item.ServiceID));
		}); //filter all services to only include services in this store
		
		function inThisStore(serviceid){ //helper function to check if a service is in the current store (by checking if the serviceid is in the temp array of StoreServices which was filtered to only show StoreServices for this store)
			for (var k = 0; k < temp.length; k++){
				if (temp[k].ServiceID == serviceid){
					//console.log('Store Services Debug: Comparing of this pair was True - ' + temp[k].ServiceID + ' / ' + serviceid);
					return true;
				}
				else{
					if(globals.debugApp){
						console.log('Store Services Debug: Comparing of this pair was FALSE !!! - ' + temp[k].ServiceID + ' / ' + serviceid);
					}
				}
			}
			return false;
		}

		stores[i].Services = []; //add a Services property to the store with an empty array
		for (var j = 0; j < s.length; j++){
			stores[i].Services.push(s[j]);
		} //add all the services we found above

		//console.log( "Store Services Debug: FINAL Services injected for this store : " + JSON.stringify( stores[i].Services ) );
	}
	if(globals.debugApp){
		console.log('Finished getting all stores in - getAllStores()');
	}
	return stores;
}


//TODO: Move this method to a service and inject where it is needed
//function for getting interests
function getInterests(){ 
	var interests = GetItemFromLocalData('Interests');

	if (!interests){
		return [];
	}
	else{
		return JSON.parse(interests);
	}
}



// FUNCTION:  PARSE SERVER OK //
//used in js/app.js to determine if the Server is Ready based on the response from the ServerOK web method
function parseServerOK(data) {
	var output;
	if ($(data).find('ServerOKResult').children("Accessed").text() == 'true'){
		output = true;
	}
	else{
		output = false;
	}
	return output;
}



var TempDataVersion;
function setSyncVersion(){
	TempDataVersion = GetItemFromLocalData('DataVersion');
}



//FUNCTION: PARSE SYNC START //
//used in js/app.js to determine if the data versions match (no download sync needed) or not (download sync is needed)
function parseSyncStart(data) {
		var output = false;
		var AlwaysSync = parseInt($(data).find('SyncStartResult').children("AlwaysSync").text());
		var DataVersion = $(data).find('SyncStartResult').children("DataVersion").text();

		//if (AlwaysSync == 1 || DataVersion != window.localStorage.getItem('DataVersion')){
		if(globals.debugApp){
			console.log('DataVersion compared: ' + DataVersion + '  / ' + GetItemFromLocalData('DataVersion') );
		}

		if (AlwaysSync == 1 || DataVersion != GetItemFromLocalData('DataVersion') ){
			TempDataVersion = DataVersion; //set TempDataVersion to the server data version so that the client data version can be updated later (see syncend function on this page)
			output = true;
		}
		return output; //return whether or not we need a download sync
}//END





// FUNCTION: XML TO STRING
function xmlToString(xmlData) {
    var xmlString;
    //IE
    if (window.ActiveXObject){
        xmlString = xmlData.xml;
    }
    // code for Mozilla, Firefox, Opera, etc.
    else{
        xmlString = (new XMLSerializer()).serializeToString(xmlData);
    }
    return xmlString;
}//END




//FUNCTION: SEND PUSH TOKEN TO SERVER //
//AJAX function for downloading promo headers, used only in a download sync, called in js/app.js
var tokenRetry = 0;
function sendPushTokenToServer() {
	$.ajax({ //ajax call for set push web method
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 16000,
		data: soapMessageSetPush(),
		success: function(data){
			saveClientLog(12, 0, 0, 'push token that was received by server : ' + globals.userAccount.get('PushToken') );
			if(globals.debugApp){
				console.log('SUCCESS: push token sent to server: ' + globals.userAccount.get('PushToken') );
			}	
		},
		error: function(error){
			saveClientLog(13, 0, 0, 'push token was not sent to server: ' + error);
			if(globals.debugApp){
				console.log('ERROR: pushing token was not sent to server' + error);
			}

			//push token retry (retry on)
			if(tokenRetry < 4){
				tokenRetry = tokenRetry + 1;
				setTimeout(function(){
					sendPushTokenToServer();
				},10000);
			}
		},
		contentType: "text/xml; charset=utf-8"
	});
} //END



//--------------------//
//  REFRESH METHODS   //
//--------------------//
function refreshClientSet() {
	//console.log("Client Set download Requested");
	var error=false;
	$.ajax({
		url: GetItemFromLocalData('ClientURL'), //the ClientURL we stored earlier
		type: "POST", //Alway use POST, the web service is SOAP based not RESTful
		dataType: "xml", //Always xml, the webservice does not use JSON
		timeout : 30000, //The ajaxTimeout object is defined in js/app.js
		data: soapMessageClientSetAll(), //soap messages are defined in js/soapMessages.js
		success: function(data){ //ajax function successs callback (i.e. the function did not time out for lack of internet or something 
			//else happened that caused an error in the actual web service call like the server is down, ..etc)
			error = false;
			if(globals.debugApp){
				console.log("SUCCESS: REFRESH ClientSet() was downloaded.");
			}

			saveClientLog(90, 0, 0, '', 0, 'SUCCESS: REFRESH ClientSet() was downloaded.');
			var cs = {};

			$(data).find('RClientSetServer').each(function(){ //for each RclientSetServer object in the XML response (for more details on response format for various web methods, see the webservice specification: http://74.208.209.112/Market_GreenSquare_001/WebService/WebService1.asmx)
				var ItemName = $(this).children("ItemName").text(); //The name of the setting
				var ItemValue = $(this).children("ItemValue").text(); //The value of the setting
				cs[ItemName] = ItemValue; //Save the setting as a property of the cs object defined above; the ItemName is the key and the ItemValue is the value
			});

			//save to localStorage, localStorage is basically the local database for this application; 
			//JSON.stringify converts arrays or objects into json string literals, localStorage can only save strings
			SaveClientSetsToAppData( JSON.stringify(cs) );

			refreshStoreList();// Move to storelist now
		},
		error: function(data){
			if(globals.debugApp){
				console.log("ERROR: downloadClientSet() was not downloaded.");
			}
			saveClientLog(91, 0, 0, '', 0, 'ERROR: REFRESH downloadClientSet() was not downloaded.');
		},
		contentType: "text/xml; charset=utf-8"
	}).done(function(){
		if(globals.debugApp){
			console.log("ClientSet download DONE");
		}
	});
} //END


//AJAX function for downloading stores, used only in a download sync
function refreshStoreList(){
	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 20000,
		data: soapMessageStoreListAllByDescript(),
		success: function(data){

			var stuff = []; //local array to hold the stores
			if(globals.debugApp){
				console.log("SUCCESS: Store List was downloaded");
			}

			saveClientLog(94, 0, 0, '', 0, 'SUCCESS: REFRESH Store List was downloaded');
			//console.log('Stores Data: '+xmlToString(data)+"--"+window.localStorage.getItem('ClientURL')+"--"+soapMessageStoreListAllByDescript());

			$(data).find('RStoreServer').each(function(index){
				var StoreID = parseInt($(this).children("StoreID").text());
				var Descript = $(this).children("Descript").text();
				//parseInt is used when saving the value if the expected value is an int

				var Address1 = $(this).children("Address1").text();
				var Address2 = $(this).children("Address2").text();
				var City = $(this).children("City").text();
				var State = $(this).children("State").text();
				var Zip = $(this).children("Zip").text();
				var Phone = $(this).children("Phone").text();
				var Latitude = parseFloat($(this).children("Latitude").text()); //parseFloat is used when saving the value if the expected value is a real number (i.e. not an int but has decimals)
				var Longitude = parseFloat($(this).children("Longitude").text());
				var RegularPrice = Math.round(parseFloat($(this).children("RegularPrice").text())*100)/100; //Math.round limits the decimal number to two places
				var PlusPrice = Math.round(parseFloat($(this).children("PlusPrice").text())*100)/100;
				var PremiumPrice = Math.round(parseFloat($(this).children("PremiumPrice").text())*100)/100;
				var DieselPrice = Math.round(parseFloat($(this).children("DieselPrice").text())*100)/100;
				var KerosenePrice = Math.round(parseFloat($(this).children("KerosenePrice").text())*100)/100;
				var GasLastUpdate = $(this).children("GasLastUpdate").text();
				stuff.push({
					StoreID : StoreID,
					Descript: Descript,
					Address1 : Address1,
					Address2 : Address2,
					City : City,
					State : State,
					Zip : Zip,
					Phone : Phone,
					Latitude : Latitude,
					Longitude : Longitude,
					RegularPrice : RegularPrice,
					PlusPrice : PlusPrice,
					PremiumPrice : PremiumPrice,
					DieselPrice : DieselPrice,
					KerosenePrice : KerosenePrice,
					GasLastUpdate : GasLastUpdate
				});
			});

			//GENERATE timeStamp and store it in rootscope, this is displayed with the redemption
			var currentdate = new Date(); 
			var storesSyncDate = "StoreList last synced: " + getMonth(currentdate) + " " + addOrd(currentdate.getDate()) + " " + " @ " + getTime(currentdate);
		    window.localStorage.setItem('StoresSyncDate', storesSyncDate);

			globals.TempStores = JSON.stringify(stuff); //save the stringified stores in the globals TempStores variable, TempStores will replace local Storage stores in the sync end function
			//we do not save localStorage automatically here so that Stores, Services, and StoreServices are all saved at the same time and are on the same DataVersion

			SaveStoresToAppData( globals.TempStores );
			globals.TempStores = null;

			SetItemInLocalData('StoreListRetry', 0);

			refreshServices();

		},
		error: function(data){
			if(globals.debugApp){
				console.log("ERROR: Store List was not downloaded");
			}
			saveClientLog(93, 0, 0, '', 0, 'ERROR: REFRESH Store List was not downloaded');
			globals.ajaxTimedOut = true;
		},
		contentType: "text/xml; charset=utf-8"
	});
}//END



function refreshStoreServices() {
	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 20000,
		data: soapMessageStoreServiceListAll(),
		success: function(data){
			if(globals.debugApp){
				console.log('SUCCESS: Store services downloaded');
			}

			saveClientLog(95, 0, 0, '', 0, 'SUCCESS: Store services downloaded');
			var stuff = [];

			$(data).find('RStoreServiceServer').each(function(index)
			{
				var ServiceID = $(this).children("ServiceID").text();
				var StoreID = parseInt($(this).children("StoreID").text());
				stuff.push({
					ServiceID : ServiceID,
					StoreID : StoreID
				});
			});

			globals.TempStoreServices = JSON.stringify(stuff);
			SaveStoreServicesToAppData( globals.TempStoreServices );
			globals.TempStoreServices = null;
		},
		error: function(data){
			if(globals.debugApp){
				console.log('ERROR: Store services was not downloaded');
			}
			saveClientLog(96, 0, 0, '', 0, 'ERROR: Store services was not downloaded');
			globals.ajaxTimedOut = true;
		},
		contentType: "text/xml; charset=utf-8"
	});
}


function refreshServices() {
	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 20000,
		data: soapMessageServiceListAll(),
		success: function(data){
			if(globals.debugApp){
				console.log('SUCCESS: REFRESH Services downloaded');
			}
			saveClientLog(97, 0, 0, '', 0, 'SUCCESS: REFRESH Services downloaded');
			var stuff = [];

			$(data).find('RServiceServer').each(function(index){
				var ServiceID = $(this).children("ServiceID").text();
				var Descript1 = $(this).children("Descript1").text();
				var SortOrder = parseInt($(this).children("SortOrder").text());
				stuff.push({
					ServiceID : ServiceID,
					Descript1 : Descript1,
					SortOrder : SortOrder
				});
			});

			globals.TempServices = JSON.stringify(stuff);
			SaveServicesToAppData( globals.TempServices );
			globals.TempServices = null;

			refreshStoreServices();
		},
		error: function(data){
			if(globals.debugApp){
				console.log('ERROR: Services was not downloaded');
			}
			saveClientLog(97, 0, 0, '', 0, 'ERROR: Services was not downloaded');
			globals.ajaxTimedOut = true;
		},
		contentType: "text/xml; charset=utf-8"
	});
}//END




function refreshPromoHead($scope, $rootScope, $timeout, $compile, type){
	if(globals.debugApp){
		console.log("refreshPromoHead()  initiated");
	}

	var error = false;

	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 20000,
		data: soapMessagePromoHeadListAll(),
		success: function(data){
			if(globals.debugApp){
				console.log("SUCCESS: REFRESH Promo Head Downloaded via refreshPromoHead()");
			}

			saveClientLog(97, 0, 0, '', 0, 'ERROR: REFRESH Promo Head Downloaded via refreshPromoHead()');
			error = false;
			var stuff = [];
			$(data).find('RPromoHeadServer').each(function(index){
				var HeadID = $(this).children("HeadID").text();
				var Descript1 = $(this).children("Descript1").text();
				var SortOrder = parseInt($(this).children("SortOrder").text());
				//console.log("promo header received: " + HeadID + ":" + Descript1 + ":" + SortOrder);

				stuff.push({
					HeadID : HeadID,
					Descript1 : Descript1,
					SortOrder : SortOrder
				});
			});

			SaveHeadersToAppData( JSON.stringify(stuff) );
		},
		error: function(data){
			if(globals.debugApp){
				console.log("ERROR: REFRESH Promo Head was not Downloaded");
			}

			saveClientLog(98, 0, 0, '', 0, 'ERROR: REFRESH Promo Head was not Downloaded');

			setTimeout(function(){	
				screenRefresh($scope, $rootScope, $timeout, $compile, type);
			}, 1000);
		},
		contentType: "text/xml; charset=utf-8"
	}).done(function(){
		if(globals.debugApp){
			console.log("refreshPromoHead()  DONE - going into refreshPromo()");
		}

		refreshPromo($scope, $rootScope, $timeout, $compile, type); //if no ajax error was thrown, go onto downloadpromo
	});
}//END


function storeRefresh(){
	refreshClientSet(); //starts with Clientsets and ends with Store Services
}

function storeRefreshFinished(){

	globals.Stores = getAllStores();

	setTimeout(function(){
		var scope = angular.element($("#storesDirective")).scope();
		scope.showLatestStoreData();
	}, 10);

	setTimeout(function(){
		$('#storesLoading').animate({opacity:0}, 400);
		$('#storeList').listview('refresh');

		setTimeout(function(){
			$('#storesLoading').hide();
			window.wizSpinner.hide();
			$('#storeList').listview('refresh');

			if(globals.debugApp){
				console.log("ListView Refreshed! ");
			}
		}, 400); // about 3 secs is needed for showlateststoredata
	}, 400);
}


//TODO - Create logic to delete unused PromoImages from PromoImage array
function refreshPromo($scope, $rootScope, $timeout, $compile, type){ 
	var error;

	$.ajax({
		url: GetItemFromLocalData('ClientURL'),
		type: "POST",
		dataType: "xml",
		timeout : 35000,
		data: soapMessagePromoList2(),
		success: function(data){
			if(globals.debugApp){
				console.log("SUCCESS: REFRESH Promos downloaded");
			}

			saveClientLog(99, 0, 0, '', 0, 'SUCCESS: REFRESH Promos downloaded');
			error = false;
			var savepromos = []; //the promos that will be saved to localstorage
			var newpromos = [];	//promos that are new
			var savepromostores = []; //promostores that will be saved to localstorage
			//gets the promoimage object from localstorage or creates a new one if not available, JSON.parse converts a string into a javascript array or object (it is the opposite of JSON.stringify)
			var PromoImages = LoadPromoImagesFromAppData() ? LoadPromoImagesFromAppData() : {}; 

			var promoImagesDone = 0; //indicates how many promo images have been downloaded from the server

			$(data).find('RPromoServer2').each(function(index){
				var PromoID = $(this).children("PromoID").text();
				var preDescText=$(this).children("Descript1").text();
				var Descript1 =preDescText;
				var Descript2 = $(this).children("Descript2").text();
				var PromoType = parseInt($(this).children("PromoType").text());
				var HeadID = $(this).children("HeadID").text();
				var InterestID = $(this).children("InterestID").text();
				var PromoStore = parseInt($(this).children("PromoStore").text());
				var PromoUse = parseInt($(this).children("PromoUse").text());
				var PromoAccount = parseInt($(this).children("PromoAccount").text());
				var DateStart = ticksToEpoch(parseInt($(this).children("DateStartTicks").text()));
				var DateEnd = ticksToEpoch(parseInt($(this).children("DateEndTicks").text()));
				var DisplaySec = parseInt($(this).children("DisplaySec").text());
				var Uses = parseInt($(this).children("Uses").text());
				var AccountUses = parseInt($(this).children("AccountUses").text());
				var Age = parseInt($(this).children("Age").text());
				var Points = parseInt($(this).children("Points").text());
				var DetailHTMLFile = $(this).children("DetailHTMLFile").text();
				var PhotoFile = $(this).children("PhotoFile").text();
				var ThumbFile = $(this).children("ThumbFile").text();
				var DescriptPush = $(this).children("DescriptPush").text();
				var FocusTime = $(this).children("FocusTime").text();

				if(InterestID){
					if(globals.debugApp){
						console.log("InterestID " + InterestID + " for " + Descript1 + " (Warning! this promo is using an Interest only ID!");
					}
				}

				if (FocusTime){
					FocusTime = parseInt(FocusTime); //focus time indicates if this promotion can be used in the focus now module: 0 indicates no, 1 is breakfast, 2 is lunch, 3 is dinner, and 4 is late night
				}
				else{
					FocusTime = 0;
				}

				var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;

				if ((Uses == 0 || AccountUses < Uses) && now > DateStart && now < DateEnd){ 
				//make sure the promotion is valid (i.e. today's date is between the promo start and end date, also make sure the promo 
				//is not a redeemable promo with zero 'Uses' OR that the user has enough AccountUses to redeem the promotion)
					savepromos.push({
						PromoID : PromoID,
						Descript1 : Descript1,
						Descript2 : Descript2,
						PromoType : PromoType,
						HeadID : HeadID,
						InterestID : InterestID,
						PromoStore : PromoStore,
						PromoUse : PromoUse,
						PromoAccount : PromoAccount,
						DateStart : DateStart,
						DateEnd : DateEnd,
						DisplaySec : DisplaySec,
						Uses : Uses,
						AccountUses : AccountUses,
						Age : Age,
						Points : Points,
						DetailHTMLFile : DetailHTMLFile,
						PhotoFile : PhotoFile,
						ThumbFile : ThumbFile,
						DescriptPush : DescriptPush,
						FocusTime : FocusTime
					});
				}
				else{
					if(globals.debugApp){
						console.log("Promo is either invalid (date/uses) or not redeemable (event): " + PromoID);
					}
				}
			});

			//GENERATE timeStamp and store it in rootscope, this is displayed with the redemption
			var currentdate = new Date(); 
			var promosSyncDate = "Promos last synced: " + getMonth(currentdate) + " " + addOrd(currentdate.getDate()) + " " + " @ " + getTime(currentdate);
		    window.localStorage.setItem('PromosSyncDate', promosSyncDate);

		    var op =  LoadPromosFromAppData() ? LoadPromosFromAppData() : null; 

		    if(!PromoImages){ //Check to see if PromoImages are empty, if so then Old promos array has to be null
		    	op = null;
		    	PromoImages = {};
		    	if(globals.debugApp){
		    		console.log("promo images arr was empty. grabbing all images");
		    	}
		    }

		    if( op != null ){ // Check to see if old promos exist
		    	var oldpromos = op;
		    	if(globals.debugApp){
		    		console.log("There were Old promos grab");
		    	}
		    }else{
		    	var oldpromos = null;
		    }

			//determine which promos are new (i.e. they have not been saved to the app before)
			for (var i = 0; i < savepromos.length; i++){
				if (!inPromos(savepromos[i].PromoID, oldpromos)){
					newpromos.push(savepromos[i]);
				}
			} 

			if (newpromos.length > 0){
				$(data).find('RPromoStoreServer2').each(function(index){
					var PromoID = $(this).children("PromoID").text();
					var StoreID = parseInt($(this).children('StoreID').text());
					savepromostores.push({
						PromoID : PromoID,
						StoreID : StoreID
					});
				});
			}

			// Check for new Image Files, if there are any we need to download them by adding that promo to 'savedpromos' 
			if( oldpromos != null ){ // Check to see if old promos exist
		    	//A block of code to detect a change of promo image name, if there is one
		    	for (var i = 0; i < savepromos.length; i++){
		    		//Check if saved and old promos have the same PromoID
					for (var j = 0; j < oldpromos.length; j++){
						if (oldpromos[j].PromoID == savepromos[i].PromoID){
						
							//CHeck if promos do not contain the same image name, if not then
							if(savepromos[i].PhotoFile != oldpromos[j].PhotoFile){
								if(globals.debugApp){
									console.log("Sync-Debug: !! A new photofile was found for an Old Promo. Let's update it..");
								}
								newpromos.push(savepromos[i]);//push this promo into new promos so the image will be updated
							}
						}
					}
				} 
		    }


			if (newpromos.length > 0){
				//download and save all promostores if there are any new promotions, we do not only download promostores for newpromos 
				//because the logic to check whether or not this promostore is for a new or old promo would likely be slower than just 
				//downloading and saving all of them
				//Clear Promos
				SavePromoStoresToAppData(JSON.stringify(savepromostores));
				promoImagesDone = 0;
				var i = 0;

				downloadPromoImage(newpromos, i, function(){

					if(promoImagesDone >= newpromos.length){ //success call back for the downloadpromoimage function, if all the new promo images have been downloaded then save them and call promosDone function (defined below)
						
						if(globals.debugApp){
							console.log("SUCCESS in downloading all new promo imgs.");
						}

						saveClientLog(89, 0, 0, 'SUCCESS in downloading all new promo imgs.' );

						if (!error){ 
							//if there are any promos to be saved, save them to localStorage
							SavePromoImagesToAppData( JSON.stringify(PromoImages) ); //Save Promo images
							SavePromosToAppData(JSON.stringify(savepromos)); 

							SaveAppDataJson(); //SAVE DATA
						}
						else{
							if(globals.debugApp){
								console.log("error in Refresh Promos: " + error);
							}
						}

						storeRefresh();
						setTimeout(function(){
							$scope.Headers = getAllHeadersWithPromos('refreshPromos()'); 

							setTimeout(function(){
								$scope.Promos = getAllPromos(0,'refreshPromos()');
									
								setTimeout(function(){	
									if(type == 0){ // type is to tell whether its for Prizes or Promos
										promoPageEvoke($scope, 1);
									}
									else{
										prizePageEvoke($scope, $rootScope, $timeout, $compile);
									}
								}, 1200);
							}, 100);
						}, 1000);	

						if(globals.debugApp){
							console.log("SUCCESS: Promos/StoreList/Services/StoreServices were refreshed");
						}
						
					}
				}, function(){  //error call back for the download promo image function

					error = true;
					if(globals.debugApp){
						console.log("ERROR in downloading promo imgs in Promo Refresh");
					}

					saveClientLog(88, 0, 0, 'ERROR in downloading promo imgs in Promo Refresh' );
				});

				
			}
			else{
				if(globals.debugApp){
					console.log("SUCCESS.. promos that were expired or invalid were just removed.");
				}

				saveClientLog(89, 0, 0, 'SUCCESS.. promos that were expired or invalid were just removed.' );

				if (!error){ 
					//if there are any promos to be saved, save them to localStorage
					SavePromoImagesToAppData( JSON.stringify(PromoImages) ); //Save Promo images
					SavePromosToAppData(JSON.stringify(savepromos)); 
					SaveAppDataJson(); //SAVE DATA
				}
				else{
					if(globals.debugApp){
						console.log("error in Refresh Promos: " + error);
					}
					//have alert here..
				}

				
				setTimeout(function(){
					$scope.Headers = getAllHeadersWithPromos('refreshPromos()'); 

					setTimeout(function(){
						$scope.Promos = getAllPromos(0,'refreshPromos()');
							
						setTimeout(function(){	
							if(type == 0){ // type is to tell whether its for Prizes or Promos
								promoPageEvoke($scope, 1); //send 1 to trigger the evoke immediately
							}
							else{
								prizePageEvoke($scope, $rootScope, $timeout, $compile);
							}
						}, 1000);
					}, 100);
				}, 1000);	

				if(globals.debugApp){
					console.log("SUCCESS: Promos/StoreList/Services/StoreServices were refreshed");
				}
			}
			


			function downloadPromoImage(photo, counter, callback, errorcallback){ //helper function for downloading a promo image
				if(counter < newpromos.length){
					if(globals.debugApp){
						console.log('Debug: image download test [' + counter + '] - ' + photo[counter].PhotoFile ); 
					}

					$.ajax({
						url: GetItemFromLocalData('ClientURL'),
						type: "POST",
						dataType: "xml",
						timeout : 40000,
						data: soapMessageGetFileChunk('Image', photo[counter].PhotoFile), //this as well as the function updateGameAssets (in js/app.js) uses the GetFileChunk web method which returns the image as a base64 encoded string
						success: function(data){
							if(globals.debugApp){
								console.log("SUCCESS: A promo-image was downloaded via downloadpromoimage()");
							}
							saveClientLog(44, 0, 0, "SUCCESS: A promo-image was downloaded via downloadpromoimage()");

							var error = $(data).find('Standard').children('MethodErrorLevel').text();
							if (error == "None"){
								if (photo[counter].PhotoFile.substring(photo[counter].PhotoFile.indexOf('.') + 1) == 'png'){ //check if the photofile name is png or jpg and save accordingly
									PromoImages[photo[counter].PhotoFile] = "data:image/png;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();
								}
								else{
									PromoImages[photo[counter].PhotoFile] = "data:image/jpeg;base64," + $(data).find('GetFileChunkResult').children('FilePart').text();
								}
								promoImagesDone++; //increments promoImagesDone which is used in the success call back to determine if all promo images have been downloaded
								
								if(globals.debugApp){
									console.log("Image Download successful (line1059/sync.js) : " + photo[counter].PhotoFile +  "  :  "+ promoImagesDone);
								}
							}
							else{
								if(globals.debugApp){
									console.log("ERROR: could not download promo image: "  + photo[counter].PhotoFile + " - Error = " + error);
								}
								saveClientLog(45, 0, 0, "ERROR: promo image downloaded but caused an error: "  + photo[counter].PhotoFile + " - Error = " + error);
							}

							var next = counter + 1;
							callback();

							downloadPromoImage(photo, next, callback, errorcallback);
						},
						contentType: "text/xml; charset=utf-8",
						error: function(data){
							//var next = counter + 1;
							if(globals.debugApp){
								console.log("error! in downloadPromoImage()");
								console.log("ERROR: could not connect to download promo image: "  + photo[counter].Photofile + " - Error = " + data);
							}
							saveClientLog(46, 0, 0, "ERROR: could not connect to download promo image: "  + photo[counter].Photofile + " - Error = " + data);
							errorcallback();
						}
					});
				}
			}

			function inPromos(promoid, promos){ //helper function to check if a promoid is in a promos array
				if (!promos){
					return false;
				}
				for (var i = 0; i < promos.length; i++){
					if (promos[i].PromoID == promoid){
						return true;
					}
				}
				return false;
			}

		},
		error: function(data){
			if(globals.debugApp){
				console.log("ERROR: in Refresh downloadPromo()");
			}
			saveClientLog(59, 0, 0, '', 0, 'ERROR: in Refresh downloadPromo()');

			setTimeout(function(){	
				screenRefresh($scope, $rootScope, $timeout, $compile);
			}, 1000);
		},
		contentType: "text/xml; charset=utf-8"
	});
}

function saveStoreData(){
	if (globals.TempStores){
		SaveStoresToAppData(globals.TempStores);
	}
	
	if (globals.TempStoreServices){
		SaveStoreServicesToAppData(globals.TempStoreServices);
	}
	
	if (globals.TempServices){
		SaveServicesToAppData( globals.TempServices );
	}
	
	SaveAppDataJson(); 

	if(globals.debugApp){
		console.log('SYNC-END - DEBUG : ## ALL STORE/SERVICES DATA was Saved..');
	}

	globals.TempStores = null;
	globals.TempServices = null;
	globals.TempStoreServices = null;
}


//Used in setupLocalData($rootScope) when a full download sync is flagged
function clearStoreAndPromoData(){
	DeletePromoImagesJson();
	DeletePromosJson();
	DeletePromoStoresJson();
	DeleteHeadersJson();
	DeleteStoresJson();
	DeleteStoreServicesJson();
	DeleteServicesJson();
	DeleteClientSetsJson();

	SaveAppDataJson();
}



function ClearDataAndLogOut(){
	DeleteAppData();
}




// FUNCTION DECRYPT ACCOUNT IF //
//helper function to decrypt accountid, used in js/soapMessages.js
function decryptAccountID() {
	if (globals.userAccount.get('AccountID') != ''){
		if(globals.debugApp){
			console.log('AccountID utilized : ' + sjcl.decrypt("AccountID", globals.userAccount.get('AccountID') ) );
		}

		return sjcl.decrypt("AccountID", globals.userAccount.get('AccountID') );
	}
	else{
		if(globals.debugApp){
			console.log('AccountID utilized : Empty');
		}
		return '';
	}
}



// FUNCTION SAVE ACCOUNT DETAIL //
//helper function to save save account details, used in js/app.js in web methods that return the account object as 
//part of the response (such as SyncStart, LinkAccount, CreateAccount, ChangeAccountDetail, GetAccountID) 
function saveAccountDetailJson(data){
	var AccountID = $(data).find("AccountID").text();
	var Email = $(data).find("Email").text();
	var FullName = $(data).find("FullName").text();
	var Phone = $(data).find("Phone").text();
	var UniqueID = parseInt($(data).find("UniqueID").text());
	var Points = parseInt($(data).find("Points").text());
	var GamePlays = parseInt($(data).find("GamePlays").text());
	var UserType = $(data).find("UserType").text();
	var UserStatus = $(data).find("UserStatus").text();
	var Birthday = $(data).find("Birthday").text();

	if(globals.debugApp){
		console.log("AccountID received from server : " + AccountID);
		console.log("Email received from server : " + Email);
		console.log("FullName received from server : " + FullName);
		console.log("Points received from server : " + Points);
		console.log("Gameplays received from server : " + GamePlays);
	}

	if (Birthday != "0001-01-01T00:00:00"){ //make sure the birthday is set
		var BirthdayTicks = ticksToEpoch(parseInt($(data).find("BirthdayTicks").text())); //see below for details about ticksToEpoch
	}
	else{
		BirthdayTicks = 0; //if the user has not specified a birthday, save birthday as 0
	}

	var GeoPromo = parseInt($(data).find("GeoPromo").text());
	var encryptedAccountID = sjcl.encrypt("AccountID", AccountID); //always encrypt AccountID before saving

	SetItemInLocalData('AccountID', encryptedAccountID);
	SetItemInLocalData('Email', Email);
	SetItemInLocalData('FullName', FullName);
	SetItemInLocalData('Phone', Phone);
	SetItemInLocalData('UniqueID', UniqueID);
	SetItemInLocalData('Points', Points);
	SetItemInLocalData('GamePlays', GamePlays);
	SetItemInLocalData('UserType', UserType);
	SetItemInLocalData('Birthday', Birthday);
	SetItemInLocalData('GeoPromo', GeoPromo);
	window.localStorage.setItem('FullName', FullName);

	saveInterests(data); // Function below
}


// FUNCTION: SAVE INTERESTS //
//helper function for saving the user's interests (returned as part of the Account object in the XML response)
function saveInterests(data){
	var Interests = [];
	$(data).find('RInterestServer').each(function(){
		var InterestID = $(this).children("InterestID").text();
		var Descript1 = $(this).children("Descript1").text();
		var Selected = parseInt($(this).children("Selected").text());
		Interests.push({
			InterestID:InterestID,
			Descript1:Descript1,
			Selected:Selected
		});
	});

	SetItemInLocalData('Interests', JSON.stringify(Interests) );
	saveLocalData();
}



//   FUNTION: SAVE CLIENT LOG   //
//  SAVE CLENTLOG IN LOCAL DATA //
function saveClientLog(logtype, promoid, storeid, beaconudid, beaconloc, comment){ //function used throughout the app to save client log, clientlogs are pushed to the server (see js/app/js) after every sync
	//these are helpful for monitoring errors. To query for errors on the server, search for client logs or type 1
	var soap = soapMessageClientLog(logtype, promoid, storeid, beaconudid, beaconloc, comment);
	//var clientlog = window.localStorage.getItem('ClientLog');
	var clientlog = GetItemFromLocalData('ClientLog');

	if (clientlog == null){
		SetItemInLocalData('ClientLog', soap );
	}
	else{
		clientlog = clientlog + soap;
		//window.localStorage.setItem('ClientLog', clientlog);
		SetItemInLocalData('ClientLog', clientlog );
	}
}


//this function is used throughout the app to reset the scrollbar when page content changes, it is important to
//reset the scroll bar everytime something shows or hides
function resetScrollbar(){
	try{
		$('.ui-content').iscrollview('refresh');
	}
	catch (err){}
}


// FUNCTION: ALERT //
//redefined the regular javascript alert method to call the native notification plugin and call a 
//custom callback function
function alert(message, callback){
	navigator.notification.alert(
	    message,  // message
	    function(){
	    	callback();
	    },         // callback
	    'Error',            // title
	    'Ok'                  // buttonName
	);
} 


function autoTruncate(length, classToFind){
	var len = length;
	var p = document.getElementsByClassName(classToFind).innerHTML;

	if(p){
		for(var i=0; i < p.length; i++){

	  		var trunc = p[i];
		  	if (trunc.length > len){
		    /* Truncate the content of the P, then go back to the end of the
		       previous word to ensure that we don't truncate in the middle of
		       a word */
		    trunc = trunc.substring(0, len);
		    trunc = trunc.replace(/\w+$/, '');
		    p[i] = trunc;
		   }
	    }
	}
}

function removeFromArray(arr, what) {
    var found = arr.indexOf(what);

    while (found !== -1) {
        arr.splice(found, 1);
        found = arr.indexOf(what);
    }
}




// FUNCTIONS EPOCH TO TICKS and TICKS TO EPOCH
//The below two helper functions convert between "Ticks" which are sent back from the server for Dates/Times (e.x. BirthdayTicks) 
//which represent C# ticks and "Epoch" which is Unix epoch time
function epochToTicks(e){
	return (e * 10000) + 621355968000000000;
}
function ticksToEpoch(t){
    return (t - 621355968000000000) / 10000;
}


function addOrd(n) { //helper method for the timestamp of a redemption
		var ords = [,'st','nd','rd'];
		var ord, m = n%100;
	return n + ((m > 10 && m < 14)? 'th' : ords[m%10] || 'th');
}
function getMonth(currentdate){ //helper method for the timestamp of a redemption
	var monthNames = ["January", "February", "March", "April", "May", "June", "July", "August", 
	"September", "October", "November", "December"];

	return monthNames[currentdate.getMonth()];
}
function getMinutes(n){ //helper method for the timestamp of a redemption
	if(n < 10){
		return '0' + n;
	}
	else{
		return n;
	}
}
function getTime(currentdate){ //helper method for the timestamp of a redemption
	if( currentdate.getHours() < 12 ){
		return currentdate.getHours() + ":" + getMinutes( currentdate.getMinutes() ) + "am"; 
	}
	else{
		if(currentdate.getHours() > 12){
			return ( currentdate.getHours() - 12 ) + ":" + getMinutes( currentdate.getMinutes() ) + "pm"; 
		}
		else{
			return currentdate.getHours()  + ":" + getMinutes( currentdate.getMinutes() ) + "pm"; 
		}
	}
}




(function(){
	angular.module('connect.store.feedback', []);
})();
(function() {
	angular.module('connect.store.feedback')
		.directive('storeFeedback', storeFeedbackDirective)
		.controller('FeedbackController', storeFeedbackController);

	storeFeedbackDirective.$inject = [];

	storeFeedbackController.$inject = ['$scope', '$rootScope', '$http', '$timeout', 'Loading'];

	function storeFeedbackDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'storeFeedback/connect.store.feedback.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) { }
	}

	function storeFeedbackController($scope, $rootScope, $http, $timeout, Loading) {
		$scope.Contact = 0;

		$scope.editContact = function() {
			if ($scope.Contact){
				$scope.Contact = 0;
			}
			else{
				$scope.Contact = 1;
			}
			resetScrollbar();
		};

		$('#feedback').on('pageshow', function() {
			if ($rootScope.FeedbackStore) {
				$('#feedbackStoreID').val($rootScope.FeedbackStore.StoreID);
				$('#feedbackStoreID').selectmenu('refresh', true);
			} else if ($rootScope.inStore) {
				$('#feedbackStoreID').val($rootScope.inStore.StoreID);
				$('#feedbackStoreID').selectmenu('refresh', true);
			} else {
				$('#feedbackStoreID').val("");
				$('#feedbackStoreID').selectmenu('refresh', true);
			}
		});

		$('#feedback').on('pagehide', function() {
			$rootScope.FeedbackStore = null;
		});

		$rootScope.FeedbackBack = false;
		$scope.Submit = false;

		Loading.then(function() {
			$timeout(function(){
				$scope.Stores = globals.Stores;
			}, 1);
		});

		$scope.Send = function() {
			$scope.Submit = true;
			if (!$('#feedbackForm').hasClass('ng-invalid')) {
				
				if (window.device.platform == 'Android'){
					var options = {
						label : "Sending Feedback..."
					};
				}
				else{
					var options = {
						label : "Sending Feedback..",
						color : '#000',
						spinnerColor : '#000'
					}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
				} 
				window.wizSpinner.show(options);

				if ($rootScope.AppFeedback) {
					var storeID = 0;
					var Latitude = 0;
					var Longitude = 0;
					var Accuracy = 0;
					var feedbackType = 1;
					//Append User Device info
					$scope.Comment = $scope.Comment + "\n.. App Version: " + globals.appVersion + ". Device Platform: " + window.device.platform + ". OS Version: " + window.device.version + ". Make: " + window.device.manufacturer + ".";

				} else {
					if ($('#feedbackStoreID').val() == undefined)
						var storeID = 0;
					else
						var storeID = $('#feedbackStoreID').val();

					var Latitude = $rootScope.Latitude;
					var Longitude = $rootScope.Longitude;
					var Accuracy = $rootScope.Accuracy;
					var feedbackType = 0;
				}
				if ($scope.Rating == undefined)
					$scope.Rating = 0;
				if ($rootScope.RegisteredUser) {

					$scope.Name = GetItemFromLocalData('FullName');
					$scope.Email = GetItemFromLocalData('Email');
					$scope.Phone = GetItemFromLocalData('Phone');
				} 
				else if (!$scope.Contact) {
					$scope.Name = '';
					$scope.Email = '';
					$scope.Phone = '';
				}
				
				//lod ID to send
				var LogID = uuid.v1();

				//Message to send
				var FeedbackMessage = soapMessageSaveFeedback(LogID, storeID, $scope.Contact, $scope.Name, $scope.Email, $scope.Phone, parseInt($scope.Rating), $scope.Comment, Latitude, Longitude, Accuracy, feedbackType);
				
				$http.post(GetItemFromLocalData('ClientURL'), FeedbackMessage, {timeout: 18000}).then(function(response) {

					$scope.Submit = false;
					$('#feedbackStoreID').val('');
					$('#feedbackStoreID').selectmenu('refresh', true);
					$('#feedbackRating').val('');
					$('#feedbackRating').selectmenu('refresh', true);
					$scope.Rating = 0;
					$scope.Contact = 0;
					$('#feedbackContact').attr('checked', false).checkboxradio('refresh');
					$scope.Name = '';
					$scope.Email = '';
					$scope.Phone = '';
					$scope.Comment = '';
					
					window.wizSpinner.hide();

					navigator.notification.alert(
						'Your feedback has been received.', // message
						function() {
							if ($rootScope.AppFeedback) {
								$.mobile.back();
								setTimeout(function() {
									$.mobile.back();
									setTimeout(function() {
										$.mobile.back();
									}, 250);
								}, 250);
							} else {
								$.mobile.back();
								setTimeout(function() {
									if ($.mobile.activePage.attr('id') == 'feedbackprompt') {
										$.mobile.back();
									}
								}, 250);
							}
						}, // callback
						'Thank You!', // title
						'Ok' // buttonName
					);
				}, function(error) {
					$scope.Submit = false;
					$('#feedbackStoreID').val('');
					$('#feedbackStoreID').selectmenu('refresh', true);
					$('#feedbackRating').val('');
					$('#feedbackRating').selectmenu('refresh', true);
					$scope.Rating = 0;
					$scope.Contact = 0;
					$('#feedbackContact').attr('checked', false).checkboxradio('refresh');
					$scope.Name = '';
					$scope.Email = '';
					$scope.Phone = '';
					$scope.Comment = '';

					window.wizSpinner.hide();
					navigator.notification.alert(
						'Your feedback has been recorded.', // message
						function() {
							if ($rootScope.AppFeedback) {
								$.mobile.back();
								setTimeout(function() {
									$.mobile.back();
									setTimeout(function() {
										$.mobile.back();
									}, 250);
								}, 250);
							} else {
								$.mobile.back();
								setTimeout(function() {
									if ($.mobile.activePage.attr('id') == 'feedbackprompt') {
										$.mobile.back();
									}
								}, 250);
							}
							
							var FeedbackSoapMessages = localStorage.getItem('Feedback') ? JSON.parse(window.localStorage.getItem('Feedback')) : null;
							//var FeedbackSoapMessages = GetItemFromLocalData('Feedback') ? JSON.parse( GetItemFromLocalData('Feedback') ) : null;

							window.localStorage.removeItem('Feedback');
							//SetItemInLocalData('Feedback', null);

							if (!FeedbackSoapMessages)
								FeedbackSoapMessages = [];

							FeedbackSoapMessages.push(FeedbackMessage);

							window.localStorage.setItem('Feedback', JSON.stringify(FeedbackSoapMessages) );
							//SetItemInLocalData('Feedback', JSON.stringify(FeedbackSoapMessages) );
							
						}, // callback
						'Thank You!', // title
						'Ok' // buttonName
					);
				});
			}
		};
		$(".feedbackInput").keydown(function() {
			if (event.keyCode == 13) {
				$scope.Send();
			}
		});

	}
})();
(function(){
	angular.module('connect.storeservice', []);
})();
(function() {
	angular.module('connect.storeservice')
		.directive('storeService', storeServiceDirective)
		.controller('StoreServiceController', storeServiceController);

	storeServiceDirective.$inject = [];

	storeServiceController.$inject = ['$rootScope', 'Loading', '$scope', '$compile'];

	function storeServiceDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'storeService/connect.storeservice.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) {  }
	}

	function storeServiceController($rootScope, Loading, $scope, $compile) {
		Loading.then(function() {
			setTimeout(function() {
				$rootScope.Services = getAllServices();
			},1)
		});

		$("#storeservice").on('pageinit', function(){
			var width = $(window).width();
			$("#StoreServDirective .ui-content").css('width', width * .9 );
			$("#StoreServDirective #ServicesWrapper").css('margin', '10px' );
			$("#StoreServDirective #ServicesWrapper").css('width', width * .9);
		});


		$scope.showLatestServicesData = function(){
			
			$rootScope.Services = getAllServices();
			console.log('Sync Debug: Refreshing Services Page - showLatestServicesData()');
			
			setTimeout(function(){
				$rootScope.$apply();

				setTimeout(function(){
					if($('#storeSerContent').iscrollview() ){
						$('#storeSerContent').iscrollview('refresh');
					}
					$scope.$broadcast("REFRESH");
				}, 20);
			}, 50);
		}

	}

})();
(function(){
	angular.module('connect.store', []);
})();
(function() {
	angular.module('connect.store')
		.directive('connectStore', storeDirective)
		.controller('StoreController', storeController);

	storeDirective.$inject = [];
	storeController.$inject = ['$scope', '$rootScope', '$timeout', 'ClientSet', 'GeoLocation', 'Loading', '$compile'];


	function storeDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'store/connect.store.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) { }
	}

	function storeController($scope, $rootScope, $timeout, ClientSet, GeoLocation, Loading, $compile) {

		$scope.storeRefreshBut = function(){

			if(globals.debugApp){
				console.log("Refresh in Store List was Called! ");
			}

			if (window.device.platform == 'Android'){
				var options = {
					label : "Updating Store List"
				};
			}
			else{
				var options = {
					label : "Updating Store List",
					color : '#000',
					spinnerColor : '#000'
				}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
			} 
			
			$('#storesLoading').show();
			$('#storesLoading').animate({opacity:1}, 400);
			window.wizSpinner.show(options);

			storeRefresh();

			setTimeout(function(){
				var scope = angular.element($("#storesDirective")).scope();
				scope.showLatestStoreData();

				setTimeout(function(){
					$('#storesLoading').animate({opacity:0}, 400);
					$('#storeList').listview('refresh');

					setTimeout(function(){
						setTimeout(function(){
							//servicesPageEvoke($scope);
							$rootScope.$apply();
						}, 100);

						$('#storesLoading').hide();
						window.wizSpinner.hide();
						$('#storeList').listview('refresh');

						if(globals.debugApp){
							console.log("ListView Refreshed! ");
						}
					}, 400); // about 3 secs is needed for showlateststoredata
				}, 700);
			}, 4000);

			setTimeout(function(){
				$('#storeList').listview('refresh');
			}, 6000);
		};

		
		$('#stores').on('pageinit', function($scope){

			if (window.device.platform == 'Android'){
				var options = {
					label : "Displaying Store List"
				};
			}
			else{
				var options = {
					label : "Displaying Store List",
					color : '#000',
					spinnerColor : '#000'
				}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
			} 

			$('#storesLoading').show();
			window.wizSpinner.show(options);

			//Now Screen Resize
			var height = $(window).height() - 17;
			$('#storesContent').css('height', height - $('#stores .ui-header').height() - $('#stores .ui-footer').height()  );

			var content = height - $('#stores .ui-header').height() - $('#stores .ui-footer').height();
			$('#optionsBox').css('height', content * .19 );
			$('#map').css('height', content - $('#optionsBox').height() );
			$('#storeList').css('height', content - $('#optionsBox').height() ); 
		});


		$("#stores").one('pageshow', function($scope){

			var scope = angular.element($("#storesDirective")).scope();
			scope.showLatestStoreData();

			if (window.device.platform == 'Android'){
				setTimeout(function(){
					$('#storesLoading').hide();
					window.wizSpinner.hide();
					$('#storeList').listview('refresh');

					if(globals.debugApp){
						console.log("ListView Refreshed! ");
					}
				}, 1000); // about 3 secs is needed for showlateststoredata
				
				setTimeout(function(){
					$('#storeList').listview('refresh');
				}, 2000);
			}
			else{
				setTimeout(function(){
					$('#storeList').listview('refresh');
					$('#storesLoading').hide();
					window.wizSpinner.hide();
				}, 1000);
				setTimeout(function(){
					$('#storeList').listview('refresh');
				}, 2000);
			}
		});



		$("#stores").on('pageshow', function($scope){
			//storeList
			if ($('#map').is(':visible')){
				$('#mapbutton').removeClass('ui-btn-active');
				$('#mapbutton').addClass('ui-btn-active');
			}
			else{
				$('#listbutton').removeClass('ui-btn-active');
				$('#listbutton').addClass('ui-btn-active');
			} 
			$('#storeList').listview('refresh');
		});	//highlight the map or list toggle button on pageshow based on which element (map or list) is shown (currently not working, 
		//bug added to pivotal tracker)

		$scope.chainFriendly = globals.Change.chainFriendly;

		$scope.Call = function(store) {
			window.location.href = 'tel:' + store.Phone;
			saveClientLog(53, store.StoreID, 0, '', 0, 'calling store');
		};
		$scope.Navigate = function(store) {
			if (window.device.platform == 'Android') {
				PhoneNavigator.doNavigate(store.Latitude, store.Longitude, function() {}, function() {});
			} else{
				window.location.href = 'maps:daddr=' + store.Latitude + "," + store.Longitude;
			}
			saveClientLog(57, store.StoreID, 0, '', 0, 'checking directions for store');
		};
		$scope.Share = function(store) {
			window.plugins.socialsharing.share('I went to the ' + store.Address1 + " " + store.Address2 + " " + store.City + ", " + store.State + " " + globals.Change.chainFriendly + "." + '\n' + ClientSet.getSocialShareURL(), 'Check out this great ' + globals.Change.chainFriendly + ' location.');
			saveClientLog(0, store.StoreID, 0, '', 0, 'user shared store');
		};
		$scope.Feedback = function(store) {
			$timeout(function() {
				$rootScope.FeedbackStore = store;
				$rootScope.AppFeedback = false;
			}, 1);
			$.mobile.changePage('#feedback');
		};

		$scope.showLatestStoreData = function() {

			var stores = getAllStores($scope);
			globals.Stores = stores;

			GeoLocation.setCurrentPosition().then(function() {
				var yourStartLatLng;
				if ($rootScope.haveGPS && typeof google != 'undefined') {

					if(globals.debugApp){
						console.log('STORES-DEBUG: Setting STORE DISTANCE');
					}

					for (var i = 0; i < stores.length; i++) {
						var PositionLatLng = new google.maps.LatLng($rootScope.Latitude, $rootScope.Longitude);
						var StoreLatLong = new google.maps.LatLng(stores[i].Latitude, stores[i].Longitude);
						var Distance = google.maps.geometry.spherical.computeDistanceBetween(PositionLatLng, StoreLatLong);
						Distance *= 0.000621371;
						Distance = Math.round(Distance);
						stores[i].Distance = Distance;
					}
					yourStartLatLng = new google.maps.LatLng($rootScope.Latitude, $rootScope.Longitude);
				} 
				else {
					if(globals.debugApp){
						console.log('STORES-DEBUG: ERROR - Could not set STORE DISTANCE');
					}

					if (typeof google != 'undefined') {
						yourStartLatLng = new google.maps.LatLng(36.318877, -78.409205);
					}
				}

				stores.sort(function(a, b) {
					return a.Distance - b.Distance
				});
				$scope.Stores = stores;
				if (typeof google != 'undefined') {
					map = new google.maps.Map($('#map')[0], {
						'center': yourStartLatLng,
						zoom: 10,
						mapTypeId: google.maps.MapTypeId.ROADMAP,
						zoomControl: false,
						mapTypeControl: false,
						streetViewControl: false
					});
					updateMapStores();
				}
			});

			$scope.hasSelectedServices = function(store) {
				var output = true;
				for (var i = 0; i < $rootScope.Services.length; i++) {
					if ($rootScope.Services[i].Selected) {
						output = false;
						for (var j = 0; j < store.Services.length; j++) {
							if (store.Services[j].ServiceID == $rootScope.Services[i].ServiceID) {
								output = true;
								break;
							} else
								output = false;
						}
						if (output == false)
							return false;
					}
				}
				return output;
			};

			function updateMapStores() {
				if(globals.debugApp){
					console.log('STORES-DEBUG: Updating MAP STORES');
				}

				var availableTags = [];
				for (var i = 0; i < $scope.Stores.length; i++) {
					if ($scope.hasSelectedServices($scope.Stores[i])) {
						availableTags.push({
							'label': $scope.Stores[i].Address1 + " " + $scope.Stores[i].Address2 + ", " + $scope.Stores[i].City + ", " + $scope.Stores[i].State + " " + $scope.Stores[i].Zip,
							'value': $scope.Stores[i]
						});
						addMarker($scope.Stores[i].Latitude, $scope.Stores[i].Longitude, $scope.Stores[i])
					}
				}

				$("#search-mini").autocomplete({
					source: availableTags,
					messages: {
						noResults: '',
						results: function() {}
					}
				});
			}

			function addMarker(longitude, latitude, Store) {
				var marker = new google.maps.Marker({
					position: new google.maps.LatLng(longitude, latitude),
					map: map,
					icon: globals.Change.flagIcon,
					Store: Store
				});
				google.maps.event.addListener(marker, 'click', function() {
					$timeout(function() {
						$scope.Store = Store;
					}, 1);
				});
			}

			$("#map").hide();
			$("#mapsearch").hide();

			$("#mapbutton").tap(function() {
				if ($(this).hasClass('ui-btn-active')){
					return false;
				}

				$(this).addClass('ui-btn-active');
				$('#listbutton').removeClass('ui-btn-active');
				$("#list").hide();
				$("#map").show();
				$('#storeRefresh').hide();
				$("#mapsearch").show();

				try {
					var center = map.getCenter();
					google.maps.event.trigger(map, "resize");
					map.setCenter(center);
				} catch (err) {}
				setTimeout(function() {
					$('#map a').attr('href', '');
				}, 5000);
			});
			$("#listbutton").tap(function() {
				if ($(this).hasClass('ui-btn-active')){
					return false;
				}

				$(this).addClass('ui-btn-active');
				$('#mapbutton').removeClass('ui-btn-active');
				$("#map").hide();
				$("#mapsearch").hide();
				$('#storeRefresh').show();
				$("#list").show();
				$('#storeList').listview('refresh');
			});

			$("#search-mini").on("autocompleteselect", function(event, ui) {
				event.preventDefault();
				map.setCenter(new google.maps.LatLng(ui.item.value.Latitude, ui.item.value.Longitude));
				$('#search-mini').val(ui.item.label);
			});

			$('.ui-input-text').keyup(function() {
				$('.ui-input-text').val($(this).val());
			});

			$timeout(function() {
				$scope.ShowGas = ClientSet.getShowGasPrice();
				$scope.HideStoreCall = !ClientSet.getShowStoreCall();

				if(globals.debugApp){
					console.log('$scope.ShowGas = ' + $scope.ShowGas);
				}
			}, 150); // give clientset time to load
		};


		$scope.Extra = 0;
		$scope.viewStoreDetails = function(store) {
			$timeout(function() {

				if ($scope.Extra == store.StoreID){
					$scope.Extra = 0;
				}
				else{
					$scope.Extra = store.StoreID;
				}
				saveClientLog(51, store.StoreID, 0, '', 0, 'viewed store details');
			});
		}

		$scope.getGasPrice = function(Store) {
			var gasType = getPreferredGas();

			if(globals.debugApp){
				console.log('DEBUG (STORE): Gas Type returned is ---> ' + gasType);
			}

			if (gasType == 'Plus') {
				if (Store.PlusPrice > 0){
					return 'Plus: $' + Store.PlusPrice.toFixed(2);
				}
				else{
					return '';
				}
			} else if (gasType == 'Premium') {
				if (Store.PremiumPrice > 0){
					return 'Prem: $' + Store.PremiumPrice.toFixed(2);
				}
				else{
					return '';
				}
			} else if (gasType == 'Diesel') {
				if (Store.DieselPrice > 0){
					return 'Dies: $' + Store.DieselPrice.toFixed(2);
				}
				else{
					return '';
				}
			} else if (gasType == 'Kerosene') {
				if (Store.KerosenePrice > 0){
					return 'Ker: $' + Store.KerosenePrice.toFixed(2);
				}
				else{
					return '';
				}
			} else {
				if (Store.RegularPrice > 0){
					return 'Reg: $' + Store.RegularPrice.toFixed(2);
				}
				else{
					return '';
				}
			}
		};

		$scope.getGasLastUpdate = function(GasLastUpdate) {

			var date = new Date(GasLastUpdate);
			var hour = date.getHours();
			var minute = date.getMinutes();
			var ap = "AM";
			if (hour > 11) {
				ap = "PM";
			}
			if (hour > 12) {
				hour = hour - 12;
			}
			if (hour == 0) {
				hour = 12;
			}
			//if (hour   < 10) { hour   = "0" + hour;   }
			if (minute < 10) {
				minute = "0" + minute;
			}
			var timeString = hour + ':' + minute + ' ' + ap;
			var formattedDateString = (date.getMonth() + 1) + '/' + date.getDate() + ' ' + timeString; //date.format("m/dd h:MM Z");
			return formattedDateString;
		};
	}

})();
(function() {
	angular.module('connect.settings', []);
}());
(function() {
	angular.module('connect.settings')
	.directive('connectSettings', connectSettingsDirective)
	.controller('connectSettingsController', connectSettingsController);

	connectSettingsDirective.$inject = [];
	connectSettingsController.$inject = ['$scope', '$rootScope', '$timeout', '$http', '$q', 'Loading', 'ClientSet'];

	function connectSettingsDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'settings/connect.settings.html',
			controller: connectSettingsController,
			link: function(){
			}
		}
		
		return directive;
	}

	function connectSettingsController($scope, $rootScope, $timeout, $http, $q, Loading, ClientSet) {

		$('#settings').on('pageshow', function(){
			$('#settingsControlGroup').controlgroup('refresh');
		});

		$('#settings').on('pageinit', function(){
			if ($(window).height() < 500){  //iphone 4
				$('[id^="settingsBut2"]').css('margin', '7px auto');
				$('[id^="settingsBut2"]').css('width', '70%');
				$('[id^="loginimage"]').css('width', '31%');
				$('[id^="loginimage"]').css('margin-top', '3px');
				$('[id^="loginimage"]').css('margin-bottom', '2px');
			}
		});

		$scope.sync = function() {
			globals.isRestart = true;
			setAppRestart(1);
			navigator.splashscreen.show();
			
			setSyncNow('true');
			saveLocalData();
			SaveAppDataJson();

			setTimeout(function() {
				navigator.splashscreen.hide();
			}, 7200);			

			setTimeout(function() {
       			window.location.href = window.location.href.substring(0, window.location.href.indexOf('#')); //reload main.html, basically restart the web app
			}, 2000);	
		}; //The Sync Now function which allows the user to force a sync. Sync Now updates the initialSyncDoneTimeout variable (defined in js/sync.js) to 45 seconds and removes the application data version (forces a full download sync) and game version (forces the game assets to be updated)
		

		Loading.then(function() { //you will see this in many controllers since many controller actions wait for the Loading factory promise to be resolved
			//we use $rootScope with ng-show (main.html) since it is more reliable than using $scope (at least from my experience)
			//$rootScope.showMapSetting = ClientSet.getShowMap(); //client set is not available until after Loading factory is complete, showMapSetting determines whether or not to give the user the option to edit now map settings (based on the client settings)
			$timeout(function(){
				//get device token to print
				$rootScope.deviceToken = getPushToken();
			}, 1);
		});

		$scope.Share = function() { //function for clicking the share module
			window.plugins.socialsharing.share(ClientSet.getSocialShareMessage() + '\n' + ClientSet.getSocialShareURL(), ClientSet.getSocialShareTitle(), null, null); //call the social sharing phonegap plugin
			$timeout(function() {
				resetScrollbar();
			}, 10000);
			saveClientLog(0, 0, 0, '', 'user shared app');
		};
	}
}());

(function(){
	angular.module('connect.register', []);
})();


(function(){
	angular.module('connect.register')
	.directive('connectRegister', connectRegister)
	.controller('RegisterController', connectRegisterCtrl);

	connectRegister.$inject = [];
	connectRegisterCtrl.$inject = ['$scope', '$rootScope', '$http'];


	function connectRegister(){
		var directive = {
			restrict: 'E',
			templateUrl: 'register/connect.register.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs){ }
	}

	// Register - Controller //
	//***********************//
	//controller for handling user registration (for unregistered user only)	
	function connectRegisterCtrl($scope, $rootScope, $http){

		//This checks the phone number input and auto insert the dashes (exp 999-999-9999)
		$('#regphone').keyup(function(e){

			if(globals.debugApp){
				console.log('DEBUG: Registration Phone number modified');
			}
		    
		      if ((e.keyCode > 47 && e.keyCode < 58) || (e.keyCode < 106 && e.keyCode > 95) ) {
		      	
		      	if(this.value.length <= 6){
			    	this.value = this.value.replace(/(\d{3})\-?/, '$1-');
			    	if(globals.debugApp){
			    		console.log('fired ---> success');
			    	}
		      	}
			    else{
			    	this.value = this.value.replace(/(\d{3})\-?(\d{3})\-?/,'$1-$2-');
			    	if(globals.debugApp){
			    		console.log('fired ---> success 2');
			    	}
			    }
			    return true;
			  }			  
			//remove all chars, except dash and digits
			this.value = this.value.replace(/[^\-0-9]/g, '');
		});

		$('#login').on('pageshow', function(){
			$('#birthdayRegister').mobiscroll({ preset: 'date'});
		});

		//property that determines whether or not the form has been submitted by the user (or attempted 
		//to be submitted) this is used throughout the app and is tied to showing or hiding form errors 
		//(i.e. if submit is false then do not show form errors but if submit is true then show form errors 
		//such as invalid email address or this field is required ...etc) ... $scope.Submit should be reset to 
		//false after the user is done with the form and the form has been cleared/reset, this is not currently 
		//implemented and should be implemented throughout the app.
		$scope.Submit = false; 

		$scope.Register = function(){ //function tied to the register button
			
			$scope.Submit = true; //the user has submitted the form, form errors (if any) will now be shown (see main.html for details)
			
			if (!$('#registrationForm').hasClass('ng-invalid')) //if the form is valid (no errors)
			{
				var birthday = $('#birthdayRegister').val(); //get the birthday using jQuery instead of Angular (scope/ng-model) this has been reliable with the mobiscroll date plugin but you might be able to just use angular
				if ($scope.BirthdayClub && birthday != undefined && birthday != "") { //if the user has opted in for the burthday club and they have provided a birthday
					birthday = moment(birthday).toDate().getTime(); //set birthday to the Unix epoch time
				}
				else{
					birthday = -2208739198680; //date in year 1900 sets null in server
				}
				if ($scope.geopromo){ //if the user selected to receive location based promotions
					var geopromo = 1; //set geopromo to 1
				}
				else{
					var geopromo = 0;
				}

				if ($scope.phone == undefined){
					$scope.phone = "";
				}


				$scope.geopromotion = geopromo; //used in verification dialog
				$scope.birthday = birthday; 

				if (window.device.platform == 'Android') {
					var options = {
						label : "Processing..",
						timeout: 120
					};
				} else {
					var options = {
						label : "Processing..",
						color: '#000',
						spinnerColor: '#000',
						timeout: 120
					};
				}
				
				window.wizSpinner.show(options); 

				//startLoader(); //start the AJAX loader (used whenever we are about to make calls to the server or when something will take time) the loader prevents the user from doing anything else until it hides
				$http.post(GetItemFromLocalData('ClientURL'), soapMessageCreateAccount($scope.email, $scope.password, $scope.fullname, $scope.phone, birthday, geopromo), {timeout: 30000}).then(function(response){ //call appropriate soapMessage function (see js/soapMessages.js) with the appropriate parameters
					
					window.wizSpinner.hide();

					var validated = $(response.data).find('CreateAccountResult').children("Validated").text(); //from the sevrer, indicates the account was created or not
					
					if(globals.debugApp){
						console.log(validated + "  " + $scope.fullname + " " + $scope.email + " " + $scope.password + " " + $scope.phone + " " + $scope.birthday + " " + $scope.geopromotion);
					}

					//If email verification is off, then go ahead and save account then go to interests page
					if (validated == "true"){
						saveAccountDetailJson(response.data); //save the account details to the device (function is defined in js/sync.js)
						
						//comment the line below out when email verificaton is 'ON'
						$rootScope.RegisteredUser = true; //set the user as registered

						navigator.notification.alert( //call to notification phonegap plugin
					    'Registration complete.',  // message
					    function(){
					      	$.mobile.changePage('#interestList', { transition: "fade"});
					   		 },         // callback
					  	   'Account created!',    // title
					   	   'Ok'                  // buttonName
						);

						if(globals.debugApp){
							console.log(" No verification is required "  );
						}

					}
					//TODO: Creat email verification Client Set for alternative message

					//If email verification is on and creation of email/account was successful
					/*else if (validated == "false" && $scope.email != null)
					{

						window.localStorage.setItem('verifyPrompt', 1); //save/set verify prompt to '1' so the verify checking method is set off

						$scope.verifyPrompt = getVerifyPrompt(); 

						// **USE THESE MESSAGES FOR WHEN EMAIL VERIFICATION IS DONE **
						//'We sent you an verification email to the account you provided.\n Click on the link in the email to finish registration.',  // message
						//'Registration submitted, Please check your email.'

						navigator.notification.alert( //call to notification phonegap plugin
					    'Account Created',  // message
					    function(){
					      	$.mobile.changePage('#main', { transition: "fade"});
					   		 },         // callback
					  	   'Registration submitted!',    // title
					   	   'Ok'                  // buttonName
						);

						console.log("Just registered. VerifyPrompt was set to " + $scope.verifyPrompt );
					}*/
					else{
						alert('It appears your account already exists, please sign in.', function(){
							$.mobile.changePage('#linkAccount', { transition: "slide"});
						});	 //if the server did not validate then the account likely exists, change the page to the linkaccount page (login)
					}

				}, function(error){ //indicates that the ajax function failed due to poor internet or something else
						window.wizSpinner.hide();//stop the loader
					$rootScope.Error(globals.ajaxTimeoutMessage, //the message to be shown on the error screen
					function(){ //callback
						if(globals.debugApp){
							console.log("..");
						}
					},
					false, //whether or not to show the try again button (used for game ending error)
					function(){
						if(globals.debugApp){
							console.log("..");
						}
						//try again call back
					}); //call the error method, defined in ErrorController below, shows the blue screen
				});
			}
		};
	}
})();
(function(){
	angular.module('connect.promos', []);
})();
(function() {
	angular.module('connect.promos')
		.directive('connectPromos', promosDirective)
		.controller('PromosController', promosController);

	promosDirective.$inject = [];

	promosController.$inject = ['$scope', '$rootScope', '$timeout', 'Loading', '$compile'];

	function promosDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'promos/connect.promos.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) {  }
	}

	//IDEA FOR BUG - Have a switch to initialize a refresh ON page shown.
	function promosController($scope, $rootScope, $timeout, Loading, $compile) {

		$scope.promosRefreshed = false;
		$scope.onPage = false;
		
		$('#promos').on('pageshow', function(){
			if($scope.promosRefreshed == false){
				$('#promosLoading').hide();

				if( $('#iscroller').iscrollview() ){
					$('#iscroller').iscrollview('refresh');
				}
				setTimeout(function(){
					$scope.onPage = true;
				},10);
			}
			else{ //launch Promos Refresh method
				$scope.promoPageRefresh();
			}
		});

		$("#promos").on('pageinit', function(){

			if($scope.promosRefreshed  == false){ //if promos refreshed is true then we will be setting css anyways so lets skip it
				var height = $(window).height();
				var width = $(window).width();

				$("#promos .ui-content").css('height', height - $('#promos .ui-header').height() - $('#promos .ui-footer').height() -1 );
				$("#promos .ui-content").css('width', width );
				$("#promos .promosHeaderWrapper").css('width', width);
				$("#promos .promoPageHeader").css('width', width );
				$("#promos #headerContainer").css('width', width );
				$("#promos #promoContainer").css('width', width * .333 - 5 ); // the last arithmitic is for padding (see CSS/HTML page of this directive)
				$("#promos .promoPageHeader").css('height', height * .0384 );

				$("#promos .promotext").css('height', height * .044 );
				$("#promos .promoimage").css('width', width * .3333 - 3.5 );
				$("#promos .promoimage").css('height', ( width * .3333 ) - $('#promos .promotext').height() );
				$("#promos .promotext").css('width', $('#promos .promoimage').width() - 2 ); // take away 4 for padding
				$("#promos .promotext").css('bottom', $('#promos .promotext').height() );
				$("#promos .promotext").css('left', 0 );

				$("#promos #promoContainer").css('height', $('#promos .promoimage').height() + $('#promos .promotext').height() + 2);
				$("#promos #headerContainer").css('height', 'auto' );
			}
		}); 

		$('#promos').on('pagehide', function(){
			$('#promosLoading').hide();
			$scope.onPage = false;
		});

		Loading.then(function() {
			setTimeout(function(){
				if(globals.debugApp){
					console.log('Loading.then function in Promos page initiated');
				}
				$scope.Headers = getAllHeadersWithPromos('Promos Page loading method'); //get all headers with promos to show on the page, each header is a touchCarousel
				$scope.Promos = getAllPromos(0,'Promos Page loading method');
			},1);
		});


		// FOR PROMO PAGE
		$scope.promoPageRefresh = function(){

			if (window.device.platform == 'Android'){
				var options = {
					label : "Refreshing Specials"
				};
			}
			else{
				var options = {
					label : "Refreshing Specials",
					color : '#000',
					spinnerColor : '#000'
				}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
			} 
			window.wizSpinner.show(options);
			

			setTimeout(function(){
				$('#promosLoading').show();
				$('#promosLoading').animate({opacity:1}, 800);
				$("#wrapper").empty();
				$scope.Headers = getAllHeadersWithPromos('promoPageEvoke');
				$scope.Promos = getAllPromos(0, 'promoPageEvoke');

					setTimeout(function(){
					$("#wrapper").html($compile('<div class = "promosHeaderWrapper" ng-repeat="Header in Headers" ng-show="Headers.length > 0">' +
						'<div id = "headerContainer">' +
							'<div class="promoPageHeader">' +
								'{{::Header.Descript1}}' +
							'</div>' +
							'<div id = "promorow">' +
							'<div ng-repeat="Promo in Header.Promos" ng-class="{ \'disabledPromo \' : invalidPromo(Promo)}">' +
								'<div id = "promoContainer" >' +
									'<div id="{{::Promo.PromoID}}" ng-click="viewPromo(Promo)">' +
										'<div><img class="promoimage" src="{{::Promo.PhotoURL}}"/><div>' +
										'<div class="promotext"> {{::Promo.Descript1}} </div>' +
									'</div>' +
								'</div>' +
							'</div>' +
							'</div>' +
						'</div>' +
					'</div>' +
					'<div id="promoPad"></div>')($scope));    // Append new elements 
					
					$scope.$apply(); 

					setTimeout(function(){
						var height = $(window).height();
						var width = $(window).width();

						$("#promos .ui-content").css('height', height - $('#promos .ui-header').height() - $('#promos .ui-footer').height() );
						$("#promos .ui-content").css('width', width );
						$("#promos .promosHeaderWrapper").css('width', width);
						$("#promos .promoPageHeader").css('width', width );
						$("#promos #headerContainer").css('width', width );
						$("#promos #promoContainer").css('width', width * .333 - 5 ); // the last arithmitic is for padding (see CSS/HTML page of this directive)
						$("#promos .promoPageHeader").css('height', height * .0384 );

						$("#promos .promotext").css('height', height * .044 );
						$("#promos .promoimage").css('width', width * .3333 - 3.5 );
						$("#promos .promoimage").css('height', ( width * .3333 ) - $('#promos .promotext').height() );
						$("#promos .promotext").css('width', $('#promos .promoimage').width() - 2 ); // take away 4 for padding
						$("#promos .promotext").css('bottom', $('#promos .promotext').height() );
						$("#promos .promotext").css('left', 0 );

						$("#promos #promoContainer").css('height', $('#promos .promoimage').height() + $('#promos .promotext').height() + 2);
						$("#promos #headerContainer").css('height', 'auto' );

						setTimeout(function(){
							$('#promosLoading').animate({opacity:0}, 1200);
							if($('#iscroller').iscrollview() ){
								$('#iscroller').iscrollview('refresh');
							}
						}, 1);	

						setTimeout(function(){
							$('#promosLoading').hide();
							setTimeout(function(){
								window.wizSpinner.hide();   // Used for promos page refresh
							}, 200);	
							$scope.promosRefreshed = false;
						}, 1200);	

					}, 1);
				}, 1);
			}, 1);
		}


		$scope.promoRefreshBut = function(){
			console.log("Refresh in PROMOS page was Called! ");

			if (window.device.platform == 'Android'){
				var options = {
					label : "Updating and refreshing Specials"
				};
			}
			else{
				var options = {
					label : "Updating and refreshing Specials",
					color : '#000',
					spinnerColor : '#000'
				}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
			} 
			window.wizSpinner.show(options);

			$('#promosLoading').show();
			$('#promosLoading').animate({opacity:1}, 500);
			
			$("#wrapper").empty();
			refreshPromoHead($scope, $rootScope, $timeout, $compile, 0); //refreshed and downloads header, promos, and promo images if there are new ones
		};


		$scope.viewPromo = function(Promo) {
			if (!$scope.invalidPromo(Promo)) {

				$rootScope.Promo = Promo;
				$rootScope.promoDialogPic = Promo.PhotoURL;
				$rootScope.PromoRedemption = true;
				$rootScope.PrizeRedemption = false;
				$rootScope.notRedeemable = Promo.PromoUse == 0;

				/*  MOVED ALL STORE LOGIC TO PROMO DIALOG */
				var coldestIndex = null;
				var coldestRatio = 0;
				try {
					myimage = new Image();
					myimage.src = $rootScope.Promo.PhotoURL;
					var colorThief = new ColorThief();
					var colors = colorThief.getPalette(myimage, 9);
					for (var i = 0; i < 9; i++) {
						if (((colors[i][2] / colors[i][0]) > coldestRatio) && (((colors[i][0] + colors[i][1] + colors[i][2]) / 3) < 200)) {
							coldestRatio = colors[i][2] / colors[i][0];
							coldestIndex = i;
						}
					}
				} catch (err) {
					if (coldestIndex == null)
						$('.promoDialogDescription').css('color', 'black');
					else {
						var r = colors[coldestIndex][0];
						var g = colors[coldestIndex][1];
						var b = colors[coldestIndex][2];
						$('.promoDialogDescription').css('color', 'rgb(' + r + ',' + g + ',' + b + ')');
					}
				}
				$timeout(function() {
					$.mobile.changePage('#promodog');
				});
				saveClientLog(32, $rootScope.Promo.PromoID, 0, '', 0, 'viewed promotion');
			}
		};

		$scope.invalidPromo = function(Promo) { //function that determines if a promo is valid, if it is not then the promo is dimmed out (see main.html and main.css)
			var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;
			var valid = (Promo.Uses == 0 || Promo.AccountUses < Promo.Uses) && now > Promo.DateStart && now < Promo.DateEnd;
			return !valid;
		};

	}
})();
(function(){
	angular.module('connect.promo.dialog', []);
})();
(function() {
	angular.module('connect.promo.dialog')
		.directive('connectPromoDialog', connectPromoDialogDirective)
		//TODO: rename PromoDialogController to convention
		.controller('PromoDialogController', promoDialogController);

	connectPromoDialogDirective.$inject = [];
	promoDialogController.$inject = ['$scope', '$rootScope', '$http', '$timeout', 'ClientSet'];

	var ajaxTimeoutPromoMessage = 'We were unable to contact the server. May we suggest moving to an area with a stronger internet connection or try again later?'; //the message the user sees

	function connectPromoDialogDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'promoDialog/connect.promo.dialog.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) {  }
	}

	function promoDialogController($scope, $rootScope, $http, $timeout, ClientSet) {

		$scope.redeemNow = false; //determines if a redeemNow is in progress, certain things are shown/hidden or buttons disabled based on this (see main.html)
		var CouponRedemptionFilePart;
		var oldBrightVal;

		//function for opening external link (in case Descript2) is a link, this prevents the app from visiting a 
		//link within the same web view as PhoneGap and instead opens a new browser window on the device (this prevents 
		//the app from getting stuck on a web page since there is no back button, especially on ios)
		$scope.openExternalLink = function(PromoLink) {
			if (window.device.platform === 'Android') {
				navigator.app.loadUrl(PromoLink, {
					openExternal: true
				});
			} else {
				window.open(PromoLink, '_system');
			}
		} 


		$scope.Redeem = function() { //function for the redeem button
			if ($rootScope.RegisteredUser) {
				navigator.notification.confirm(
					'This offer displays for a limited amount of time. You should be at the register before redeeming this offer. Are you ready to redeem now?',
					callBackFunctionRedeem, // Specify a function to be called
					'Ready?', ["Yes", "No"]
				);

				function callBackFunctionRedeem(b) {
					if (b == 1) { //callback for the user choosing yes
						if (window.device.platform == 'Android'){
							var options = {
								label : "Loading Redemption"
							};
						}
						else{
							var options = {
								label : "Loading Redemption",
								color : '#000',
								spinnerColor : '#000'
							}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
						} 
						window.wizSpinner.show(options);

						$("#promopic").animate({
							opacity: 0
						}, 250);

						$("#promoDescriptionTwo").animate({
							opacity: 0
						}, 250); //animate out promo pic and descript2 so that the transition is smoother

						if ($rootScope.inStore) {
							$scope.Latitude = $rootScope.Latitude;
							$scope.Longitude = $rootScope.Longitude;
							$scope.Accuracy = $rootScope.Accuracy;
							$scope.StoreID = $rootScope.inStore.StoreID;
							redeemNow();
						} 
						else {
							navigator.geolocation.getCurrentPosition(function(position) {
								$scope.Latitude = position.coords.latitude;
								$scope.Longitude = position.coords.longitude;
								$scope.Accuracy = position.coords.accuracy;
								$scope.StoreID = 0;
								redeemNow();
							}, function(error) {
								navigator.geolocation.getCurrentPosition(function(position) {
									$scope.Latitude = position.coords.latitude;
									$scope.Longitude = position.coords.longitude;
									$scope.Accuracy = position.coords.accuracy;
									$scope.StoreID = 0;
									redeemNow();
								}, function(error) {
									$scope.Latitude = 0;
									$scope.Longitude = 0;
									$scope.Accuracy = 0;
									$scope.StoreID = 0;
									redeemNow();
								}, {
									enableHighAccuracy: false,
									maximumAge: 10000,
									timeout: 5000
								});
							}, {
								enableHighAccuracy: true,
								maximumAge: 10000,
								timeout: 5000
							});
						} //if the user is in store then take note of their location, otherwise try getting location again so 
						//we can determine store redemptions on the back end (this will later be replaced with beacons and gps will be back up for this scenario)
						

						function redeemNow() { //call web methods for redemptions

							if(globals.debugApp){
								console.log("RedeemNow() function has been launched!.. retreiving barcode...");
							}

							$http.post(GetItemFromLocalData('ClientURL'), soapMessagePromoRedeem($rootScope.Promo.PromoID, $scope.StoreID, $scope.Latitude, $scope.Longitude, $scope.Accuracy, 1), {timeout: 30000} ).then(function(response) {
								
								if(globals.debugApp){
									console.log("Server sent promo info...");
								}

								var error = $(response.data).find('Standard').children('MethodErrorMsg').text();

								if (parseInt($(response.data).find('PromoRedeemResult').children("PromoOK").text()) == 1) {
									var data1 = response.data; //store the response from the first web method call, redemption uses a 2 step process

									if(globals.debugApp){
										console.log("RedeemNow() First step successful.. Second step process started...");
									}

									$http.post(GetItemFromLocalData('ClientURL'), soapMessagePromoRedeem($rootScope.Promo.PromoID, $scope.StoreID, $scope.Latitude, $scope.Longitude, $scope.Accuracy, 2), {timeout: 30000} ).then(function(response) {
										
										if(globals.debugApp){
											console.log("RedeemNow() Second step successful.. ENTERING StartRedeemNow()...");
										}
										startRedeemNow(data1, response.data); //start redeem now on the client and pass in the data from both web methods response
									}, function(error) {
										
										//$rootScope.Error(ajaxTimeoutPromoMessage, function() {
										window.wizSpinner.hide();

										navigator.notification.confirm(
											'Server couldnt be reached..',
											callBackFunctionServerDown, // Specify a function to be called
											'Please check your internet signal, Would you like to Retry.', ["Yes", "No"]
										);

										$("#promopic").animate({
											opacity: 1
										}, 250);

										$("#promoDescriptionTwo").animate({
											opacity: 1
										}, 250); //animate out promo pic and descript2 so that the transition is smoother

										function callBackFunctionServerDown(b) {
											if (b == 1) {
												if (window.device.platform == 'Android'){
													var options = {
														label : "Loading Redemption"
													};
												}
												else{
													var options = {
														label : "Loading Redemption",
														color : '#000',
														spinnerColor : '#000'
													}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
												} 
												window.wizSpinner.show(options);
												redeemNow();
											}
											else{
												$.mobile.changePage('#promos');
											}
										}

										if(globals.debugApp){
											console.log("Promo Redeem error. error 2");
										}
									});
								} else {
									window.wizSpinner.hide();
									if(globals.debugApp){
										console.log("Promo invalid... error 1");
									}

									alert(error, function() {});

									navigator.notification.confirm(
										'Promo is invalid',
										callBackFunctionServerDown, // Specify a function to be called
										'Please try refreshing promos, Click "Sync Now" in the "More" Settings to refresh data', ["Ok"]
									);

									$("#promopic").animate({
										opacity: 1
									}, 250);

									$("#promoDescriptionTwo").animate({
										opacity: 1
									}, 250); //animate out promo pic and descript2 so that the transition is smoother

									function callBackFunctionServerDown(b) {
										if (b == 1) {
											//window.localStorage.setItem('PromoRetry',1); //set promoRetry and go to promos page, a promo sync will happen
											$.mobile.changePage('#settings');
										}
									}
								}
							}, function(error) {
								
								window.wizSpinner.hide();

								if(globals.debugApp){
									console.log("Promo Redeem error. 3");
								}

								navigator.notification.confirm(
									'Server couldnt be reached..',
									callBackFunctionServerDown, // Specify a function to be called
									'Please check your internet signal, Would you like to Retry.', ["Yes", "No"]
								);

								$("#promopic").animate({
									opacity: 1
								}, 250);

								$("#promoDescriptionTwo").animate({
									opacity: 1
								}, 250); //animate out promo pic and descript2 so that the transition is smoother

								function callBackFunctionServerDown(b) {
									if (b == 1) {
										if (window.device.platform == 'Android'){
											var options = {
												label : "Loading Redemption"
											};
										}
										else{
											var options = {
												label : "Loading Redemption",
												color : '#000',
												spinnerColor : '#000'
											}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
										} 
										window.wizSpinner.show(options);
										redeemNow();
									}
									else{
										$.mobile.changePage('#promos');
									}
								}
							});
						}//end of redeemNow()
					} else {}
				}//End of CallBackFunctionRedeem()

			} else { //if the user is not registered then show dialog and prompt user to register
				navigator.notification.confirm(
					'You must be a registered user to redeem this Special. Would you like to register or sign in now?',
					callBackFunctionRedeemRegister, // Specify a function to be called
					'Registration Required', ["Yes", "No"]
				);

				function callBackFunctionRedeemRegister(b) {
					if (b == 1) {
						$.mobile.changePage('#redeemRegisterAlert');
						$('#redeemRegisterAlert_back').show();
						$rootScope.redeemRegisterAlerted = true;
					}
				}
			}
		}

		function startRedeemNow(data1, data2){ //done with web method calls, now start redeem on the deivce

			//GENERATE timeStamp and store it in rootscope, this is displayed with the redemption
			//helper methods are located in sync.js
			var currentdate = new Date(); 
			var datetime = getMonth(currentdate) + " " + addOrd(currentdate.getDate()) + " " + " @ " + getTime(currentdate);
			$rootScope.timeStamp = datetime;

			$rootScope.Promo.AccountUses = $rootScope.Promo.AccountUses + 1; //update account uses for this promotion (does not update locally stored promotion yet)
			
			if ($rootScope.Promo == $rootScope.InstantPrize){
				$timeout(function(){
					$rootScope.InstantPrize = null; //if we are viewing the instant prize (see game) then set the instant prize to null because the user can only see it once
					resetScrollbar();
				});
			}

			//var p = JSON.parse( window.localStorage.getItem('Promos') );
			var p = LoadPromosFromAppData();
			for (var i = 0; i < p.length; i++){
				if (p[i].PromoID == $rootScope.Promo.PromoID){
					p[i].AccountUses = $rootScope.Promo.AccountUses; //update the locally stored promotion's accountuses
				}
			}

			if(globals.debugApp){
				console.log("RedeemNow() started..  #promopic and #redeemNow is now Shown.");
			}
			
			SavePromosToAppData(JSON.stringify(p) );

			//ACTIVATE brightness plugin and set it to 1
			//getBrightness();
			setBrightness(1);

			$scope.redeemNow = true; //redeem now is in progress

			$("#promopic").animate({opacity:1}, 250);
			$("#redeemNow").animate({opacity:1}, 250); //animate in content (see main.html)

			//window.localStorage.setItem('Points', $(data1).find('PromoRedeemResult').children("Points").text()); //update points in case this was a prize redemption
			setPoints( $(data1).find('PromoRedeemResult').children("Points").text() );

			saveLocalData(); //save to local data variable

			CouponRedemptionFilePart = $(data1).find('PromoRedeemResult').children("FilePart").text();
			if (CouponRedemptionFilePart){
				if(CouponRedemptionFilePart.substring(1, 3) == "9j")
					$rootScope.promoDialogPic = 'data:image/jpeg;base64,' + CouponRedemptionFilePart;
				else
					$rootScope.promoDialogPic = 'data:image/png;base64,' + CouponRedemptionFilePart;
			} //set the promoDialogPic based on the base64 encoded image string recieved by the server (for the coupon)
			else{
				$rootScope.promoDialogPic = ''; //no picture (probably just a PLU code)
				if(globals.debugApp){
					console.log("PLU Code is being used..");
				}
			}

			var CouponRedemptionRedeemText = $(data1).find('PromoRedeemResult').children("RedeemText").text();
			//replace descripttext with the coupon redemption text
			if(CouponRedemptionRedeemText != ''){
				$scope.DescriptText = CouponRedemptionRedeemText;
			}
			else{
				$scope.DescriptText = 'Show your coupon at the register to redeem this promotion.';
			}


			var CouponRedemptionDisplaySec = parseInt($(data1).find('PromoRedeemResult').children("DisplaySec").text()); //how long the coupon will display in seconds
			$scope.AllowedUses = parseInt($(data2).find('PromoRedeemResult').children("AllowedUses").text()); //how many redemptions are allowed per user for this coupon
			$scope.Uses = parseInt($(data2).find('PromoRedeemResult').children("Uses").text()); //how many uses the user has used, these 2 values are used to calculate remaining uses for the coupon
			var until = '+' + CouponRedemptionDisplaySec + 's'; //used in the countdown plugin to determine how long the countdown should last in seconds
			

			$('#promotimer').countdown({until: until, onExpiry: function(){ //callback after countdown finishes
				$rootScope.leavePromo();
				$scope.endRedeemNow();
			}, format: 'MS'}); //format is minutes and seconds
			
			setTimeout(function(){
				resetScrollbar();
				window.wizSpinner.hide();
				SaveAppDataJson(); //save to file
			}, 100);
		}

		//Brightness Plug-in SET//
		//----------------------//
		function setBrightness(value) {
		    // value should be float in range from 0 to 1.
		    window.brightness.setBrightness(value, setSuccess, setFail);
		}

		function setSuccess(status) {
		    //alert('SET BRIGHT- Success Message: ' + status);
		    if(globals.debugApp){
		    	console.log('SET BRIGHT- Success Message: ' + status);
		    }
		}

		function setFail(status) {
		    //alert('SET BRIGHT- Error: ' + status);
		    if(globals.debugApp){
		   		console.log('SET BRIGHT- Error: ' + status);
		   	}
		}

		$rootScope.leavePromo = function(){   //leave promo function defined in rootscope since used outside of promoscontroller
			
			setTimeout(function(){
				if ($.mobile.activePage.attr('id') == 'promodog'){ //make sure we are on the promo detail page (i.e. the user did not leave the promo redeem early)
					if ($rootScope.redeemRegisterAlerted){ //if this is after the user logged in or registered because they saw redeemRegisterAlerted then take them to promos
						$.mobile.changePage('#promos');
						$rootScope.redeemRegisterAlerted = false;
					}
					else{
						$.mobile.back();
					}
					$('#promotimer').countdown('destroy'); //destory the counter so it can start new when used again
				}
			}, 10);
		};

		$('#promodog').on('pagehide', function(){
			$scope.endRedeemNow(); //if the user leaves this page then call endRedeemNow
		});



		$('#promodog').on('pageshow', function(){
			window.wizSpinner.hide();

			if(globals.debugApp){
				console.log( 'Promo-Debug:  Does this promo have promo stores: '  + $rootScope.Promo.hasStores );
			}
			if($('#iscroller').iscrollview() ){
				$('#iscroller').iscrollview('refresh');
			}
		});

		$('#redeemRegisterAlert').on('pagehide', function(){ //when the redeem register alert page hides
			if ($.mobile.activePage.attr('id') == 'promodog'){ //if we are currently on the promos page (i.e. the user saw redeemRegisterAlert after attempting to redeem a promotion without an account)
				$rootScope.redeemRegisterAlerted = false; //set redeemRegisterAlerted back to false
			}
		});

		$scope.endRedeemNow = function () //not in redeemNow mode, put regular promo photo back instead of coupon
		{
			if(globals.debugApp){
				console.log('DEBUG: Changing brightness back to old value - ' + oldBrightVal);
			}

			setTimeout(function(){
				setBrightness(globals.userBrightness); //old value
			}, 500);

			$scope.redeemNow = false;
			$rootScope.PromoDialogPic = $rootScope.Promo.PhotoURL;
			$('#promoDescriptionTwo').css('opacity', 1);
			$('#redeemNow').css('opacity', 1);
		};

		$scope.getPoints = function(){ //returns points to show for prize promotions
			return getPoints();
		};

		$scope.Share = function(){ //function to share the promo using the social share plugin
			window.plugins.socialsharing.share($rootScope.Promo.Descript1 + '\n' + ClientSet.getSocialShareURL(), 'Check out this great offer from ' + ClientSet.getCompanyName() + '!', $rootScope.Promo.PhotoURL, null);
			saveClientLog(0, $rootScope.Promo.PromoID, 0, '', 0, 'user shared promo');
		}

		$scope.showParticipatingStores = function(){ //function to show the stores participating in this offer (if not all)

			var options = {
				label : "Loading Participating Stores"
			};

			window.wizSpinner.show(options);

			//Get Promo Stores HERE
			$rootScope.Promo.Stores = getPromoStores($rootScope.Promo);

			if ($rootScope.haveGPS && typeof google != 'undefined') {
				for (var i = 0; i < $rootScope.Promo.Stores.length; i++) {
					var PositionLatLng = new google.maps.LatLng($rootScope.Latitude, $rootScope.Longitude);
					var StoreLatLong = new google.maps.LatLng($rootScope.Promo.Stores[i].Latitude, $rootScope.Promo.Stores[i].Longitude);
					var Distance = google.maps.geometry.spherical.computeDistanceBetween(PositionLatLng, StoreLatLong);
					Distance *= 0.000621371;
					Distance = Math.round(Distance);
					$rootScope.Promo.Stores[i].Distance = Distance;
				} //for each store in this promotion (if this is a promotion available only in certain stores) calculate (if the user has gps) the distance between the user's current position and the store
			}
			$rootScope.Promo.Stores.sort(function(a, b) {
				return a.Distance - b.Distance
			}); //sort the stores by the nearest first


			$timeout(function(){
				$.mobile.changePage('#participatingStores');
			},5);

		};

		function getPromoStores(Promo){
			var p = LoadPromosFromAppData() ? LoadPromosFromAppData() : null; //Grab all promos with Stores

			//sort through old promo and match promo ID
			for (var i = 0; i < p.length; i++){
				if (p[i].PromoID == Promo.PromoID){
					if (p[i].PromoStore){
						var ps = LoadPromoStoresFromAppData() ? LoadPromoStoresFromAppData() : {};

						if (ps){
							ps = ps.filter(function(item){
								return (item.PromoID == p[i].PromoID);
							}); //get the promo stores that match this promo id
							if (ps.length > 0){
								var storeids = [];
								for (var k = 0; k < ps.length; k++){
									storeids.push(ps[k].StoreID);
								} //get the store ids for the stores that support this promo


								var s = globals.Stores;
								if (s){
									s = s.filter(function(item){
										return (storeids.indexOf(item.StoreID) != -1);
									}); //get the stores that have ids in the storeids array

									if (s.length > 0){
										return s;
									} //return all stores for this promo
									else{
										if(globals.debugApp){
											console.log('ERROR! : no promo stores to return in getPromoStores(Promo) within Promos Dir.')
										}
										
										return [];
									}
								}
							}
						}
					}
				}
			}
		}//End of getPromoStores(Promo)
	}
})();


(function(){
	angular.module('connect.preferred.gas.type', []);
})();
(function(){
	angular.module('connect.preferred.gas.type')
	.directive('preferredGasType', preferredGasTypeDirective)
	//TODO: rename SetPreferredGasController to convention everywhere needed
	//.controller('preferredGasTypeController', preferredGasTypeController);
	.controller('SetPreferredGasController', preferredGasTypeController);

	preferredGasTypeDirective.$inject = [];
	preferredGasTypeController.$inject = ['$scope','$timeout'];


	function preferredGasTypeDirective(){
		var directive = {
			restrict: 'E',
			templateUrl: 'preferredGas/connect.preferred.gas.type.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs){}

	}

	function preferredGasTypeController($scope, $timeout){

		$scope.Set = function(gasType){
			$timeout(function(){
				//window.localStorage.setItem('PreferredGas', gasType);
				setPreferredGas(gasType);
				saveLocalData();
				SaveAppDataJson(); 
				$timeout(function(){
					$.mobile.changePage('#accountDetails', { transition: "slide", reverse: true});
				}, 10);
			}, 1);
		};
		$scope.getGas = function(){
			return getPreferredGas();
		};
	}

})();
(function(){
	angular.module('connect.prizes', []);
})();
(function() {
	angular.module('connect.prizes')
		.directive('prizes', prizesDirective)
		.controller('PrizesController', prizesController);

	prizesDirective.$inject = [];
	prizesController.$inject = ['$scope', '$rootScope', '$timeout', 'Loading', '$compile'];

	function prizesDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'prizes/connect.prizes.html',
			link: link
		};
		return directive;

		function link(scope, element, attrs) {}
	}

	function prizesController($scope, $rootScope, $timeout, Loading, $compile) {

		Loading.then(function(){
			$timeout(function(){
				$scope.showLatestPrizeData();
			}, 1);
		});

		$('#prizes').on('pageshow', function(){
			$("#prizes #prizesContainer").animate({opacity:1}, 400);

			saveClientLog(31, 0, 0, '', 0, 'viewed loyalty promotions');

			if( $('#prizescroller').iscrollview() ){
				$('#prizescroller').iscrollview('refresh');
			}
			//console.log('Prizes in scope (prizes directive) : ' + JSON.stringify( $scope.PrizeHeaders ) );
			
			$('#prizesLoading').animate({opacity:0}, 400);
			setTimeout(function(){
				$('#prizesLoading').hide();
			},380);
		});

		$("#prizes").on('pageinit', function(){
			//MAIN Screen Resize
			var height = $(window).height(); // android and ios
			var width = $(window).width(); 

			$("#prizes .ui-content").css('height', height - $('#prizes .ui-header').height() - $('#prizes .ui-footer').height() );
			$("#prizes .ui-content").css('width', width );
			$("#prizes #prizesPageContent").css('width', width );

			$("#prizes .prizeHeaderWrapper").css('width', width );
			$("#prizes .prizeHeader").css('width', width );
			$("#prizes #prHeaderContainer").css('width', width );
			$("#prizes #prizescroller").css('width', width );
			$("#prizes #prizesContainer").css('width', width * .333 - 5 );
			$("#prizes .prizeHeader").css('height', height * .038 );

			$("#prizes .prizetext").css('height',  height * .0355 );
			$("#prizes .prizeimage").css('width', width * .3333 - 3.5 );
			$("#prizes .prizeimage").css('height', ( width * .3333 ) - $('#prizes .prizetext').height() );
			$("#prizes .prizetext").css('width', $('#prizes .prizeimage').width() - 4 );
			$("#prizes .prizetext").css('bottom', $("#prizesPageContent .prizetext").height() );
			$("#prizes .prizetext").css('left', 0 );

			$("#prizes #prizesContainer").css('height', $("#prizesPageContent .prizeimage").height() +  $("#prizesPageContent .prizetext").height() + 4);
			$("#prizes #prHeaderContainer").css('height', 'auto' );

		});

		$('#prizes').on('pagehide', function(){
			$("#prizes #prizesContainer").animate({opacity:0}, 400);
			$('#prizesLoading').hide();
		});


		$scope.showLatestPrizeData = function() {

			if(globals.debugApp){
				console.log('PRIZES-Debug: Sorting the latest Prize Data.');
			}

			var prizes = getAllPromos(1, 'showLatestPrizeData() in scope..');
			var ip = prizes.filter(function(item) {
				return (item.PromoAccount == 1)
			});

			if (prizes.length > 0) {
				var prizeHeaders = [];
				prizes = prizes.filter(function(item) {
					return (item.PromoAccount != 1);
				});
				prizes.sort(function(a, b) {
					return a.Points - b.Points
				});
				prizeHeaders.push({
					Points: prizes[0].Points,
					Prizes: []
				});

				prizeHeaders[0].Prizes.push(prizes[0]);

				for (var i = 1; i < prizes.length; i++) {
					if (prizes[i].Points == prizeHeaders[prizeHeaders.length - 1].Points)
						prizeHeaders[prizeHeaders.length - 1].Prizes.push(prizes[i]);
					else {
						prizeHeaders.push({
							Points: prizes[i].Points,
							Prizes: []
						});
						prizeHeaders[prizeHeaders.length - 1].Prizes.push(prizes[i]);
					}
				}
				
				$timeout(function() {
					$scope.PrizeHeaders = prizeHeaders;
				}, 1);
			} else{
				$scope.PrizeHeaders = [];
				if(globals.debugApp){
					console.log('PRIZES-Debug: Prizes were empty!!!');
				}
			}
			if (ip.length > 0) {
				$timeout(function() {
					$rootScope.InstantPrize = ip[0];
				});
			}
		};


		$scope.getPoints = function() {
			return getPoints();
		};

		$scope.viewPromo = function(Prize) {
			if (window.device.platform == 'Android'){
				var options = {
					label : "Loading Prize"
				};
				window.wizSpinner.show(options);
			}
			if ($scope.getPoints() >= Prize.Points) {
				$rootScope.Promo = Prize;
				$rootScope.promoDialogPic = Prize.PhotoURL;
				$rootScope.PromoRedemption = false;
				$rootScope.PrizeRedemption = true;
				$rootScope.notRedeemable = Prize.PromoUse == 0;

				var coldestIndex = null;
				var coldestRatio = 0;
				try {
					myimage = new Image();
					myimage.src = $rootScope.Promo.PhotoURL;
					var colorThief = new ColorThief();
					var colors = colorThief.getPalette(myimage, 9);
					for (var i = 0; i < 9; i++) {
						if (((colors[i][2] / colors[i][0]) > coldestRatio) && (((colors[i][0] + colors[i][1] + colors[i][2]) / 3) < 200)) {
							coldestRatio = colors[i][2] / colors[i][0];
							coldestIndex = i;
						}
					}
				} catch (err) {
					if (coldestIndex == null)
						$('.promoDialogDescription').css('color', 'black');
					else {
						var r = colors[coldestIndex][0];
						var g = colors[coldestIndex][1];
						var b = colors[coldestIndex][2];
						$('.promoDialogDescription').css('color', 'rgb(' + r + ',' + g + ',' + b + ')');
					}
				}

				$timeout(function() {
					$.mobile.changePage('#promodog');
				});

				saveClientLog(32, $rootScope.Promo.PromoID, 0, '', 0, 'viewed loyalty promotion');
			}
		};

		$scope.prizesRefreshBut = function(){
			console.log("Refresh in PROMOS page was Called! ");
			$scope.promosIsSyncing = true;

			if (window.device.platform == 'Android'){
				var options = {
					label : "Updating and refreshing Prizes"
				};
			}
			else{
				var options = {
					label : "Updating and refreshing Prizes",
					color : '#000',
					spinnerColor : '#000'
				}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
			} 
			window.wizSpinner.show(options);

			$('#prizesLoading').show();
			$('#prizesLoading').animate({opacity:1}, 400);
			
			refreshPromoHead($scope, $rootScope, $timeout, $compile, 1 ); //refreshed and downloads header, promos, and promo images if there are new ones
		};

		$scope.prizePageRefresh = function(){

			setTimeout(function(){
				$("#prizeWrapper").html($compile( ' ' +
					'<div class = "prizeHeaderWrapper" ng-show="InstantPrize && validPrize(InstantPrize)">' +
						'<div id = "prHeaderContainer">' +
							'<div class="prizeHeader">' +
								'Instant Prize' +
							'</div>' +
							'<div id = "prizesrow">' +
								'<div id = "prizesContainer">' +
									'<a ng-click="viewPromo(InstantPrize)">' +
										'<div><img class="prizeimage" src="{{InstantPrize.PhotoURL}}"/></div>' +
										'<div id = "instantPrizeDescription" class="prizetext">{{InstantPrize.Descript1}}</div>' +
									'</a>' +
								'</div>' +
							'</div>' +
						'</div>' +
					'</div>' +
					'<div class = "prizeHeaderWrapper" ng-repeat="PrizeHeader in PrizeHeaders" ng-show="PrizeHeaders.length > 0">' +
						'<div id = "prHeaderContainer">' +
							'<div class="prizeHeader">' +
								'{{PrizeHeader.Points}}' +
							'</div>' +
							'<div id = "prizesrow">' +
								'<div ng-repeat="Prize in PrizeHeader.Prizes" ng-class="{\'disabledPrize\' : Prize.Points > getPoints()}" ng-show = "validPrize(Prize)">' +
									'<div id = "prizesContainer">' +
										'<a ng-click="viewPromo(Prize)">' +
											'<div><img class="prizeimage " src="{{Prize.PhotoURL}}"/></div>' +
											'<div class="prizetext"> {{Prize.Descript1}} </div>' +
										'</a>' +
									'</div>' +
								'</div>' +
							'</div>' +
						'</div>' +
					'</div>' +
					'<div id="prizePad"></div>' )($scope));   // Append new elements 
			
				$scope.$apply();
			}, 10);	


			setTimeout(function(){
				//PRIZE PAGE Screen Resize
				var height = $(window).height(); // android and ios
				var width = $(window).width(); 

				$("#prizes .ui-content").css('height', height - $('#prizes .ui-header').height() - $('#prizes .ui-footer').height() );
				$("#prizes .ui-content").css('width', width );
				$("#prizes #prizesPageContent").css('width', width );

				$("#prizes .prizeHeaderWrapper").css('width', width );
				$("#prizes .prizeHeader").css('width', width );
				$("#prizes #prHeaderContainer").css('width', width );
				$("#prizes #prizescroller").css('width', width );
				$("#prizes #prizesContainer").css('width', width * .333 - 5 );
				$("#prizes .prizeHeader").css('height', height * .038 );

				$("#prizes .prizetext").css('height',  height * .0355 );
				$("#prizes .prizeimage").css('width', width * .3333 - 3.5 );
				$("#prizes .prizeimage").css('height', ( width * .3333 ) - $('#prizes .prizetext').height() );
				$("#prizes .prizetext").css('width', $('#prizes .prizeimage').width() - 4 );
				$("#prizes .prizetext").css('bottom', $("#prizesPageContent .prizetext").height() );
				$("#prizes .prizetext").css('left', 0 );

				$("#prizes #prizesContainer").css('height', $("#prizesPageContent .prizeimage").height() +  $("#prizesPageContent .prizetext").height() + 4);
				$("#prizes #prHeaderContainer").css('height', 'auto' );

				if(globals.debugApp){
					console.log('STARTING PRIZES CAROUSEL ON PRIZES PAGE');
				}
				
				setTimeout(function(){
					$("#prizes #prizesContainer").animate({opacity:1}, 400);
					window.wizSpinner.hide();

					if(globals.debugApp){
						console.log('End of Prize Refresh');
					}

					$('#prizesLoading').animate({opacity:0}, 400);

					if($('#prizescroller').iscrollview() ){
						$('#prizescroller').iscrollview('refresh');
					}
				}, 10);	

				setTimeout(function(){
					$('#prizesLoading').hide();
				}, 400);	
				$rootScope.$apply();
			},120);
		}

		$scope.getPointsClass = function(Points) {
			var myPoints = getPoints();
			if (myPoints >= Points){
				return "prizePoints blue";
			}
			else{
				return "prizePoints red";
			}
		};

		$scope.validPrize = function(Prize) {
			var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;
			var valid = now > Prize.DateStart && now < Prize.DateEnd;
			return valid;
		};

	}

})();
(function(){
	angular.module('connect.password.reset', []);
})();
(function() {
	angular.module('connect.password.reset')
		.directive('passwordReset', passwordResetDirective)
		.controller('PasswordResetController', passwordResetController);

	passwordResetDirective.$inject = [];
	passwordResetController.$inject = ['$scope', '$http'];

	function passwordResetDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'passwordReset/connect.password.reset.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) { }
	}

	function passwordResetController($scope, $http) {
		var token;
		$scope.Submit = false;

		$scope.ResetPassword = function() {
			$scope.Submit = true;
			$scope.noError = false;

			if (!$('#passwordResetForm').hasClass('ng-invalid')) {
				$scope.noError = true;
				
				if (window.device.platform == 'Android') {
					var options = {
						label : "Processing.."
					};
				} else {
					var options = {
						label : "Processing..",
						color: '#000',
						spinnerColor: '#000'
					};
				}
				window.wizSpinner.show(options); 
				
				$http.post(GetItemFromLocalData('ClientURL'), soapMessageAccountPasswordResetStart($scope.email), {timeout: 22000}).then(function(response) {

					token = $(response.data).find('AccountPasswordResetStartResult').children("TokenID").text();

					$http.post(GetItemFromLocalData('ClientURL'), soapMessageAccountPasswordResetEnd(token, $scope.email), {timeout: 22000}).then(function(response) {
						
						window.wizSpinner.hide();
						var errormessage = $(response.data).find('Standard').children("MethodErrorMsg").text();
						if (errormessage == '') {
							var successmessage = $(response.data).find('AccountPasswordResetEndResult').children("SuccessMsg").text();
							if (successmessage != ''){
								navigator.notification.alert(
									successmessage, // message
									function() {}, // callback
									'Success!', // title
									'Ok' // buttonName
								);
							}
							else{
								navigator.notification.alert(
									"We've reset your password. A new one will be emailed to you. This may take up to 60 minutes to be processed.", // message
									function() {}, // callback
									'Success!', // title
									'Ok' // buttonName
								);
							}
							setTimeout(function() {
								$scope.email = '';
								$scope.Submit = false;
							}, 500);
							$.mobile.back();
						} else {
							alert(errormessage, function() {
								console.log("..");
							});
						}
					}, function(error) {
						window.wizSpinner.hide();
						$rootScope.Error(globals.ajaxTimeoutMessage, function() {
							if(globals.debugApp){
								console.log("..");
							}
						}, false, function() {
							if(globals.debugApp){
								console.log("..");
							}
						});
					});
				}, function(error) {
					window.wizSpinner.hide();
					$rootScope.Error(globals.ajaxTimeoutMessage, function() {
						if(globals.debugApp){
							console.log("..");
						}
					}, false, function() {
						if(globals.debugApp){
							console.log("..");
						}
					});
				});
			}
		};
	}
})();
(function(){
	angular.module('connect.passwordchange', []);
})();
(function() {
	angular.module('connect.passwordchange')
		.directive('passwordChange', passwordChangeDirective)
		.controller('ChangePasswordController', passwordChangeController);

	passwordChangeDirective.$inject = [];

	passwordChangeController.$inject = ['$scope', '$http'];

	function passwordChangeDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'passwordChange/connect.passwordchange.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) {	}
	}

	function passwordChangeController($scope, $http) {

		// ON HIDE
		$('#changePassword').on('pagehide', function(){ //refresh the interests on the page on pagehide in case the user has updated them
			var scope = angular.element($("#changePassword")).scope();
			 scope.$apply(function(){
           	 scope.oldPassword = '';
	  		 scope.newPassword = '';
	  		 scope.Submit = false;
 		   });
		});
		// ON SHOW
		$('#changePassword').on('pageshow', function(){ //when the page is shown, update the form fields with the user's current info if available
			var scope = angular.element($("#changePassword")).scope();
			 scope.$apply(function(){
        	 scope.oldPassword = '';
	  	 	 scope.newPassword = '';
	   		 scope.Submit = false;
  			});
		}); 

		$scope.Submit = false;
		$scope.ChangePassword = function() {
			$scope.Submit = true;

			if (!$('#changePasswordForm').hasClass('ng-invalid')) {
				
				if (window.device.platform == 'Android') {
					var options = {
						label : "Changing Password...",
						timeout: 120
					};
				} else {
					var options = {
						label : "Changing Password...",
						color: '#000',
						spinnerColor: '#000',
						timeout: 120
					};
				}
				window.wizSpinner.show(options); 

				$http.post(GetItemFromLocalData('ClientURL'), soapMessageChangeAccountPassword($scope.oldPassword, $scope.newPassword), {timeout: 26000}).then(function(response) {
					window.wizSpinner.hide();

					var processed = $(response.data).find('ChangeAccountPasswordResult').children("Processed").text(); //indicates whether or not the web method was processed correctly (comes from the server)
					var error = $(response.data).find('Standard').children('MethodErrorMsg').text(); //indicates the error message (if any)
					if (processed == "true") {
						var successmessage = $(response.data).find('ChangeAccountPasswordResult').children("SuccessMsg").text();
						if (successmessage != ''){
							navigator.notification.alert(
								successmessage, // message
								function() {}, // callback
								'Success!', // title
								'Ok' // buttonName
							); //if the server sent back a success message then show it (note: go through the app and change any success messages like "Account Created" to success messages from the server, same with any error messages)
						}
						else{
							navigator.notification.alert(
								'Your password has been changed.', // message
								function() {}, // callback
								'Success!', // title
								'Ok' // buttonName
							); //if the server marks the request processed but did not send back a success message then show our own
						}
						setTimeout(function() {
							$scope.oldPassword = '';
							$scope.newPassword = '';
							$scope.Submit = false;
						}, 500); //clear the change password form
						$.mobile.changePage('#accountDetails');
					} else{
						alert(error, function() {});
					}
				}, function(error) {
					window.wizSpinner.hide();
					$rootScope.Error(globals.ajaxTimeoutMessage, function() {}, false, function() {});
				});
			}
		};
	}
})();
(function(){
	angular.module('connect.lottery.numbers', []);
})();
(function() {
		angular.module('connect.lottery.numbers')
			.directive('lotteryNumbers', lotteryNumbersDirective)
			.controller('LotteryNumbersController', lotteryNumbersController);

		lotteryNumbersDirective.$inject = [];

		lotteryNumbersController.$inject = ['$scope', '$rootScope', '$timeout', 'LocalData', 'ClientSet', 'Loading'];

		function lotteryNumbersDirective() {
			var directive = {
				restrict: 'E',
				templateUrl: 'lotteryNumbers/connect.lottery.numbers.html',
				link: link
			};

			return directive;

			function link(scope, element, attrs) { }
		}

		function lotteryNumbersController($scope, $rootScope, $timeout, LocalData, ClientSet, Loading) {

			$scope.showLotteryUrlByState = function(state){
                      
                if(globals.debugApp){
                	console.log( "Button " + state + " was clicked on Lottery Page."); 
                }
                     
	            var webLinkURL="";
	            if(state == 1){
	                webLinkURL = $rootScope.lotteryUrl01;
	            }
	            else if(state == 2){
	                webLinkURL = $rootScope.lotteryUrl02;
                }
                else if(state == 3){
	                webLinkURL = $rootScope.lotteryUrl03;
	            }
	              
	            // Open in Native Browser
	            if(window.device.platform === 'Android') {
	                navigator.app.loadUrl(webLinkURL, {openExternal:true});
	            } 
	            else {
	                window.open(webLinkURL, '_system', 'location=yes');
	            }        
    		};
		}
})();

(function(){
	angular.module('connect.participating.stores', []);
})();
(function() {
		angular.module('connect.participating.stores')
			.directive('participatingStores', participatingStoresDirective)
			.controller('ParticipatingStoresController', participatingStoresController);

		participatingStoresDirective.$inject = [];

		participatingStoresController.$inject = ['$scope', '$rootScope', '$timeout', 'ClientSet', 'Loading'];

		function participatingStoresDirective() {
			var directive = {
				restrict: 'E',
				templateUrl: 'participatingStores/connect.participating.stores.html',
				link: link
			};

			return directive;

			function link(scope, element, attrs) {

			}
		}

		function participatingStoresController($scope, $rootScope, $timeout, ClientSet, Loading) {

			$('#participatingStores').on('pageinit', function(){
				$('#participatingStoresList').css('height', $(window).height() - 50);
			});	//set participating store list to exact height, participatingStoresList does not use data-iscroll since it tends to cause bugs


			$('#participatingStores').on('pageshow', function(){
				window.wizSpinner.hide();
				$('#participatingStoresList').listview().listview('refresh'); //refresh the list since it changes based on which store is being selected
			}); 


			$scope.chainFriendly = globals.Change.chainFriendly;
			$scope.Call = function(store) {
				window.location.href = 'tel:' + store.Phone;
				saveClientLog(53, store.StoreID, 0, '', 0, 'calling store');
			};

			$scope.Navigate = function(store) {
				if (window.device.platform == 'Android') {
					PhoneNavigator.doNavigate(store.Latitude, store.Longitude, function() {}, function() {});
				} else
					window.location.href = 'maps:daddr=' + store.Latitude + "," + store.Longitude;
				saveClientLog(57, store.StoreID, 0, '', 0, 'checking directions for store');
			};

			$scope.Share = function(store) {
				window.plugins.socialsharing.share('I went to the ' + store.Address1 + " " + store.Address2 + " " + store.City + ", " + store.State + " " + globals.Change.chainFriendly + "." + '\n' + ClientSet.getSocialShareURL(), 'Check out this great ' + globals.Change.chainFriendly + ' location.');
				saveClientLog(0, store.StoreID, 0, '', 0, 'user shared store');
			};

			$scope.Feedback = function(store) {
				$timeout(function() {
					$rootScope.FeedbackStore = store;
					$rootScope.AppFeedback = false;
				}, 1);
				$.mobile.changePage('#feedback');
			};

			$scope.Extra = 0;
			$scope.viewStoreDetails = function(store) {
				$timeout(function() {
					if ($scope.Extra == store.StoreID){
						$scope.Extra = 0;
					}
					else{
						$scope.Extra = store.StoreID;
					}

					saveClientLog(51, store.StoreID, 0, '', 0, 'viewed store details');
				});
			}

			//TODO: only resolve no reject
			Loading.then(function() {
				$scope.ShowGas = ClientSet.getShowGasPrice();
			});

			$scope.getGasPrice = function(Store) {
				var gasType = getPreferredGas();
				if (gasType == 'Plus') {
					if (Store.PlusPrice > 0){
						return 'Plus: $' + Store.PlusPrice.toFixed(2);
					}
					else{
						return '';
					}
				} else if (gasType == 'Premium') {
					if (Store.PremiumPrice > 0){
						return 'Prem: $' + Store.PremiumPrice.toFixed(2);
					}
					else{
						return '';
					}
				} else if (gasType == 'Diesel'){
					if (Store.DieselPrice > 0){
						return 'Dies: $' + Store.DieselPrice.toFixed(2);
					}
					else{
						return '';
					}
				} else if (gasType == 'Kerosene') {
					if (Store.KerosenePrice > 0){
						return 'Ker: $' + Store.KerosenePrice.toFixed(2);
					}
					else{
						return '';
					}
				} else {
					if (Store.RegularPrice > 0){
						return 'Reg: $' + Store.RegularPrice.toFixed(2);
					}
					else{
						return '';
					}
				}
			};


			$scope.getGasLastUpdate = function(GasLastUpdate) {

				var date = new Date(GasLastUpdate);
				var hour = date.getHours();
				var minute = date.getMinutes();
				var ap = "AM";
				if (hour > 11) {
					ap = "PM";
				}
				if (hour > 12) {
					hour = hour - 12;
				}
				if (hour == 0) {
					hour = 12;
				}
				//   if (hour   < 10) { hour   = "0" + hour;   }
				if (minute < 10) {
					minute = "0" + minute;
				}
				var timeString = hour + ':' + minute + ' ' + ap;
				var formattedDateString = (date.getMonth() + 1) + '/' + date.getDate() + ' ' + timeString; //date.format("m/dd h:MM Z");
				return formattedDateString;
			};

		}
})();
(function(){
	angular.module('connect.login', []);
})();
(function(){
	angular.module('connect.login')
	.directive('connectLogin', connectLoginDirective)
	//TODO: This controller should be named for what it's being used for. IE it's a login page
	.controller('redeemRegisterAlertController', loginRegisterController);

	connectLoginDirective.$inject = [];
	loginRegisterController.$inject = ['$scope', '$rootScope', '$timeout', '$compile', 'Sync'];

	function connectLoginDirective(){
		var directive = {
			restrict: 'E',
			templateUrl: 'login/connect.login.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs){
			
		}
	}

		// REDEEM REGISTER ALERT CONTROLLER //
//**********************************//
//TODO: Controller really needed if it's just href? Might be needed for future
	function loginRegisterController($scope, $rootScope, $timeout, $compile, Sync){
		
		$('#redeemRegisterAlert').on('pageinit', function(){
			$('#redeemRegisterAlertContent').css('margin-top', ($(window).height()-175)/2);
		});


		$('#redeemRegisterAlert').on('pageshow', function(){
			setTimeout(function(){
				if(globals.debugApp){
					console.log('Splash hidden');
				}
				navigator.splashscreen.hide(); //hide the splash screen
				window.wizSpinner.hide(); 
			}, 100);
		});

		//page is a string of the html file
		$scope.redirect = function(page) {
			if(page == 'login'){
				$.mobile.changePage('#login');
				console.log('DEBUG: Going into login page');
			}
			else if(page == 'linkAccount'){
				$.mobile.changePage('#linkAccount');
			}
			else if(page == 'passwordReset'){
				$.mobile.changePage('#passwordReset');
			}
			else if(page == 'main'){
				$.mobile.changePage('#main');
			}
		}
	}
})();
(function(){
	angular.module('connect.local.data', []);
})();
(function(){
	angular.module('connect.local.data')

	.factory('LocalData', connectLocalDataService);


	function connectLocalDataService(){

		return {

			saveLocalData : function(){
				SaveUserAccountToAppData( JSON.stringify(globals.userAccount) );
				if(globals.debugApp){
					console.log('DEBUG: Content Global.userAccount was saved : ' + JSON.stringify( globals.userAccount ) );
				}
			},

			getElectrumUniqueID : function(){
				var tempElectrumUniqueID; 

				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		tempElectrumUniqueID = globals.userAccount.get('ElectrumUniqueID');  //Get User Account Object	
				}
		      	else{
					tempElectrumUniqueID = localStorage.getItem('Electrum.Unique.ID');
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: getElectrumUniqueID() : ' + tempElectrumUniqueID);
				}
				//return data requested
				if (tempElectrumUniqueID){
					return tempElectrumUniqueID;
				}
				else{
					return '';
				}
			},
			setElectrumUniqueID : function(value){
				//Check if LocalStorage is enabled and SET data
				if( globals.localStorage == false){
		       		globals.userAccount.set('ElectrumUniqueID', value);  
				}
		      	else{
					localStorage.setItem('Electrum.Unique.ID', value);
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: setElectrumUniqueID() - Setting value: ' + value);
				}
			},


			//put in account array
			getUniqueID : function(){
				var tempUniqueID; 

				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		tempUniqueID = globals.userAccount.get('UniqueID');  //Get User Account Object
				}
		      	else{
					tempUniqueID = localStorage.getItem('UniqueID');
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: getUniqueID() : ' + tempUniqueID);
				}

				return tempUniqueID;
			},
			setUniqueID : function(value){
				//Check if LocalStorage is enabled and SET data
				if( globals.localStorage == false){
		       		globals.userAccount.set('UniqueID', value);  //Get User Account Object
				}
		      	else{
					localStorage.setItem('UniqueID', value);
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: setUniqueID() : ' + value);
				}
			},


			//put in account array
			getUserType : function(){
				var tempUserType;  

				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		tempUserType = globals.userAccount.get('UserType');  //Get User Account Object
				}
		      	else{
					tempUserType = localStorage.getItem('UserType');
				}

				
				if(globals.debugApp){
					console.log('USER ACCOUNT: getUserType() : ' + tempUserType);
				}

				return tempUserType;
			},
			setUserType : function(value){
				//Check if LocalStorage is enabled and SET data
				if( globals.localStorage == false){
		       		globals.userAccount.set('UserType', value);  //Get User Account Object
				}
		      	else{
					localStorage.setItem('UserType', value);
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: setUserType() : ' + value);
				}
			},


			//put in account array
			getUserStatus : function(){
				var tempUserStatus;  //Get User Account Object

				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		tempUserStatus = globals.userAccount.get('UserStatus');  //Get User Account Object
				}
		      	else{
					tempUserStatus = localStorage.getItem('UserStatus');
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: getUserStatus() : ' + tempUserStatus);
				}

				return tempUserStatus;
			},
			setUserStatus : function(value){
				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		globals.userAccount.set('UserStatus', value);  //Get User Account Object
				}
		      	else{
					localStorage.setItem('UserStatus', value);
				}

				if(globals.debugApp)
					console.log('USER ACCOUNT: setUserStatus() : ' + value);
			},


			//put in account array
			getReleaseDate : function(){
				var tempReleaseDate;  //Get User Account Object

				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		tempReleaseDate = globals.userAccount.get('ReleaseDate');  //Get User Account Object
				}
		      	else{
					tempReleaseDate = localStorage.getItem('ReleaseDate');
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: getReleaseDate() : ' + tempReleaseDate);
				}

				return tempReleaseDate;
			},
			setReleaseDate : function(value){
				//Check if LocalStorage is enabled and GET data
				if( globals.localStorage == false){
		       		globals.userAccount.set('ReleaseDate', value);  //Get User Account Object
				}
		      	else{
					localStorage.setItem('ReleaseDate', value);
				}

				if(globals.debugApp){
					console.log('USER ACCOUNT: setReleaseDate() : ' + value);
				}
			},


			getElectrumBarcode : function(){
				var tempElectrumBarcode = globals.userAccount.get('ElectrumBarcode');  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: getElectrumBarcode() : ' + tempElectrumBarcode);
				}

				if (tempElectrumBarcode){
					return tempElectrumBarcode;
				}
				else{
					return '';
				}
			},
			setElectrumBarcode : function(value){
				globals.userAccount.set('ElectrumBarcode', value);  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: getElectrumBarcode() : ' + value);
				}
			},



			getKickbackSignedIn : function(){
				var tempKickbackSignedIn = globals.userAccount.get('KickbackSignedIn');  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: getKickbackSignedIn() : ' + tempKickbackSignedIn);
				}

				if(tempKickbackSignedIn && tempKickbackSignedIn != ''){
					return tempKickbackSignedIn;
				}
				else{
					return 0;
				}
			},
			setKickbackSignedIn : function(value){
				globals.userAccount.set('KickbackSignedIn', value);  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: setKickbackSignedIn() : ' + value);
				}
			},
			getKickbackSignedIn : function(){
				var signedIn = localStorage.getItem('Kickback.SignedIn');
				if(signedIn){
					return signedIn;
				}
				else{
					return 0;
				}
			},

			getBeaconWatchID : function(){
				var tempBeaconWatchID = globals.userAccount.get('BeaconWatchID');  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: getBeaconWatchID() : ' + tempBeaconWatchID);
				}

				return tempBeaconWatchID;

			},
			setBeaconWatchID : function(value){
				globals.userAccount.set('BeaconWatchID', value);  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: setBeaconWatchID() : ' + value);
				}
			},



			getBeaconWatchIDLegacy : function(){
				var beaconwatchid = localStorage.getItem('Beacon.Watch.ID');
				return beaconwatchid;
			},
			
			getDataVersion : function(){ 
				var tempDataVersion = globals.userAccount.get('DataVersion');  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: getDataVersion() : ' + tempDataVersion);
				}

				return parseInt(tempDataVersion);
			},
			setDataVersion : function(value){
				globals.userAccount.set('DataVersion', value);  //Get User Account Object

				if(globals.debugApp){
					console.log('USER ACCOUNT: setDataVersion() : ' + value);
				}
			},

			/*
			getDataVersionLegacy : function(){ 
				var dataVersion = window.localStorage.getItem('DataVersion');
				
				return parseInt(dataVersion);
			},


			getSyncNow : function(){ 
				var tempSyncNow = globals.userAccount.get('SyncNow'); //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: getSyncNow() : ' + tempSyncNow);

				if (!tempSyncNow)
					return 0;
				else
					return parseInt(tempSyncNow);
			},
			setSyncNow : function(value){
				globals.userAccount.set('SyncNow', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setSyncNow() : ' + value);
			},


			getSyncNowLegacy : function(){ 
				var syncNow = window.localStorage.getItem('SyncNow');
				if (!syncNow)
					return 0;
				else
					return parseInt(syncNow);
			},
			
			getVerifyPrompt : function(){ // Flag to show email verify prompt
				var tempVerifyPrompt = globals.userAccount.get('VerifyPrompt');  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: getEmail() : ' + tempVerifyPrompt);

				if (!tempVerifyPrompt)
					return 0;
				else
					return parseInt(tempVerifyPrompt);
			},
			setVerifyPrompt : function(value){
				globals.userAccount.set('VerifyPrompt', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setVerifyPrompt() : ' + value);
			},
			getVerifyPromptLegacy : function(){ // Flag to show email verify prompt
				var verifyPrompt = window.localStorage.getItem('VerifyPrompt');
				if (!verifyPrompt)
					return 0;
				else
					return parseInt(verifyPrompt);
			},
			
			getRegisteredUser : function(){
				var tempAccountID = globals.userAccount.get('AccountID'); //Get User Account Object

				if(globals.debugApp)
					console.log('*** USER ACCOUNT: getRegisteredUser() : ' + tempAccountID != null && tempAccountID != '' );

				return tempAccountID != null && tempAccountID != '';
			},


			getAccountID : function(){
				var tempAccountID = globals.userAccount.get('AccountID');  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: getAccountID() : ' + tempAccountID);

				return tempAccountID;
			},
			setAccountID : function(value){
				globals.userAccount.set('AccountID', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setAccountID() : ' + value);
			},
			getRegisteredUserLegacy : function(){
				var accountid = window.localStorage.getItem('AccountID');
				return accountid != null && accountid != '' && accountid != undefined; //returns whether or not the user is registered by checking accountid
			},
			
			getEmail : function(){
				var tempEmail = globals.userAccount.get('Email'); //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: getEmail() : ' + tempEmail);

				return tempEmail;
			},
			setEmail : function(value){
				globals.userAccount.set('Email', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setEmail() : ' + value);
			},
			getEmailLegacy : function(){
				return window.localStorage.getItem('Email');
			},
			
			getFullName : function(){
				var tempFullName = globals.userAccount.get('FullName'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getFullName() : ' + tempFullName);

				return tempFullName;
			},
			setFullName : function(value){
				globals.userAccount.set('FullName', value);  //Get User Account Object
				window.localStorage.setItem('FullName', value);

				if(globals.debugApp)
					console.log('USER ACCOUNT: setFullName() : ' + value);
			},

			
			getFullNameLegacy : function(){
				return window.localStorage.getItem('FullName');
			},
			
			
			getGamePlays : function(){
				var tempGamePlays = globals.userAccount.get('GamePlays'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getGamePlays() : ' + tempGamePlays);

				if (!tempGamePlays)
					tempGamePlays = 0;
				else
					tempGamePlays = parseInt(tempGamePlays);

				return tempGamePlays;
			},
			setGamePlays : function(value){
				globals.userAccount.set('GamePlays', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setGamePlays() : ' + value);
			},
			
			getGamePlaysLegacy : function(){
				var GamePlays = window.localStorage.getItem('GamePlays');
				if (!GamePlays)
					GamePlays = 0;
				else
					GamePlays = parseInt(GamePlays);
				return GamePlays;
			},
			

			
			getNewPlayer : function(){
				var tempNewPlayer = globals.userAccount.get('NewPlayer'); 
				console.log('USER ACCOUNT: getNewPlayer() : ' + tempNewPlayer);

				//returns whether or not this is the first time the user is playing the game
				return parseInt(tempNewPlayer) == 1;
			},
			setNewPlayer : function(value){
				globals.userAccount.set('NewPlayer', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setNewPlayer() : ' + value);
			},
			getNewPlayerLegacy : function(){
				return parseInt(window.localStorage.getItem('NewPlayer')) == 1; //returns whether or not this is the first time the user is playing the game
			},
			
			getPointsLegacy : function(){
				var tempPoints = globals.userAccount.get('Points'); 
				console.log('USER ACCOUNT: getPoints() : ' + tempPoints);

				//returns whether or not this is the first time the user is playing the game
				return parseInt(tempPoints);
			},
			setPoints : function(value){
				globals.userAccount.set('Points', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPoints() : ' + value);
			},
			getPoints : function(){
				return parseInt(window.localStorage.getItem('Points'));
			},

			
			getPromoPlay : function(){
				var tempPromoPlay = globals.userAccount.get('PromoPlay'); 
				console.log('USER ACCOUNT: getPromoPlay() : ' + tempPromoPlay);

				//returns whether or not this is the first time the user is playing the game
				return parseInt(tempPromoPlay);
			},
			setPromoPlay : function(value){
				globals.userAccount.set('PromoPlay', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPromoPlay() : ' + value);
			},
			
			getPromoPlayLegacy : function(){
				return parseInt(window.localStorage.getItem('PromoPlay')); //returns whether or not instant prize is available for this game round
			},




			getGameCard : function(cardNumber){

				if(globals.debugApp)
					console.log('USER ACCOUNT: getGameCard() - Get Card - : ' + cardNumber );

				switch (cardNumber) {
				    case 0:
				        return globals.userAccount.get('card1');
				    case 1:
				        return globals.userAccount.get('card2');
				    case 2:
				        return globals.userAccount.get('card3');
				    case 3:
				        return globals.userAccount.get('card4');
				    case 4:
				        return globals.userAccount.get('card5');
				    case 5:
				        return globals.userAccount.get('card6');
				    case 6:
				        return globals.userAccount.get('card7');
				    case 7:
				        return globals.userAccount.get('card8');
				    case 8:
				        return globals.userAccount.get('card9');
				    case 9:
				        return globals.userAccount.get('card10');
				    case 10:
				        return globals.userAccount.get('card11');
				    case 11:
				        return globals.userAccount.get('card12');
				    case 12:
				        return globals.userAccount.get('card13');
				    default:
				    	return null;
				}
			},
			setGameCard : function(cardName, value){

				if(globals.debugApp)
					console.log('USER ACCOUNT: setGameCard() - Setting Card - : ' + cardName + ' to ' + value);

				switch (cardName) {
				    case 'bg1.png':
				        globals.userAccount.set('card1', value);
				        break;
				    case 'cardfront.png':
				        globals.userAccount.set('card2', value);
				        break;
				    case 'cardback.png':
				        globals.userAccount.set('card3', value);
				        break;
				    case 'cardfrontmatch.png':
				        globals.userAccount.set('card4', value);
				        break;
				    case 'promo.png':
				        globals.userAccount.set('card5', value);
				        break;
				    case '1.png':
				        globals.userAccount.set('card6', value);
				        break;
				    case '2.png':
				        globals.userAccount.set('card7', value);
				        break;
				    case '3.png':
				        globals.userAccount.set('card8', value);
				        break;
				    case '4.png':
				        globals.userAccount.set('card9', value);
				        break;
				    case '5.png':
				        globals.userAccount.set('card10', value);
				        break;
				    case '6.png':
				        globals.userAccount.set('card11', value);
				        break;
				    case '7.png':
				        globals.userAccount.set('card12', value);
				        break;
				    case '8.png':
				        globals.userAccount.set('card13', value);
				        break;
				    default:
				    	return null;
				}
			},


			
			getPushPromo : function(){ //returns the promo that came through a push message
				var tempPushPromo = globals.userAccount.get('PushPromo'); 
				console.log('USER ACCOUNT: getPushPromo() : ' + tempPushPromo);

				if (!tempPushPromo){
					return null; //there are many null returns in factories that indicate something does not exist or not to show or use something
				}
				else{
					tempPushPromo = JSON.parse(tempPushPromo);
					var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;
					var valid = (tempPushPromo.Uses == 0 || tempPushPromo.AccountUses < tempPushPromo.Uses) && now > tempPushPromo.DateStart && now < tempPushPromo.DateEnd; //make sure the promotion is valid before returning it
					if (valid)
						return tempPushPromo;
					else
						return null;
				}
			},
			setPushPromo : function(value){
				globals.userAccount.set('PushPromo', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPushPromo() : ' + value);
			}, 
			getPushPromoLegacy : function(){ //returns the promo that came through a push message
				var PushPromo = window.localStorage.getItem('PushPromo');

				if (!PushPromo)
					return null; //there are many null returns in factories that indicate something does not exist or not to show or use something
				else{
					PushPromo = JSON.parse(PushPromo);
					var now = moment().tz('America/New_York').toDate().getTime() - globals.timeZoneOffset;
					var valid = (PushPromo.Uses == 0 || PushPromo.AccountUses < PushPromo.Uses) && now > PushPromo.DateStart && now < PushPromo.DateEnd; //make sure the promotion is valid before returning it
					if (valid)
						return PushPromo;
					else
						return null;
				}
			},


			//TODO: This should be in a service or a helper method for the Main Controller
			getFocusPromo : function(promos){ //return the promotion to be shown in the focus promotion time of day based now module
				var now = moment().hour();
				var message = ""; //holds the message to be shown in the now module based on the time of day
				if (5 <= now && now <= 10){
					now = 1;
					message = "Start Your Morning Right!";
				}
				else if (11 <= now && now <= 16){
					now = 2;
					message = "How About This for Lunch?";
				}
				else if (17 <= now && now <= 22){
					now = 3;
					message = "Join Us for Dinner!";
				}
				else{
					now = 4;
					message = "Late Night Snack?";
				}
				var focusPromos = [];
				for (var i = 0; i < promos.length; i++){
					if (promos[i].FocusTime == now){
						focusPromos.push(promos[i]); //go through all the promos we have (passed into this function) and get the ones that match this focus time
					}
				}
				if (focusPromos.length == 0) //no promos match the current focus time
					return null;
				else{
					var index = Math.floor(Math.random() * ((focusPromos.length - 1) - 0 + 1)) + 0;
					focusPromos[index].FocusMessage = message;
					return focusPromos[index]; //randomly select one focus promo and return it
				}
			},


			getPhone : function(){
				var tempPhone = globals.userAccount.get('Phone'); 
				console.log('USER ACCOUNT: getPhone() : ' + tempPhone);

				return tempPhone;
			},
			setPhone : function(value){
				globals.userAccount.set('Phone', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPhone() : ' + value);
			},
			getPhoneLegacy : function(){
				return window.localStorage.getItem('Phone');
			},

			
			getBirthday : function(){
				var tempBirthday = globals.userAccount.get('Birthday'); 
				console.log('USER ACCOUNT: getBirthday() : ' + tempBirthday);

				return tempBirthday;
			},
			setBirthday : function(value){
				globals.userAccount.set('Birthday', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setBirthday() : ' + value);
			},
			getBirthdayLegacy : function(){
				return parseInt(window.localStorage.getItem('Birthday'));
			},

			
			getGeoPromo : function(){
				var tempGeoPromo = globals.userAccount.get('GeoPromo'); 
				console.log('USER ACCOUNT: getGeoPromo() : ' + tempGeoPromo);

				return tempGeoPromo;
			},
			setGeoPromo : function(value){
				globals.userAccount.set('GeoPromo', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setGeoPromo() : ' + value);
			}, 
			getGeoPromoLegacy : function(){
				return window.localStorage.getItem('GeoPromo');
			},

			
			getPreferredGas : function(){ //get the user's preferred gas type for display with stores that have gas
				var gasType = globals.userAccount.get('PreferredGas');
				if (!gasType || gasType == '')
					return 'Regular';
				else
					return gasType;
			},
			setPreferredGas : function(value){
				globals.userAccount.set('PreferredGas', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPreferredGas() : ' + value);
			}, 
			getPreferredGasLegacy : function(){ //get the user's preferred gas type for display with stores that have gas
				var gasType = window.localStorage.getItem('PreferredGas');
				if (!gasType)
					return 'Regular';
				else
					return gasType;
			},


			getPushEnabled : function(){ //android only -- get whether or not the user has enabled push
				var tempPushEnabled = globals.userAccount.get('PushEnabled');
				if (!tempPushEnabled || tempPushEnabled == 'true')
					return true;
				else
					return false;
			},
			setPushEnabled : function(value){
				globals.userAccount.set('PushEnabled', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPushEnabled() : ' + value);
			},
			getPushEnabledLegacy : function(){ //android only -- get whether or not the user has enabled push
				var pushenabled = window.localStorage.getItem('PushEnabled');
				if (!pushenabled || pushenabled == 'true')
					return true;
				else
					return false;
			},


			//   RATING MODULE IS NOT BEING USED
			getShowRating : function(){ //get whether or not to show the Rating now module, it should be shown 1 week after the first time the user uses the app
				try{
					var now = moment().toDate().getTime();
					var first = parseInt( globals.userAccount.get('Rating') );
					if (first == 0)
						return false;
					else if ((now - first) > 604800000)
						return true;
					else
						return false;
				}
				catch (err){
					return false;
				}
			},
			setShowRating : function(value){
				parseInt( globals.userAccount.set('Rating', value) )  //Get User Account Object
				console.log('USER ACCOUNT: setShowRating() : ' + value);
			},
			getShowRating : function(){ //get whether or not to show the Rating now module, it should be shown 1 week after the first time the user uses the app
				try{
					var now = moment().toDate().getTime();
					var first = parseInt(window.localStorage.getItem('Rating'));
					if (first == 0)
						return false;
					else if ((now - first) > 604800000)
						return true;
					else
						return false;
				}
				catch (err){
					return false;
				}
			},

			//TODO: Move this to main directory
			getGreeting : function(){
				//var index = Math.floor(Math.random() * ((greetings.length - 1) - 0 + 1)) + 0; //randomly pick a greeting from js/greetings.js to show on the main/now screen header
				var now = moment().hour();
				var message = ""; //holds the message to be shown in the now module based on the time of day
				if (5 <= now && now <= 10){
					message = "Good Morning";
				}
				else if (11 <= now && now <= 16){
					message = "Good Afternoon";
				}
				else if (17 <= now && now <= 22){
					message = "Good Evening";
				}
				else{
					message = "Have a great late night";
				}

				return message;
			},


			getShowFasCash : function(){
				var tempShowFasCash = globals.userAccount.get('FasCash'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getShowFasCash() : ' + tempShowFasCash);

				return !tempShowFasCash;
			},
			setShowFasCash : function(value){
				globals.userAccount.set('FasCash', value);  //Get User Account Object

				if(globals.debugApp)
					console.log('USER ACCOUNT: setShowFasCash() : ' + value);
			}, 
			getShowFasCashLegacy : function(){
				return !window.localStorage.getItem('FasCash'); //indicates if the user has already registered for fascash in which case do not show the fascash now module (only used for Fas APP)
			},


			getFasCashApplication : function(){ //gets (if available) a saved in progress fas cash application
				var tempFasCashApplication = globals.userAccount.get('FasCashApplication'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getFasCashApplication() : ' + tempFasCashApplication);

				if (tempFasCashApplication){
					return JSON.parse(sjcl.decrypt("FasCashApplication", tempFasCashApplication));
				}
				else
					return null;
			},
			setFasCashApplication : function(){ //gets (if available) a saved in progress fas cash application
				globals.userAccount.set('FasCashApplication', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setFasCashApplication() : ' + tempFasCashApplication);
			},/*
			getFasCashApplicationLegacy : function(){ //gets (if available) a saved in progress fas cash application
				var application = window.localStorage.getItem('FasCashApplication');
				if (application){
					return JSON.parse(sjcl.decrypt("FasCashApplication", application));
				}
				else
					return null;
			},

			*/


			//get whether or not to show the now share module, should show up every week starting with the first time 
			//the app is launched. 
			//Does not need a SET function. 
			getShowShare : function(){ 
				var tempShowShare = globals.userAccount.get('ShowShare'); 

				if(globals.debugApp){
					console.log('USER ACCOUNT: getShowShare() : ' + tempShowShare);
				}
	
				var now = moment().toDate().getTime();

				if (tempShowShare){
					if (now - tempShowShare > 604800000){
						globals.userAccount.set('ShowShare', now);  //set
						return true;
					}
					else{
						return false;
					}
				}
				else{
					globals.userAccount.set('ShowShare', now);  //set
					return true;
				}
			},

			/*
			getShowShareLegacy : function(){ 
				//get whether or not to show the now share module, should show up every week starting with the first time 
				//the app is launched
				var sharelast = parseInt(window.localStorage.getItem('Share.Last'));
				var now = moment().toDate().getTime();
				if (sharelast){
					if (now - sharelast > 604800000){
						window.localStorage.setItem('Share.Last', now);
						return true;
					}
					else
						return false;
				}
				else{
					window.localStorage.setItem('Share.Last', now);
					return true;
				}
			},
			*/



			getAppVersion : function(){ //get the version of the app to show on the about screen
				var tempAppVersion = globals.userAccount.get('AppVersion'); 
				console.log('USER ACCOUNT: getProductVersion() : ' + tempAppVersion);

				if (tempAppVersion && tempAppVersion != ''){
					return tempAppVersion;
				}
				else{
					return '2.x';
				}
			},
			setAppVersion : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('AppVersion', value); 

				if(globals.debugApp){
					console.log('USER ACCOUNT: setAppVersion() : ' + value);
				}
			},

			/*
			getProductVersionLegacy : function(){ //get the version of the app to show on the about screen
				var productVersion = window.localStorage.getItem('AppVersion');
				if (productVersion)
					return productVersion;
				else
					return '2.x';
			},
			*/

/*
			getDeviceModel : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempDeviceModel = globals.userAccount.get('DeviceModel'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getDeviceModel() : ' + tempDeviceModel );

				return tempDeviceModel;
			},
			setDeviceModel : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('DeviceModel', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setDeviceModel() : ' + value);
			}, 

			getDeviceType : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempDeviceType = globals.userAccount.get('DeviceType'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getDeviceType() : ' + tempDeviceType );

				return tempDeviceType;
			},
			setDeviceType : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('DeviceType', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setDeviceType() : ' + value);
			}, 

			getDeviceVersion : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempDeviceVersion = globals.userAccount.get('DeviceVersion'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getDeviceVersion() : ' + tempDeviceVersion );

				return tempDeviceVersion;
			},
			setDeviceVersion : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('DeviceVersion', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setDeviceVersion() : ' + value);
			}, 

			getDeviceOS : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempDeviceOS = globals.userAccount.get('DeviceOS'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getDeviceOS() : ' + tempDeviceOS );

				return tempDeviceOS;
			},
			setDeviceOS : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('DeviceOS', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setDeviceOS() : ' + value);
			}, 





			getPushToken : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempPushToken = globals.userAccount.get('PushToken'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getPushToken() : ' + tempPushToken);

				return tempPushToken;
			},
			setPushToken : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('PushToken', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPushToken() : ' + value);
			}, 


			getTokenID : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempTokenID = globals.userAccount.get('TokenID'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getTokenID() : ' + tempTokenID);

				return tempTokenID;
			},
			setTokenID : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('TokenID', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setTokenID() : ' + value);
			}, 


			getUDID : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempUDID = globals.userAccount.get('UDID'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getUDID() : ' + tempUDID);

				return tempUDID;
			},
			setUDID : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('UDID', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setUDID() : ' + value);
			}, 	


			getAppRestart : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempAppRestart = globals.userAccount.get('AppRestart'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getAppRestart() : ' + tempClientLog);

				return tempAppRestart;
			},
			setAppRestart : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('AppRestart', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setAppRestart() : ' + value);
			}, 




			getPromosConstruct : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempPromosConstruct = globals.userAccount.get('PromosConstruct'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getPromosConstruct() : ' + tempPromosConstruct);

				return tempPromosConstruct;
			},
			setPromosConstruct : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('PromosConstruct', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPromosConstruct() : ' + value);
			}, 


			getStoreListRetry : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempStoreListRetry = globals.userAccount.get('StoreListRetry'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getStoreListRetry() : ' + tempStoreListRetry);

				return tempStoreListRetry;
			},
			setStoreListRetry : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('StoreListRetry', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setStoreListRetry() : ' + value);
			}, 


			getPromoRetry : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempPromoRetry = globals.userAccount.get('PromoRetry'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getPromoRetry() : ' + tempPromoRetry);

				return tempStoreListRetry;
			},
			setPromoRetry : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('PromoRetry', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setPromoRetry() : ' + value);
			}, 



			getGameProgress : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempGameProgress = globals.userAccount.get('GameProgress'); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: getGameProgress() : ' + tempGameProgress);

				return tempGameProgress;
			},
			setGameProgress : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('GameVersion', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setGameProgress() : ' + value);
			},



			getVersion : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempVersion = globals.userAccount.get('Version'); 
				console.log('USER ACCOUNT: getVersion() : ' + tempVersion);

					return tempVersion;
			},
			setVersion : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('Version', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setVersion() : ' + value);
			},


			getGameVersion : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var tempGameVersion = globals.userAccount.get('GameVersion'); 
				console.log('USER ACCOUNT: getPoints() : ' + tempGameVersion);

				if (!tempGameVersion || tempGameVersion == '')
					return null;
				else
					return tempGameVersion;
			},
			setGameVersion : function(value){ //get the version of the app to show on the about screen
				globals.userAccount.set('GameVersion', value); 

				if(globals.debugApp)
					console.log('USER ACCOUNT: setGameVersion() : ' + value);
			},

			*/

			getGameVersionLegacy : function(){ //get the game version of the client to compare with the game version on the server to determine whether or not to udpateGameAssets (defined below)
				var gameversion = window.localStorage.getItem('Game.Version');
				if (!gameversion){
					return null;
				}
				else{
					return gameversion;
				}
			}
		};
	}
})();
(function(){
	angular.module('connect.loading', []);
})();
//      SUMMARY:      
//the loading factory is the main factory for the application, the sync process gets called here ...
//many controllers rely on the Loading factory promise to be resolved which indicates that the 
//sync process is complete and that data is available for controllers to access (or the process 
//eited due to an ajax error or initialSyncDoneTimeout caused the factory promise to be resolved
//and the loading page to hide but the sync is still running in the background, if this is case 
//the user might see slightly outdated data)
(function() {
	angular.module('connect.loading')
	.factory('Loading', loadingService);

	loadingService.$inject = ['$http', '$q', '$rootScope', '$timeout', 'Sync'];


	function loadingService($http, $q, $rootScope, $timeout, Sync) {
		
		setTimeout(function() {
			globals.Change = setChain();
		});

		var deferred = $q.defer(); //Angular's promise library
		
		//The following timeout is needed
		setTimeout(function() {
			globals.Stores = getAllStores(); //Storelist
			setupLocalData($rootScope, $timeout); //defined in js/sync.js
		}, 600); 


		function resolve(){
			if(globals.debugApp){
				console.log("Calling deferred.resolved())");
			}

			$timeout(function(){
				deferred.resolve(); //resolve the Loading promise
			},1);
		}


		// FUNCTION: SETUP LOCAL DATA //
		//function called before syncing setup some data
		function setupLocalData($rootScope, $timeout) {
			//Save ClientURL first (high priority)
			SetItemInLocalData('ClientURL', globals.Change.server + 'Market_' + globals.Change.chain + '_001/WebService/WebService1.asmx' );
			if(globals.debugApp){
		   	 	console.log( 'ClientURL used: ' + GetItemFromLocalData('ClientURL') );
		   		console.log("SetUpLocalData initiated..");
		   		console.log("App version " + globals.appVersion );
		   	}

		    saveClientLog(48,0,0, "SetUpLocalData initiated..");
		    setSyncVersion();//Set sync version variable
			
			var oldAppVersion = getAppVersion();
			var first = moment().toDate().getTime(); //gets the current time in Unix milliseconds
			//window.localStorage.setItem('Rating', first); //Sets Rating to the first app launch time in Unix milliseconds so we can determine when to show the Rating now module (one week from initial app launch)

		    if(oldAppVersion < globals.appVersion){
		    	if(globals.debugApp){
		    		console.log("App Updated: updated to " + globals.appVersion + " from " + oldAppVersion + ".. Full cleanup/sync will take place.");
		    	}
		    	saveClientLog(48,0,0, "App Updated: updated to " + globals.appVersion + " from " + oldAppVersion + ".. Full cleanup/sync will take place.");
		    	globals.initialSyncDoneTimeout = 30000;

				SetItemInLocalData('DataVersion',null);
				SetItemInLocalData('GameVersion',null);
				SetItemInLocalData('SyncNow',null);

		    	clearStoreAndPromoData();
		    }
		    else if ( getSyncNow() == true ){
		    	if(globals.debugApp){
		    		console.log("Sync now was activated: .. Full cleanup/sync will take place.");
		    	}
		    	saveClientLog(49,0,0, "Sync now was activated: .. Full cleanup/sync will take place.");
				globals.initialSyncDoneTimeout = 30000;

				SetItemInLocalData('DataVersion',null);
				SetItemInLocalData('GameVersion',null);
				SetItemInLocalData('SyncNow',null);

				clearStoreAndPromoData();
			}
			else {
				globals.initialSyncDoneTimeout = 20000;
			}

			//needed for the loading of clearStoreAndPromoData();
			setTimeout(function(){

				SetItemInLocalData('ReleaseDate',globals.releaseDate);
				SetItemInLocalData('AppVersion',globals.appVersion);
				SetItemInLocalData('PromosConstruct',0);
				SetItemInLocalData('StoreListRetry',0);
				SetItemInLocalData('PromoRetry',0);
				SetItemInLocalData('DeviceModel',window.device.model);
				SetItemInLocalData('DeviceType','mobile');
				SetItemInLocalData('DeviceVersion',window.device.version);
				SetItemInLocalData('DeviceOS',window.device.platform);

				//$rootScope.RegisteredUser is used throughout js/app.js (Angular) to indicate
				//whether or not this is a registered user. This is not Angular code but we have access to $rootScope since it was passed into the setupLocalData function
				$rootScope.RegisteredUser = getRegisteredUser();
				if(globals.debugApp){
					console.log( '() DEBUG: Setting $rootScope.RegisteredUser in setupLoacalData() to ' + $rootScope.RegisteredUser + ' for acctID - ' + getAccountID() );
				}
				//if client settings have not been saved to local storage (for example they have not yet been downloaded from the server and this is the first app launch), then load them into 
				//localStorage from installClientSets all install Arrays are in js/installTables.js
				// ** LOAD ClientSets ** //
				var cs =  LoadClientSetsFromAppData();

				
				//Test to see if cs (clientsets) is empty
				if (!cs || Object.getOwnPropertyNames(cs).length < 2){
					cs = {};
					//console.log('DEBUG-SYNC: globals.installClientSets == ' + JSON.stringify(installClientSets) );
					for (var h = 0; h < globals.installClientSets.length; h++){
						cs[globals.installClientSets[h].ItemName.toLowerCase()] = globals.installClientSets[h].ItemValue;
					}
					SaveClientSetsToAppData( JSON.stringify(cs) );
					if(globals.debugApp){
						console.log('DEBUG-SYNC: Clientset was not saved..  Using Defaults. : ' + JSON.stringify(cs));
					}
				} else{
					if(globals.debugApp){
						console.log('DEBUG-SYNC: Clientset were prev saved.. Skip Defaults.' + JSON.stringify(cs));
					}
				}
			

				//detects if the UDID has been set (i.e. is this the first time using the app and no UDID has been saved from a legacy Connect 1.x app, 
				//see js/app.js for more about saving UDID and AccountID from legacy Connect customers)
				if (GetItemFromLocalData('UDID') === null || GetItemFromLocalData('UDID') === ''){	
					if (window.device.platform == 'Android')
			   			setUDID('D' + uuid.v1());
			   		if (window.device.platform == 'iOS')
			   			setUDID('A' + uuid.v1()); //set the UDID based on the device OS, and a generated GUID
				}

				if (window.localStorage.getItem('Trivia.Order') === null){ //Trivia is still in localstorage
					var order = [];
					for (var i = 0; i < trivia.length; i++){
						order.push(i);
					}
					order.sort(function() {
					  return 0.5 - Math.random();
					});

					window.localStorage.setItem('Trivia.Order', JSON.stringify(order));
					window.localStorage.setItem('Trivia.Index', '0');
					//Randomly generate the order for the Trivia module questions/answers, set the index to 0 so that the user sees the first item in the array
				}

				if( GetItemFromLocalData('AccountID') === null ){ 
					if(globals.debugApp){
						console.log('DEBUD: Setting Account info blank for New User.. ');
					}

					SetItemInLocalData('AccountID', '');
					SetItemInLocalData('FullName', '');
					SetItemInLocalData('Phone', '');
					SetItemInLocalData('UniqueID', '');
					SetItemInLocalData('Points', '');
					SetItemInLocalData('GamePlays', '');
					SetItemInLocalData('UserType', '');
					SetItemInLocalData('UserStatus', '');
					SetItemInLocalData('GeoPromo', '');
					SetItemInLocalData('Birthday', 0);
					SetItemInLocalData('NewPlayer', 1);

					if (GetItemFromLocalData('DataVersion') === null) //The DataVersion determines whether or not the app requires a download sync or just a regular promo sync
						SetItemInLocalData('DataVersion','install');
				}

				//The device values are helpful when negative feedback comes in. Use the device id (UDID) from the Feedback table to lookup the 
				//device details (model, version, OS). These values are used in the Sync Start web method (js/app.js)
				if(GetItemFromLocalData('PushToken') === null){
					//The push token is determined by Urban Airship (see js/app.js)
					SetItemInLocalData('PushToken', '');
				}

				if(globals.debugApp){
					console.log("SYNC-DEBUG: .. moving to resolve()");
				}

				globals.initialSyncDone = true;
				resolve();

			}, 100);
		
		} //END

		return deferred.promise;
	}
})();
//End of Script



(function(){
	angular.module('connect.link.account', []);
})();
(function() {
	angular.module('connect.link.account')
		.directive('linkAccount', linkAccountDirective)
		.controller('LinkAccountController', linkAccountController);

	linkAccountDirective.$inject = [];
	linkAccountController.$injectd = ['$scope', '$rootScope', '$http'];

	function linkAccountDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'linkAccount/connect.link.account.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) {

		}
	}

	function linkAccountController($scope, $rootScope, $http) {
		$scope.Submit = false;

		$scope.LinkAccount = function() {
			$scope.Submit = true;
			if (!$('#linkAccountForm').hasClass('ng-invalid')) {

				if (window.device.platform == 'Android') {
					var options = {
						label : "Processing.. Logging in",
						timeout: 120
					};
				} else {
					var options = {
						label : "Processing.. Logging in",
						color: '#000',
						spinnerColor: '#000',
						timeout: 120
					};
				}
				window.wizSpinner.show(options); 
				
				$http.post(GetItemFromLocalData('ClientURL'), soapMessageLinkAccount($scope.email, $scope.password), {timeout: 30000} ).then(function(response) {
					var validated = $(response.data).find('LinkAccountResult').children("Validated").text(); //indicates if the login credentials were valid

					if (validated == "true") {
						navigator.splashscreen.show();

						saveAccountDetailJson(response.data);
						$rootScope.RegisteredUser = true;

						console.log('DEBUG /// ' + getEmail() );

						function Sync() {
							setTimeout(function() {
           						navigator.splashscreen.hide();
       						}, 10000);

       						setTimeout(function() {
								loginSave();
								window.wizSpinner.hide();
							}, 600);
						}; //The Sync Now function which allows the user to force a sync. Sync Now updates the initialSyncDoneTimeout variable (defined in js/sync.js) to 45 seconds and removes the application data version (forces a full download sync) and game version (forces the game assets to be updated)
					
						Sync();	

					} else{
						window.wizSpinner.hide();
						alert('Incorrect email or password', function() {}); //use the custom alert function defined in js/sync.js
					}
				}, function(error) {
					window.wizSpinner.hide();
				
					setTimeout(function() {
						if(globals.debugApp){
							console.log("link account ERROR: " + error);
						}
						navigator.notification.confirm(
							'Server couldnt be reached..',
							callBackFunctionServerDown, // Specify a function to be called
							'Please check your internet signal, Would you like to Retry the login.', ["Yes", "No"]
						);

						function callBackFunctionServerDown(b) {
							if (b == 1) {
								$scope.LinkAccount();
							}
							else{
								// Do nothing
							}
						}
					}, 10);

				});
			}
		};

	}
})();
(function () {
	angular.module('connect.kickback-rewards').factory('KickbackUser', KickbackUserModel);

	KickbackUserModel.$inject = [];
	function KickbackUserModel() {
		/**
		 * @class KickbackUser
		 * @description KickbackUser is the user for kickback that contains all the data needed for registration and user info
		 * @constructor
		 */
		function KickbackUser(kickbackUser) {
			if (!kickbackUser || typeof kickbackUser !== 'object') {
				debugger;
				throw 'Cannot create new KickbackUser: You must pass in a kickback user, to create a new KickbackUser pass in an empty object {}';
			}
			this.AccessTimes = kickbackUser.AccessTimes;
			this.AccessedFrom = kickbackUser.AccessedFrom;
			this.AccruedDollars = kickbackUser.AccruedDollars;
			this.AccruedGallons = kickbackUser.AccruedGallons;
			this.AccruedPoints = kickbackUser.AccruedPoints;
			this.ActivationDate = kickbackUser.ActivationDate;
			this.ActiveMember = kickbackUser.ActiveMember;
			this.Address1 = kickbackUser.Address1;
			this.Address2 = kickbackUser.Address2;
			this.AnniversaryDate = kickbackUser.AnniversaryDate;
			this.BirthDate = kickbackUser.BirthDate;
			this.CancellationDate = kickbackUser.CancellationDate;
			this.CardNumber = kickbackUser.CardNumber;
			this.CardToTrack1 = kickbackUser.CardToTrack1;
			this.City = kickbackUser.City;
			this.Country = kickbackUser.Country;
			this.Creation_Date = kickbackUser.Creation_Date;
			this.DollarsRedeemed = kickbackUser.DollarsRedeemed;
			this.DriversLicense = kickbackUser.DriversLicense;
			this.Email = kickbackUser.Email;
			this.Expiration = kickbackUser.Expiration;
			this.FirstName = kickbackUser.FirstName;
			this.FirstRedemptionDate = kickbackUser.FirstRedemptionDate;
			this.FirstTrxCashier = kickbackUser.FirstTrxCashier;
			this.FirstTrxDate = kickbackUser.FirstTrxDate;
			this.FirstTrxLocation = kickbackUser.FirstTrxLocation;
			this.GLocationID = kickbackUser.GLocationID;
			this.LastName = kickbackUser.LastName;
			this.LastPurchaseDate = kickbackUser.LastPurchaseDate;
			this.LastRedemptionDate = kickbackUser.LastRedemptionDate;
			this.LastTriggerDate = kickbackUser.LastTriggerDate;
			this.LifeTimePoints = kickbackUser.LifeTimePoints;
			this.LifetimeDollars = kickbackUser.LifetimeDollars;
			this.LocationEnrolled = kickbackUser.LocationEnrolled;
			this.MaxDollars = kickbackUser.MaxDollars;
			this.MaxPoints = kickbackUser.MaxPoints;
			this.MemLPI = kickbackUser.MemLPI;
			this.MiddleName = kickbackUser.MiddleName;
			this.MothersMaiden = kickbackUser.MothersMaiden;
			this.Notes = kickbackUser.Notes;
			this.NumberOfRedemptions = kickbackUser.NumberOfRedemptions;
			this.PIN = kickbackUser.PIN;
			this.ParentCardNumber = kickbackUser.ParentCardNumber;
			this.ParentType = kickbackUser.ParentType;
			this.PersonalInfoModifiedDate = kickbackUser.PersonalInfoModifiedDate;
			this.PhoneSelected = kickbackUser.PhoneSelected;
			this.Prefix = kickbackUser.Prefix;
			this.PromoID = kickbackUser.PromoID;
			this.SpouseBirthdate = kickbackUser.SpouseBirthdate;
			this.State = kickbackUser.State;
			this.TriggerGroup = kickbackUser.TriggerGroup;
			this.Zip = kickbackUser.Zip;
			this.cardnumber = kickbackUser.cardnumber;//?why are there 2 card numbers? this one is null JK 10/28
			this.created_at = kickbackUser.created_at;
			this.email_address = kickbackUser.email_address;
			this.email_confirmation_token = kickbackUser.email_confirmation_token;
			this.email_confirmed = kickbackUser.email_confirmed;
			this.email_confirmed_at = kickbackUser.email_confirmed_at;
			this.email_confirmed_on = kickbackUser.email_confirmed_on;
			this.flag1 = kickbackUser.flag1;
			this.gender = kickbackUser.gender;
			this.is_onhold = kickbackUser.is_onhold;
			this.maxpointsperday = kickbackUser.maxpointsperday;
			this.maxtrxperday = kickbackUser.maxtrxperday;
			this.memberGroup = kickbackUser.memberGroup;
			this.message1 = kickbackUser.message1;
			this.message2 = kickbackUser.message2;
			this.message3 = kickbackUser.message3;
			this.mobile = kickbackUser.mobile;
			this.notes2 = kickbackUser.notes2;
			this.phone = kickbackUser.phone;
			this.security1_answer = kickbackUser.security1_answer;
			this.security1_id = kickbackUser.security1_id;
			this.security2_answer = kickbackUser.security2_answer;
			this.security2_id = kickbackUser.security2_id;
			this.updated_at = kickbackUser.updated_at;

			if(this.BirthDate === null || this.BirthDate === ''){
				this.BirthDate = '00-00-0000';
			}
		}

		KickbackUser.prototype.removePersonalData = removePersonalData;
		KickbackUser.prototype.removeAddress = removeAddress;
		KickbackUser.prototype.$merge = $merge;

		return KickbackUser;

		function removePersonalData() {
			this.MothersMaiden = null;
			this.BirthDate = null;
			this.SpouseBirthdate = null;
			this.security1_id = null;
			this.security1_answer = null;
			this.security2_id = null;
			this.security2_answer = null;
			this.DriversLicense = null;
		}

		function removeAddress() {
			this.Address1 = null;
			this.Address2 = null;
			this.City = null;
			this.State = null;
			this.Zip = null;
			this.Country = null;
		}
		
		/**
		 * @description allows for the bound angular object to keep bindings while updating data
		 */
		function $merge(kickbackUser) {
			this.AccessTimes = kickbackUser.AccessTimes;
			this.AccessedFrom = kickbackUser.AccessedFrom;
			this.AccruedDollars = kickbackUser.AccruedDollars;
			this.AccruedGallons = kickbackUser.AccruedGallons;
			this.AccruedPoints = kickbackUser.AccruedPoints;
			this.ActivationDate = kickbackUser.ActivationDate;
			this.ActiveMember = kickbackUser.ActiveMember;
			this.Address1 = kickbackUser.Address1;
			this.Address2 = kickbackUser.Address2;
			this.AnniversaryDate = kickbackUser.AnniversaryDate;
			this.BirthDate = kickbackUser.BirthDate;
			this.CancellationDate = kickbackUser.CancellationDate;
			this.CardNumber = kickbackUser.CardNumber;
			this.CardToTrack1 = kickbackUser.CardToTrack1;
			this.City = kickbackUser.City;
			this.Country = kickbackUser.Country;
			this.Creation_Date = kickbackUser.Creation_Date;
			this.DollarsRedeemed = kickbackUser.DollarsRedeemed;
			this.DriversLicense = kickbackUser.DriversLicense;
			this.Email = kickbackUser.Email;
			this.Expiration = kickbackUser.Expiration;
			this.FirstName = kickbackUser.FirstName;
			this.FirstRedemptionDate = kickbackUser.FirstRedemptionDate;
			this.FirstTrxCashier = kickbackUser.FirstTrxCashier;
			this.FirstTrxDate = kickbackUser.FirstTrxDate;
			this.FirstTrxLocation = kickbackUser.FirstTrxLocation;
			this.GLocationID = kickbackUser.GLocationID;
			this.LastName = kickbackUser.LastName;
			this.LastPurchaseDate = kickbackUser.LastPurchaseDate;
			this.LastRedemptionDate = kickbackUser.LastRedemptionDate;
			this.LastTriggerDate = kickbackUser.LastTriggerDate;
			this.LifeTimePoints = kickbackUser.LifeTimePoints;
			this.LifetimeDollars = kickbackUser.LifetimeDollars;
			this.LocationEnrolled = kickbackUser.LocationEnrolled;
			this.MaxDollars = kickbackUser.MaxDollars;
			this.MaxPoints = kickbackUser.MaxPoints;
			this.MemLPI = kickbackUser.MemLPI;
			this.MiddleName = kickbackUser.MiddleName;
			this.MothersMaiden = kickbackUser.MothersMaiden;
			this.Notes = kickbackUser.Notes;
			this.NumberOfRedemptions = kickbackUser.NumberOfRedemptions;
			this.PIN = kickbackUser.PIN;
			this.ParentCardNumber = kickbackUser.ParentCardNumber;
			this.ParentType = kickbackUser.ParentType;
			this.PersonalInfoModifiedDate = kickbackUser.PersonalInfoModifiedDate;
			this.PhoneSelected = kickbackUser.PhoneSelected;
			this.Prefix = kickbackUser.Prefix;
			this.PromoID = kickbackUser.PromoID;
			this.SpouseBirthdate = kickbackUser.SpouseBirthdate;
			this.State = kickbackUser.State;
			this.TriggerGroup = kickbackUser.TriggerGroup;
			this.Zip = kickbackUser.Zip;
			this.cardnumber = kickbackUser.cardnumber;//?why are there 2 card numbers? this one is null JK 10/28
			this.created_at = kickbackUser.created_at;
			this.email_address = kickbackUser.email_address;
			this.email_confirmation_token = kickbackUser.email_confirmation_token;
			this.email_confirmed = kickbackUser.email_confirmed;
			this.email_confirmed_at = kickbackUser.email_confirmed_at;
			this.email_confirmed_on = kickbackUser.email_confirmed_on;
			this.flag1 = kickbackUser.flag1;
			this.gender = kickbackUser.gender;
			this.is_onhold = kickbackUser.is_onhold;
			this.maxpointsperday = kickbackUser.maxpointsperday;
			this.maxtrxperday = kickbackUser.maxtrxperday;
			this.memberGroup = kickbackUser.memberGroup;
			this.message1 = kickbackUser.message1;
			this.message2 = kickbackUser.message2;
			this.message3 = kickbackUser.message3;
			this.mobile = kickbackUser.mobile;
			this.notes2 = kickbackUser.notes2;
			this.phone = kickbackUser.phone;
			this.security1_answer = kickbackUser.security1_answer;
			this.security1_id = kickbackUser.security1_id;
			this.security2_answer = kickbackUser.security2_answer;
			this.security2_id = kickbackUser.security2_id;
			this.updated_at = kickbackUser.updated_at;

			if(this.BirthDate === null || this.BirthDate === ''){
				this.BirthDate = '00-00-0000';
			}
		}
	}

} ());
(function () {
	angular.module('connect.kickback-rewards').factory('KickbackReward', KickbackRewardModel);

	KickbackRewardModel.$inject = [];
	function KickbackRewardModel() {
		/**
		 * @class KickbackReward
		 * @description KickbackReward is the user for kickback that contains all the data needed for registration and user info
		 * @constructor
		 */
		function KickbackReward(kickbackReward) {
			if (!kickbackReward || typeof kickbackReward !== 'object') {
				debugger;
				throw 'Cannot create new KickbackReward: You must pass in a kickback user, to create a new KickbackReward pass in an empty object {}';
			}

			this.uid = kickbackReward.uid;
			this.group_id = kickbackReward.group_id;
			this.combo_id = kickbackReward.combo_id;
			this.category = kickbackReward.category;
			this.label = kickbackReward.label;
			this.messageBody = kickbackReward.messageBody;
			this.codeType = kickbackReward.codeType;
			this.code = kickbackReward.code;
			this.dollarvalue = kickbackReward.dollarvalue;
			this.pointvalue = kickbackReward.pointvalue;
			this.expire_days = kickbackReward.expire_days;
			this.count = kickbackReward.count;
			this.expiresOn = kickbackReward.expiresOn;
		}

		KickbackReward.prototype.$merge = $merge;

		return KickbackReward;
		
		/**
		 * @description allows for the bound angular object to keep bindings while updating data
		 */
		function $merge(kickbackReward) {
			this.uid = kickbackReward.uid;
			this.group_id = kickbackReward.group_id;
			this.combo_id = kickbackReward.combo_id;
			this.category = kickbackReward.category;
			this.label = kickbackReward.label;
			this.messageBody = kickbackReward.messageBody;
			this.codeType = kickbackReward.codeType;
			this.code = kickbackReward.code;
			this.dollarvalue = kickbackReward.dollarvalue;
			this.pointvalue = kickbackReward.pointvalue;
			this.expire_days = kickbackReward.expire_days;
			this.count = kickbackReward.count;
			this.expiresOn = kickbackReward.expiresOn;
		}
	}

} ());
(function () {
	angular.module('connect.kickback-rewards').factory('KickbackPunchCard', KickbackPunchCardModel);

	KickbackPunchCardModel.$inject = ['ClientSet'];
	function KickbackPunchCardModel(ClientSet) {
		/**
		 * @class KickbackPunchCard
		 * @description KickbackPunchCard is the user for kickback that contains all the data needed for registration and user info
		 * @constructor
		 */
		function KickbackPunchCard(kickbackPunchCard) {
			if (!kickbackPunchCard || typeof kickbackPunchCard !== 'object') {
				debugger;
				throw 'Cannot create new KickbackPunchCard: You must pass in a kickback user, to create a new KickbackPunchCard pass in an empty object {}';
			}
			this.currentPunches = kickbackPunchCard.currentPunches ? parseInt(kickbackPunchCard.currentPunches) : 0;
			this.desc = kickbackPunchCard.desc;
			this.id = kickbackPunchCard.id;
			this.numberToGet = kickbackPunchCard.numberToGet ? parseInt(kickbackPunchCard.numberToGet) : 0;
			this.progressLine = kickbackPunchCard.progressLine;

			if(globals.debugApp){
				console.log("Kickback punch ID for " + this.desc + " = " + this.id);
				console.log(this.id + ' - ' + ClientSet.getPunchCardImage(this.id) );
			}
			
			//image selection based on id
			this.punchImage = ClientSet.getPunchCardImage(this.id, this.desc);
			
			
			this.__defineGetter__('_progressPercent', function() {
				if(this.currentPunches === 0 || this.numberToGet === 0)
					return 0;
				return parseInt((this.currentPunches / this.numberToGet)*100);
			});
			
			this.__defineGetter__('_complete', function() {
				return this.currentPunches >= this.numberToGet;
			});
		}

		KickbackPunchCard.prototype.$merge = $merge;

		return KickbackPunchCard;
		
		/**
		 * @description allows for the bound angular object to keep bindings while updating data
		 */
		function $merge(kickbackPunchCard) {
			this.currentPunches = kickbackPunchCard.currentPunches;
		}
	}

} ());
(function () {
	angular.module('connect.kickback-rewards').factory('kickbackRewardsService', kickbackRewardsService);

	kickbackRewardsService.$inject = ['$http', '$q', '$timeout', '$window', '$rootScope', 'ClientSet', 'KickbackUser', 'KickbackRegistrationUser', 'KickbackPunchCard', 'KickbackReward'];
	function kickbackRewardsService($http, $q, $timeout, $window, $rootScope, ClientSet, KickbackUser, KickbackRegistrationUser, KickbackPunchCard, KickbackReward) {

		var kickbackUser;
		var kickbackPassword;
		var kickbackEndpoint;

		// ios is 1000 / android 1700
		var timer;
		if(device.platform === "iOS") {
			timer = 1200;  
		}
		else {
			timer = 5000;
			if(globals.debugApp){
				console.log('Android loading service is being loaded. local data should have been initialize');
			}
		}

		setTimeout(function() {
			//Credentials for the CHAIN 
			kickbackUser = ClientSet.getKickbackUser(); // 'handymart',//ClientSet.getKickbackUser()
			kickbackPassword = ClientSet.getKickbackPass(); // 'e8c8164c26a20072aba1f274edccdd01'
			kickbackEndpoint = ClientSet.getKickbackURL(); // 'https://www.rewardsbutler.com/api/';
			if(globals.debugApp){
				console.log('KICKBACK-DEBUG: Kickback Credentials were initialized.. User : ' + kickbackUser);
				console.log('KICKBACK-DEBUG: Getting credentials from client sets');
			}
		}, timer);
		


			var kickbackStateLocalName = 'connect-kickback-state',
				kickbackState,
				publicKickbackState = {};

			var service = {
				getKickbackState: getKickbackState,
				register: register,
				signout: signout,
				signin: signin,
				checkRegistered: checkRegistered,
				getBalance: getBalance,
				cardFromPhone: cardFromPhone,
				verifyPin: verifyPin,
				getInfo: getInfo,
				getPunchStatus: getPunchStatus,
				securityquestions: securityquestions,
				updateService: updateService
			};

			if(globals.debugApp){
				console.log("KICKBACK-DEBUG: initiating service for Kickback");
			}

			loadLocalState();// kick off the state load

			return service;


		function updateService(user, pass, endpoint){
			console.log("KICKBACK-DEBUG: Updated service with: " + user + ' ' + pass + ' ' + endpoint);
			kickbackUser = user,
			kickbackPassword = pass,
			kickbackEndpoint = endpoint;
		}



		function callKickbackAPI(method, data) {

			if(globals.debugApp){
				console.log("Kickback: API call made for " + method);
			}

			return $q(function (resolve, reject) {
				var dataToSend = {};

				console.log("Kickback: Data being sent " + JSON.stringify(data) );
				for (var key in data) {
					if (data.hasOwnProperty(key)) {
						if (data[key] !== null && data[key] !== undefined && typeof data[key] !== 'function') {
							dataToSend[key] = data[key];
						}
					}
				}
				dataToSend.user = kickbackUser;
				dataToSend.pass = kickbackPassword;
				dataToSend.call = method;

				if(globals.debugApp){
					console.log("KICKBACK-DEBUG: Data being sent has the credentials of : " + dataToSend.user + ' - ' + dataToSend.pass + ' - ' + dataToSend.call );
				}
				
				$http({
					method: 'POST',
					url: kickbackEndpoint,
					params: dataToSend,
					data: $.param(dataToSend),
					headers: {
						'Content-Type': 'application/x-www-form-urlencoded',
						'Access-Control-Allow-Origin': '*'
					}
				}).then(function (result) {
					if (result && result.status === 200 && result.data) {
						if (result.data.status === 0)
							return resolve(result.data.data);
						return reject(result.data);
					}
					return reject(result);
				}, function (err, e, x) {
					if(globals.debugApp){
						console.log("KICKBACK-ERROR: error of API service for Kickback -- " + err);
					}
					reject(err);
				});
				dataToSend = null;
			});
		}

		/**
		 * @description save the service kickbackState into the local storage
		 */
		function saveLocalState() {
			//if(globals.debugApp){
				console.log('KICKBACK-DEBUG: Saving local state in Kickback-Rewards.Service');
			//}
			$window.localStorage.setItem(kickbackStateLocalName, JSON.stringify(kickbackState));
			syncPublicKickbackState();

			var tempKickbackSignedIn = globals.userAccount.get('KickbackSignedIn')
			if(getKickbackSignedIn() == 1){
				kickbackGameEvoke(ClientSet);
				console.log('KB user account exist');
			} //update game scope (URL and card #)
		}

		/**
		 * @description loads the local kickbackState into the service
		 */
		function loadLocalState() {
			if(globals.debugApp){
				console.log('KICKBACK-DEBUG: loading local state in Kickback-Rewards.Service');
			}

			kickbackState = JSON.parse($window.localStorage.getItem(kickbackStateLocalName));

			if (!kickbackState) {
				kickbackState = defaultKickbackState();
				saveLocalState();
			} 
			else {
				kickbackState.kickbackUser = new KickbackUser(kickbackState.kickbackUser);
			}

			syncPublicKickbackState();
		}
		
		/**
		 * @description returns a copy of the private kickbackState Variable 
		 */
		function getKickbackState() {
			return publicKickbackState;
		}

		function syncPublicKickbackState() {
			publicKickbackState.registered = kickbackState.registered;
			if (!publicKickbackState.kickbackUser) {
				publicKickbackState.kickbackUser = new KickbackUser(kickbackState.kickbackUser);
			} 
			else {
				publicKickbackState.kickbackUser.$merge(kickbackState.kickbackUser);
			}
		}
		
		/**
		 * @description returns the default kickbackState Object
		 */
		function defaultKickbackState() {
			if(globals.debugApp){
				console.log('KICKBACK-DEBUG: setting default state.');
			}

			window.localStorage.setItem('Kickback.SignedIn', 0);
			return {
				registered: false,
				kickbackUser: new KickbackUser({})
			}
		}

		function signin(CardNumber, PIN, LastName) {
			return $q(function (resolve, reject) {
				service.verifyPin(CardNumber, PIN, LastName).then(function () {
					kickbackState.registered = true;
					// Save into local state
					window.localStorage.setItem('Kickback.SignedIn', 1);
					kickbackState.kickbackUser = new KickbackUser({
						CardNumber: CardNumber,
						PIN: PIN,
						LastName: LastName
					});
					if(globals.debugApp){
						console.log('KICKBACK-DEBUG: User is signed in and user model was constructed.');
					}

					saveLocalState();
					resolve();
				}, reject);
			});
		}

		/**
		 * @description registers a new kickback user
		 * @param kickbackUser KickbackUser the user object to register
		 */
		function register(kickbackUserToRegister) {
			return $q(function (resolve, reject) {
				kickbackUserToRegister = new KickbackRegistrationUser(kickbackUserToRegister);//cast just in case
				if (kickbackUserToRegister.BirthDate) {
					kickbackUserToRegister.BirthDate = moment(kickbackUserToRegister.BirthDate).format('YYYY-MM-DD');
				}
				else{
					kickbackUserToRegister.BirthDate = '0000-00-00';
				}
				if(globals.debugApp){
					console.log('KICKBACK-DEBUG: Mobile phone of User that is registering = ' + kickbackUserToRegister.mobile)
				}
				
				callKickbackAPI('register', kickbackUserToRegister).then(function (response) {
					kickbackState.registered = true;
					window.localStorage.setItem('Kickback.SignedIn', 1);
					kickbackState.kickbackUser = new KickbackUser({
						CardNumber: kickbackUserToRegister.cardnumber,
						PIN: kickbackUserToRegister.PIN,
						FirstName: kickbackUserToRegister.FirstName,
						LastName: kickbackUserToRegister.LastName,
						Email: kickbackUserToRegister.Email,
						mobile: kickbackUserToRegister.mobile
					});

					if(globals.debugApp){
						console.log('KICKBACK-DEBUG: User registered and user model was constructed.');
					}

					saveLocalState();
					return resolve();
				}, function (err) {
					if(globals.debugApp){
						console.log('KICKBACK-ERROR: User could not registered : ' + err);
					}
					
					kickbackState.registered = false;
					window.localStorage.setItem('Kickback.SignedIn', 0);
					saveLocalState();
					return reject(err);
				});
			});

		}
		
		/**
		 * @description clears local storage variables effectively signing out
		 */
		function signout() {
			kickbackState.registered = false;
			window.localStorage.setItem('Kickback.SignedIn', 0);
			kickbackState.kickbackUser = new KickbackUser({});
			saveLocalState();
		}
		
		/**
		 * @description checks if the cardnumber is registered
		 * @param cardnumber int the card number to check if registered
		 */
		function getBalance(cardnumber) {
			return callKickbackAPI('getbalance', { cardnumber: cardnumber });
		}
		
		/**
		 * @description checks if the cardnumber and if the pin is valid
		 * @param cardnumber int the card number to check if registered
		 */
		function verifyPin(cardnumber, PIN, LastName) {
			return callKickbackAPI('verifyPin', { cardnumber: cardnumber, PIN: PIN, LastName: LastName });
		}
		
		/**
		 * @description gets the information about the kickback user
		 * @param cardnumber int the card number to check if registered
		 */
		function getInfo(cardnumber, PIN) {
			return callKickbackAPI('getinfo', { cardnumber: cardnumber, PIN: PIN });
		}
		
		/**
		 * @description checks if the cardnumber is registered
		 * @param cardnumber int the card number to check if registered
		 */
		function checkRegistered(cardnumber) {
			return callKickbackAPI('check_registered', { cardnumber: cardnumber });
		}

		/**
		 * @description checks if there is a card number registered to a phone number
		 * @param phone int the phone number to check cards registered against
		 */
		function cardFromPhone(phone) {
			return callKickbackAPI('card_from_phone', { phone: phone });
		}
		
		/**
		 * @description gets a list of availabile secuirty questions to use on register
		 * @param cardnumber
		 */
		function securityquestions(cardnumber) {
			return callKickbackAPI('securityquestions', { cardnumber: cardnumber });
		}
		
		/**
		 * @description gets the punch status of the cards
		 * @param cardnumber
		 * @param PIN
		 * @param LastName
		 * @returns array(KickbackPunchCard)
		 * TODO locationID? is this needed, the API errors if not given
		 */
		function getPunchStatus(cardnumber, PIN, LastName) {
			return $q(function (resolve, reject) {
				return callKickbackAPI('getpunchstatus', { cardnumber: cardnumber, PIN: PIN, LastName: LastName, locationID: '123456' }).then(function (punchCards) {
					var i,
						len = punchCards.length,
						kickbackPunchCards = new Array(len);
					for (i = 0; i < len; i++) {
						kickbackPunchCards[i] = new KickbackPunchCard(punchCards[i]);
					}
					resolve(kickbackPunchCards);
				}, reject);
			});
		}
		
		/**
		 * @description checks if there is a card number registered to a phone number
		 * @param cardnumber
		 */
		function listRewards(cardnumber) {
			return $q(function (resolve, reject) {
				return callKickbackAPI('listrewards', { cardnumber: cardnumber }).then(function (rewards) {
					var i,
						len = rewards.length,
						kickbackRewards = new Array(len);
					for (i = 0; i < len; i++) {
						kickbackRewards[i] = new KickbackReward(rewards[i]);
					}
					resolve(kickbackRewards);
				}, reject);
			});
		}

	}
} ());
(function(){
	angular.module('connect.kickback-rewards').directive('kickbackRewards', kickbackRewards);
	
	kickbackRewards.$inject = [];
	kickbackRewardsCtrl.$inject = ['$scope', '$rootScope', '$timeout', 'kickbackRewardsService', 'ClientSet'];
	
	function kickbackRewards() {
		return {
			restrict: 'E',
			templateUrl: 'kickback-rewards/connect.kickback-rewards.html',
			controller: kickbackRewardsCtrl,
			controllerAs: 'kickbackRewardsCtrl'
		}
	}
	
	function kickbackRewardsCtrl($scope, $rootScope,  $timeout, kickbackRewardsService, ClientSet) {

		var vm = this;
		vm.goToSignIn = goToSignIn;
		vm.goToRegister = goToRegister;
		vm.showTerms = showTerms;
		vm.hideTerms = hideTerms;
		vm.refresh = refresh;

		setTimeout(function() {
			vm.kickbackImage = globals.Change.kickbackImage;
			$scope.Chain = globals.Change.chainFriendly;

			if(globals.debugApp){
				console.log('Kickback: initializing Rewards Ctrl for ' + $scope.Chain);
			}
		}, 800);
		
		vm.kickbackState = kickbackRewardsService.getKickbackState();
		vm.settingsOpen = false;
		
		$scope.$on('kickback-settings:close', function() {
			vm.settingsOpen = false;
		});
		
		function goToSignIn() {
			vm.showSignIn = true;
			vm.showRegister = false;
		}
		
		function goToRegister() {
			vm.showSignIn = false;
			vm.showRegister = true;
		}
		
		function showTerms() {
			vm.termsOpen = true;
		}
		
		function hideTerms() {
			vm.termsOpen = false;
		}
		
		function refresh() {
			$scope.$broadcast('kickback-rewards:refresh');
		}
	}
}());
(function () {
	angular.module('connect.kickback-rewards').factory('KickbackRegistrationUser', KickbackRegistrationUserModel);

	KickbackRegistrationUserModel.$inject = [];
	function KickbackRegistrationUserModel() {
		/**
		 * @class KickbackRegistrationUser
		 * @description KickbackRegistrationUser is the user for kickback that contains all the data needed for registration and user info
		 * @constructor
		 */
		function KickbackRegistrationUser(kickbackRegistrationUser) {
			if(!kickbackRegistrationUser || typeof kickbackRegistrationUser !== 'object') {
				throw 'Cannot create new KickbackRegistrationUser: You must pass in a kickback user, to create a new KickbackRegistrationUser pass in an empty object {}';
			}
			this.FirstName = kickbackRegistrationUser.FirstName;
			this.LastName = kickbackRegistrationUser.LastName;
			this.cardnumber = kickbackRegistrationUser.cardnumber;
			this.PIN = kickbackRegistrationUser.PIN;
			this.BirthDate = kickbackRegistrationUser.BirthDate;
			this.Prefix = kickbackRegistrationUser.Prefix;
			this.MiddleName = kickbackRegistrationUser.MiddleName;
			this.Address1 = kickbackRegistrationUser.Address1;
			this.Address2 = kickbackRegistrationUser.Address2;
			this.City = kickbackRegistrationUser.City;
			this.State = kickbackRegistrationUser.state;
			this.Zip = kickbackRegistrationUser.Zip;
			this.Country = kickbackRegistrationUser.country;
			this.phone = kickbackRegistrationUser.phone;
			this.mobile = kickbackRegistrationUser.mobile;
			this.Email = kickbackRegistrationUser.Email;

			this.mobile = kickbackRegistrationUser.mobile;
			
			/* Secure Information */
			this.MothersMaiden = kickbackRegistrationUser.MothersMaiden;
			this.security1_id = kickbackRegistrationUser.security1_id;
			this.security1_answer = kickbackRegistrationUser.security1_answer;
			this.security2_id = kickbackRegistrationUser.security2_id;
			this.security2_answer = kickbackRegistrationUser.security2_answer;
			this.flag1 = kickbackRegistrationUser.flag1;
			this.DriversLicense = kickbackRegistrationUser.DriversLicense;
			
			this.gender = kickbackRegistrationUser.gender;
			
			/* Used by Kickback, not needed for the App */
			this.LocationEnrolled = kickbackRegistrationUser.LocationEnrolled;

			if(this.BirthDate === null || this.BirthDate === ''){
				this.BirthDate = '00-00-0000';
			}
		}
		
		KickbackRegistrationUser.prototype.removePersonalData = removePersonalData;
		KickbackRegistrationUser.prototype.removeAddress = removeAddress;
		
		return KickbackRegistrationUser;
		
		function removePersonalData() {
			this.MothersMaiden = null;
			this.BirthDate = null;
			this.security1_id = null;
			this.security1_answer = null;
			this.security2_id = null;
			this.security2_answer = null;
			this.DriversLicense = null;
		}
		
		function removeAddress() {
			this.Address1 = null;
			this.Address2 = null;
			this.City = null;
			this.State = null;
			this.Zip = null;
			this.Country = null;
		}
	}
	
}());
(function(){
	angular.module('connect.kickback-iframe', []);
})();
(function() {
	angular.module('connect.kickback-iframe')
		.directive('kickbackIframe', kickbackIframeDirective)
		.controller('KickbackIframeController', kickbackIframeController);

	kickbackIframeDirective.$inject = [];
	kickbackIframeController.$inject = ['$scope', 'kickbackRewardsService', 'Loading', '$rootScope', '$timeout', 'ClientSet', '$sce'];

	function kickbackIframeDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'kickback-iframe/connect.kickback-iframe.html',
			link: link
		};
		return directive;

		function link(scope, element, attrs) { }

	}

	function kickbackIframeController($scope, kickbackRewardsService, Loading, $rootScope, $timeout, ClientSet, $sce) {

		var frame = document.getElementById('kickbackGameIframe');
		var vm = this;
		var kickbackState = kickbackRewardsService.getKickbackState();
		vm.kickbackUser = kickbackState.kickbackUser;

		Loading.then(function(){
			$scope.updateKbGameURL(); //KB Game Client Sets init
		}); 

		$scope.updateKbGameURL = function(){
			console.log('updateKbGameURL was Fired');

			// *KB Game Client Sets init* //
			$scope.kbGameURL = $sce.trustAsResourceUrl( ClientSet.getKBGameURL() + vm.kickbackUser.CardNumber + '/' ); //URL + their cardnumber appended to the game's URL + '/'

			if(globals.debugApp){
				console.log( 'KB Iframe was initiated. ');
			}

			// If KB Game exists (if URL is not null or 0), initialize game 
			if($scope.kbGameURL && $scope.kbGameURL != 0){
				$scope.kbGameTitle = ClientSet.getKBGameTitle();
				//if(globals.debugApp){
					console.log( 'KB GAME URL: ' + $scope.kbGameURL + ' Title: ' + $scope.kbGameTitle );
				//}
			}
		}


		$('#kickbackIframe').on('pagebeforeshow', function() {

			if (window.device.platform == 'Android') {
				var options = {
					label : "Loading Content",
					timeout: 60
				};
			} else {
				var options = {
					label : "Loading Content",
					color: '#000',
					spinnerColor: '#000',
					timeout: 60
				};
			}	
			
			window.wizSpinner.show(options); 

			if(globals.debugApp){
				//alert('Debug: Connecting to ' + $scope.kbGameURL); 
				console.log( 'KB GAME was initiated. with url ' + $scope.kbGameURL);   //   http://www.handymartrewardsgames.com/poker/?program=handymart&mobile=true&cardnumber=
			}

			$("#kickbackIframe .ui-content").css('height', $(window).height() - $('#kickbackIframe .ui-header').height() - 50 );
			$("#kickbackIframe #kickbackIframeWrapper").css('height', $('#kickbackIframe .ui-content').height() + 50 );
			$("#kickbackIframe #kickbackGameIframe").css('height', $('#kickbackIframe .ui-content').height() + 50 );
			$("#kickbackIframe #kickbackGameIframe").css('width', $(window).width() + 50 );

			var kickbackCounter = 0;
			var kickbackIframeInterval = setInterval(function() {
				if (kickbackCounter == 50) {
					clearInterval(kickbackIframeInterval);
					window.wizSpinner.hide();
					navigator.notification.alert(
						'Could not connect to server', // message
						function() {
							$.mobile.changePage('#kickbackRewards');
						}, // callback
						'Error', // title
						'Ok' // buttonName
					);
				} else if (frame.contentWindow.document.body.innerHTML.replace(/(\r\n|\n|\r)/gm, "")) {
					clearInterval(kickbackIframeInterval);
					window.wizSpinner.hide();
					
					if(globals.debugApp){
						console.log("kickback games Iframe loaded");
					}
				} else {
					kickbackCounter++;
				}
			}, 1000);
		});

	}
})();
(function(){
	angular.module('connect.geolocation', []);
})();
(function() {
	angular.module('connect.geolocation')
	//TODO: rename GeoLocation to geoLocationService
	//.factory('geoLocationService', geoLocationService);
		.factory('GeoLocation', geoLocationService);

	geoLocationService.$inject = ['$q', '$rootScope'];

	function geoLocationService($q, $rootScope) {
		return {

			setCurrentPosition: function() {

				var locationService = navigator.geolocation; // cordova geolocation plugin

				if(globals.debugApp){
					console.log("CHECK IN - DEBUG - Location: Using Cordova's Geoloaction");
				}

				var defer = $q.defer();
				locationService.getCurrentPosition(function(position) {
					console.log("CHECK IN - DEBUG - Location: Success: Lat/Long/Acc - " + position.coords.latitude + " " + position.coords.longitude + " " + position.coords.accuracy);
					//alert("DEBUG - Location: Success: Lat/Long/Acc - " + position.coords.latitude + " " + position.coords.longitude + " " + position.coords.accuracy);
					
					$rootScope.Latitude = position.coords.latitude;
					$rootScope.Longitude = position.coords.longitude;
					$rootScope.Accuracy = position.coords.accuracy;
					$rootScope.haveGPS = true; //$rootScope.haveGPS is a global Angular variable that keeps track of whether or not the user has a GPS location
					defer.resolve();
				}, function(error) {
					if(globals.debugApp){
						console.log("CHECK IN - DEBUG - Location: Error: " + error.message);
					}
					locationService.getCurrentPosition(function(position) {
						$rootScope.Latitude = position.coords.latitude;
						$rootScope.Longitude = position.coords.longitude;
						$rootScope.Accuracy = position.coords.accuracy;
						$rootScope.haveGPS = true;
						defer.resolve();
					}, function(error) {
						if(globals.debugApp){
							console.log("CHECK IN - DEBUG - Location: Error: " + error.message);
						}
						$rootScope.haveGPS = false;
						$rootScope.Latitude = 0;
						$rootScope.Longitude = 0;
						$rootScope.Accuracy = 0;
						defer.resolve();
					}, {
						enableHighAccuracy: false,
						maximumAge: 10000,
						timeout: 10000
					}); //if high accuracy fails, try getting it with low accuracy
				}, {
					enableHighAccuracy: true,
					maximumAge: 10000,
					timeout: 12000
				}); //try getting gps with high accuracy enabled
				return defer.promise;
			}
		}
	}
})();
(function(){
	angular.module('connect.interestList', []);
}());
(function() {
	angular.module('connect.interestList')
		.directive('connectInterestList', connectInterestListDirective)
		.controller('connectInterestListController', connectInterestListController);

	connectInterestListDirective.$inject = [];
	connectInterestListController.$inject = ['$scope', '$rootScope', '$http', '$timeout', 'Loading', 'ClientSet'];

	function connectInterestListDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'interestList/connect.interestlist.html',
			controller: 'connectInterestListController'
		};
		return directive;
	}

	function connectInterestListController ($scope, $rootScope, $http, $timeout, Loading, ClientSet) { //controller for managing user interests

		Loading.then(function() {
			$timeout(function() {
				console.log("Interested Controller loaded");
			
				$scope.InterestTitle = ClientSet.getInterestTitle();
				$scope.InterestHeader = ClientSet.getInterestHeader(); //set the interest page title and header based on client set (see main.html for where they actually show on the page)
			},1);
		});

		$('#interestList').on('pageshow', function(){
			$('#interestsPageContent').css('height', $(window).height() - 53);
			$('#interestList').trigger('create');	//create the interestlist every time to show the latest interest
		});

		$('#interestList').on('pageinit', function() { //on page init fill up the interests on the page
			$timeout(function() {
				//TODO: JK 5/10/2015 This will cause memory leaks when routing is updated. 
				//This needs to be unbinded on $scope.$destroy
				$scope.Interests = getInterests();
			}, 1);
		});

		var previousPage = '';
		$('#interestList').on('pageshow', function(event, data) {
			previousPage = data.prevPage.attr('id');
		});

		$('#interestList').on('pagehide', function() { //refresh the interests on the page on pagehide in case the user has updated them
			$timeout(function() {
				$scope.Interests = getInterests();
			}, 1);
		});

		$scope.Interests = getInterests(); //called on app startup (after Angular is bootstrapped and controllers begin executing)

		$scope.SaveInterests = function() {
			var interests = ''; //variable to hold the interests to be saved, formatted for the SOAP message
			var interestCount = 0; //variable to hold the number of interests to be saved in case they are above the max
			$(".interestInput:checked").each(function(index) {
				interests = interests + '<RAccountInterestServer><InterestID>' + $(this).attr('id') + '</InterestID></RAccountInterestServer>';
				interestCount++;
			});
			if (interestCount <= ClientSet.getInterestMax()) { //make sure interests are less than or equal to the max defined by the client setting
				window.wizSpinner.show();
				$http.post(GetItemFromLocalData('ClientURL'), soapMessageSaveAccountInterest(interests), {timeout: 10000}).then(function(response) {
					window.wizSpinner.hide();
					var processed = $(response.data).find("Processed").text();
					var error = $(response.data).find('Standard').children('MethodErrorMsg').text();
					if (processed == 'true') {
						navigator.notification.alert(
							'Interests saved.', // message
							function() {}, // callback
							'Success!', // title
							'Ok' // buttonName
						);
						
						if (previousPage == 'accountDetails') //if the user came to interests from the accountDetails screen then take them back there
							$.mobile.back();
						else
							$.mobile.changePage('#main');
						saveInterests(response.data); //save interests to local storage, this function is implemented in js/sync.js
					} else
						alert(error, function() {
							if (previousPage == 'accountDetails')
								$.mobile.back();
							else
								$.mobile.changePage('#main');
						});
				}, function(error) {
					window.wizSpinner.hide();
					$rootScope.Error(globals.ajaxTimeoutMessage, function() {
						if ($rootScope.redeemRegisterAlerted)
							$.mobile.changePage('#promodog');
						else if (previousPage == 'accountDetails')
							$.mobile.back();
						else
							$.mobile.changePage('#main');
					}, false, function() {});
				});
			} else { //if the user is trying to save more interests than max then show the interest overmax message (client setting)
				navigator.notification.alert(
					ClientSet.getInterestOverMax(), // message
					function() {
						setTimeout(function() {
							savingInterests = true;
						}, 1000);
					}, // callback
					'Error', // title
					'Ok' // buttonName
				);
			}
		};
	}
}());
(function(){
	angular.module('connect.game', [
		'connect.game.gamehelp',
		'connect.game.matchingGame'
	]);
}());
(function(){
	angular.module('connect.feedback.prompt', []);
})();
(function(){
	angular.module('connect.feedback.prompt')
	.directive('feedbackPrompt', feedbackPromptDirective)
	.controller('FeedbackPromptController', feedbackPromptController);

	feedbackPromptDirective.$inject = [];

	feedbackPromptController.$inject = ['$scope', '$rootScope', '$timeout'];



	function feedbackPromptDirective(){
		var directive = {
			restrict: 'E',
			templateUrl: 'feedback/connect.feedback.prompt.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs){
			
		}
	}

	function feedbackPromptController($scope, $rootScope, $timeout){
		$scope.StoreFeedback = function(){
			$timeout(function(){
				$rootScope.AppFeedback = false;
			}, 1);
		};
	}

})();
(function(){
	angular.module('connect.fas.cash', []);
})();
(function() {
	angular.module('connect.fas.cash')
		.directive('fasCash', fasCashDirective)
		.controller('FasCashController', fasCashController);

	fasCashDirective.$inject = [];
	fasCashController.$inject = ['$scope', '$rootScope', '$timeout', '$http', 'Loading', 'ClientSet'];

	function fasCashDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'fasCash/connect.fas.cash.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) {

		}
	}

	function fasCashController($scope, $rootScope, $timeout, $http, Loading, ClientSet) {

		/*

		$('#fascash').on('pageshow', function(){
			$('#birthdayFasCash').mobiscroll({ preset: 'date'}); //mobiscroll is the date picker
		});

		Loading.then(function() {
			$timeout(function() {
			$scope.AllStates = ClientSet.getStates();
		});

		$scope.email = "";
		$scope.firstname = "";
		$scope.lastname = "";
		$scope.homephone = "";
		$scope.mobilephone = "";
		$scope.streetaddress = "";
		$scope.city = "";
		$scope.state = "";
		$scope.zip = "";
		$scope.license = "";
		$scope.licensestate = "";
		$scope.birthday = "";
		$scope.ach = "";
		$scope.bankrouting = "";
		$scope.bankaccount = "";
		$scope.pin = "";
		$scope.securityquestion = "";
		$scope.securityanswer = "";
		$scope.promotioncode = "";
		$scope.agreement = "";



		var currentPage = 0;
		$scope.BasicsSubmit = false;
		$scope.AddressSubmit = false;
		$scope.IdentificationSubmit = false;
		$scope.AccountInformationSubmit = false;
		$scope.SecuritySubmit = false;

		
		

		$scope.Exit = function() {
			navigator.notification.confirm(
				'Would you like to securely save your application to continue later?',
				callBackFunctionFasSave, // Specify a function to be called
				'Save?',
				"Yes, No"
			);

			function callBackFunctionFasSave(b) {
				if (b == 1) {
					saveApplication();
				} else {
					window.localStorage.removeItem('FasCashApplication');
				}
			}
			$.mobile.back();
		};

		$scope.getPrevText = function() {
			switch (currentPage) {
				case 0:
					return "Already Registered";
					break;
				case 1:
					return "Previous";
					break;
				case 2:
					return "Previous";
					break;
				case 3:
					return "Previous";
					break;
				case 4:
					return "Previous";
					break;
				case 5:
					return "Previous";
					break;
				default:
					return "Previous";
					break;
			}
		};

		$scope.getNextText = function() {
			switch (currentPage) {
				case 0:
					return "Register Now";
					break;
				case 1:
					return "Next";
					break;
				case 2:
					return "Next";
					break;
				case 3:
					return "Next";
					break;
				case 4:
					return "Next";
					break;
				case 5:
					return "Next";
					break;
				default:
					return "Submit";
					break;
			}
		};

		function valid(currentPage) {
			switch (currentPage) {
				case 0:
					return true;
				case 1:
					$timeout(function() {
						$scope.BasicsSubmit = true;
					}, 1);
					$('#fasCashState').selectmenu('refresh', true);
					return !$('#BasicsFields input').hasClass('ng-invalid') && !$('#BasicsFields select').hasClass('ng-invalid');
					break;
				case 2:
					$timeout(function() {
						$scope.AddressSubmit = true;
					}, 1);
					$('#fasCashLicenseState').selectmenu('refresh', true);
					return !$('#AddressFields input').hasClass('ng-invalid') && !$('#AddressFields select').hasClass('ng-invalid');
					break;
				case 3:
					$timeout(function() {
						$scope.IdentificationSubmit = true;
					}, 1);
					return !$('#IdentificationFields input').hasClass('ng-invalid') && !$('#IdentificationFields select').hasClass('ng-invalid');
					break;
				case 4:
					$timeout(function() {
						$scope.AccountInformationSubmit = true;
					}, 1);
					$('#fasCashSecurityQuestion').selectmenu('refresh', true);
					return !$('#AccountInformationFields input').hasClass('ng-invalid') && !$('#AccountInformationFields select').hasClass('ng-invalid');
					break;
				case 5:
					$timeout(function() {
						$scope.SecuritySubmit = true;
					}, 1);
					$('#fasCashAgreement').checkboxradio('refresh');
					return !$('#SecurityFields input').hasClass('ng-invalid') && !$('#SecurityFields select').hasClass('ng-invalid');
					break;
				default:
					return true;
					break;
			}
		};

		// FormToWizard plugin Created by jankoatwarpspeed.com (edited) 
		function selectStep(i) {
			$("#steps li").removeClass("current");
			$("#stepDesc" + i).addClass("current");
		}

		(function($) {
			$.fn.formToWizard = function(options) {
				options = $.extend({
					submitButton: ""
				}, options);

				var element = this;

				var steps = $(element).find("fieldset");
				var count = steps.size();

				// 2
				$(element).before("<ul id='steps'></ul>");

				steps.each(function(i) {
					$(this).wrap("<div id='step" + i + "'></div>");
					$(this).append("<p id='step" + i + "commands'></p>");

					if (i == 0) {
						createNextButton(i);
						selectStep(i);
					} else if (i == count - 1) {
						$("#step" + i).hide();
						createPrevButton(i);
					} else {
						$("#step" + i).hide();
						createPrevButton(i);
						createNextButton(i);
					}
				});


				function createPrevButton(i) {}

				function createNextButton(i) {}

			}
		})(jQuery);

		function prev() {
			var stepName = "step" + currentPage;
			var i = currentPage;
			$("#" + stepName).hide();
			$("#step" + (i - 1)).show();
			selectStep(i - 1);
			resetScrollbar();
			$timeout(function() {
				currentPage--;
			}, 1);
		}

		function next() {
			var stepName = "step" + currentPage;
			var i = currentPage;
			if (valid(currentPage)) {
				$("#" + stepName).hide();
				$("#step" + (i + 1)).show();
				selectStep(i + 1);
				resetScrollbar();
				$timeout(function() {
					currentPage++;
				}, 1);
				saveApplication();
			} else {
				resetScrollbar();
			}
		}

		$scope.getPageTitle = function() {
			var pageTitle = "Fas Cash";
			switch (currentPage) {
				case 0:
					pageTitle = "Fas Cash";
					break;
				case 1:
					pageTitle = "Basics";
					break;
				case 2:
					pageTitle = "Address";
					break;
				case 3:
					pageTitle = "Identification";
					break;
				case 4:
					pageTitle = "Account Information";
					break;
				case 5:
					pageTitle = "Security";
					break;
				case 6:
					pageTitle = "Agreement";
					break;
				default:
					break;
			}
			return pageTitle;
		};

		$('#fascash').on('pageinit', function() {
			$("#fasCashForm").formToWizard();
			resetScrollbar();
		});

		$('#fascash').one('pageshow', function() {
			var application = getFasCashApplication();
			if (application != null) {
				$scope.email = application.email;
				$scope.firstname = application.firstname;
				$scope.lastname = application.lastname;
				$scope.homephone = application.homephone;
				$scope.mobilephone = application.mobilephone;
				$scope.streetaddress = application.streetaddress;
				$scope.city = application.city;
				$scope.state = application.state;
				$scope.zip = application.zip;
				$scope.license = application.license;
				$scope.licensestate = application.licensestate;
				$scope.birthday = application.birthday;
				$scope.ach = application.ach;
				$scope.bankrouting = application.bankrouting;
				$scope.bankaccount = application.bankaccount;
				$scope.pin = application.pin;
				$scope.securityquestion = application.securityquestion;
				$scope.securityanswer = application.securityanswer;
				$scope.promotioncode = application.promotioncode;
				$scope.agreement = application.agreement;
			} else {
				$scope.email = getEmail();
				$scope.mobilephone = getPhone();
				if (getBirthday() != 0 && getBirthday() != null && moment(getBirthday()).isValid() && moment(getBirthday()).year() != 1900) {
					$scope.birthday = moment(getBirthday()).format("MM/DD/YYYY");
				}
				if (getFullName().indexOf(' ') != -1) {
					$scope.firstname = getFullName().substring(0, getFullName().indexOf(' '));
					$scope.lastname = getFullName().substring(getFullName().indexOf(' ') + 1);
				} else {
					$scope.firstname = getFullName();
				}
				$timeout(function() {
					$('input').trigger('input');
				}, 1);
			}
		})

		$scope.AlreadyRegistered = function() {
			$timeout(function() {
				$rootScope.showFasCash = false;
			}, 1);
			window.localStorage.setItem('FasCash', 'Done');
			window.localStorage.removeItem('FasCashApplication');
			$.mobile.back();
		};

		$scope.Submit = false;

		$scope.Register = function() {
			resetScrollbar();
			$scope.Submit = true;

			if (!$('#fasCashForm').hasClass('ng-invalid')) {
				if (window.device.platform == 'Android') {
					var options = {
						label : "Processing..",
						timeout: 120
					};
				} else {
					var options = {
						label : "Processing..",
						color: '#000',
						spinnerColor: '#000',
						timeout: 120
					};
				}
				window.wizSpinner.show(options); 
				
				var birthday = moment($scope.birthday).format('YYYY-MM-DD');
				if (!$scope.homephone)
					$scope.homephone = '';
				if (!$scope.mobilephone)
					$scope.mobilephone = '';
				$http.post(ClientSet.getACHSubmitURL(), soapMessageNPC($scope.ach, $scope.bankaccount, $scope.bankrouting, birthday, $scope.city, $scope.license, $scope.licensestate, $scope.email, $scope.firstname, $scope.homephone, $scope.lastname, $scope.mobilephone, $scope.pin, $scope.promotioncode, $scope.securityanswer, $scope.securityquestion, $scope.state, $scope.streetaddress, $scope.zip), {
					timeout: 10000,
					headers: {
						'SOAPAction': 'http://tempuri.org/IEnrollment/Enroll'
					}
				}).then(function(response) {
					startLoader();
					var result = $(response.data).find('EnrollResult').children("a\\:Result").text();
					var errorInfo = $(response.data).find('a\\:ErrorInfo');
					if (errorInfo && errorInfo.length > 0) {
						var error = "";
						errorInfo.each(function() {
							error += $(this).children("a\\:ErrorDesc").text();
							error += "\n";
						});
						error = error.substring(0, error.length - 1);
						alert(error, function() {
							window.wizSpinner.hide();
						});
					} else {
						navigator.notification.alert(
							'Thank you for submitting your application. We will be in touch when your card is ready for use.', // message
							function() {
								window.wizSpinner.hide();
								$scope.AlreadyRegistered();
							}, // callback
							'Success!', // title
							'Ok' // buttonName
						);
					}
				}, function(error) {
					window.wizSpinner.hide();
					$rootScope.Error(ajaxTimeoutMessage, function() {
						console.log("");
					}, false, function() {
						console.log("");
					});
				});
			}
		};

		$scope.Next = function() {
			switch (currentPage) {
				case 0:
					next();
					break;
				case 1:
					next();
					break;
				case 2:
					next();
					break;
				case 3:
					next();
					break;
				case 4:
					next();
					break;
				case 5:
					next();
					break;
				default:
					$scope.Register();
					break;
			}
		};

		$scope.Prev = function() {
			switch (currentPage) {
				case 0:
					$scope.AlreadyRegistered();
					break;
				case 1:
					prev();
					break;
				case 2:
					prev();
					break;
				case 3:
					prev();
					break;
				case 4:
					prev();
					break;
				case 5:
					prev();
					break;
				default:
					prev();
					break;
			}
		};

		function saveApplication() {
			var application = {};
			application.email = $scope.email;
			application.firstname = $scope.firstname;
			application.lastname = $scope.lastname;
			application.homephone = $scope.homephone;
			application.mobilephone = $scope.mobilephone;
			application.streetaddress = $scope.streetaddress;
			application.city = $scope.city;
			application.state = $scope.state;
			application.zip = $scope.zip;
			application.license = $scope.license;
			application.licensestate = $scope.licensestate;
			if ($scope.birthday)
				application.birthday = moment($scope.birthday).format('YYYY-MM-DD');
			else
				application.birthday = '';
			application.ach = $scope.ach;
			application.bankrouting = $scope.bankrouting;
			application.bankaccount = $scope.bankaccount;
			application.pin = $scope.pin;
			application.securityquestion = $scope.securityquestion;
			application.securityanswer = $scope.securityanswer;
			application.promotioncode = $scope.promotioncode;
			application.agreement = $scope.agreement;
			application = JSON.stringify(application);
			window.localStorage.setItem('FasCashApplication', sjcl.encrypt("FasCashApplication", application));
		}

		$scope.open = function(link) {
			navigator.app.loadUrl(link, {
				openExternal: true
			});
		}

		*/
	}

})();
(function(){
	angular.module('connect.fas.cash.help', []);
})();
(function() {
	angular.module('connect.fas.cash.help')
		.directive('fasCashHelp', fasCashHelpDirective)
		.controller('FasCashHelpController', fasCashHelpController);

	fasCashHelpDirective.$inject = [];
	fasCashHelpController.$inject = ['$scope'];

	function fasCashHelpDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'fasCashHelp/connect.fas.cash.help.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) {

		}
	}

	function fasCashHelpController($scope) {
		$scope.open = function(link) {
			navigator.app.loadUrl(link, {
				openExternal: true
			});
		}
	}
})();
(function(){
	angular.module('connect.faq', []);
})();
(function() {
	angular.module('connect.faq')
		.directive('factsAndQuestions', factsAndQuestionsDirective)
		.controller('AppFaqController', factsAndQuestionsController);

	factsAndQuestionsDirective.$inject = [];

	factsAndQuestionsController.$inject = ['$scope', '$rootScope', '$timeout'];

	function factsAndQuestionsDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'faq/connect.faq.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) { }
	}

	function factsAndQuestionsController($scope, $rootScope, $timeout) {
		$scope.ApplicationFeedback = function() {
			$timeout(function() {
				$rootScope.AppFeedback = true;
			}, 1);
		};
	}
})();
(function() {
	angular.module('connect.error', []);
}());
(function() {
	angular.module('connect.error').directive('connectError', connectError);

	connectError.$inject = [];
	connectErrorCtrl.$inject = ['$scope', '$rootScope', '$timeout'];

	function connectError() {
		var directive = {
			restrict: 'E',
			templateUrl: 'error/connect.error.html',
			controller: connectErrorCtrl
		}
	}


	function connectErrorCtrl($scope, $rootScope, $timeout) {

		$rootScope.Error = function(message, callback, cantryagain, tryagain) {
			$timeout(function() {
				$rootScope.ErrorMessage = message;
				$rootScope.CanTryAgain = cantryagain;
			}); //update the error screen error message and indicate if the user can try again (show try again option or not)
			$('#error').show();
			$('.errorImage').css('margin-top', ($(window).height() - $('.errorImage').height()) / 2 - $('.errorTextWrapper').height());
			$(".errorImage").animate({
				opacity: 1
			}, 2000);
			$('#error').addClass('slideInDown');

			$rootScope.Exit = function() {
				$('#error').addClass('slideOutUp');
				$('#error').hide();
				$('#error').removeClass('slideInDown');
				$(".errorImage").css('opacity', 0);
				$timeout(function() {
					callback();
				});
			}; //function for closing the error screen and calling the callback passed into the function

			$rootScope.TryAgain = function() {
				$('#error').addClass('slideOutUp');
				$('#error').hide();
				$('#error').removeClass('slideInDown');
				$timeout(function() {
					tryagain();
				});
			}; //function for closing screen and trying again (used in gameend)
		};
	}
}());
(function(){
	angular.module('connect.electrum', [
		'connect.electrum.page',
		'connect.electrum.iframe'
		]);
})();
(function(){
	angular.module('connect.client.set', []);
})();
(function(){
	angular.module('connect.client.set')
	.factory('ClientSet', clientSetService);

	clientSetService.$inject = [];

	function clientSetService(){
		return {

		getRegistrationPrompt : function(){
			var registrationPrompt;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				registrationPrompt = tempObj.ClientSets ? tempObj.ClientSets['registration.prompt'] : null;
	      	}
	      	else{
				registrationPrompt = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['registration.prompt'] : null;
			}

			//return data requested
			if (!registrationPrompt || registrationPrompt == 0){
				return 0;
			}
			else{
				return parseInt(registrationPrompt);
			}
		},

		getRegistrationPromptHour : function(){
			var registrationPromptHour;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				registrationPromptHour = tempObj.ClientSets ? tempObj.ClientSets['registration.prompt.hour'] : null;

	      	}
	      	else{
				registrationPromptHour = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['registration.prompt.hour'] : null;
			}

			//return data requested
			if (!registrationPromptHour || registrationPromptHour == 0){
				return 0;
			}
			else{
				return parseInt(registrationPromptHour);
			}
		},

		getCompanyName : function(){
			var companyName;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				companyName = tempObj.ClientSets ? tempObj.ClientSets['companyname'] : null;
	      	}
	      	else{
				companyName = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['companyname'] : null;
			}			

			//return data requested
			if (!companyName || companyName == 0){
				return globals.Change.chain;
			}
			else{
				return companyName;
			}
		},

		getProductName : function(){
			var productName;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				productName = tempObj.ClientSets ? tempObj.ClientSets['productname'] : null;
	      	}
	      	else{
				productName = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['productname'] : null;
			}

			//return data requested
			if (!productName || productName == 0){
				return globals.Change.chain;
			}
			else{
				return productName;
			}
		},

		getShowGasPrice : function(){
			var showGasPrice

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showGasPrice = tempObj.ClientSets  ? tempObj.ClientSets['show.gasprice'] : null;
	      	}
	      	else{
				showGasPrice = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['show.gasprice'] : null;
			}

			if(globals.debugApp){
				console.log('DEBUG-CLIENTSETS: ShowGasPrice (should be 1 or 0) = ' + showGasPrice);
			}

			//return data requested
			if (!showGasPrice || showGasPrice == 0){
				return false;
			}
			else{
				return true;
			}
		},

		getLotteryState01 : function(){
			var showLotteryState;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showLotteryState = tempObj.ClientSets ? tempObj.ClientSets['lottery.state1.name'] : null;
	      	}
	      	else{
				showLotteryState = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['lottery.state1.name'] : null;
			}

			//return data requested
			if (!showLotteryState || showLotteryState == 0){
				return null;
			}
			else{
				return showLotteryState;
			}
		},

		getLotteryUrl01 : function(){
			var showLotteryUrl;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showLotteryUrl = tempObj.ClientSets ? tempObj.ClientSets['lottery.state1.url'] : null;
	      	}
	      	else{
				showLotteryUrl = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['lottery.state1.url'] : null;
			}

			//return data requested
			if (!showLotteryUrl || showLotteryUrl == 0){
				return null;
			}
			else{
				return showLotteryUrl;
			}
		},

		getLotteryState02 : function(){
			var showLotteryState;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showLotteryState = tempObj.ClientSets ? tempObj.ClientSets['lottery.state2.name'] : null;
	      	}
	      	else{
				showLotteryState = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['lottery.state2.name'] : null;
			}

			//return data requested
			if (!showLotteryState || showLotteryState == 0){
				return null;
			}
			else{
				return showLotteryState;
			}
		},

		getLotteryUrl02 : function(){
			var showLotteryUrl;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showLotteryUrl = tempObj.ClientSets ? tempObj.ClientSets['lottery.state2.url'] : null;}
	      	else{
				showLotteryUrl = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['lottery.state2.url'] : null;
			}

			if (!showLotteryUrl || showLotteryUrl == 0){
				return null;
			}
			else{
				return showLotteryUrl;
			}
		},

		getLotteryState03 : function(){
			var showLotteryState;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showLotteryState = tempObj.ClientSets ? tempObj.ClientSets['lottery.state3.name'] : null;
	      	}
	      	else{
				showLotteryState = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['lottery.state3.name'] : null;
			}
			
			//return data requested
			if (!showLotteryState || showLotteryState == 0){
				return null;
			}
			else{
				return showLotteryState;
			}
		},

		getLotteryUrl03 : function(){
			var lotteryUrl;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				lotteryUrl = tempObj.ClientSets ? tempObj.ClientSets['lottery.state3.url'] : null;
	      	}
	      	else{
				lotteryUrl = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['lottery.state3.url'] : null;
			}
			
			//return data requested
			if (!lotteryUrl || lotteryUrl == 0){
				return null;
			}
			else{
				return lotteryUrl;
			}
		},	

		getInterestTitle : function(){
			var interestTile ;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				interestTile = tempObj.ClientSets ? tempObj.ClientSets['interest.title'] : null;
	      	}
	      	else{
				interestTile = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['interest.title'] : null;
			}
			
			//return data requested
			if (!interestTile || interestTile == 0){
				return "Interests";
			}
			else{
				return interestTile;
			}
		},

		getInterestHeader : function(){
			var interestHeader;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				interestHeader = tempObj.ClientSets ? tempObj.ClientSets['interest.header'] : null;
	      	}
	      	else{
				interestHeader = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['interest.header'] : null;
			}
			
			//return data requested
			if (!interestHeader || interestHeader == 0){
				return 'Please select your Interests.  This helps customize your experience.';
			}
			else{
				return interestHeader;
			}
		},

		getInterestMax : function(){
			var interestMax;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				interestMax = tempObj.ClientSets ? tempObj.ClientSets['interest.max'] : null;
	      	}
	      	else{
				interestMax = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['interest.max'] : null;
			}

			//return data requested
			if (!interestMax || interestMax == 0){
				return 1000;
			}
			else{
				return parseInt(interestMax);
			}
		},

		getInterestOverMax : function(){
			var interestOverMax;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				var cs = tempObj.ClientSets ? tempObj.ClientSets: null;
				interestOverMax = cs ? cs['interest.overmax'] : null;
	      	}
	      	else{
				var cs = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets')) : null;
				interestOverMax = cs ? cs['interest.overmax'] : null;
			}

			//return data requested
			if (!interestOverMax || interestOverMax == 0){
				return 'Please select no more than ' + cs['interest.max'] + ' interests.';
			}
			else{
				return interestOverMax;
			}
		},


		getGameTitle : function(){
			var gameTitle;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				gameTitle = tempObj.ClientSets ? tempObj.ClientSets['game.title'] : null;
	      	}
	      	else{
				gameTitle = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['game.title'] : null;
			}

			//return data requested
			if (!gameTitle || gameTitle == 0){
				return '';
			}
			else{
				return gameTitle;
			}
		},

		getGameValueOne : function(){
			var gameValueOne;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				gameValueOne = tempObj.ClientSets ? tempObj.ClientSets['game.value01'] : null;
	      	}
	      	else{
				gameValueOne = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['game.value01'] : null;
			}

			//return data requested
			if (!gameValueOne || gameValueOne == 0){
				return '1,2,3,4,5,6,7,10';
			}
			else{
				return gameValueOne;
			}
		},

		getShowStoreCall : function(){
			var showStoreCall;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				showStoreCall = tempObj.ClientSets ? tempObj.ClientSets['show.store.call'] : null;
	      	}
	      	else{
				showStoreCall = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['show.store.call'] : null;
			}

			//return data requested
			if (!showStoreCall || showStoreCall == 0){
				return false;
			}
			else{
				return true;
			}
		},

		getRegisterFieldBirthday : function(){
			var registerFieldBirthday;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				registerFieldBirthday = tempObj.ClientSets ? tempObj.ClientSets['register.field.birthday'] : null;
	      	}
	      	else{
				registerFieldBirthday = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['register.field.birthday'] : null;
			}

			//return data requested
			if (!registerFieldBirthday || registerFieldBirthday == 0){
				return 'Birthday Club';
			}
			else{
				return registerFieldBirthday;
			}
		},

		getSocialShareTitle : function(){
			var socialShareTitle;


			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				socialShareTitle = tempObj.ClientSets ? tempObj.ClientSets['social.share.title'] : null;
			}
	      	else{
				socialShareTitle = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['social.share.title'] : null;
			}

			//return data requested
			if (!socialShareTitle || socialShareTitle == 0){
				return null;
			}
			else{
				return socialShareTitle;
			}
		},

		getSocialShareMessage : function(){
			var socialShareMessage;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				socialShareMessage = tempObj.ClientSets ? tempObj.ClientSets['social.share.message'] : null;
			}
	      	else{
				socialShareMessage = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['social.share.message'] : null;
			}

			//return data requested
			if (!socialShareMessage || socialShareMessage == 0){
				return null;
			}
			else{
				return socialShareMessage;
			}
		},

		getSocialShareURL : function(){
			var socialShareURL;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				socialShareURL = tempObj.ClientSets ? tempObj.ClientSets['social.share.url'] : null;
			}
	      	else{
				socialShareURL = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['social.share.url'] : null;
			}

			//return data requested
			if (!socialShareURL || socialShareURL == 0){
				return '';
			}
			else{
				return socialShareURL;
			}
		},

		getCheckinGPSEnable : function(){
			var checkinGPSEnable;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				checkinGPSEnable = tempObj.ClientSets  ? tempObj.ClientSets['checkin.gps.enable'] : null;
			}
	      	else{
				checkinGPSEnable = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['checkin.gps.enable'] : null;
			}

			//return data requested
			if (!checkinGPSEnable || checkinGPSEnable == 0){
				return false;
			}
			else{
				return true;
			}
		},

		getCheckinGPSMaxAccuracy : function(){
			var checkinGPSMaxAccuracy;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				checkinGPSMaxAccuracy = tempObj.ClientSets ? tempObj.ClientSets['checkin.gps.maxaccuracy'] : null;			
			}
	      	else{
				checkinGPSMaxAccuracy = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['checkin.gps.maxaccuracy'] : null;
			}

			//return data requested
			if (!checkinGPSMaxAccuracy || checkinGPSMaxAccuracy == 0){
				return 1500;
			}
			else{
				return parseInt(checkinGPSMaxAccuracy);
			}
		},

		getCheckinGPSMaxDistance : function(){
			var checkinGPSMaxDistance;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				checkinGPSMaxDistance = tempObj.ClientSets ? tempObj.ClientSets['checkin.gps.maxdistance'] : null;			
			}
	      	else{
				checkinGPSMaxDistance = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['checkin.gps.maxdistance'] : null;
			}

			//return data requested
			if (!checkinGPSMaxDistance || checkinGPSMaxDistance == 0){
				return 500;
			}
			else{
				return parseInt(checkinGPSMaxDistance);
			}
		},

		getSurvey : function(){
			var cs;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				cs = tempObj.ClientSets ? tempObj.ClientSets : null;		
			}
	      	else{
				cs = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets')) : null;
			}


			var question = cs ? cs['survey.question'] : null;
			if (!question){
				question = '';
			}
			var answerone = cs ? cs['survey.answer.one'] : null;
			if (!answerone){
				answerone = '';
			}
			var answeronecolor = cs ? cs['survey.answer.one.color'] : null;
			if (!answeronecolor){
				answeronecolor = '';
			}
			var answertwo = cs ? cs['survey.answer.two'] : null;
			if (!answertwo){
				answertwo = '';
			}
			var answertwocolor = cs ? cs['survey.answer.two.color'] : null;
			if (!answertwocolor){
				answertwocolor = '';
			}
			var answerthree = cs ? cs['survey.answer.three'] : null;
			if (!answerthree){
				answerthree = '';
			}
			var answerthreecolor = cs ? cs['survey.answer.three.color'] : null;
			if (!answerthreecolor){
				answerthreecolor = '';
			}
			var answerfour = cs ? cs['survey.answer.four'] : null;
			if (!answerfour){
				answerfour = '';
			}
			var answerfourcolor = cs ? cs['survey.answer.four.color'] : null;
			if (!answerfourcolor){
				answerfourcolor = '';
			}

			return {
				Question : question,
				AnswerOne: answerone,
				AnswerOneColor: answeronecolor,
				AnswerTwo: answertwo,
				AnswerTwoColor: answertwocolor,
				AnswerThree: answerthree,
				AnswerThreeColor: answerthreecolor,
				AnswerFour: answerfour,
				AnswerFourColor: answerfourcolor
			};
		},

		getStates : function(){
			var states;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				states = tempObj.ClientSets ? tempObj.ClientSets['states'] : null;		
			}
	      	else{
				states = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['states'] : null;
			}

			//return data requested
			if (!states || states == 0){
				return null;
			}
			else{
				return states.split(',');
			}
		},

		getFasCash : function(){
			var fascash;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				fascash = tempObj.ClientSets ? tempObj.ClientSets['fascash'] : null;		
			}
	      	else{
				fascash = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['fascash'] : null;
			}

			//return data requested
			if (!fascash || fascash == 0){
				return 0;
			}
			else{
				return parseInt(fascash);
			}
		},

		getACHSubmitURL : function(){
			var achsubmiturl;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				achsubmiturl = tempObj.ClientSets ? tempObj.ClientSets['ach.submit.url'] : null;		
			}
	      	else{
				achsubmiturl = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['ach.submit.url'] : null;
			}

			//return data requested
			if (!achsubmiturl || achsubmiturl == 0){
				return null;
			}
			else{
				return achsubmiturl;
			}
		},

		getACHMerchantID : function(){
			var achmerchantid;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				achmerchantid = tempObj.ClientSets ? tempObj.ClientSets['ach.merchantid'] : null;		
			}
	      	else{
				achmerchantid = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['ach.merchantid'] : null;
			}

			//return data requested
			if (!achmerchantid || achmerchantid == 0){
				return null;
			}
			else{
				return achmerchantid;
			}
		},

		getGameHide : function(){
			var gamehide;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				gamehide = tempObj.ClientSets ? tempObj.ClientSets['game.hide'] : null;		
			}
	      	else{
				gamehide = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['game.hide'] : null;
			}

			//return data requested
			if (!gamehide || gamehide == 0){
				return 0;
			}
			else{
				return parseInt(gamehide);
			}
		},

		getShowPush : function(){
			var nowpush;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowpush = tempObj.ClientSets ? tempObj.ClientSets['now.push'] : null;		
			}
	      	else{
				nowpush = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.push'] : null;
			}

			//return data requested
			if (!nowpush || nowpush == 0){
				return 0;
			}
			else{
				return parseInt(nowpush);
			}
		},

		getShowTrivia : function(){
			var nowtrivia;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowtrivia = tempObj.ClientSets ? tempObj.ClientSets['now.trivia'] : null;		
			}
	      	else{
				nowtrivia = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.trivia'] : null;
			}

			//return data requested
			if (!nowtrivia || nowtrivia == 0){
				return 0;
			}
			else{
				return parseInt(nowtrivia);
			}
		},

		getShowMap : function(){
			var nowmap;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowmap = tempObj.ClientSets ? tempObj.ClientSets['now.map'] : null;		
			}
	      	else{
				nowmap = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.map'] : null;
			}

			//return data requested
			if (!nowmap || nowmap == 0){
				return 0;
			}
			else{
				return parseInt(nowmap);
			}
		},

		getShowCheckIn : function(){
			var nowcheckin;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowcheckin = tempObj.ClientSets ? tempObj.ClientSets['now.checkin'] : null;	
			}
	      	else{
				nowcheckin = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.checkin'] : null;
			}

			//return data requested
			if (!nowcheckin || nowcheckin == 0){
				return 0;
			}
			else{
				return parseInt(nowcheckin);
			}
		},

		getShowGame : function(){
			var nowgame;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowgame = tempObj.ClientSets ? tempObj.ClientSets['now.game'] : null;
			}
	      	else{
				nowgame = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.game'] : null;
			}

			if(!nowgame){
				console.log('getShowGame in clientsets equals ' + nowgame);
			}

			//return data requested
			if (!nowgame || nowgame == 0){
				return 0;
			}
			else{
				return parseInt(nowgame);
			}
		},

		getShowRating : function(){
			var nowrating;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowrating = tempObj.ClientSets ? tempObj.ClientSets['now.rating'] : null;
			}
	      	else{
				nowrating = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.rating'] : null;
			}

			//return data requested
			if (!nowrating || nowrating == 0){
				return 0;
			}
			else{
				return parseInt(nowrating);
			}
		},

		getShowShare : function(){
			var nowshare;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowshare = tempObj.ClientSets ? tempObj.ClientSets['now.share'] : null;
			}
	      	else{
				nowshare = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.share'] : null;
			}

			//return data requested
			if (!nowshare || nowshare == 0){
				return 0;
			}
			else{
				return parseInt(nowshare);
			}
		},

		getShowFocusPromo : function(){
			var nowfocus;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				nowfocus = tempObj.ClientSets ? tempObj.ClientSets['now.focus.promo'] : null;
			}
	      	else{
				nowfocus = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['now.focus.promo'] : null;
			}

			//return data requested
			if (!nowfocus || nowfocus == 0){
				return 0;
			}
			else{
				return parseInt(nowfocus);
			}
		},

		getGameVersion : function(){
			var gameversion;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				gameversion = tempObj.ClientSets ? tempObj.ClientSets['game.version'] : null;
			}
	      	else{
				gameversion = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['game.version'] : null;
			}

			//return data requested
			if (!gameversion || gameversion == 0){
				return 0;
			}
			else{
				return gameversion;
			}
		},

		getKickbackURL : function(){
			var kickbackUrl;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackUrl = tempObj.ClientSets ? tempObj.ClientSets['kickback.url'] : null;
			}
	      	else{
				kickbackUrl = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.url'] : null;
			}

			//return data requested
			return kickbackUrl;
		},

		getKickbackPass : function(){
			var kickbackPass;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackPass = tempObj.ClientSets ? tempObj.ClientSets['kickback.pass'] : null;
			}
	      	else{
				kickbackPass = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.pass'] : null;
			}

			//return data requested
			return kickbackPass;
		},

		getKickbackUser : function(){
			var kickbackUser;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackUser = tempObj.ClientSets ? tempObj.ClientSets['kickback.user'] : null;
			}
	      	else{
				kickbackUser = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.user'] : null;
			}

			//return data requested
			return kickbackUser;
		},

		getKickbackImage : function(){
			return globals.Change.kickbackImage;
		},

		getKBGamePoker : function(){
			var kickbackGamePoker;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackGamePoker = tempObj.ClientSets ? tempObj.ClientSets['kickback.game.poker'] : null;
			}
	      	else{
				kickbackGamePoker = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.game.poker'] : null;
			}

			//return data requested
			if (!kickbackGamePoker || kickbackGamePoker == 0){
				return 0;
			}
			else{
				return parseInt(kickbackGamePoker);
			}
		},

		getKBGameFootball : function(){
			var kickbackGameFootball;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackGameFootball = tempObj.ClientSets ? tempObj.ClientSets['kickback.game.football'] : null;
			}
	      	else{
				kickbackGameFootball = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.game.football'] : null;
			}

			//return data requested
			if (!kickbackGameFootball || kickbackGameFootball == 0){
				return 0;
			}
			else{
				return parseInt(kickbackGameFootball);
			}
		},

		getKBGameTitle : function(){
			var kickbackGameName;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackGameName = tempObj.ClientSets ? tempObj.ClientSets['kickback.game.title'] : null;			
			}
	      	else{
				kickbackGameName = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.game.title'] : null;
			}

			//return data requested
			return kickbackGameName;
		},

		getKBGameURL : function(){
			var kickbackGameURL;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				kickbackGameURL = tempObj.ClientSets ? tempObj.ClientSets['kickback.game.url'] : null;
			}
	      	else{
				kickbackGameURL = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.game.url'] : null;
			}

			//return data requested
			return kickbackGameURL;
		},

		getKBGameHide : function(){
			var KBGameHide;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				KBGameHide = tempObj.ClientSets ? tempObj.ClientSets['kickback.game.hide'] : null;			
			}
	      	else{
				KBGameHide = localStorage.getItem('ClientSets') ? JSON.parse(window.localStorage.getItem('ClientSets'))['kickback.game.hide'] : null;
			}

			//return data requested
			if (!KBGameHide || KBGameHide == 0){
				return 0;
			}
			else{
				return parseInt(KBGameHide);
			}
		},

		getElectrumURL : function(){
			var electrumurl;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrumurl = tempObj.ClientSets ? tempObj.ClientSets['electrum.url'] : null;		
			}
	      	else{
				electrumurl = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.url'] : null;
			}

			//return data requested
			return electrumurl;
		},

		getElectrumAppID : function(){
			var electrumappid;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrumappid = tempObj.ClientSets ? tempObj.ClientSets['electrum.appid'] : null;		
			}
	      	else{
				electrumappid = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.appid'] : null;
			}

			//return data requested
			return electrumappid;
		},

		getElectrumPoints : function(){
			var electrumpoints;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrumpoints = tempObj.ClientSets ? tempObj.ClientSets['electrum.points'] : null;		
			}
	      	else{
				electrumpoints = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.points'] : null;
			}

			//return data requested
			if (electrumpoints){
				return parseInt(electrumpoints);
			}
			else{
				return 0;
			}
		},

		getElectrumServerErr : function(){
			var electrumservererr;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrumservererr = tempObj.ClientSets ? tempObj.ClientSets['electrum.servererr'] : null;	
			}
	      	else{
				electrumservererr = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.servererr'] : null;
			}

			//return data requested
			if (electrumservererr){
				return electrumservererr;
			}
			else{
				return "We're sorry but we are unable to contact the server at this time. Please check your Internet connection.";
			}
		},

		getElectrumNow47 : function(){
			var electrumnow;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrumnow = tempObj.ClientSets ? tempObj.ClientSets['electrum.now.47'] : null;
			}
	      	else{
				electrumnow = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.now.47'] : null;
			}

			//return data requested
			return electrumnow;
		},

		getElectrumMenu47 : function(){
			var electrummenu;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrummenu = tempObj.ClientSets ? tempObj.ClientSets['electrum.menu.47'] : null;
			}
	      	else{
				electrummenu = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.menu.47'] : null;
			}

			//return data requested
			return electrummenu;
		},

		getElectrumMenuMain : function(){
			var electrummenumain;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrummenumain = tempObj.ClientSets ? tempObj.ClientSets['electrum.menu.main'] : null;			
			}
	      	else{
				electrummenumain = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.menu.main'] : null;
			}

			//return data requested
			return electrummenumain;
		},

		getElectrumOptions: function(){
			var enrolled = false;

			if( getElectrumUniqueID() ){
				enrolled = true;
			}

			//var enrolled = 'Electrum.Unique.ID'in localStorage;
			var electrumoptions = [];
			var electrumtrans;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				electrumtrans = tempObj.ClientSets ? tempObj.ClientSets['electrum.trans'] : null;		
			}
	      	else{
				electrumtrans = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['electrum.trans'] : null;
			}

			//return data requested
			if (electrumtrans){
				electrumtrans = electrumtrans.split(',');
				for (var i = 0; i < electrumtrans.length; i++){
					if ((enrolled && electrumtrans[i] != 44) || (!enrolled && electrumtrans[i] == 44)){
						var electrumtranstext = tempObj.ClientSets ? tempObj.ClientSets['electrum.trans.' + electrumtrans[i]] : null;

						if (electrumtranstext){
							electrumoptions.push({
								TranCode: electrumtrans[i],
								Text: electrumtranstext
							});
						}
					}
				}
			}
			return electrumoptions;
		},
		
		getRadiusActive : function(){
			var radiusactive;

			//Check if LocalStorage is enabled and get data
			if( globals.localStorage == false){
	       		var tempObj = JSON.parse(globals.appDataJson);
				radiusactive = tempObj.ClientSets ? tempObj.ClientSets['radius.active'] : null;			
			}
	      	else{
				radiusactive = 'ClientSets' in localStorage ? JSON.parse(window.localStorage.getItem('ClientSets'))['radius.active'] : null;
			}

			//return data requested
			if (radiusactive || radiusactive == 0){
				return parseInt(radiusactive);
			}
			else{
				return 0;
			}
		},

		//TODO: Move this to appropiate KB module
		//This method uses no local storage
		getPunchCardImage : function(id, label){
			var image;

			if(globals.debugApp){
				console.log('KICKBACK-DEBUG: Getting ' + label + ' image with punchcard id: ' + id);
			}

			//Add these mentos.png , naturevalley.png, orbit.png, skins.png
			if(id == 3){
				image = 'images/kickback-Clubs/coffee.png';
			}
			else if(id == 35){
				image = 'images/kickback-Clubs/minutemaid.png';
			}
			else if(id == 43){
				image = 'images/kickback-Clubs/yupmilk.png';
			}
			else if(id == 47){
				image = 'images/kickback-Clubs/mentos.png';
			}
			else if(id == 45){
				image = 'images/kickback-Clubs/magnumbar.png';
			}
			else if(id == 41){
				image = 'images/kickback-Clubs/grannygreens.png';
			}
			else if(id == 29){
				image = 'images/kickback-Clubs/5hrenergy.png';
			}
			else if(id == 37){
				image = 'images/kickback-Clubs/bonappetit.png';
			}
			else if(id == 55){
				image = 'images/kickback-Clubs/doritoslaysmall.png';
			}
			else if(id == 31){
				image = 'images/kickback-Clubs/powerade32.png';
			}
			else if(id == 39){
				image = 'images/kickback-Clubs/fantabottles.png';
			}
			else if(id == 5){
				image = 'images/kickback-Clubs/fountaindrink.png';
			}
			else if(id == 9){
				image = 'images/kickback-Clubs/maolamilkgallon.png';
			}
			else if(id == 11){
				image = 'images/kickback-Clubs/frozendrinks.png';
			}
			else if(id == 19){
				image = 'images/kickback-Clubs/snickers.png';
			}
			else if(id == 21){
				image = 'images/kickback-Clubs/m&m.png';
			}
			else if(id == 23){
				image = 'images/kickback-Clubs/monsterjava.png';
			}
			else if(id == 25){
				image = 'images/kickback-Clubs/monsterultra.png';
			}
			else if(id == 33){
				image = 'images/kickback-Clubs/hersheys.png';
			}
			else if(id == 57){
				image = 'images/kickback-Clubs/doritoslaysmall.png';
			}
			else if(id == 99){
				image = 'images/kickback-Clubs/naturevalley.png';
			}
			else if(id == 115){
				image = 'images/kickback-Clubs/orbit.png';
			}
			else if(id == 141){
				image = 'images/kickback-Clubs/goodys.png';
			}
			else if(id == 167){
				image = 'images/kickback-Clubs/squatch.png';
			}
			else if(id == 169){
				image = 'images/kickback-Clubs/monster.png';
			}
			else{
				image = 'images/kickback-Clubs/placeholder.png';
			}
			//continue with else if's - if more images are needed

			return image;
		}

		};
	}
})();
(function(){
	angular.module('connect.app', 
		[
		'templates',
		'connect.kickback-rewards',
		'connect.kickback-iframe',
		'connect.game',
		'connect.sync',
		'connect.changeEmail',
		'connect.interestList',
		'connect.accountdetails',
		'connect.login',
		'connect.register',
		'connect.local.data',
		'connect.client.set',
		'connect.promo.dialog',
		'connect.participating.stores',
		'connect.promos',
		'connect.loading',
		'connect.settings',
		'connect.terms.of.use',
		'connect.about.developer',
		'connect.feedback.prompt',
		'connect.store.feedback',
		'connect.preferred.gas.type',
		'connect.link.account',
		'connect.fas.cash',
		'connect.fas.cash.help',
		'connect.faq',
		'connect.password.reset',
		'connect.passwordchange',
		'connect.changeaccountdetails',
		'connect.storeservice',
		'connect.prizes',
		'connect.geolocation',
		'connect.store',
		'connect.electrum',
		'connect.lottery.numbers'
		]
	);
})();

(function () {
	angular.module('connect.app').factory('connectAppFooterService', connectAppFooterService);
	connectAppFooterService.$inject = ['$rootScope'];

	function connectAppFooterService($rootScope) {
		var service = {
			navIcons: []
		};

		$rootScope.$on('connect:ready', initialize);

		return service;

		function initialize() {
			service.navIcons.push({
				click: null,
				href: '#main',
				icon: 'fa-home',
				selected: true,
				navText: 'Home'
			});

			if ($rootScope.kickbackEnabled) {
				service.navIcons.push({
					click: null,
					href: '#kickbackRewards',
					icon: 'fa-trophy',
					selected: false,
					navText: 'Rewards'
				});
			} else if ($rootScope.enableElectrum) {
				service.navIcons.push({
					click: null,
					href: '#electrum',
					icon: 'fa-credit-card',
					selected: false,
					navText: 'Loyalty'
				});
			} else if ($rootScope.showGame) {
				service.navIcons.push({
					click: $rootScope.Game,
					href: '#game',
					icon: 'fa-gamepad',
					selected: false,
					navText: 'Win'
				});
			} else {
				service.navIcons.push({
					click: null,
					href: '#feedbackprompt',
					icon: 'fa-comment',
					selected: false,
					navText: 'Feedback'
				});
			}

			service.navIcons.push({
				click: null,
				href: '#promos',
				icon: 'fa-shopping-cart',
				selected: false,
				navText: 'Specials'
			});

			service.navIcons.push({
				click: null,
				href: '#stores',
				icon: 'fa-location-arrow',
				selected: false,
				navText: 'Locations'
			});

			service.navIcons.push({
				click: null,
				href: '#settings',
				icon: 'fa-bars',
				selected: false,
				navText: 'More'
			});
		}
	}
} ());
(function(){
	angular.module('connect.app').directive('connectAppFooter', connectAppFooter);
	
	connectAppFooter.$inject = [];
	connectAppFooterCtrl.$inject = ['$scope', '$rootScope', 'connectAppFooterService'];
	

	function connectAppFooter() {
		return {
			restrict: 'E',
			templateUrl: 'connect-app-footer/connect.connect-app-footer.html',
			controller: connectAppFooterCtrl,
			controllerAs: 'connectAppFooterCtrl'
		}
	}
	
	function connectAppFooterCtrl($scope, $rootScope, connectAppFooterService) {
		var vm = this;
		vm.clickNav = clickNav;
		vm.selectedNav = null;
		vm.navIcons = connectAppFooterService.navIcons;
		
		function clickNav(navIcon) {
			for(var i = 0, len = vm.navIcons.length; i < len; i++) {
				vm.navIcons[i].selected = false;
			}
			if(globals.debugApp){
				console.log(navIcon);
			}

			navIcon.selected = true;
			globals.page = navIcon.navText;
			if(navIcon.click) {
				navIcon.click();
			}
		}

	}
}());
(function(){
	angular.module('connect.changeEmail', []);
}());
(function() {
	angular.module('connect.changeEmail')
		.directive('connectChangeEmail', connectChangeEmailDirective)
		.controller('connectChangeEmailController', connectChangeEmailController);

	connectChangeEmailDirective.$inject = [];
	connectChangeEmailController.$inject = ['$scope', '$rootScope', '$http'];

	function connectChangeEmailDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'changeEmail/connect.changeemail.html',
			controller: 'connectChangeEmailController'
		};
		return directive;
	}

	function connectChangeEmailController($scope, $rootScope, $http) {

		$('#changeEmail').on('pageshow', function(){
			var scope = angular.element($("#changeEmail")).scope();
			scope.$apply(function(){

	        	scope.password = '';
		    	scope.newEmail = '';
		    	scope.Submit = false;
	    	});
		}); //when the page is shown, update the form fields with the user's current info if available


		$('#changeEmail').on('pagehide', function(){ //refresh the interests on the page on pagehide in case the user has updated them

			var scope = angular.element($("#changeEmail")).scope();
			scope.$apply(function(){

	        	scope.password = '';
		   		scope.newEmail = '';
		    	scope.Submit = false;
	    	});
		});

		$scope.Submit = false;

		$scope.ChangeEmail = function() {
			$scope.Submit = true;

			if (!$('#changeEmailForm').hasClass('ng-invalid')) {
				
				if (window.device.platform == 'Android') {
					var options = {
						label : "Changing Email...",
						timeout: 120
					};
				} else {
					var options = {
						label : "Changing Email...",
						color: '#000',
						spinnerColor: '#000',
						timeout: 120
					};
				}
				window.wizSpinner.show(options); 

				$http.post(GetItemFromLocalData('ClientURL'), soapMessageChangeAccountEmail($scope.password, $scope.newEmail), {timeout: 25000}).then(function(response) {
					
					window.wizSpinner.hide();
					var processed = $(response.data).find('ChangeAccountEmailResult').children("Processed").text();
					var error = $(response.data).find('Standard').children('MethodErrorMsg').text();

					if (processed == "true") {
						SetItemInLocalData("Email", $scope.newEmail);

						navigator.notification.alert(
							'Email change complete.', // message

							function() {
							}, // callback
							'Success!', // title
							'Ok' // buttonName
						);
						setTimeout(function() {
							$scope.Submit = false;
						}, 500); //clear the change password form
						$.mobile.changePage('#accountDetails');

					} else{
						alert(error, function() {
							$.mobile.changePage('#accountDetails');
						});
					}
				}, function(error) {
					
					window.wizSpinner.hide();

					$rootScope.Error(globals.ajaxTimeoutMessage, function() {
						if(globals.debugApp){
							console.log(" .. ");
						}
					}, false, function() {
						if(globals.debugApp){
							console.log(" .. ");
						}
					});
				});
			}
		};
	}
}());
(function(){
	angular.module('connect.changeaccountdetails', []);
})();
(function() {
	angular.module('connect.changeaccountdetails')
		.directive('changeAccountDetails', changeAccountDetailsDirective)
		//TODO: reformat controller
		.controller('ChangeAccountDetailsController', changeAccountDetailsController);

	changeAccountDetailsDirective.$inject = [];

	changeAccountDetailsController.$inject = ['$scope', '$rootScope', '$http'];


	function changeAccountDetailsDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'changeAccountDetails/connect.changeaccountdetails.html',
			link: link
		};

		return directive;

		function link(scope, element, attrs) { }
	}

	function changeAccountDetailsController($scope, $rootScope, $http) {

		$('#changeAccountDetails').on('pageshow', function() {

			$('#birthdaychangeaccountdetails').mobiscroll({ preset: 'date'});
			//when the page is shown, update the form fields with the user's current info if available
			$scope.fullname = getFullName();
			$scope.phone = getPhone();
			if (getBirthday() != 0 && getBirthday() != null && moment(getBirthday()).isValid() && moment(getBirthday()).year() != 1900) {
				$scope.birthday = moment(getBirthday()).format("MM/DD/YYYY");
			}
			$scope.geopromo = getGeoPromo();
			$scope.password = '';
			$scope.Submit = false;

			$('input').trigger('input');
		});
		$('#changeAccountDetails').on('pagehide', function() {

			$scope.password = '';
			$scope.Submit = false;
		});

		$scope.Submit = false;

		$scope.ChangeAccountDetails = function() {
			$scope.Submit = true;

			if (!$('#changeAccountDetailsForm').hasClass('ng-invalid')) {

				var birthday = $('#birthdaychangeaccountdetails').val();
				if (birthday != undefined && birthday != "") {
					var newbirthday = moment(birthday).toDate().getTime();
				} 
				else {
					var newbirthday = -2208739198680;
				}

				if ($scope.geoPromo){
					var newgeopromo = 1;
				}
				else{
					var newgeopromo = 0;
				}
				

				if (window.device.platform == 'Android') {
					var options = {
						label : "Processing..",
						timeout: 120
					};
				} else {
					var options = {
						label : "Processing..",
						color: '#000',
						spinnerColor: '#000',
						timeout: 120
					};
				}
				window.wizSpinner.show(options); 

				$http.post(GetItemFromLocalData('ClientURL'), soapMessageChangeAccountDetail($scope.password, $scope.fullname, $scope.phone, newbirthday, newgeopromo), {timeout: 25000} ).then(function(response) {
					window.wizSpinner.hide();		
					var processed = $(response.data).find('ChangeAccountDetailResult').children("Processed").text();
					var error = $(response.data).find('Standard').children('MethodErrorMsg').text();

					if (processed == "true") {
						saveAccountDetailJson(response.data);
						$rootScope.RegisteredUser = true; //probably don't need this line
						navigator.notification.alert(
							'Your account has been updated.', // message
							function() {
								//$.mobile.changePage('#accountDetails', { transition: "slide", reverse: true});
								//	$scope.Submit = false;
							}, // callback
							'Success!', // title
							'Ok' // buttonName
						);
						setTimeout(function() {
							$scope.Submit = false;
						}, 500); //clear the change password form
						$.mobile.changePage('#accountDetails');

					} else {
						alert(error, function() {
							$.mobile.changePage('#accountDetails');
						});
					}

				}, function(error) {
					window.wizSpinner.hide();
					$rootScope.Error(globals.ajaxTimeoutMessage, function() {
						if(globals.debugApp){
							console.log(" .. ");
						}
					}, false, function() {
						if(globals.debugApp){
							console.log(" .. ");
						}
					});
					
				});
			}
		};

	}
})();
(function(){
	angular.module('connect.accountdetails', []);
}());
(function() {
	angular.module('connect.accountdetails').directive('connectAccountDetails', accountDetailsDirective).controller('accountDetailsController', accountDetailsController);

	accountDetailsDirective.$inject = [];
	accountDetailsController.$inject = ['$scope', '$timeout', 'Loading', 'ClientSet'];

	function accountDetailsDirective() {
		var directive = {
			restrict: 'E',
			templateUrl: 'accountdetails/connect.accountdetails.html',
			controller: 'accountDetailsController'
		};

		return directive;
	}

	function accountDetailsController($scope, $timeout, Loading, ClientSet) {

		$('#accountDetails').on('pageshow', function(){
			$('#accountDetailsControlGroup').controlgroup('refresh'); //The control group is dynamically updated (from js/app.js) so we update it on every pageshow
		});


		Loading.then(function() {
			$timeout(function() {
				$scope.UserEmail = getEmail();

				if(globals.debugApp){
					console.log('USER EMAIL IN SCOPE' + $scope.UserEmail );
				}

				$scope.ShowGas = ClientSet.getShowGasPrice();
				$scope.InterestTitle = ClientSet.getInterestTitle();

				if (getPushEnabled()){
					$scope.PushSetting = 'Disable Push';
				}
				else{
					$scope.PushSetting = 'Enable Push';
				}
			},1);
		});


		$scope.Android = window.device.platform == 'Android';
		var inProgress = false;
		
		$scope.editPush = function() {
			if (!inProgress) {
				inProgress = true;
				if (getPushEnabled()) {
					//PushNotification.disablePush();
					SetItemInLocalData('PushEnabled', 'false');
					SetItemInLocalData('PushToken', "");

					$timeout(function() {
						$scope.PushSetting = 'Enable Push';
					}, 1);
				} else {
					//PushNotification.enablePush();
					SetItemInLocalData('PushEnabled', 'true');

					$timeout(function() {
						$scope.PushSetting = 'Disable Push';
					}, 1);
				}
				setTimeout(function() {
					inProgress = false;
				}, 500);
			}
		};

		$scope.logOut = function() {
			if (!inProgress) {
				inProgress = true;

				$timeout(function() {
				
					if(globals.debugApp){
						console.log("DEBUG: Logging out");
					}

					navigator.notification.confirm(
						'Your points are stored on the server. They are tied to this email only. Remember your password.',
						callBackConfirm, // Specify a function to be called
						'Are you sure you want to logout?', ["Yes", "No"]
					);

					function callBackConfirm(b) {
						if (b == 1) {
							// for YES

							navigator.splashscreen.show();

							if (window.device.platform == 'Android'){
								var options = {
									label : "Logging Out"
								};
							}
							else{
								var options = {
									label : "Logging Out",
									color : '#000',
									spinnerColor : '#000'
								}; //if this is an iOS device, change the loader color since it defaults to white and can blend in to the loadingpage
							} 

							//Cancel Sync if it's still running
							if( isSyncFinished() == false ){
								stopSync();
							}

							window.wizSpinner.show(options);
							//call function to clear data for log out
							ClearDataAndLogOut();

							setTimeout(function() {
								navigator.splashscreen.hide();
							}, 11000);

							setTimeout(function() {
								//Now sync app to retart it (add timer)
								window.localStorage.setItem('appRestart', 1);
								setSyncNow('true');
				       			window.location.href = window.location.href.substring(0, window.location.href.indexOf('#')); //reload main.html, basically restart the web app
				       		}, 5000);
						}
						else{
							// for NO - Do Nothing
						}
						inProgress = false;
					}
				}, 10);
			}
		};
	}
}());
(function(){
	angular.module('connect.about.developer', []);
})();
(function(){
	angular.module('connect.about.developer')
	.directive('aboutDeveloper', aboutDeveloperDirective)
	.controller('AboutController', aboutDeveloperController);

	aboutDeveloperDirective.$inject = [];

	aboutDeveloperController.$inject = ['$scope', '$timeout', 'ClientSet', 'Loading'];

	function aboutDeveloperDirective(){
		var directive = {
			restrict: 'E',
			templateUrl: 'aboutDeveloper/connect.about.developer.html',
			link: link
		}

		return directive;

		function link(scope, element, attrs){ }
	}

	function aboutDeveloperController($scope, $timeout, ClientSet, Loading){

		Loading.then(function(){
			$timeout(function(){
				$scope.CompanyName = ClientSet.getCompanyName();
				$scope.ProductName = ClientSet.getProductName();
				$scope.ProductVersion = getAppVersion();
				$scope.ReleaseDate = getReleaseDate();
			}, 1);
		});

		$('#about').one('pageshow', function(){
			$scope.Chain = globals.Change.chainFriendly;
			if(globals.debugApp){
				console.log( 'DEBUG: Chain being used is ' + $scope.Chain );
			}
		});
	}
})();